.ds = \-\^\-
.de Sp
.if t .sp .3
.if n .sp
..
.TH wmrack 1.0 "1 June 1997" wmrack
.UC
.SH NAME
\fBwmrack\fP \- the WindowMaker Sound Control
.SH SYNOPSIS
.B wmrack
[options]
.SH DESCRIPTION
The \fBwmrack\fP is CD player and Audio Mixer written to be
docked to WindowMaker's dock. It can also be used swallowed into
the button bars of most fvwm compatible window managers.
\fBwmrack\fP handles mounted volumes, opens and closes the tray, can
display the current position in various ways and skips also data tracks.
It gives you access to all your mixer devices, so that you may change
volume or balance and set the record source.
.SH OPTIONS
.TP
\fB\-b\fP \fBCOLSPEC\fP or \fB\*=background\fP \fBCOLSPEC\fP
Specifies the background color of the LED. It is avaiable through the symbolic 
XPM colorname
.I led_color_black.
.SP
The other colors of the LED can be changed using the \fB-l\fP option.
.Sp
To find out what colors are available, try
.I showrgb
(part of X11).
.TP
\fB\-d\fP \fBDEVICE\fP or \fB\*=device\fP \fBDEVICE\fP
Sets the CD-ROM device. This defaults to /dev/cdrom.
.TP
\fB\-h\fP or  \fB\*=help\fP
Prints a summary of supported options and their default values.
.TP
\fB\-l\fP \fBCOLSPEC\fP or \fB\*=ledcolor\fP \fBCOLSPEC\fP
Specifies the color of the led. It is darkened two times (for a total of
three colors) to get all needed colors. So better use a bright color.
.Sp
For the design of own XPM, the ledcolor is made avaiable through the use
of the symbolic xpm color names
.I led_color_high,
.I led_color_low,
and
.I led_color_med.
There is also a symbol named
.I led_color_back
to get the default background color of the led\-display. It can be changed
using the \fB-l\fP option.
.Sp
To find out what colors are available, try
.I showrgb
(part of X11).
.TP
\fB\-m\fP \fBDEVICE\fP or \fB\*=mixer\fP \fBDEVICE\fP
Sets the MIXER device. This defaults to /dev/mixer.
.TP
\fB\-p\fP or \fB\*=noprobe\fP
This option disables the startup probing for a cd. Default is to probe the
cdrom. This will close the tray and read the TOC of the cd (if there is one).
.TP
\fB\-s\fP \fBSTYLEFILE\fP or \fB\*=style\fP \fBSTYLEFILE\fP
.B wmrack
will try to load its window\-pixmaps from the specified
.B STYLEFILE.
It will search this file for XPM pixmaps named
.I cdnodisc,
.I cdplaying,
.I cdpaused,
.I cdstopped,
.I cdled,
.I mixer,
and
.I mixled.
If some of those are not defined, the compile\-time defaults will be used.
.TP
\fB\-w\fP or \fB\*=withdrawn\fP
Starts the
.B wmrack
in withdrawn window state. This is useful to dock the window to
.B WindowMaker.
.TP
\fB\-M\fP \fBMODESTRING\fP or \fB\*=mode\fP \fBMODESTRING\fP
By default
.B wmrack
will startup showing the CDROM controls. With this option you can specify what 
controls should be shown. Valid \fBMODESTRINGS\FP are
.I cdrom,
and
.I mixer.
.SH INVOCATION
\fBwmrack\fP can be called using different ways. The most common invocation
is from your dock file:
.Sp
        wmrack
        WMRack
        \fIPOSITION\fP 2 -1 0
        wmrack
        --withdrawn
.Sp
Another way to call \fBwmrack\fP is to swallow it into the \fBafterstep (1)\fP
\fBWharf (1)\fP. This is best done playcing the following line into your
\fI.steprc\fP:
.Sp
	*Wharf WMRack nil Swallow "wmrack" wmrack &
.Sp
This method will also work for other button\-bars, such as the \fBFvwmButtons (1)\fP
of the \fBfvwm (1)\fP window manager.
.SH GENERAL USAGE
The \fBwmrack\fP features a simple click interface. All times the buttons will
show a standart sign which specifies the action it will do. But there are some 
noteable extensions to that explained below.
.Sp
You can always change the controls shown by clicking the middle button (this
is the one which shows a disc or a speaker) of the controls. This button will
show a symbol of the controls you can change to by pressing it (the disc and
the speaker).
.Sp
If you click this button with Control-Button-3, \fBWMrack\fP will exit.
.SH CDROM USAGE
The default behavior of \fBwmrack\fP is to try to read the cdrom at
startup. If there was no cd, it will not try again unless you press the close
or play button. This will close the cdrom and again try to read it. Unless
there is a cd, \fBwmrack\fP will again suspend until your next action.
.TP
.B open tray
Clicking an open/eject button with button-3 will always open the tray.
.TP
.B skip
By pressing the button down and holding it on one of the prev/next track
buttons the cdrom goes fast forward or backward.
.TP
.B time left
A button-1 click into the time display switches between time running and time
left display.
.TP
.B total time
A button-2 click into the time display switches between track and total time.
.TP
.B repeat
A button-3 click into the time display cycles through normal mode, repeat all, 
and repeat one play mode.
.PP
The cd player also offers a play list functionality. By default it will map
out all data tracks of the current cdrom, but you can also randomize the list
or program it to the tracks you want to hear. These functions are only
avaiable while a cdrom is in the drive and the drive is \fIstopped\fP.
.TP
.B randomize
Clicking Control-Button-3 to the track display causes the playlist to be
randomized. No track will repeat, the tracks are just mixed up.
.Sp
You will see the short message \fIRA:ND\fP in the time display.
.TP
.B start programming
Click Control-Button-1 into the track display to start programing a new
playlist. You will see a short \fIPR:OG\fP message in the time display and a
\fIM\fP will show up in the lower left corner of the display.
.TP
.B add track to list
Use the prev-/next-track buttons to select a track and click Mod1-Button-1
into the track display to add it to the playlist. The time display will show
the number of the tracks in the list and the number of the selected track for
a short time and will than switch back and display the total ength of the
playlist.
.TP
.B clear list
To abort the programing of a playlist click Control-Button-1 into the
track-display.
.TP
.B start playing the list
Simply press the PLAY button to play the list.
.SH MIXER USAGE
Main controls of the mixer are the two volume scales at the left and the right 
side of the display. Using the mouse the scales can be modified.
.TP
.B button-1
change volume of clicked scale
.TP
.B button-2
change volume of both scales
.TP
.B button-3
change the balance of the volume
.PP
Clicking into the alphanumeric display changes the currently shown mixer
device. Valid devices are VOlume, BAss, TReble, SYnth, PCm, SPeaker, LIne,
MIc, CD, MiXer, Pcm2, REcord, IGain, OGain, Line1, Line2, and Line3.
You can also remove devices from this list.
.TP
.B button-1
go to the next device
.TP
.B button-2
go to the main volume (first device)
.TP
.B button-3
go to the previous device
.TP
.B control-button-1
show all devices
.TP
.B control-button-3
remove current device
.PP
Below the change-controls button is the record source button. It show either
a 'X' and is inactive, or it show a speaker or a recording sign and is active.
By pressing this button you can change the source of your recordings.
.TP
.B button-1
toggle record source button
.TP
.B button-2
set as record source and clear all other
.SH COPYRIGHTS
Copyright 1997, Oliver Graf <ograf@fga.de>.
Most styles copyright 1997, Heiko Wagner <hwagner@fga.de>.
.Sp
No guarantees or warranties or anything are provided or implied in any way
whatsoever. Use this program at your own risk. Permission to use this program
for any purpose is given, as long as the copyright is kept intact.
.SH AUTHORS
Oliver Graf <ograf@fga.de> -- the coding
.Sp
Heiko Wagner <hwagner@fga.de> -- the hyped window shapes
.SH CREDITS
Rob Malda <malda@cs.hope.edu> -- who had written ascd and asmixer
.Sp
Michael Kurz <mkurz@rzws.fh-aalen.de> -- also for ascd and asmixer
.Sp
Thomas McWilliams <tgm@netcom.com> -- who has done Workbone
