	/*

	Copyright (C) 1998 Stefan Westerfeld
                       stefan@space.twc.de

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    */

#ifndef __EXECDLG_H_
#define __EXECDLG_H_

#include "synth.h"
#include <qdialog.h>
#include <qtimer.h>
#include <qlabel.h>
#include <qscrbar.h>
#include <qlayout.h>

class ExecDlg :public QDialog {
	Q_OBJECT
public:
	QTimer *cpuusagetimer;
	QLabel *cpuusagelabel;
	Arts::Synthesizer *Synthesizer;
	QVBoxLayout *mainlayout,*sliderlayout;

	void addVar(QString var);
	void start();
	ExecDlg(QWidget *parent, Arts::Synthesizer *Synthesizer);

protected slots:
	void stop();
	void updateCpuUsage();
};

class SynthScrollBar :public QScrollBar {
	Q_OBJECT
public:
	Arts::Synthesizer *Synthesizer;
	QString varname;

	SynthScrollBar(QWidget *parent, QString varname, Arts::Synthesizer *Synthesizer);
public slots:
	void setSynthVar(int newvalue);
};

#endif
