#include "artsobject.h"

long ArtsObject_impl::objectInstances = 0;

ArtsObject_impl::ArtsObject_impl()
{
	referenceCount = 0;
	objectDescription = "<unknown>";
	objectInstances++;
}

ArtsObject_impl::~ArtsObject_impl()
{
	printf("one %s object freed\n",objectDescription.c_str());
	objectInstances--;
	if(objectInstances == 0) orb->shutdown(TRUE);
}

void ArtsObject_impl::describe(string desc)
{
	objectDescription = desc;
}

void ArtsObject_impl::incRef()
{	
	referenceCount++;
	printf("incRef(%s) -> %ld\n",objectDescription.c_str(),referenceCount);
}

void ArtsObject_impl::decRef()
{	
	assert(referenceCount > 0);
	referenceCount--;
	printf("decRef(%s) -> %ld\n",objectDescription.c_str(),referenceCount);
	if(referenceCount == 0)
	{
		cleanUp();				// same trick as in KOM
								// you may clean up children now, that have
								// references to you  ... overload that
								// function
		if(_refcnt() != 1)
			printf("decRef: WARNING; CORBA reference count is now %ld\n",_refcnt());
		CORBA::release(this);	// free this instance
	}
}

void ArtsObject_impl::destroy()
{
	incRef();
	decRef();
}

void ArtsObject_impl::cleanUp()
{
	// overload me
}
