// Copyright 1998 by Kevin Atkinson under the terms of the LGPL

#ifndef ap_string_
#define ap_string_

class ap_string {
  char *begin_,*end_;
  char *true_begin_;
public:
  typedef unsigned int size_type;

  size_type size() const {return end_-begin_;}
  bool empty() const {return !size();}

  ap_string() : begin_(0), end_(0), true_begin_(0) {}
  ap_string(size_type s) {
    end_ = begin_ = true_begin_ = new char[s];
  }
  ap_string(const char *d) {
    const char *i=d; while (*i) ++i;
    end_ = begin_ = true_begin_ = new char[i-d];
    for (; *d; ++d,++end_) *end_ = *d;
  }
  ap_string(const ap_string &other) {
    end_ = begin_ = true_begin_ = new char[other.size()];
    for (const char *i = other.begin_; i != other.end_; ++i, ++end_) *end_=*i; 
  }
  void operator=(const ap_string &other) {
    delete[] true_begin_;
    end_ = begin_ = true_begin_ = new char[other.size()];
    for (const char *i = other.begin_; i != other.end_; ++i, ++end_) *end_=*i; 
  }

  ~ap_string() {delete[] true_begin_;}
  void clear() {delete[] true_begin_; true_begin_=begin_=end_=0;}
  
  bool operator==(const ap_string &other) const {
    if (size() != other.size()) return false;
    for (const char *i = begin_, *j = other.begin_; i != end_; ++i, ++j)
      if (*i != *j) return false;
    return true;
  }
    
  void pop_front() {++begin_;}
  void operator += (char d) {*end_++ = d;}
  void remove(size_type pos) {
    --end_;
    for (char *i=begin_+pos; i != end_; ++i) *i = *(i+1);
  }
  char& operator[] (size_type pos) {return begin_[pos];}
  const char& operator[] (size_type pos) const {return begin_[pos];}
};

#endif
