
#include "mwordlist.hh"
#include "as_data.hh"

AS_WordLists::AS_WordLists(aspell *sc) {
  del_main = true;
  main_ = new ReadOnlyWL(sc);
  del_personal = true;
  personal_ = new WritableWL(sc);
  del_session = true;
  session_ = new WritableWL(sc);
}

AS_WordLists::~AS_WordLists() {
  if (del_main)
    delete main_;
  if (del_personal)
    delete personal_;
  if (del_session)
    delete session_;
}

const AS_WordLists::SWordList 
  AS_WordLists::words_w_soundslike (const char *m) const 
{
  return SCMWL_Internal(main_->words_w_soundslike(m),
			personal_->words_w_soundslike(m),
			session_->words_w_soundslike(m));
}

AS_ReplLists::AS_ReplLists(aspell *sc) {
  del_personal = true;
  personal_ = new WritableReplList(sc);
}

AS_ReplLists::~AS_ReplLists() {
  if (del_personal)
    delete personal_;
}

const AS_ReplLists::SWordList 
  AS_ReplLists::words_w_soundslike (const char *m) const 
{
  return personal_->words_w_soundslike(m);
}



