
#include "as_error.hh" 

string SC_Error::message() const {
  switch (problem) {
  case none:
    return "";
  case nonexistent:
    return "The file \"" + file + "\" can not be found.";
  case bad_format:
    return "The file \"" + file + "\" is not in the proper format.";
  case cant_write:
    return "Sorry, I can't write to \"" + file + "\".";
  case duplicates:
    return "There were duplicate words in the input.  The file \"" + file
      + "\" containes a word list without the duplicates.  Please rerun with that file as input.";
  case unknown_lang:
    return "Sorry the language \"" + add_info + "\" is not known." +
      (file.size() ? "In file \"" + file + "\"." : string());
  case mismatched_lang:
    return "Sorry the language in file \"" + file + 
      "\" is not the same as the language in other files.";
  }
  return "";
}
