
#ifndef __generic_lang_loader__
#define __generic_lang_loader__

#include <iostream.h>
#include <string>
#include "const_string.hh"

class SC_GenericLangLoader {
protected:
  const char *name_;
        char *to_lower_;
        char *to_upper_;
        char *is_alpha_;
        char *soundslike_chars_;
private:
  string     name_intr;

  char to_upper(const char c) const {return to_upper_[static_cast<unsigned char>(c)];}

  void print_code_body(const string &class_name, const string &var_name, 
		       const char *var, int length, ostream &out);
  void print_code_header(const string &class_name, ostream &out = cout);
  void print_code_header(ostream &out = cout);
  void print_code_body(const string &class_name, ostream &out = cout);
  void print_code_body(ostream &out = cout);
  
  void init(const string &name);

public:
  SC_GenericLangLoader(const string &name);
  SC_GenericLangLoader(const string &name, const string &path);
  ~SC_GenericLangLoader();

  void get_from_file(const string &file);
  void print_code_to_file();
};

#endif
