#define real_itr_cast(obj) \
  (*reinterpret_cast<real_itr *>(obj))
#ifndef value_func
#  define undef_value_func
#  define value_func(obj) (obj)
#endif

base::const_iterator::const_iterator() {
  itr = 0;
}

base::const_iterator::const_iterator(void *i) {
  itr = new real_itr(real_itr_cast(i));
}

base::const_iterator::~const_iterator() {
  delete &real_itr_cast(itr);
}

base::const_iterator::const_iterator(const base::const_iterator& other) {
  itr = new real_itr(real_itr_cast(other.itr));
}

base::const_iterator& 
base::const_iterator::operator=(const base::const_iterator& other) {
  delete &real_itr_cast(itr);
  itr = new real_itr(real_itr_cast(other.itr));
}

base::const_iterator::return_type base::const_iterator::operator* () {
  return value_func(*real_itr_cast(itr));
}

base::const_iterator& base::const_iterator::operator++() {
  ++real_itr_cast(itr);
  return *this;
}

base::const_iterator base::const_iterator::operator++(int) {
  const_iterator temp = *this;
  ++real_itr_cast(itr);
  return temp;
}

#ifdef include_operator_plus
base::const_iterator base::const_iterator::operator+(unsigned int offset) {
  real_itr temp = real_itr_cast(itr) + offset;
  return const_iterator(&temp);
}
#endif

bool operator==(base::const_iterator rhs, base::const_iterator lhs) {
  return real_itr_cast(rhs.itr) == real_itr_cast(lhs.itr);
         
}

bool operator!=(base::const_iterator rhs, base::const_iterator lhs) {
  return real_itr_cast(rhs.itr) != real_itr_cast(lhs.itr);
}

#undef real_itr_cast

#ifdef undef_value_func
#  undef undef_value_func
#  undef value_func
#endif
