
#include <string>
#include <pair>

class aspell;

class replacement_list {
private:
  class Internal;
  Internal *internal;
  aspell   *spell_checker_;
  string    file_name;
public:
  class const_iterator {
    typedef pair<string, string> value_type;
    const value_type &operator* () const;
    const_iterator& operator++();
    const_iterator& operator++(int);
    friend bool operator==(const const_iterator&, const const_iterator&);
  }
  typedef const_iterator iterator;

  typedef string       key_type;
  typedef string       data_type;
  typedef unsigned int size_type;

  replacement_list();
  replacement_list(aspell*, const string &fn="");
  ~replacement_list();
  
  pair<const_iterator,const_iterator> equal_range(const key_type&) const;
  bool insert(const key_type&, const data_type&);
  size_type count(const key_type&) const;
  size_type size() const;
}
