
#include "aspell-c.h"
#include "aspell.hh"

aspell * aspell_new(const char *master, const char *personal) {
  return new aspell(master,personal);
}

void aspell_free(aspell *sc) {
  delete sc;
}

const aspellError * aspell_error(aspell *sc) {
  return &sc->error();
}

const char * aspell_lang_name(aspell *sc) {
  return sc->lang_name();
}

aspellSuggestions * aspell_suggest(aspell *sc, const char *word) {
  aspellSuggestions * sug = new aspellSuggestions;
  aspell::Suggestions * sug_o =  new aspell::Suggestions;
  *sug_o = sc->suggest(word);
  sug->internal_obj = sug_o;
  sug->size = sug_o->size();
  sug->data = new aspellString[sug->size];
  for (size_t i = 0; i != sug->size; ++i) {
    sug->data[i] = (*sug_o)[i].c_str();
  }
  return sug;
}
 
int aspell_check(aspell *sc, const char *word) {
  return sc->check(word);
}
 
int aspell_check_raw(aspell *sc, const char *word) {
  return sc->check_raw(word);
}
 
void aspell_add_personal(aspell *sc, const char *word) {
  sc->add_personal(word);
}
 
void aspell_add_session(aspell *sc, const char *word) {
  sc->add_session(word);
}

void aspell_save_dicts(aspell *sc) {
  sc->save_dicts();
}

void aspell_clear_session(aspell *sc) {
  sc->clear_session();
}

void aspell_change_personal(aspell *sc, const char *base) {
  sc->personal_dict().load(base);
}

aspellWordList * get_personal(aspell *sc);
aspellWordList * get_session(aspell *sc);
  
void aspell_free_suggestions(aspellSuggestions *wl) {
  delete reinterpret_cast<aspell::Suggestions *>(wl->internal_obj);
  delete wl->data;
  delete wl;
}

void aspell_free_word_list(aspellWordList *wl) {}

const char *  aspell_error_file(const aspellError *error) {
  return error->file.c_str();
}

const char *  aspell_error_addinfo(const aspellError *error) {
  return error->add_info.c_str();
}

aspellProblem aspell_error_problem(const aspellError *error) {
  return static_cast<aspellProblem>(static_cast<int>(error->problem));
}
 
const char *  aspell_error_message(aspellError *error) {
  return "";
}
