#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global cddaLocation; 
global endsector; 
global endtime; 
global endtrack; 
global filename; 
global method; 
global numOfTracks; 
global outputdir; 
global seenHelp; 
global startsector; 
global starttime; 
global starttrack; 
global status_var; 
global widget; 
    set widget(helpwindow) {.top45}
    set widget(rev,.top45) {helpwindow}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc RiptheCD {} {
global status_var trackList numOfTracks
global cddaLocation outputdir method filename
global starttrack endtrack starttime endtime
global startsector endsector

switch -exact $method {

"Time"            { set options "$starttrack\[$starttime\]-$endtrack\[$endtime\]"
                  }

"Sectors"         { set options "$starttrack\[$starttime.$startsector\]-$endtrack\[$endtime.$endsector\]"
                  }

"Tracks 2 1-file" { set options "$starttrack-$endtrack"
                  }

}


if { $method == "Tracks" } {

  set index 0
  while { $index < $numOfTracks } {
     set options "$trackList($index)-$trackList($index)"
     if { [ catch { exec $cddaLocation/cdparanoia -w $options $outputdir/$filename$index.wav 2> /var/tmp/cdrip.txt} ] == 0 } {
        set status_var "Ripping ended successfully"
     } else {
       set status_var "An error occured during ripping !!!"
       Window hide .top19
       return
     }
     set index [ expr $index + 1 ]
  }


} else {

   if { [ catch { exec $cddaLocation/cdparanoia -w $options $outputdir/$filename 2> /var/tmp/cdrip.txt} ] == 0 } {

       set status_var "Ripping ended successfully"
   } else {
       set status_var "Ripping did not end successfully!"
   }


}

Window hide .top19
return
}

proc SelectTracks {} {
global cddaLocation status_var

Window show .top18
.top18.cpd20.01 delete 0 end

# Read info from cd
if { [ catch { exec $cddaLocation/cdparanoia -Q 2> /var/tmp/cdinfo.txt } ] == 0 } {

     if [ catch { open /var/tmp/cdinfo.txt r } fileId ] {
        puts stdout "Error opening infofile:$fileId"
        return
     } else {

        set string [ gets $fileId ]
        set first [ string first "=" $string ]
        while { $first == -1 } {
           set string [ gets $fileId ]
           set first [ string first "=" $string ]
        }    

        while { ![eof $fileId] } {
           set string [ gets $fileId ]
           set first [ string first ":" $string ]
           if { $first != -1 } {
              .top18.cpd20.01 insert end $string
           }

        }
     }

     close $fileId

} else {

   Window hide .top18
   set status_var "Error reading cdrom! Is an audio cd inserted?"

}


return
}

proc SetTrackList {} {
global trackList numOfTracks

set list [ .top18.cpd20.01 curselection ]
set numOfTracks [ llength $list ]

set index 0
while { $index < $numOfTracks } {

   set idx [ lindex $list $index ]
   set string [ .top18.cpd20.01 get $idx $idx ]

   set number [ string range $string 1 3 ]
   set number [ expr $number + 0 ]

   set trackList($index) $number
   set index [ expr $index + 1 ]
}

Window hide .top18
return
}

proc ShowHelp {} {
global cddaLocation status_var seenHelp


if { $seenHelp == 0 } {

if [ catch { open $cddaLocation/cdriphelp.hlp r } fileId ] {
  set status_var "Error opening helpfile:$fileId"
  Window hide .top45
  return

} else {

  set string [ gets $fileId ]

  while { ![eof $fileId] } {

   .top45.cpd47.03 insert end "$string\n"
   set string [ gets $fileId ]
  .top45.cpd47.03 delete 1.0 1.end

  }
}

close $fileId
set seenHelp 1

}

return
}

proc StartTheRip {} {
global status_var trackList numOfTracks
global cddaLocation outputdir method filename
global starttrack endtrack starttime endtime
global startsector endsector ripmessage

Window show .top19

set ripmessage ""

switch -exact $method {

"Tracks"          { set ripmessage "Tracks ripping selected. $numOfTracks tracks will be ripped into multiple files. This will take some time when you press the start-button!"
                  }
"Time"            { set ripmessage "Time ripping selected. Ripping from track $starttrack at time $starttime to track $endtrack at $endtime.  This will take some time when you press the start-button!"
                  }

"Sectors"         { set ripmessage "Sector ripping selected. Ripping from track $starttrack at time $starttime and sector $startsector until track $endtrack at time $endtime and sector $endsector.  This will take some time when you press the start-button!"
                  }

"Tracks 2 1-file" { set ripmessage "Tracks 2 1-file selected. $numOfTracks tracks will be ripped into one file.  This will take some time when you press the start-button!"
                  }

}


return
}

proc main {argc argv} {
global method starttrack endtrack filename outputdir starttime endtime
global startsector endsector status_var seenHelp
global cddaLocation bindir wavloc configfile
global trackList numOfTracks

# Init

set bindir "/usr/local/mp3studio"
set wavloc "/"
set configfile "~/.mp3studiorc"

LoadPrefs

set cddaLocation $bindir
set outputdir $wavloc

set seenHelp 0
set method "Tracks"
set starttrack 1
set endtrack 1
set filename "track"
set starttime "00:00:00"
set endtime "00:00:00"
set startsector "00"
set endsector "00"

set status_var "Waiting for your command"

set numOfTracks 0
}

proc LoadPrefs {} {
global configfile mp3loc wavloc bindir

if [ catch { open $configfile r } fileId ] {
  # Check if file exists
  if { [ file exists $configfile ] == 0 } {
     SavePrefs
     return
  } else {
    puts stdout "Error opening configfile!"
    return
  }

} else {

  set mp3loc [ gets $fileId ]
  set playloc [ gets $fileId ]
  set wavloc [ gets $fileId ]
  set newloc [ gets $fileId ]
  set samplecommand [ gets $fileId ]
  set mixercommand [ gets $fileId ]
  set devtape [ gets $fileId ]
  set bindir [ gets $fileId ]

}

close $fileId
return
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 
    wm focusmodel $base passive
    wm geometry $base 419x349+121+292
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "CD-Contents"
    frame $base.cpd20  -background #323232 -borderwidth 1 -height 30  -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd20.01  -background #323232  -font -adobe-courier-bold-r-normal-*-*-100-*-*-m-*-iso8859-*  -foreground #d47639 -height 0 -highlightbackground Black  -selectbackground #d6a400 -selectmode extended  -xscrollcommand {.top18.cpd20.02 set}  -yscrollcommand {.top18.cpd20.03 set} 
    scrollbar $base.cpd20.02  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top18.cpd20.01 xview} -highlightbackground Black  -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd20.03  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top18.cpd20.01 yview} -highlightbackground Black  -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    button $base.but22  -activebackground #921016 -activeforeground White -background #323232  -command {global trackList numOfTracks
set numOfTracks 0}  -disabledforeground Black  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text Cancel 
    button $base.but23  -activebackground #921016 -activeforeground White -background #323232  -command SetTrackList -disabledforeground Black  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text OK 
    message $base.mes31  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised -text CD-contents 
    message $base.mes49  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2  -text {Select all tracks to be ripped} 
    message $base.mes95  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Track 
    message $base.mes96  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text {Length sectors/time} 
    message $base.mes97  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text {Start sector/time} 
    message $base.mes98  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Copy 
    message $base.mes99  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Pre 
    message $base.mes100  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Ch 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd20  -x 9 -y 92 -width 396 -height 218 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd20 0 -weight 1
    grid rowconf $base.cpd20 0 -weight 1
    grid $base.cpd20.01  -in .top18.cpd20 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd20.02  -in .top18.cpd20 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd20.03  -in .top18.cpd20 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but22  -x 195 -y 316 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but23  -x 303 -y 316 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.mes31  -x 5 -y 5 -width 409 -height 36 -anchor nw -bordermode ignore 
    place $base.mes49  -x 6 -y 48 -width 193 -height 16 -anchor nw -bordermode ignore 
    place $base.mes95  -x 5 -y 75 -width 44 -height 16 -anchor nw -bordermode ignore 
    place $base.mes96  -x 51 -y 75 -width 118 -height 16 -anchor nw -bordermode ignore 
    place $base.mes97  -x 173 -y 75 -width 107 -height 16 -anchor nw -bordermode ignore 
    place $base.mes98  -x 282 -y 75 -width 34 -height 16 -anchor nw -bordermode ignore 
    place $base.mes99  -x 319 -y 75 -width 34 -height 16 -anchor nw -bordermode ignore 
    place $base.mes100  -x 350 -y 75 -width 21 -height 16 -anchor nw -bordermode ignore
}

proc vTclWindow.top19 {base} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 433x217+114+309
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Confirm selection"
    message $base.mes20  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised  -text {Confirm selection} 
    message $base.mes21  -aspect 500 -background #303030 -foreground #d6a400 -justify center  -padx 5 -pady 2 -relief groove -text message -textvariable ripmessage 
    button $base.but23  -activebackground #921016 -activeforeground White -background #323232  -command RiptheCD -disabledforeground Black  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text {Settings OK, start ripping} 
    button $base.but24  -activebackground #921016 -activeforeground White -background #323232  -command {Window hide .top19} -disabledforeground Black  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text {Change settings} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes20  -x 40 -y 9 -width 343 -height 36 -anchor nw -bordermode ignore 
    place $base.mes21  -x 45 -y 55 -width 333 -height 91 -anchor nw -bordermode ignore 
    place $base.but23  -x 177 -y 150 -width 194 -height 26 -anchor nw -bordermode ignore 
    place $base.but24  -x 51 -y 151 -width 121 -height 26 -anchor nw -bordermode ignore
}

proc vTclWindow.top28 {base} {
    if {$base == ""} {
        set base .top28
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 464x296+8+145
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "MP3-Studio CD-Ripper"
    message $base.mes32 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3-Studio CD-Ripper} 
    button $base.but42 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var method

set command "StartTheRip"
$command} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Start 
    button $base.but43 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command exit -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Exit 
    frame $base.fra50 \
        -background #323232 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    message $base.fra50.mes53 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge \
        -text {Starting sector} 
    message $base.fra50.mes56 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge \
        -text {Starting track} 
    entry $base.fra50.ent57 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable endtrack 
    message $base.fra50.mes60 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge -text Method 
    menubutton $base.fra50.men61 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #505050 \
        -highlightcolor White -padx 4 -pady 3 \
        -relief ridge -text Tracks -textvariable method 
    menu $base.fra50.men61.01 \
        -cursor {} -tearoff 0 
    $base.fra50.men61.01 add command \
        -command {global method
set method "Tracks"} -label Tracks 
    $base.fra50.men61.01 add command \
        -command {global method
set method "Time"} -label Time 
    $base.fra50.men61.01 add command \
        -command {global method
set method "Sectors"} -label Sectors 
    $base.fra50.men61.01 add command \
        -command {global method
set method "Tracks 2 1-file"} \
        -label {Tracks 2 1-file} 
    message $base.fra50.mes67 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge -text Tracks 
    message $base.fra50.mes68 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge \
        -text {Ending sector} 
    message $base.fra50.mes70 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief raised \
        -text {Ripping options} 
    message $base.fra50.mes71 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge \
        -text {Ending track} 
    entry $base.fra50.ent72 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable starttrack 
    button $base.fra50.but73 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command SelectTracks \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 -padx 9 -pady 3 \
        -relief ridge -text {<click to select>} 
    message $base.fra50.mes85 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge -text Filename 
    message $base.fra50.mes86 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge -text {Output dir} 
    entry $base.fra50.ent87 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable startsector 
    entry $base.fra50.ent88 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable endsector 
    entry $base.fra50.ent90 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable filename 
    message $base.fra50.mes91 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge \
        -text {Starting time} 
    message $base.fra50.mes92 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief ridge -text {Ending time} 
    entry $base.fra50.ent93 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable starttime 
    entry $base.fra50.ent94 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable endtime 
    entry $base.fra50.ent28 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 \
        -insertbackground Red -justify center -relief ridge \
        -selectbackground #323232 -textvariable outputdir 
    button $base.but55 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window show $widget(helpwindow)
ShowHelp} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Help 
    frame $base.fra79 \
        -background #323232 -borderwidth 2 -height 75 \
        -highlightbackground #323232 -relief groove -width 125 
    message $base.fra79.mes81 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -relief raised -text Status 
    message $base.fra79.mes82 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -text {Waiting for your command} \
        -textvariable status_var 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes32 \
        -x 5 -y 5 -width 454 -height 36 -anchor nw -bordermode ignore 
    place $base.but42 \
        -x 345 -y 264 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but43 \
        -x 240 -y 264 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.fra50 \
        -x 10 -y 45 -width 440 -height 160 -anchor nw -bordermode ignore 
    place $base.fra50.mes53 \
        -x 225 -y 100 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes56 \
        -x 11 -y 54 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.ent57 \
        -x 114 -y 76 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.mes60 \
        -x 11 -y 31 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.men61 \
        -x 115 -y 31 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes67 \
        -x 225 -y 31 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes68 \
        -x 225 -y 124 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes70 \
        -x 6 -y 5 -width 429 -height 21 -anchor nw -bordermode ignore 
    place $base.fra50.mes71 \
        -x 11 -y 77 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.ent72 \
        -x 114 -y 53 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.but73 \
        -x 328 -y 30 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.mes85 \
        -x 11 -y 100 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes86 \
        -x 11 -y 124 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.ent87 \
        -x 328 -y 99 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.ent88 \
        -x 328 -y 123 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.ent90 \
        -x 114 -y 99 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.mes91 \
        -x 225 -y 54 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.mes92 \
        -x 225 -y 75 -width 100 -height 20 -anchor nw -bordermode ignore 
    place $base.fra50.ent93 \
        -x 328 -y 53 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.ent94 \
        -x 328 -y 76 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.fra50.ent28 \
        -x 114 -y 123 -width 102 -height 22 -anchor nw -bordermode ignore 
    place $base.but55 \
        -x 15 -y 263 -width 99 -height 26 -anchor nw -bordermode ignore 
    place $base.fra79 \
        -x 10 -y 205 -width 440 -height 55 -anchor nw -bordermode ignore 
    place $base.fra79.mes81 \
        -x 6 -y 5 -width 429 -height 21 -anchor nw -bordermode ignore 
    place $base.fra79.mes82 \
        -x 6 -y 29 -width 429 -height 21 -anchor nw -bordermode ignore 
}

proc vTclWindow.top45 {base} {
    if {$base == ""} {
        set base .top45
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 
    wm focusmodel $base passive
    wm geometry $base 498x357+438+230
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Help Window Encoder"
    message $base.mes46  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised  -text {MP3-Studio Help Window} 
    frame $base.cpd47  -background #323232 -borderwidth 1 -height 30  -highlightbackground Black -relief raised -width 30 
    scrollbar $base.cpd47.01  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top45.cpd47.03 xview} -highlightbackground Black  -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd47.02  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top45.cpd47.03 yview} -highlightbackground Black  -orient vert -troughcolor #323232 -width 10 
    text $base.cpd47.03  -background #323232  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -foreground #d6a400 -height 1 -highlightbackground Black  -selectbackground #921016 -selectforeground White -width 8  -xscrollcommand {.top45.cpd47.01 set}  -yscrollcommand {.top45.cpd47.02 set} 
    button $base.but48  -activebackground #921016 -activeforeground White -background #323232  -command {Window hide $widget(helpwindow)} -disabledforeground Black  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text Close 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes46  -x 5 -y 5 -width 488 -height 36 -anchor nw -bordermode ignore 
    place $base.cpd47  -x 10 -y 45 -width 478 -height 276 -anchor nw 
    grid columnconf $base.cpd47 0 -weight 1
    grid rowconf $base.cpd47 0 -weight 1
    grid $base.cpd47.01  -in .top45.cpd47 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd47.02  -in .top45.cpd47 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd47.03  -in .top45.cpd47 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    place $base.but48  -x 379 -y 326 -width 100 -height 26 -anchor nw -bordermode ignore
}

Window show .
Window show .top28

main $argc $argv
