/*
  Crystal Space Windowing System: tool bar class
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "cstulbar.h"
#include "util/input/csevent.h"

csToolBar::csToolBar (csComponent *iParent, csDialogFrameStyle iFrameStyle) :
  csDialog (iParent, iFrameStyle)
{
  DragStyle = CS_DRAG_MOVEABLE;
}

bool csToolBar::HandleEvent (csEvent &Event)
{
  if (csDialog::HandleEvent (Event))
    return true;
  switch (Event.Type)
  {
    case csevMouseDown:
      if ((Event.Mouse.Button == 2)
       && bound.ContainsRel (Event.Mouse.x, Event.Mouse.y))
      {
        Select ();
        Drag (Event.Mouse.x, Event.Mouse.y, CS_DRAG_ALL);
        return true;
      } /* endif */
      break;
    case csevMouseMove:
      if (bound.ContainsRel (Event.Mouse.x, Event.Mouse.y))
        SetMouse (csmcMove);
      break;
  } /* endswitch */
  return false;
}
