/*
  Crystal Space Windowing System: tool bar class
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSTULBAR_H__
#define __CSTULBAR_H__

#include "csdialog.h"

/**
 * The ToolBar class is a subclass of csDialog which implements more tool-bar
 * specific functions. Note that csDialog itself also can act as a simple
 * unmovable (nailed) toolbar, for example windows with CSWS_TOOLBAR style
 * uses csDialog not csToolBar for their toolbar object.
 */
class csToolBar : public csDialog
{
public:
  /// Create tool bar object
  csToolBar (csComponent *iParent, csDialogFrameStyle iFrameStyle = csdfsNone);

  /// Handle input events
  virtual bool HandleEvent (csEvent &Event);
};

#endif // __CSTULBAR_H__
