/*
  Crystal Space Windowing System: auxiliary includes and definitions
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CSWSAUX_H__
#define __CSWSAUX_H__

#include "util/def.h"
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#if defined(OS_DOS) || defined(OS_WIN32)
#  include <conio.h>
#  include <io.h>
#endif
#if defined(OS_UNIX)
#  include <unistd.h>
#endif
#include <time.h>
#include <assert.h>

#include "version.h"
#include "general/command.h"
#include "scripts/intscri.h"
#include "engine/texture.h"
#include "engine/camera.h"
#include "engine/polygon/polygon.h"
#include "engine/sector.h"
#include "engine/world.h"
#include "engine/light/light.h"
#include "engine/light/dynlight.h"
#include "engine/light/lghtmap.h"
#include "engine/stats.h"
#include "util/inifile.h"
#include "util/parser.h"
#include "util/archive.h"
#include "util/util.h"
#include "render/graph3d.h"

#endif // __CSWSAUX_H__
