/*
  Crystal Space Windowing System: 2D sprites
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "system/system.h"
#include "engine/2d/csspr2d.h"
#include "render/igraph2d.h"
#include "render/igraph3d.h"
#include "engine/texture.h"

csSprite2D::csSprite2D (TextureMM *Tex, int x, int y, int w, int h)
{
  SprTex = Tex;
  SetTextureRectangle (x, y, w, h);
  hTex = NULL;
  
  if (SprTex != NULL)
	  Gfx2D->RegisterTexture (GetIMipMapContainerFromTextureMM(SprTex), hTex);
}

csSprite2D::~csSprite2D ()
{
  Gfx2D->DeregisterTexture (hTex);
}

void csSprite2D::Draw (int sx, int sy, int sw, int sh)
{
   if (hTex)
     Gfx2D->DrawSprite(hTex, sx, sy, sw, sh, tx, ty, tw, th);
}
