/*
    Copyright (C) 1998 by Jorrit Tyberghein
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <time.h>

#include "engine/basic/cscoll.h"
#include "engine/objects/thing.h"


Collection::Collection (char* name) : 
 csObjectTrigger (name, CS_COLLECTION), objects(8,8) {}

csObject* Collection::find_object (char* name)
{
  for (int i = 0 ; i < objects.Length() ; i++)
  {
    csObject* csobj = (csObject*)(objects[i]);
    if (!strcmp ( csobj->get_name (), name)) return csobj;
  }
  return NULL;
}

void Collection::transform ()
{
  for (int i = 0 ; i < objects.Length() ; i++)
    if ( ((csObject*)(objects[i]))->get_type () == CS_THING)
      ((Thing*)(objects[i]))->transform ();
}

void Collection::set_move (csSector* home, float x, float y, float z)
{
  for (int i = 0 ; i < objects.Length() ; i++)
    if ( ((csObject*)(objects[i]))->get_type () == CS_THING)
      ((Thing*)(objects[i]))->set_move (home, x, y, z);
}

void Collection::set_transform (Matrix3& matrix)
{
  for (int i = 0 ; i < objects.Length() ; i++)
    if ( ((csObject*)(objects[i]))->get_type () == CS_THING)
      ((Thing*)(objects[i]))->set_transform (matrix);
}

void Collection::move (float dx, float dy, float dz)
{
  for (int i = 0 ; i < objects.Length() ; i++)
    if ( ((csObject*)(objects[i]))->get_type () == CS_THING)
      ((Thing*)(objects[i]))->move (dx, dy, dz);
}

void Collection::transform (Matrix3& matrix)
{
  for (int i = 0 ; i < objects.Length() ; i++)
    if ( ((csObject*)(objects[i]))->get_type () == CS_THING)
      ((Thing*)(objects[i]))->transform (matrix);
}

//---------------------------------------------------------------------------
