/*
    Copyright (C) 1998 by Jorrit Tyberghein
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <time.h>

#include "engine/basic/csobject.h"
#include "scripts/trigger.h"

//---------------------------------------------------------------------------

CS_ID cur_id = 0;

CS_ID CSNewID ()
{
  return cur_id++;
}

void CSResetID ()
{
  cur_id = 0;
}

//---------------------------------------------------------------------------

csObject::csObject (char* name, int type)
{
  strcpy (csObject::name, name);
  csObject::type = type;
  id = CSNewID ();
  userdata = NULL;
}

//---------------------------------------------------------------------------

csObjectTrigger::csObjectTrigger (char* name, int type) : csObject (name, type)
{
  CHK (activate_triggers = new TriggerList ());
}

csObjectTrigger::~csObjectTrigger ()
{
  CHK (delete activate_triggers);
}

void csObjectTrigger::new_activate_trigger (csScript* script, csObject* ob)
{
  activate_triggers->add_trigger (script, ob);
}

void csObjectTrigger::do_activate_triggers ()
{
  activate_triggers->perform (this);
}

//---------------------------------------------------------------------------
