
#include "com/com.h"
#include "engine/itexture.h"
#include "engine/iworld.h"
#include "engine/world.h"
#include "engine/texture.h"

IMPLEMENT_COMPOSITE_UNKNOWN( csWorld, World )

IMPLEMENT_METHOD(Clear, clear, csWorld, World)
IMPLEMENT_METHOD(Initialize, initialize, csWorld, World)

STDMETHODIMP IWorld::GetTextures(ITextureContainer** ppRes)
{
    METHOD_PROLOGUE( csWorld, World )
	Textures* pTextures = pThis->get_textures();

	if (pTextures)
	{
		*ppRes = GetITextureContainerFromTextures( pTextures );
		(*ppRes)->AddRef();
	}
    
    return S_OK;
}

STDMETHODIMP IWorld::MipMapSettings(int nSettings)
{
    METHOD_PROLOGUE( csWorld, World )

    pThis->mipmap_settings(nSettings);
    return S_OK;
}




