
#include "com/com.h"

#ifndef __IWORLD_H__
#define __IWORLD_H__

interface ITextureContainer;

extern const IID IID_IWorld;

/**
 * Temporary interface for the world.
 * This has to be rewritten to be COMpatible
 * once we port the entire engine over.
 */
interface IWorld : public IUnknown
{
    /**
    * Initialize the world. This function needs to be called after the
    * texture system has been correctly initilialized.
    */
    STDMETHOD(Initialize)();

    STDMETHOD(Clear)();
    STDMETHOD(GetTextures)(ITextureContainer** ppRes);

    STDMETHOD(MipMapSettings)(int nSetting);

    DECLARE_IUNKNOWN()
};

#endif
