/*
    Copyright (C) 1998 by Jorrit Tyberghein
    Written by Dan Ogles

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "com/com.h"

extern CS_HLIBRARY csLoadLibrary (char *szLibName);
extern PROC csGetProcAddress (CS_HLIBRARY, char *);

int main (int argc, char *argv[])
{
	HRESULT hRes;
	PROC pfnDllRegisterServer = NULL;
	int i;

	if (argc < 1)
	{
		printf ("Usage : %s <DLL Name> [DLL Name]*\n", argv[0]);
		exit (1);
	}

	for( i=1 ; i < argc ; i++) {
		printf ("%s.......",argv[i]);
		CS_HLIBRARY hLib = csLoadLibrary (argv[i]);

		if (!hLib)
		{
			printf ("Couldn't open library!\n");
			continue;
		}

		pfnDllRegisterServer = csGetProcAddress (hLib, "DllRegisterServer");
		if (!pfnDllRegisterServer)
		{
			printf ("Unable to find DllRegisterServer.\n");
			continue;
		}

		hRes = pfnDllRegisterServer ();
		if (FAILED (hRes))
		{
			printf ("DllRegisterServer failed.\n");
			continue;
		}

		printf ("DllRegisterServer succeeded.\n");
	}
	return 0;
}
