/*
    Copyright (C) 1998 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef DUMPER_H
#define DUMPER_H

class Matrix3;
class Vector3;
class Vector2;
class Plane;
class Box;
class csCamera;
class PolyPlane;
class Polygon2D;
class Polygon3D;
class PolygonSet;
class PolyTexture;
class csSector;
class csWorld;
class csSpriteTemplate;
class csSprite3D;

/**
 * This class knows how to dump debug information about several
 * other classes. It is put here in order to minimize dependencies.
 * Other classes only need to make this class a friend if it has
 * to access private or protected stuff.
 */
class Dumper
{
public:
  static void dump (Matrix3* m, char* name);
  static void dump (Vector3* v, char* name);
  static void dump (Vector2* v, char* name);
  static void dump (Plane* p);
  static void dump (Box* b);
  static void dump (csCamera* c);
  static void dump (PolyPlane* p);
  static void dump (Polygon2D* p, char* name);
  static void dump (Polygon3D* p);
  static void dump (PolygonSet* p);
  static void dump (PolyTexture* p, char* name);
  static void dump (csSector* s);
  static void dump (csWorld* w);
  static void dump (csSpriteTemplate* s);
  static void dump (csSprite3D* s);
};

#endif
