/*
  Maze editor: 3D visualizer class
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "me_3d.h"

// mzDraftEditor class palette
static int palette_mzCameraView[] =
{
  cs_Color_Black			// background
};

#define CSPAL_3DVIEW_BACKGROUND	0

mz3DWindow::mz3DWindow (csComponent *iParent, char *iTitle) :
  csWindow (iParent, iTitle, 0)
{
}

mzCameraView::mzCameraView (csComponent *iParent) : csComponent (iParent)
{
  SetPalette (palette_mzCameraView, sizeof (mzCameraView) / sizeof (int));
  state |= CSS_SELECTABLE;
  if (parent)
    parent->SendCommand (cscmdWindowSetClient, (void *)this);
}

void mzCameraView::Draw ()
{
  Box (0, 0, bound.Width (), bound.Height (), CSPAL_3DVIEW_BACKGROUND);
  csComponent::Draw ();
}

bool mzCameraView::HandleEvent (csEvent &Event)
{
  switch (Event.Type)
  {
    case csevMouseDown:
      break;
  } /* endswitch */
  return csComponent::HandleEvent (Event);
}
