/*
    Copyright (C) 1998 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "util/def.h"
#include "general/walktest/bot.h"
#include "engine/sector.h"

Bot::Bot (csSpriteTemplate* tmpl, char* name) : csSprite3D (name)
{
  set_template (tmpl);
  d.x = 0; d.y = 0; d.z = -4;
}

Bot::~Bot ()
{
}

void Bot::move (long elapsed_time)
{
  OrthoTransform old_pos (m_world2this (), v_world2this ());
  Vector3 rd = ((float)elapsed_time)/1000. * d;
  csSprite3D::move (rd.x, rd.y, rd.z);
  Vector3 new_pos = v_world2this ();
  csSector* s = get_mso ().get_first_sector ();
  bool mirror = false;
  Vector3 v_old_pos = new_pos;
  s = s->follow_segment (old_pos, new_pos, mirror);
  if (ABS (v_old_pos.x-new_pos.x) < SMALL_EPSILON &&
      ABS (v_old_pos.y-new_pos.y) < SMALL_EPSILON &&
      ABS (v_old_pos.z-new_pos.z) < SMALL_EPSILON)
  {
    if (s != get_mso ().get_first_sector ())
    {
      get_mso ().init_one_sector (s);
    }
  }
  else
  {
    csSprite3D::move (-rd.x, -rd.y, -rd.z);
    //d = -d;
    d.x = 5*(((float)rand ()) / (float)RAND_MAX);
    d.y = 5*(((float)rand ()) / (float)RAND_MAX);
    d.z = 5*(((float)rand ()) / (float)RAND_MAX);
  }
}

