# This is a subinclude file used to define the rules needed
# to build the BeOS 2D driver -- belib2d

#-------------------------------------------------------------- rootdefines ---#
ifeq ($(MAKESECTION),rootdefines)

# System-dependent help commands
define SYSHELP
	@echo "  make lib2d       Make the BeLib 2D driver"
endef

endif # ifeq ($(MAKESECTION),rootdefines)

#-------------------------------------------------------------- roottargets ---#
ifeq ($(MAKESECTION),roottargets)

.PHONY: lib2d

lib2d:
	@echo "+==================================================================="
	@echo "| Compiling BeLib 2D driver for OS=$(OS), compiler=$(COMP) and processor=$(PROC)."
	@echo "| Compiling in $(OPT) mode."
	@echo "| Don't forget to register this library with csregsvr!"
	@echo "+==================================================================="
	$(MAKE) -f mk/cs.mak MAKE_DLL=yes lib2d

endif # ifeq ($(MAKESECTION),roottargets)

#-------------------------------------------------------------- postdefines ---#
ifeq ($(MAKESECTION),postdefines)

# The 2D Belib driver
ifeq ($(USE_DLL),yes)
  LIB2D=$(DLL_DIR)xlib2d$(DLL)
else
  LIB2D=libx2d.a
endif
SRC_LIB2D = $(wildcard system/be/driver2d/*.cpp \
	system/fonts.cpp render/graph2d.cpp render/igraph2d.cpp \
	com/guids.cpp com/cscom.cpp com/inttable.cpp \
	engine/basic/csrect.cpp $(SYS_SRC_DLL))
LIB2D_OBJ = $(addprefix $(OUT),$(SRC_LIB2D:.cpp=.o))

endif # ifeq ($(MAKESECTION),postdefines)

#------------------------------------------------------------------ targets ---#
ifeq ($(MAKESECTION),targets)

.PHONY: lib2d stat_lib2d libclean libcleanlib libdepend

# Chain rules
all: lib2d
clean: libclean
cleanlib: libcleanlib
depend: libdepend

lib2d: $(OUTDIRS) $(LIB2D)

$(LIB2D) : $(LIB2D_OBJ)
ifeq ($(MAKE_DLL),no)
	ar -r $@ $^
else
	$(LINK) -o $@ $^ $(LFLAGS) $(LIB_PATH) $(LIBS)
endif

libclean:
	$(RM) $(LIB2D)

libcleanlib:
	$(RM) $(LIB2D_OBJ) $(LIB2D)

libdepend:
	$(CC) -MM $(CFLAGS) $(INC_PATH) $(SRC_LIB2D) | sed $(SED_DEPEND) >$(OUTOS)lib2d.dep

-include $(OUT)lib2d.dep

endif # ifeq ($(MAKESECTION),targets)
