# This is a subinclude file used to define the rules needed
# to build the GGI 2D driver -- ggi2d

#-------------------------------------------------------------- rootdefines ---#
ifeq ($(MAKESECTION),rootdefines)

# System-dependent help commands
define SYSHELP
	@echo "  make ggi2d        Make the GGI 2D driver"
endef

endif # ifeq ($(MAKESECTION),rootdefines)

#-------------------------------------------------------------- roottargets ---#
ifeq ($(MAKESECTION),roottargets)

.PHONY: ggi2d

ggi2d:
	@echo "+==================================================================="
	@echo "| Compiling GGI 2D driver for OS=$(OS), compiler=$(COMP) and processor=$(PROC)."
	@echo "| Compiling in $(OPT) mode."
	@echo "| Don't forget to register this library with csregsvr!"
	@echo "+==================================================================="
	$(MAKE) -f mk/cs.mak MAKE_DLL=yes ggi2d

endif # ifeq ($(MAKESECTION),roottargets)

#-------------------------------------------------------------- postdefines ---#
ifeq ($(MAKESECTION),postdefines)

# The GGI 2D driver
ifeq ($(USE_DLL),yes)
  GGI2D=csggi2d$(DLL)
else
  GGI2D=$(OUT)libcsggi2d.a
endif
SRC_GGI2D = $(wildcard system/libggi/driver2d/*.cpp \
	system/fonts.cpp render/graph2d.cpp render/igraph2d.cpp \
	com/guids.cpp com/cscom.cpp com/inttable.cpp \
	geometry/csrect.cpp $(SYS_SRC_DLL))
GGI2D_OBJ = $(addprefix $(OUT),$(SRC_GGI2D:.cpp=.o))

endif # ifeq ($(MAKESECTION),postdefines)

#------------------------------------------------------------------ targets ---#
ifeq ($(MAKESECTION),targets)

.PHONY: ggi2d ggiclean ggicleanlib ggidepend

# Chain rules
all: ggi2d
clean: ggiclean
cleanlib: ggicleanlib
depend: ggidepend

ggi2d: $(OUTDIRS) $(GGI2D)

$(GGI2D): $(GGI2D_OBJ)
ifeq ($(MAKE_DLL),no)
	ar -r $@ $^
else
	$(LINK) -o $@ $^ $(LFLAGS) $(LIB_PATH) $(LIBS)
endif

ggiclean:
	$(RM) $(GGI2D)

ggicleanlib:
	$(RM) $(GGI2D_OBJ) $(GGI2D)

ggidepend:
	$(CC) -MM $(CFLAGS) $(INC_PATH) $(SRC_GGI2D) | sed $(SED_DEPEND) >$(OUTOS)ggi2d.dep

-include $(OUT)ggi2d.dep

endif # ifeq ($(MAKESECTION),targets)
