# This is a subinclude file used to define the rules needed
# to build the X-windows 2D driver -- xlib2d

#-------------------------------------------------------------- rootdefines ---#
ifeq ($(MAKESECTION),rootdefines)

# System-dependent help commands
define SYSHELP
	@echo "  make xlib2d       Make the XLib 2D driver"
endef

endif # ifeq ($(MAKESECTION),rootdefines)

#-------------------------------------------------------------- roottargets ---#
ifeq ($(MAKESECTION),roottargets)

.PHONY: xlib2d

xlib2d:
	@echo "+==================================================================="
	@echo "| Compiling XLib 2D driver for OS=$(OS), compiler=$(COMP) and processor=$(PROC)."
	@echo "| Compiling in $(OPT) mode."
	@echo "| Don't forget to register this library with csregsvr!"
	@echo "+==================================================================="
	$(MAKE) -f mk/cs.mak MAKE_DLL=yes xlib2d

endif # ifeq ($(MAKESECTION),roottargets)

#-------------------------------------------------------------- postdefines ---#
ifeq ($(MAKESECTION),postdefines)

# The 2D Xlib driver
ifeq ($(USE_DLL),yes)
  XLIB2D=xlib2d$(DLL)
else
  XLIB2D=$(OUT)libx2d.a
endif
SRC_XLIB2D = $(wildcard system/xlib/driver2d/*.cpp \
	system/fonts.cpp render/graph2d.cpp render/igraph2d.cpp \
	com/guids.cpp com/cscom.cpp com/inttable.cpp \
	geometry/csrect.cpp $(SYS_SRC_DLL))
XLIB2D_OBJ = $(addprefix $(OUT),$(SRC_XLIB2D:.cpp=.o))

endif # ifeq ($(MAKESECTION),postdefines)

#------------------------------------------------------------------ targets ---#
ifeq ($(MAKESECTION),targets)

.PHONY: xlib2d xlibclean xlibcleanlib xlibdepend

# Chain rules
all: xlib2d
clean: xlibclean
cleanlib: xlibcleanlib
depend: xlibdepend

xlib2d: $(OUTDIRS) $(XLIB2D)

$(XLIB2D): $(XLIB2D_OBJ)
ifeq ($(MAKE_DLL),no)
	ar -r $@ $^
else
	$(LINK) -o $@ $^ $(LFLAGS) $(LIB_PATH) $(LIBS)
endif

xlibclean:
	$(RM) $(XLIB2D)

xlibcleanlib:
	$(RM) $(XLIB2D_OBJ) $(XLIB2D)

xlibdepend:
	$(CC) -MM $(CFLAGS) $(INC_PATH) $(SRC_XLIB2D) | sed $(SED_DEPEND) >$(OUTOS)xlib2d.dep

-include $(OUT)xlib2d.dep

endif # ifeq ($(MAKESECTION),targets)
