#include <stdlib.h>
#include "com/com.h"
#include "render/glide/driver2d/g2dglide.h"

static unsigned int gb_cRef = 0;

extern const CLSID CLSID_Graphics2DGlide;

// Implementation of the csGraphics2DWin32 factory... ///////////

IMPLEMENT_UNKNOWN_NODELETE( csGraphics2DGlideFactory )

BEGIN_INTERFACE_TABLE( csGraphics2DGlideFactory )
	IMPLEMENTS_INTERFACE( IGraphics2DFactory )
        IMPLEMENTS_INTERFACE( IGraphics2DGlideFactory )
END_INTERFACE_TABLE()

STDMETHODIMP csGraphics2DGlideFactory::CreateInstance(REFIID riid, ISystem* piSystem, void**ppv)
{
	if (!piSystem)
	{
		*ppv = 0;
		return E_INVALIDARG;
	}

	csGraphics2DGlide* pNew = new csGraphics2DGlide(piSystem);
	if (!pNew)
	{
		*ppv = 0;
		return E_OUTOFMEMORY;
	}
		
	return pNew->QueryInterface(riid, ppv);
}

STDMETHODIMP csGraphics2DGlideFactory::LockServer(BOOL bLock)
{
	if (bLock)
		gb_cRef++;
	else
		gb_cRef--;

	return S_OK;
}
