/*
    Copyright (C) 1998 by Jorrit Tyberghein and Dan Ogles
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

// g2d_glide.h
// Graphics2DGlide Class Declaration
// Written by xtrochu and Nathaniel

#ifndef G2D_GLIDE_H
#define G2D_GLIDE_H

#if defined(DO_GLIDE)
#include <glide.h>
 
#if (defined(OS_WIN32) || (defined(OS_DOS) && defined(COMP_WCC)) || defined(OS_LINUX))
/// Windows version. 
class Graphics2DGlide : public csGraphics2D
{
  friend class csGraphics3D;
  friend class Graphics2DGlide;
  
public:
  Graphics2DGlide(int argc, char* argv[]);
  virtual ~Graphics2DGlide(void);
  
  virtual bool Open (char *Title);
  virtual void Close ();
  
  virtual void Print (csRect *area = NULL);
  
  virtual void SetRGB(int i, int r, int g, int b);
 
  virtual bool BeginDraw(/*int Flag = (CSDRAW_2DGRAPHICS | CSDRAW_2DGRAPHICS_WRITE)*/);
  virtual void FinishDraw();
#if defined(OS_WIN32)
  virtual HWND GethWnd() {return hwnd;};
#endif
  int GraphicsReady;
  static int Depth;
  
protected:
#if defined(OS_WIN32)
  HWND hwnd;
#endif
  bool bPalettized;
  bool bPaletteChanged;
  int glDrawMode;
  GrLfbInfo_t lfbInfo;
};

#endif // DO_GLIDE
#endif // OS_...S
#endif // G3D_GLIDE_H

