#if !defined(HICACHEANDMANAGE_H_INCLUDED)

#include "render/hicache.h"
#include "render/texmem.h"

///
struct HighColorCacheAndManage_Data : public HighColorCache_Data
{
  /// texture memory position
  textMemSpace mempos;
};

///
class HighColorCacheAndManage : public HighColorCache
{
public:
  /// takes the maximum size of the cache
  HighColorCacheAndManage(int max_size, HIGHCOLOR_TYPE type, int bpp,TextureMemoryManager * tm);
  ///
  virtual ~HighColorCacheAndManage();

  ///
  virtual void Add(IPolygonTexture *polytex);
  ///
  virtual void Add(IMipMapContainer *texture);

  ///
  virtual void Clear();

  ///
  virtual void Dump() = 0;

protected:
	TextureMemoryManager * manager;
  ///
  virtual void Load(HighColorCacheAndManage_Data *d) = 0;
  ///
  virtual void Unload(HighColorCacheAndManage_Data *d) = 0;
  ///
  virtual void Load(HighColorCache_Data *d) {
	  Load((HighColorCacheAndManage_Data *)d);
  }
  ///
  virtual void Unload(HighColorCache_Data *d) {
	  Unload((HighColorCacheAndManage_Data *)d);
  }
};

#define HICACHEANDMANAGE_H_INCLUDED
#endif // !HICACHEANDMANAGE_H_INCLUDED
