/*
    Copyright (C) 1998 by Jorrit Tyberghein
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef CSBE_H
#define CSBE_H

#include "com/com.h"
#include "util/def.h"
#include "render/igraph2d.h"
#include "util/input/csinput.h"
#include "system/system.h"
#include "system/be/beitf.h"

/// BeLIB version.
class SysSystemDriver : public csSystemDriver
{
public:
  SysSystemDriver ();

  virtual void Loop ();
  virtual void SetSystemDefaults ();

  virtual bool perform_extension (char* cmd, char* arg = NULL);
  long LoopThread(void *data);

  /// Implementation of IBeLibSystemDriver
  class XBeLibSystemDriver : public IBeLibSystemDriver
  {
    DECLARE_IUNKNOWN()
  };
  friend class XBeLibSystemDriver;

  ///
  XBeLibSystemDriver m_xBeLibSystemDriver;

  // COM stuff
  DECLARE_IUNKNOWN()
  DECLARE_INTERFACE_TABLE(SysSystemDriver)
};

/// BeLIB version.
class SysKeyboardDriver : public csKeyboardDriver
{
  friend class csSystemDriver;
public:
  SysKeyboardDriver();

  virtual bool Open (csEventQueue *EvQueue);
  virtual void Close ();
};

/// BeLIB version.
class SysMouseDriver : public csMouseDriver
{
  friend class csSystemDriver;
public:
  SysMouseDriver ();

  virtual bool Open (csEventQueue *EvQueue);
  virtual void Close ();
};

#endif // CSBE_H
