
#ifdef NO_COM_SUPPORT

#include <stdio.h>
#include <stdlib.h>
#include "com/com.h"

#include <kernel/image.h>

struct LibraryList
{
  CS_HLIBRARY hLib;
  LibraryList* pNext;
};

LibraryList* gb_pLibHead = NULL;

CS_HLIBRARY csLoadLibrary( char* szLibName )
{
  LibraryList* pItem;
  image_id addon_image;
  HRESULT (*DllInitialize) ();

  addon_image = load_add_on(szLibName);

  if (addon_image > 0)
  {
//  printf("add on loaded with id=%lx, searching for DllInitialize\n",addon_image);
    DllInitialize = (HRESULT (*) ())csGetProcAddress (addon_image, "DllInitialize");
    if (!DllInitialize)
    {
      printf("Unable to find DllInitialize in %s.\n", szLibName);
      return 0;
    }
    DllInitialize ();

    pItem = new LibraryList;
    pItem->pNext = gb_pLibHead;
    pItem->hLib = addon_image;
    gb_pLibHead = pItem;
  }
  else
    printf ("Error opening library '%s'!\n", szLibName);

  return (CS_HLIBRARY)addon_image;
}

PROC csGetProcAddress( CS_HLIBRARY hLib, char* szProcName )
{
  void *func;
  return (get_image_symbol(hLib, szProcName, B_SYMBOL_TYPE_TEXT, &func) == B_OK) ? (PROC)func : NULL;
}

void csFreeAllLibraries()
{
  LibraryList* pCur = gb_pLibHead;

  while (pCur)
  {
    LibraryList* pNext = pCur->pNext;
    unload_add_on(pCur->hLib);
    delete pCur;

    pCur = pNext;
  }
}

#endif
