/*
    Copyright (C) 1998 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef GGIG2D_H
#define GGIG2D_H

#include "com/com.h"
#include "render/graph2d.h"
#include "system/libggi/driver2d/xsysg2d.h"

// The CLSID to create csGraphics2DGGI instances
extern const CLSID CLSID_GGI2DDriver;

extern const IID IID_IGraphics2DGGIFactory;

/// dummy interface
interface IGraphics2DGGIFactory : public IGraphics2DFactory
{
};

///
class csGraphics2DGGIFactory : public IGraphics2DGGIFactory
{
public:
  DECLARE_IUNKNOWN()
  DECLARE_INTERFACE_TABLE(csGraphics2DGGIFactory)

  STDMETHOD(CreateInstance)(REFIID riid, ISystem* piSystem, void** ppv);
  STDMETHOD(LockServer)(BOOL bLock);
};

///

/// GGI version.
class csGraphics2DGGI : public csGraphics2D
{
  friend class csGraphics3DSoftware;
private:
  ggi_visual_t vis;
  ggi_mode vis_mode;
  int display_width, display_height;

public:
  csGraphics2DGGI (ISystem* piSystem, bool bUses3D);
  virtual ~csGraphics2DGGI ();

  virtual bool Open (char *Title);
  virtual void Close ();

  virtual bool BeginDraw () { return (Memory != NULL); }

  virtual void Print (csRect *area = NULL);
  virtual void SetRGB (int i, int r, int g, int b);

protected:
  DECLARE_IUNKNOWN()
  DECLARE_INTERFACE_TABLE(csGraphics2DGGI)
  DECLARE_COMPOSITE_INTERFACE(XGGIGraphicsInfo)
};

#endif //GGIG2D_H
