/*
    Copyright (C) 1998 by Jorrit Tyberghein
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef CRYST_GGI_H
#define CRYST_GGI_H

#include "com/com.h"
#include "render/igraph2d.h"
#include "util/input/csinput.h"
#include "system/system.h"
#include "system/libggi/ggiinitf.h"

/// GGI version.
class SysSystemDriver : public csSystemDriver
{
public:
  SysSystemDriver () : csSystemDriver () {};

  virtual void Loop ();
  virtual void SetSystemDefaults ();
  virtual void ParseArg (int argc, char* argv[], int& i);
  virtual void Help ();

  /// Implementation of IGGISystemDriver
  class XGGISystemDriver : public IGGISystemDriver
  {
    DECLARE_IUNKNOWN()
  };
  // COM stuff
  DECLARE_IUNKNOWN()
  DECLARE_INTERFACE_TABLE(SysSystemDriver)
  DECLARE_COMPOSITE_INTERFACE_EMBEDDED (GGISystemDriver);
};

/// GGI version.
class SysKeyboardDriver : public csKeyboardDriver
{
  friend class csSystemDriver;
public:
  SysKeyboardDriver();

  virtual bool Open(csEventQueue* EvQueue);
  virtual void Close(void);
};

/// GGI version.
class SysMouseDriver : public csMouseDriver
{
  friend class csSystemDriver;
public:
  SysMouseDriver();

  virtual bool Open(csEventQueue* EvQueue);
  virtual void Close(void);
};

#endif // CRYST_GGI_H
