/*
    Copyright (C) 1998 by Jorrit Tyberghein and Steve Israelson
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#pragma once

#include <QDOffscreen.h>

/// Macintosh version.
class SysGraphics2D : public csGraphics2D
	{
private:
	WindowPtr			mainPtr;
	CTabHandle			theCTab;
	GWorldPtr			offscreen;
	PixMapHandle		theMap;
	long				rowBytes;
	unsigned char		*pixels;
	long				timer;
	long				frame;
	long 				fps;
	Str255				fpsString;
public:
	virtual 			SysGraphics2D (int argc, char* argv[]);
	virtual 			~SysGraphics2D ();

					// this is handled in the constuctor
  	virtual int 			Open(void){return 0;};
  	virtual void 			Close(void);
  	virtual void 			Init(void);

	virtual void 			Print (csRect *area = NULL);
	virtual void 			Clear(int color);
	virtual void 			DrawLine(int x1, int y1, int x2, int y2, int color);
	virtual void 			DrawHorLine(int x1, int x2, int y, int color);
	virtual void 			DrawPixel(int x, int y, int color);
	virtual void 			SetRGB(int i, int r, int g, int b);
	virtual inline unsigned char 	*GetPixelAt(long x, long y) { return (pixels + x + rowBytes * y);};

private:
	};

/// Macintosh version.
class SysMouseDriver : public csMouseDriver
{
public:
  SysMouseDriver();
  ~SysMouseDriver(void);

  bool Open(void);
  void Close(void);
};
