/*
    Copyright (C) 1998 by Jorrit Tyberghein and Steve Israelson
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*----------------------------------------------------------------
	Keyboard handling by Steve Israelson
----------------------------------------------------------------*/
#pragma once
#include <Events.h>

/// Macintosh version.
class SysKeyboardDriver : public csKeyboardDriver
{
public:
        SysKeyboardDriver(){};
        ~SysKeyboardDriver(void){};
        int		Open(void) { return 1;};
        void	Close(void) {};
        int     install(void){return 1;};
        void    uninstall(void){};
		void	chain( int ){};
private:
};

/*----------------------------------------------------------------
	A simple function to return true if the key is being pressed.
----------------------------------------------------------------*/
inline int keyboard_keydown(unsigned short k)
	{
	unsigned char km[16];
	::GetKeys( (unsigned long *) km); // this should only be called once every frame
	return ( ( km[k>>3] >> (k & 7) ) & 1);
	}


/* Constants for keyboard scan-codes */

#define SCAN_ESC        0x35
#define SCAN_1          0x12
#define SCAN_2          0x13
#define SCAN_3          0x14
#define SCAN_4          0x15
#define SCAN_5          0x17
#define SCAN_6          0x16
#define SCAN_7          0x1a
#define SCAN_8          0x1c
#define SCAN_9          0x19
#define SCAN_0          0x1d
#define SCAN_MINUS      0x1b
#define SCAN_EQUALS     0x18
#define SCAN_BACKSP     0x33
#define SCAN_TAB        0x30
#define SCAN_Q          0x0c
#define SCAN_W          0x0d
#define SCAN_E          0x0e
#define SCAN_R          0x0f
#define SCAN_T          0x11
#define SCAN_Y          0x10
#define SCAN_U          0x20
#define SCAN_I          0x22
#define SCAN_O          0x1f
#define SCAN_P          0x23
#define SCAN_LANGLE     0x21
#define SCAN_RANGLE     0x1e
#define SCAN_ENTER      0x24
#define SCAN_CTRL       0x3b
#define SCAN_A          0x00
#define SCAN_S          0x01
#define SCAN_D          0x02
#define SCAN_F          0x03
#define SCAN_G          0x05
#define SCAN_H          0x04
#define SCAN_J          0x26
#define SCAN_K          0x28
#define SCAN_L          0x25
#define SCAN_SCOLON     0x29
#define SCAN_QUOTA      0x27
#define SCAN_RQUOTA     0x32
#define SCAN_LSHIFT     0x38
#define SCAN_BSLASH     0x2a
#define SCAN_Z          0x06
#define SCAN_X          0x07
#define SCAN_C          0x08
#define SCAN_V          0x09
#define SCAN_B          0x0b
#define SCAN_N          0x2d
#define SCAN_M          0x2e
#define SCAN_COMA       0x2b
#define SCAN_DOT        0x2f
#define SCAN_SLASH      0x2c
#define SCAN_RSHIFT     0x3c
#define SCAN_GREY_STAR  0x43
#define SCAN_ALT        0x3a
#define SCAN_SPACE      0x31
#define SCAN_CAPS       0x39
#define SCAN_F1         0x7a
#define SCAN_F2         0x78
#define SCAN_F3         0x63
#define SCAN_F4         0x76
#define SCAN_F5         0x60
#define SCAN_F6         0x61
#define SCAN_F7         0x62
#define SCAN_F8         0x64
#define SCAN_F9         0x65
#define SCAN_F10        0x6d
#define SCAN_NUMLOCK    0x47
#define SCAN_SCRLOCK    0x6b
#define SCAN_HOME       0x73
#define SCAN_UP         0x7e
#define SCAN_PGUP       0x74
#define SCAN_GREY_MINUS 0x4e
#define SCAN_LEFT       0x7b
#define SCAN_PAD_5      0x57
#define SCAN_RIGHT      0x7c
#define SCAN_GREY_PLUS  0x45
#define SCAN_END        0x77
#define SCAN_DOWN       0x7d
#define SCAN_PGDN       0x79
#define SCAN_INSERT     0x72
#define SCAN_DEL        0x75
#define SCAN_F11        0x67
#define SCAN_F12        0x6f

