/*
  OS/2 support for Crystal Space 3D library
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __ICSOS2_H__
#define __ICSOS2_H__

#include "com/com.h"

typedef void (*KeyboardHandlerOS2) (void *param, unsigned char ScanCode,
  bool Down, int ShiftFlags);
typedef void (*MouseHandlerOS2) (void *param, int Button, int Down,
  int x, int y, int ShiftFlags);
typedef void (*TerminateHandlerOS2) (void *param);
typedef void (*FocusHandlerOS2) (void *param, int Enable);

extern const IID IID_ISystemDriverOS2;

interface ISystemDriverOS2 : public IUnknown
{
  /// Get user settings
  STDMETHOD (GetSettings) (int &WindowX, int &WindowY,
    int &WindowWidth, int &WindowHeight, bool &HardwareCursor) PURE;
  /// Get OS/2-specific keyboard event handler routine
  STDMETHOD (GetKeyboardHandler) (KeyboardHandlerOS2 &Handler, void *&Parm) PURE;
  /// Get OS/2-specific mouse event handler routine
  STDMETHOD (GetMouseHandler) (MouseHandlerOS2 &Handler, void *&Parm) PURE;
  /// Get OS/2-specific mouse event handler routine
  STDMETHOD (GetTerminateHandler) (TerminateHandlerOS2 &Handler, void *&Parm) PURE;
  /// Get OS/2-specific mouse event handler routine
  STDMETHOD (GetFocusHandler) (FocusHandlerOS2 &Handler, void *&Parm) PURE;
};

#endif // __ICSOS2_H__
