/*
  OS/2 support for Crystal Space 3D library
  Copyright (C) 1998 by Jorrit Tyberghein
  Written by Andrew Zabolotny <bit@eltech.ru>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free
  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifdef NO_COM_SUPPORT

#include "com/com.h"

// Minimal required part of OS2.H
typedef unsigned long ULONG;
typedef char *PSZ;
typedef const char *PCSZ;
typedef CS_HLIBRARY HMODULE, *PHMODULE;

extern "C" ULONG DosFreeModule (HMODULE hmod);
extern "C" ULONG DosLoadModule (PSZ pszObject, ULONG uObjectLen, PCSZ pszModule,
    PHMODULE phmod);
extern "C" ULONG DosQueryProcAddr (HMODULE hmod, ULONG ulOrdinal, PCSZ pszProcName,
    PROC *pProcAddr);

struct LibraryList
{
  HMODULE Handle;
  LibraryList *Next;
};

static LibraryList *LibList = NULL;

CS_HLIBRARY csLoadLibrary (char* szLibName)
{
  LibraryList* Item;
  HMODULE Handle;

  if (DosLoadModule (NULL, 0, szLibName, &Handle))
    return (CS_HLIBRARY)0;

  Item = new LibraryList;

  Item->Next = LibList;
  Item->Handle = Handle;
  LibList = Item;

  return Handle;
}

PROC csGetProcAddress (CS_HLIBRARY hLib, char* szProcName)
{
  PROC Func;
  if (DosQueryProcAddr (hLib, 0, szProcName, &Func))
    return (PROC)NULL;
  else
    return Func;
}

void csFreeAllLibraries()
{
  LibraryList* Current = LibList;

  while (Current)
  {
    LibraryList* Next = Current->Next;
    DosFreeModule (Current->Handle);
    delete Current;
    Current = Next;
  }
}

#endif
