/*
    Copyright (C) 1998 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef SYSPRINT_H
#define SYSPRINT_H

/// Several types of messages.
#define MSG_INTERNAL_ERROR 1    // Internal error, this is a serious bug in CS
#define MSG_FATAL_ERROR 2       // Error which prevents proper further execution
#define MSG_WARNING 3           // Error which doesn't prevent proper execution
#define MSG_INITIALIZATION 4    // Initialization message
#define MSG_CONSOLE 5           // Message intended for display on the console
#define MSG_STDOUT 6            // Message intended for display on stdout
#define MSG_DEBUG_0 7           // Show message if debug level is 0, 1, or 2 (no debug)
#define MSG_DEBUG_1 8           // Show message if debug level is 1 or 2 (debug mode)
#define MSG_DEBUG_2 9           // Show message if debug level 2 (verbose mode)
#define MSG_DEBUG_0F 10         // Show message if debug level is 0, 1, or 2 (no debug) and flush
#define MSG_DEBUG_1F 11         // Show message if debug level is 1 or 2 (debug mode) and flush
#define MSG_DEBUG_2F 12         // Show message if debug level 2 (verbose mode) and flush

extern void CsPrintf (int mode, char* str, ...);

#endif // SYSPRINT_H
