
#include <ddraw.h>
#include "com/com.h"
#include "system/win32/iddetect.h"

#ifndef __ISYSG2D_H__
#define __ISYSG2D_H__

extern const IID IID_IWin32GraphicsInfo;

/// IWin32GraphicsInfo interface -- for Win32-specific properties.
interface IWin32GraphicsInfo : public IUnknown
{
    ///
    STDMETHOD(Open)(char* szTitle) = 0;
    ///
    STDMETHOD(Close)() = 0;
    ///
    STDMETHOD(GetDirectDrawDriver)( LPDIRECTDRAW* lplpDirectDraw ) = 0;
    ///
    STDMETHOD(GetDirectDrawPrimary)( LPDIRECTDRAWSURFACE* lplpDirectDrawPrimary ) = 0;
    ///
    STDMETHOD(GetDirectDrawBackBuffer)( LPDIRECTDRAWSURFACE* lplpDirectDrawBackBuffer ) = 0;
    ///
    STDMETHOD(GetDirectDetection)(IDirectDetectionInternal** lplpDDetection ) = 0;
    ///
    STDMETHOD(SetColorPalette)(void) = 0;
};

#endif
