#include <assert.h>

#include "system/system.h"
#if defined(EXPLICIT_LOADER)
#include "util/gfx/csimage.h"

#if defined(DO_PNG)
extern "C" {
  #define Byte z_Byte     /* Kludge to avoid conflicting typedef in zconf.h */
  #include "zlib.h"
  #undef Byte
  #include "png.h"
}
#endif

#if defined(DO_GIF)
#include "util/gfx/gifimage.h"
#endif

#if defined(DO_JPG)
#include "util/gfx/jpgimage.h"
#endif

#if defined(DO_PNG)
#include "util/gfx/pngimage.h"
#endif

#if defined(DO_TGA)
#include "util/gfx/tgaimage.h"
#endif

#include "system/win32/imageldr.h"

init_ImageLoader image_loader;

void init_ImageLoader::init()
{
  if (!initialized)
  {
#ifdef DO_GIF
    gif = new GIFImageLoader();
#endif
#ifdef DO_JPG
    jpg = new JPGImageLoader();
#endif
#ifdef DO_PNG
    png = new PNGImageLoader();
#endif
#ifdef DO_TGA
    tga = new TGAImageLoader();
#endif
  }

  initialized = true;
}

#endif

