/*
    Copyright (C) 1998 by Jorrit Tyberghein
    Written by Nathaniel Saint Martin <noote@bigfoot.com>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __SYSSOUNDDRIVER_H
#define __SYSSOUNDDRIVER_H

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <windows.h>

#include "sound/cssnddrv.h"

///
class SysSoundDriver : public csSoundDriver
{
public:
  ///
  SysSoundDriver(int nchannels=16);

  /// open sound device at 'frequency' Hz, enable or disable 16 bit and stereo
  virtual bool Open(int frequency, bool bit16, bool stereo);
  /// close device
  virtual bool Close();

  /// set volume
  void setVolume(float v);
private:
  bool MixChunk();
  static void CALLBACK waveOutProc(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance, DWORD dwParam1, DWORD dwParam2);
  static DWORD CALLBACK waveOutThreadProc( LPVOID dwParam); 

  HWAVEOUT hwo;
  HANDLE hThread;
  DWORD dwThread;


	unsigned long old_Volume;
};

#endif // __SYSSOUNDDRIVER_H
