#ifndef __WAVELDR_H_
#define __WAVELDR_H_

#include "util/sound/wavfile.h"
#include "util/sound/aufile.h"
#include "util/sound/ifffile.h"
#include "util/sound/aifffile.h"

///
class init_WaveLoader
{
private:
  WAVWaveLoader * wav;
  AUWaveLoader * au;
  IFFWaveLoader * iff;
  AIFFWaveLoader * aiff;

public:
  ///
  init_WaveLoader() : wav(NULL), au(NULL), iff(NULL), aiff(NULL),
     initialized(false) {}

  ///
  ~init_WaveLoader()
  {
    if (wav) CHKB( delete wav );
    if (au) CHKB( delete au );
    if (iff) CHKB( delete iff );
    if (aiff) CHKB( delete aiff );
  }

  bool initialized;

  ///
  void init();
};

extern init_WaveLoader wave_loader;

#endif

