/*
    Copyright (C) 1998 by Jorrit Tyberghein

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/times.h>
#include "system/system.h"

// For one strange reason the GNU C library does not seem
// to support milliseconds anymore in clock or in ftime.
// (Is this normal or is there something wrong with my GNU C library?)
// So I have to use times instead.

// This function should return milliseconds since some specific
// time. If you don't have milliseconds easily just rewrite by
// using 'time (NULL)*1000' or something like that.

long csSystemDriver::Time ()
{
  tms t;
  return (times (&t)*1000)/CLK_TCK;
}
