/*
    Copyright (C) 1998 by Jorrit Tyberghein and Steve Israelson
  
    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.
  
    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.
  
    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PARSER_H
#define PARSER_H

/**
 * Structure to describe a single token
 */
typedef struct
{
  /// value returned when token is matched
  long	id;
  /// token to match
  char	*token;
} tokenDesc;

extern const char *kWhiteSpace;

/// Get an object from the buffer.
long csGetObject(char **buf, tokenDesc *tokens, char **name, char **data);
/// Get a command from the buffer.
long csGetCommand(char **buf, tokenDesc *tokens, char **params);

char *GetSubText(char **buf, char open, char close);
void SkipCharacters(char **buf, const char *toSkip);
char *GetAssignmentText(char **buf);

#endif

