/*
    Copyright (C) 1998 by Jorrit Tyberghein    

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <assert.h>

#include "system/system.h"
#include "util/csvector.h"

#include "sound/wave.h"
#include "sound/channel.h"
#include "sound/module.h"

#include "util/sound/moduload.h"

#ifdef EXPLICIT_LOADER
#include "system/win32/moduldr.h"
#endif

void ModuleLoader::reg_loader(ModuleLoader* loader)
{
  loaderlist().Push( (csSome)loader );
}

Module* ModuleLoader::load (char* filename)
{
  FILE* fp = SystemFopen (filename, "rb");
  if (!fp) return NULL;
  Module* i = load(fp);
  fclose (fp);
  return i;
}

Module* ModuleLoader::load (FILE* fp)
{
  fseek(fp, 0, SEEK_END);
  ULong size = ftell(fp);
  fseek(fp, 0, SEEK_SET);
  CHK (UByte* buf = new UByte [size+1] );
  fread(buf, 1, size+1, fp);
  Module* i = load(buf,size);
  CHK (delete [] buf);
  return i;
}

Module* ModuleLoader::load (UByte* buf, ULong size)
{
  #ifdef EXPLICIT_LOADER
   module_loader.init();
  #endif

  int i=0;
  while (i < loaderlist().Length() )
  {
    ModuleLoader* l = (ModuleLoader*) ( loaderlist()[i] );
    Module* m = l->loadmodule(buf,size);
    if (m) return m;
    i++; 
  }
  return NULL;
}

csVector& ModuleLoader::loaderlist()
{
  static csVector list;
  return list;
}
