/*
    Copyright (C) 1998 by Jorrit Tyberghein    

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <math.h>
#include <time.h>
#include <assert.h>

#include "system/system.h"
#include "util/csvector.h"
#include "sound/wave.h"

#include "util/sound/waveload.h"

#ifdef EXPLICIT_LOADER
#include "system/win32/waveldr.h"
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

void WaveLoader::reg_loader(WaveLoader* loader)
{
  loaderlist().Push( (csSome)loader );
}

Wave* WaveLoader::load (char* filename, char *name)
{
  FILE* fp = SystemFopen (filename, "rb");
  if (!fp) return NULL;
  Wave* i = load(fp, name);
  fclose (fp);
  return i;
}

Wave* WaveLoader::load (FILE* fp, char *name)
{
  fseek(fp, 0, SEEK_END);
  ULong size = ftell(fp);
  fseek(fp, 0, SEEK_SET);
  CHK (UByte* buf = new UByte [size+1] );
  fread(buf, 1, size+1, fp);
  Wave* i = load(buf,size,name);
  CHK (delete [] buf);
  return i;
}

Wave* WaveLoader::load (UByte* buf, ULong size, char *name)
{
  #ifdef EXPLICIT_LOADER
   wave_loader.init();
  #endif

  int i=0;
  while (i < loaderlist().Length() )
  {
    WaveLoader* l = (WaveLoader*) ( loaderlist()[i] );
    Wave* w = l->loadwave(buf,size,name);
    if (w) return w;
    i++; 
  }
  return NULL;
}

csVector& WaveLoader::loaderlist()
{
  static csVector list;
  return list;
}
