#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global bindir; 
global devtape; 
global mp3loc; 
global status; 
global widget; 

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc MakeMp3Tape {} {
global bindir devtape status

set stream [ open "| $bindir/tmake $devtape" ] 

while { ![eof $stream] } {
  set string [ gets $stream ]
  set status $string
}

set status "The tape is ready to be used"
close $stream
}

proc ReadTapeIndex {} {
global bindir devtape


set stream [ open "| $bindir/tdir $devtape" ] 
set number 1

while { ![eof $stream] } {
  set string [ gets $stream ]
  puts stdout $string
  
  if { [ string last ".mp3" $string ] > 0 } {
     
     .top17.cpd29.01 insert end "$string"
     set number [ expr $number + 1 ]

  }

}

close $stream
}

proc RecordFiles {} {
global bindir SelectedArray numOfSelected SelectMP3DirEntry PlaylistArray
global numOfSongs devtape


# Check wether files are correct.

set index 1
set numOfSongs 0
while { $index <= $numOfSelected } {

  set filename "$SelectMP3DirEntry/$SelectedArray($index)"
  set stream [ open "| $bindir/player info $filename" ]
  set errorfound 0  

  while { ![eof $stream] } {
     set string [ gets $stream ] 
     if { [string match "INFO*" $string] == 1 } {

         # File is correct
         set numOfSongs [ expr $numOfSongs + 1 ]
         set PlaylistArray($numOfSongs) $filename

      } else {

        if { [string match "ERROR*" $string] == 1 } {
          # error found!
          set errorfound 1
        }

      }

  }
  puts stdout "File to add: $SelectMP3DirEntry/$SelectedArray($index)"
  set index [ expr $index + 1 ]
  catch { close $stream }

}


# All files available : write to tape

if { $numOfSongs > 0 } {

   set index 0
   while { $index <= $numOfSongs } {
      set index [ expr $index + 1 ]
      puts stdout "rec: $PlaylistArray($index)"
      catch { exec $bindir/trec "$PlaylistArray($index)" "$PlaylistArray($index)" $devtape }
   }


}

set status "The correct files have been saved, if present"
return
}

proc Select_MP3File_Change_Dir {dir} {
global SelectMP3DirEntry Selected_MP3File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {

# no existing dir

} else { 
    catch { exec "pwd" } SelectMP3DirEntry
    if { $SelectMP3DirEntry == "/" } {
        set Selected_MP3File "/"
        Select_MP3File_Show $SelectMP3DirEntry 
    } else {
        if { [string range $Selected_MP3File end end] == "/" } {
        } else {
            set Selected_MP3File $SelectMP3DirEntry
        }   
    Select_MP3File_Show $SelectMP3DirEntry
    }
}
}

proc Select_MP3File_Show {Dir} {
global SelectMP3DirEntry Selected_MP3File mp3filter

set SelectMP3DirEntry $Dir

# Clear window contents

.top18.cpd20.01 delete 0 end
.top18.cpd21.01 delete 0 end

if { $SelectMP3DirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top18.cpd20.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top18.cpd20.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $mp3filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top18.cpd21.01 insert end $naam
    }
   }
}
}

proc Start_Select_MP3File {Arg_Filter Startdir} {
global mp3filter Selected_MP3File
set mp3filter $Arg_Filter

Window show .top18
#grab .top18

.top18.cpd20.01 delete 0 end
.top18.cpd21.01 delete 0 end

set Dir $Startdir
set Selected_MP3File $Dir
Select_MP3File_Show $Dir
}

proc main {argc argv} {
global bindir devtape mp3loc

set bindir "/usr/home/mp3/final"
set devtape "/dev/nst0"
set mp3loc "/usr/home/mp3/mp3"

catch { exec ln -s $devtape ~/tape.lnk }
}

proc PlayFile {} {
global currentfile bindir devtape
 
set listindex [ .top17.cpd29.01 curselection ]

if { $listindex != "" } {
  set speelindex [ expr $listindex + 1 ]
  set currentfile [ .top17.cpd29.01 get $listindex ]
  catch { exec $bindir/tplay $speelindex $devtape & }

}
}

proc StopPlaying {} {
catch { exec killall player }
catch { exec killall l3dec }
catch { exec killall tplay }
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 429x449+48+201
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "DAT-Player"
    entry $base.ent18 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground Black -textvariable currentfile 
    entry $base.ent19 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -textvariable status 
    label $base.lab20 \
        -background #505050 -borderwidth 1 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground #009a00 -text {Now playing} 
    label $base.lab21 \
        -background #505050 -borderwidth 1 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -text Status 
    label $base.lab28 \
        -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -relief raised -text {MP3-Studio DAT-Player} 
    frame $base.cpd29 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground #323232 -relief raised -width 30 
    listbox $base.cpd29.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black -highlightcolor White \
        -selectbackground #d6a400 -xscrollcommand {.top17.cpd29.02 set} \
        -yscrollcommand {.top17.cpd29.03 set} 
    bind $base.cpd29.01 <Double-Button-1> {
        PlayFile
    }
    scrollbar $base.cpd29.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top17.cpd29.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd29.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top17.cpd29.01 yview} -highlightbackground Black \
        -orient vert -troughcolor #323232 -width 10 
    frame $base.fra31 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground #505050 -relief ridge -width 125 
    button $base.fra31.but33 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command StopPlaying \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Stop 
    button $base.fra31.but34 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command PlayFile \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Play 
    button $base.fra31.but35 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Prev 
    button $base.fra31.but36 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Replay 
    button $base.fra31.but37 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Next 
    button $base.but38 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command exit \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Exit 
    button $base.but39 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command ReadTapeIndex \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Read index} 
    button $base.but40 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status mp3loc

if { $status == "Playing" } {
  StopPlaying
}

Start_Select_MP3File "*.mp3" "$mp3loc"} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Add files} 
    button $base.but41 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text ? 
    button $base.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command MakeMp3Tape \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Make mp3-tape} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent18 \
        -x 90 -y 37 -width 328 -height 22 -anchor nw -bordermode ignore 
    place $base.ent19 \
        -x 90 -y 63 -width 328 -height 22 -anchor nw -bordermode ignore 
    place $base.lab20 \
        -x 9 -y 37 -width 78 -height 18 -anchor nw -bordermode ignore 
    place $base.lab21 \
        -x 6 -y 62 -width 48 -height 18 -anchor nw -bordermode ignore 
    place $base.lab28 \
        -x 5 -y 5 -width 421 -height 28 -anchor nw -bordermode ignore 
    place $base.cpd29 \
        -x 10 -y 130 -width 410 -height 285 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd29 0 -weight 1
    grid rowconf $base.cpd29 0 -weight 1
    grid $base.cpd29.01 \
        -in .top17.cpd29 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd29.02 \
        -in .top17.cpd29 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd29.03 \
        -in .top17.cpd29 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.fra31 \
        -x 31 -y 90 -width 372 -height 33 -anchor nw -bordermode ignore 
    place $base.fra31.but33 \
        -x 15 -y 5 -width 60 -height 22 -anchor nw -bordermode ignore 
    place $base.fra31.but34 \
        -x 85 -y 5 -width 60 -height 22 -anchor nw -bordermode ignore 
    place $base.fra31.but35 \
        -x 155 -y 5 -width 60 -height 22 -anchor nw -bordermode ignore 
    place $base.fra31.but36 \
        -x 225 -y 5 -width 60 -height 22 -anchor nw -bordermode ignore 
    place $base.fra31.but37 \
        -x 295 -y 5 -width 60 -height 22 -anchor nw -bordermode ignore 
    place $base.but38 \
        -x 330 -y 420 -width 85 -height 22 -anchor nw -bordermode ignore 
    place $base.but39 \
        -x 13 -y 420 -width 85 -height 22 -anchor nw -bordermode ignore 
    place $base.but40 \
        -x 104 -y 420 -width 65 -height 22 -anchor nw -bordermode ignore 
    place $base.but41 \
        -x 295 -y 420 -width 27 -height 22 -anchor nw -bordermode ignore 
    place $base.but17 \
        -x 175 -y 420 -width 105 -height 22 -anchor nw -bordermode ignore 
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 592x358+43+179
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Select mp3-file(s)"
    message $base.mes19  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised  -text {Select one or more mp3-files} 
    frame $base.cpd20  -background #9900991B99FE -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.cpd20.01  -background #9900991B99FE  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -foreground #FFFFFFFFFFFF -xscrollcommand {.top18.cpd20.02 set}  -yscrollcommand {.top18.cpd20.03 set} 
    bind $base.cpd20.01 <Double-ButtonRelease-1> {
        set selected [ .top18.cpd20.01 curselection ]
if { [ llength $selected ] > 0 } {
  set dir $SelectMP3DirEntry/[ .top18.cpd20.01 get $selected ]
  set Selected_MP3File $dir
  Select_MP3File_Change_Dir $dir
}
    }
    scrollbar $base.cpd20.02  -background #9900991B99FE -borderwidth 1  -command {.top18.cpd20.01 xview} -orient horiz -width 10 
    scrollbar $base.cpd20.03  -background #9900991B99FE -borderwidth 1  -command {.top18.cpd20.01 yview} -orient vert -width 10 
    frame $base.cpd21  -background #9900991B99FE -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.cpd21.01  -background #9900991B99FE  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -foreground #FFFFFFFFFFFF -selectmode extended  -xscrollcommand {.top18.cpd21.02 set}  -yscrollcommand {.top18.cpd21.03 set} 
    bind $base.cpd21.01 <Double-Button-1> {
        global SelectedArray numOfSelected

grab release .top18


set idx [ .top18.cpd21.01 curselection ]

set numOfSelected 0
foreach index $idx {
  set numOfSelected [ expr $numOfSelected + 1 ]
  set SelectedArray($numOfSelected) [.top18.cpd21.01 get $index $index]
}

Window hide .top18

RecordFiles
    }
    scrollbar $base.cpd21.02  -background #9900991B99FE -borderwidth 1  -command {.top18.cpd21.01 xview} -orient horiz -width 10 
    scrollbar $base.cpd21.03  -background #9900991B99FE -borderwidth 1  -command {.top18.cpd21.01 yview} -orient vert -width 10 
    button $base.but23  -activebackground #921016 -activeforeground White -background #323232  -command {global SelectedArray numOfSelected

set idx [ .top18.cpd21.01 curselection ]

set numOfSelected 0
foreach index $idx {
  set numOfSelected [ expr $numOfSelected + 1 ]
  set SelectedArray($numOfSelected) [.top18.cpd21.01 get $index $index]
}

grab release .top18
Window hide .top18

RecordFiles}  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text OK 
    button $base.but24  -activebackground #921016 -activeforeground White -background #323232  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text Cancel 
    message $base.mes25  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Selection 
    entry $base.ent26  -background #9900991B99FE  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #FFFFFFFFFFFF -textvariable Selected_MP3File 
    entry $base.ent27  -background #9900991B99FE  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #FFFFFFFFFFFF -textvariable SelectMP3DirEntry 
    entry $base.ent28  -background #9900991B99FE  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #FFFFFFFFFFFF -textvariable mp3filter 
    message $base.mes29  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text Filter 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes19  -x 5 -y 5 -width 575 -height 34 -anchor nw -bordermode ignore 
    place $base.cpd20  -x 15 -y 105 -width 180 -height 215 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd20 0 -weight 1
    grid rowconf $base.cpd20 0 -weight 1
    grid $base.cpd20.01  -in .top18.cpd20 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd20.02  -in .top18.cpd20 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd20.03  -in .top18.cpd20 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.cpd21  -x 200 -y 105 -width 375 -height 215 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd21 0 -weight 1
    grid rowconf $base.cpd21 0 -weight 1
    grid $base.cpd21.01  -in .top18.cpd21 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.cpd21.02  -in .top18.cpd21 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd21.03  -in .top18.cpd21 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but23  -x 480 -y 330 -width 85 -height 22 -anchor nw -bordermode ignore 
    place $base.but24  -x 380 -y 330 -width 85 -height 22 -anchor nw -bordermode ignore 
    place $base.mes25  -x 10 -y 45 -width 65 -height 19 -anchor nw -bordermode ignore 
    place $base.ent26  -x 80 -y 45 -width 493 -height 21 -anchor nw -bordermode ignore 
    place $base.ent27  -x 15 -y 75 -width 433 -height 21 -anchor nw -bordermode ignore 
    place $base.ent28  -x 505 -y 75 -width 68 -height 21 -anchor nw -bordermode ignore 
    place $base.mes29  -x 460 -y 76 -width 45 -height 19 -anchor nw -bordermode ignore
}

Window show .
Window show .top17

main $argc $argv
