#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global bindir; 
global bitrate_entry; 
global deleteCheck; 
global seenHelp; 
global startdir; 
global widget; 
    set widget(helpwindow) {.top45}
    set widget(rev,.top45) {helpwindow}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc AddFiles {} {
global DeleteFiles numOfSelected SelectedArray bitrate_entry
global bindir newloc

set index 1
while { $index <= $numOfSelected } {

if { $DeleteFiles == 1 } {
 set command "$bindir/l3 $SelectedArray($index) $newloc -br $bitrate_entry -d"
} else {
 set command "$bindir/l3 $SelectedArray($index) $newloc -br $bitrate_entry"
}
 puts stdout "Uitvoeren: $command"
 set stream [ open "| $command" ] 
 catch { close $stream }

 set index [ expr $index + 1 ]
}


# Jobs queued. Now start a daemon.
catch { exec $bindir/l3d & }

return
}

proc Refresh {} {
global bindir


# clear listbox
.top18.cpd20.01 delete 0 end

# view queue
set stream [ open "| $bindir/l3q" ] 

# remove header
set string [ gets $stream ] 
set piece [ string first "---" $string ]

while { $piece == -1 } {
  set string [ gets $stream ] 
  set piece [ string first "---" $string ]
}

# read queue-list
set string [ gets $stream ] 
set piece -1

while { $piece == -1 } {

  # is queue empty?
  if { [string match "*<none>*" $string] == 1 } {
     #empty queue
     catch { close $stream }
     return
  }

  # entry found. Display
  .top18.cpd20.01 insert end $string

  set string [ gets $stream ] 
  set piece [ string first "---" $string ]
}


catch { close $stream }
return
}

proc Remove {} {
global bindir

set list [ .top18.cpd20.01 curselection ]

# execute l3rm for all lines in list

set numOfentries [ llength $list ]
set index 0

while { $index < $numOfentries } {

 set idx [ lindex $list $index ]
 set string [ .top18.cpd20.01 get $idx $idx ]

 set number [ string range $string 1 5 ]
 if { $number == "<CUR>" } {
   set number "cur"
 } else {
   set number [ expr $number + 0 ]
 }

 set command "$bindir/l3rm $number"

 set stream [ open "| $command" ] 
 catch { close $stream }

 set index [ expr $index + 1 ]

}


Refresh
return
}

proc Select_File_Change_Dir {dir} {
global SelectDirEntry Selected_File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {


} else { 
    catch { exec "pwd" } SelectDirEntry
    if { $SelectDirEntry == "/" } {
        set Selected_File "/"
        Select_File_Show $SelectDirEntry 
    } else {
        if { [string range $Selected_File end end] == "/" } {
        } else {
            set Selected_File $SelectDirEntry
        }   
    Select_File_Show $SelectDirEntry
    }
}
}

proc Select_File_Show {Dir} {
global SelectDirEntry Selected_File filter

set SelectDirEntry $Dir
#set Selected_File $SelectDirEntry
# Clear window contents
.top28.cpd33.01 delete 0 end
.top28.cpd35.01 delete 0 end

if { $SelectDirEntry != "/" } { 
 # Add the ..-directory
 .top28.cpd33.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top28.cpd33.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top28.cpd35.01 insert end $naam
    }
   }
}
}

proc ShowHelp {} {
global bindir seenHelp


if { $seenHelp == 0 } {

if [ catch { open $bindir/encoderhelp.hlp r } fileId ] {
  puts stdout "Error opening helpfile:$fileId"
  Window hide .top45
  return

} else {

  set string [ gets $fileId ]

  while { ![eof $fileId] } {

   .top45.cpd47.03 insert end "$string\n"
   set string [ gets $fileId ]
  .top45.cpd47.03 delete 1.0 1.end

  }
}

close $fileId
set seenHelp 1

}

return
}

proc Start_Select_File {Arg_Filter Startdir} {
global filter Selected_File
set filter $Arg_Filter

Window show .top28
grab .top28
set Dir $Startdir
set Selected_File $Dir
Select_File_Show $Dir
}

proc main {argc argv} {
global bindir seenHelp startdir wavloc newloc configfile

set seenHelp 0
Window show .top28
Window hide .top28
Window show .top18

# set directories
set bindir "/usr/local/mp3studio"
set wavloc "/"
set newloc "/"
set configfile "~/.mp3studiorc"
LoadPrefs

Refresh
}

proc LoadPrefs {} {
global bindir configfile wavloc newloc

if [ catch { open $configfile r } fileId ] {
  # Check if file exists
    puts stdout "Error opening configfile!"
    return

} else {

  set mp3loc [ gets $fileId ]
  set playloc [ gets $fileId ]
  set wavloc [ gets $fileId ]
  set newloc [ gets $fileId ]
  set samplecommand [ gets $fileId ]
  set mixercommand [ gets $fileId ]
  set devtape [ gets $fileId ]
  set bindir [ gets $fileId ]

}

close $fileId
return
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 388x370+35+211
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "MP3-Encoder"
    frame $base.cpd20 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd20.01 \
        -background #323232 \
        -font -adobe-courier-bold-r-normal-*-*-120-*-*-m-*-iso8859-* \
        -foreground #d47639 -height 0 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode extended \
        -xscrollcommand {.top18.cpd20.02 set} \
        -yscrollcommand {.top18.cpd20.03 set} 
    scrollbar $base.cpd20.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top18.cpd20.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd20.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top18.cpd20.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    button $base.but22 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window show $widget(helpwindow)
ShowHelp} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Help 
    button $base.but23 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command exit -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Exit 
    frame $base.fra24 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground Black -relief ridge -width 125 
    button $base.fra24.but25 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global wavloc

Start_Select_File "*.wav" $wavloc} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Add file(s)} 
    button $base.fra24.but27 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command Remove -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Remove file(s)} 
    button $base.fra24.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command Refresh -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Refresh 
    message $base.mes31 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3-Studio Encoder Queue} 
    message $base.mes18 \
        -aspect 1500 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Id 
    message $base.mes19 \
        -aspect 1500 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text % 
    message $base.mes20 \
        -aspect 1500 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Filename 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd20 \
        -x 9 -y 65 -width 370 -height 220 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd20 0 -weight 1
    grid rowconf $base.cpd20 0 -weight 1
    grid $base.cpd20.01 \
        -in .top18.cpd20 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd20.02 \
        -in .top18.cpd20 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd20.03 \
        -in .top18.cpd20 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but22 \
        -x 158 -y 336 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but23 \
        -x 265 -y 336 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.fra24 \
        -x 17 -y 290 -width 357 -height 40 -anchor nw -bordermode ignore 
    place $base.fra24.but25 \
        -x 5 -y 6 -width 111 -height 26 -anchor nw -bordermode ignore 
    place $base.fra24.but27 \
        -x 122 -y 6 -width 111 -height 26 -anchor nw -bordermode ignore 
    place $base.fra24.but17 \
        -x 238 -y 6 -width 111 -height 26 -anchor nw -bordermode ignore 
    place $base.mes31 \
        -x 5 -y 5 -width 378 -height 36 -anchor nw -bordermode ignore 
    place $base.mes18 \
        -x 33 -y 45 -width 22 -height 14 -anchor nw -bordermode ignore 
    place $base.mes19 \
        -x 60 -y 45 -width 22 -height 16 -anchor nw -bordermode ignore 
    place $base.mes20 \
        -x 79 -y 45 -width 58 -height 16 -anchor nw -bordermode ignore 
}

proc vTclWindow.top28 {base} {
    if {$base == ""} {
        set base .top28
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 516x365+16+142
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Select file(s)"
    message $base.mes32 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Select Wav-files to be encoded} 
    frame $base.cpd33 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd33.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -xscrollcommand {.top28.cpd33.02 set} \
        -yscrollcommand {.top28.cpd33.03 set} 
    bind $base.cpd33.01 <Double-ButtonRelease-1> {
        set selected [ .top28.cpd33.01 curselection ]
set dir $SelectDirEntry/[ .top28.cpd33.01 get $selected ]
set Selected_File $dir

Select_File_Change_Dir $dir
    }
    scrollbar $base.cpd33.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top28.cpd33.01 xview} -highlightbackground Black \
        -orient horiz -troughcolor Black -width 10 
    scrollbar $base.cpd33.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top28.cpd33.01 yview} -highlightbackground Black \
        -orient vert -troughcolor Black -width 10 
    frame $base.cpd35 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd35.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode extended \
        -xscrollcommand {.top28.cpd35.02 set} \
        -yscrollcommand {.top28.cpd35.03 set} 
    bind $base.cpd35.01 <ButtonRelease-1> {
        global SelectedArray numOfSelected

set idx [ .top28.cpd35.01 curselection ]

set numOfSelected 0
foreach index $idx {
  set numOfSelected [ expr $numOfSelected + 1 ]
  set SelectedArray($numOfSelected) "$SelectDirEntry/[.top28.cpd35.01 get $index $index]"
}
    }
    scrollbar $base.cpd35.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top28.cpd35.01 xview} -highlightbackground Black \
        -orient horiz -troughcolor Black -width 10 
    scrollbar $base.cpd35.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top28.cpd35.01 yview} -highlightbackground Black \
        -orient vert -troughcolor Black -width 10 
    message $base.mes37 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Selection 
    entry $base.ent38 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #323232 -textvariable Selected_File 
    entry $base.ent39 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #323232 -textvariable SelectDirEntry 
    entry $base.ent40 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #323232 -textvariable filter 
    message $base.mes41 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Filter 
    button $base.but42 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global Selected_File Filenames DeleteFiles
grab release .top28
Window hide .top28
set Filenames $Selected_File
set DeleteFiles $deleteCheck
AddFiles
Refresh} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    button $base.but43 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {set Selected_File ""
grab release .top28
Window hide .top28} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Cancel 
    checkbutton $base.che44 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground #323232 -relief ridge \
        -selectcolor Red -text {Delete file after encoding} \
        -variable deleteCheck 
    menubutton $base.men23 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -padx 4 -pady 3 \
        -relief ridge -text 112000 -textvariable bitrate_entry 
    menu $base.men23.m \
        -cursor {} -tearoff 0 
    $base.men23.m add command \
        -command {global bitrate_entry
set bitrate_entry "16000"} \
        -label 16000 
    $base.men23.m add command \
        -command {global bitrate_entry
set bitrate_entry "56000"} \
        -label 56000 
    $base.men23.m add command \
        -command {global bitrate_entry
set bitrate_entry "112000"} \
        -label 112000 
    message $base.mes24 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Bitrate 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes32 \
        -x 5 -y 5 -width 508 -height 36 -anchor nw -bordermode ignore 
    place $base.cpd33 \
        -x 10 -y 105 -width 155 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd33 0 -weight 1
    grid rowconf $base.cpd33 0 -weight 1
    grid $base.cpd33.01 \
        -in .top28.cpd33 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd33.02 \
        -in .top28.cpd33 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd33.03 \
        -in .top28.cpd33 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.cpd35 \
        -x 170 -y 105 -width 340 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd35 0 -weight 1
    grid rowconf $base.cpd35 0 -weight 1
    grid $base.cpd35.01 \
        -in .top28.cpd35 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd35.02 \
        -in .top28.cpd35 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd35.03 \
        -in .top28.cpd35 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.mes37 \
        -x 6 -y 48 -width 68 -height 16 -anchor nw -bordermode ignore 
    place $base.ent38 \
        -x 75 -y 45 -width 433 -height 22 -anchor nw -bordermode ignore 
    place $base.ent39 \
        -x 9 -y 75 -width 373 -height 22 -anchor nw -bordermode ignore 
    place $base.ent40 \
        -x 435 -y 75 -width 73 -height 22 -anchor nw -bordermode ignore 
    place $base.mes41 \
        -x 389 -y 77 -width 43 -height 16 -anchor nw -bordermode ignore 
    place $base.but42 \
        -x 404 -y 333 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but43 \
        -x 291 -y 333 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.che44 \
        -x 15 -y 316 -width 191 -height 22 -anchor nw -bordermode ignore 
    place $base.men23 \
        -x 75 -y 341 -width 131 -height 20 -anchor nw -bordermode ignore 
    place $base.mes24 \
        -x 12 -y 344 -width 57 -height 16 -anchor nw -bordermode ignore 
}

proc vTclWindow.top45 {base} {
    if {$base == ""} {
        set base .top45
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -cursor xterm 
    wm focusmodel $base passive
    wm geometry $base 498x357+428+192
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Help Window Encoder"
    message $base.mes46 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3-Studio Encoder Help} 
    frame $base.cpd47 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    scrollbar $base.cpd47.01 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top45.cpd47.03 xview} -highlightbackground Black \
        -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd47.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top45.cpd47.03 yview} -highlightbackground Black \
        -orient vert -troughcolor #323232 -width 10 
    text $base.cpd47.03 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d6a400 -height 1 -highlightbackground Black \
        -selectbackground #921016 -selectforeground White -width 8 \
        -xscrollcommand {.top45.cpd47.01 set} \
        -yscrollcommand {.top45.cpd47.02 set} 
    button $base.but48 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window hide $widget(helpwindow)} -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Exit 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes46 \
        -x 5 -y 5 -width 488 -height 36 -anchor nw -bordermode ignore 
    place $base.cpd47 \
        -x 10 -y 45 -width 478 -height 276 -anchor nw 
    grid columnconf $base.cpd47 0 -weight 1
    grid rowconf $base.cpd47 0 -weight 1
    grid $base.cpd47.01 \
        -in .top45.cpd47 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd47.02 \
        -in .top45.cpd47 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd47.03 \
        -in .top45.cpd47 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    place $base.but48 \
        -x 379 -y 326 -width 100 -height 26 -anchor nw -bordermode ignore 
}

Window show .
Window show .top18

main $argc $argv
