#include <iostream.h>

#include <kapp.h>
#include <kconfig.h>
#include <kconfigbase.h>
#include <klocale.h>

#include <mywidget.h>
#include <configtab.h>

#include "configtab.moc"



void configTab::apply ()
{
  //
  // die einzelnen tabs sind fuer ihre Konfiguration selbst verantwortlich.
  // Sie schreiben kconfig, speichern aber nicht auf Disk.
  //
  exit->writeConfig ();
  appear->writeConfig ();
  startup->writeConfig ();
}



configTab::configTab (QWidget* parent, const char* name, bool modal)
  : QTabDialog (0, name, modal)
{
  setCaption (i18n("Configure KTelnet"));
  resize (350, 330);

  appear = new appearanceWidget (this);
  exit = new exitWidget (this);
  startup = new startUpWidget (this);

  addTab (appear, i18n("Appearance"));
  addTab (startup, i18n("StartUp"));
  addTab (exit, i18n("On Exit"));

  // now set the main buttons (Cancel and Apply)

  setCancelButton (i18n("Cancel"));
  setApplyButton (i18n("Apply"));

  connect (this, SIGNAL (applyButtonPressed ()), SLOT (apply()) );

  connect (appear, SIGNAL (showMinimum()), parent, SLOT (showMinimum()));
  connect (appear, SIGNAL (showStandard()), parent, SLOT (showStandard()));
  connect (appear, SIGNAL (showFull()), parent, SLOT (showFull()));

  connect (appear, SIGNAL (showMenuBar()), parent, SLOT (showMenuBar()));
  connect (appear, SIGNAL (hideMenuBar()), parent, SLOT (hideMenuBar()));

  connect (appear, SIGNAL (showToolBar()), parent, SLOT (showToolBar()));
  connect (appear, SIGNAL (hideToolBar()), parent, SLOT (hideToolBar()));
}


configTab::~configTab ()
{
  delete appear;
  delete exit;
  delete startup;
}
