#ifndef __KCMDLINEARGS_H
#define __KCMDLINEARGS_H


#include <qobject.h>


/**
 * This class represents a convinient way to read out certain commandline
 * arguments. Implementation of new functions is straight forward.
 *
 */
class KCmdLineArgs
{
 public:

  /**
   * Constructor: needs the commandline arguments of main (...).
   *
   */
  KCmdLineArgs (int num, char** args);
  
  /**
   * Destructor: does nothing in this implementation
   *
   */
  virtual ~KCmdLineArgs ();

  /**
   * Checks, whether the argument named keyWord is given or not.
   * The first argument is the program name. You cant search here for the
   * program name. Use programName instead.  keyWord must include all
   * signs of an argument (e.g. "--help").
   *
   */
  bool isArgumentPresent (const char* keyWord);

  /**
   * Returns the argument following keyWord. Returns a null string if
   * keyWord is not present.
   */
  QString getArgument (const char* keyWord);

  /**
   * Returns the program name which is the first argument of the commandline
   *
   */
  const char* programName ();

 protected:

  char** theArgs;
  int n;
};



#endif
