#ifndef __MYWIDGET_H

#define __MYWIDGET_H


#include <qwidget.h>

#include <kmenubar.h>
#include <kcolordlg.h>
#include <ktopwidget.h>
#include <ktoolbar.h>


#include "sessiondata.h"


class QPushButton;
class QComboBox;
class QLineEdit;
class QPixmap;
class QPopupMenu;
class QTimer;
class QLCDNumber;
class QSlider;
class MyWidget;



class MyWidget : public KTopLevelWidget
  {
    friend class mainWidget;
    Q_OBJECT

    public:
      MyWidget (SessionManager* _sessions, QWidget* parent=0, 
		const char* name=0);

      ~MyWidget ();

    public slots:
      void deactivateSLOTS ();
      void activateSLOTS ();

      void putOnPanel ();

      void needSessionSaving (bool);

      void setup ();
      void saveOptions ();
      
      bool appendNewSession ();
      void restoreSession (); 
      void newSessionSelect ();

      void deleteSessionSelect ();

      void showHelper ();

      void removeFromToolbar ();
      void addToToolbar ();

      // only parse it to the mainwidget "m"
      void showMinimum ();
      void showStandard ();
      void showFull ();

      void hideMenuBar ();
      void showMenuBar ();

      void showToolBar ();
      void hideToolBar ();

      void showOptionsPopup (QPoint);
      void showFilePopup (QPoint);

    private:
      bool editNewSession;
     
      KMenuBar* menue;
      KToolBar* tools;

      mainWidget* m;

      QPopupMenu* filemenue;
      QPopupMenu* optionMenue;
      QPopupMenu* helpmenue;

      QAccel* NewSessAccel;

      SessionManager* sess;
  };


// further docu see in mywidget.cc
extern bool onlyChangeLines;

#endif





