#include <iostream.h>

#include <qtooltip.h>
#include <qevent.h>

#include <kapp.h>
#include <kiconloader.h>

#include "panelwindow.h"
#include "mainwidget.h"
#include "mywidget.h"

#include "panelwindow.moc"



PanelWindow::PanelWindow (SessionManager* sess, 
			  QWidget* parent, const char* name)
  : QLabel (parent, name)
{
  int i;
  KConfig* k = KApplication::getKApplication()->getConfig();
  k->setGroup ("common");

  sessions = sess;

  theSessionPop = new QPopupMenu ();
  
  for (i=0; i<sessions->count(); i++)
    {
      theSessionPop->insertItem (KApplication::getKApplication()->
				 getIconLoader()->loadIcon 
				 (sessions->icon(i)), sessions->session(i));
    }

  theSessionPop->insertSeparator ();
  theSessionPop->insertItem (i18n("Restore"), this, 
			     SLOT (restoreMainWindow()));
  
  connect (theSessionPop, SIGNAL (activated (int)), SLOT (startSession (int)));

  setPixmap (KApplication::getKApplication()->
	     getIconLoader()->loadIcon((const char*)k->readEntry ("panelIcon",
						      "mini/ktelnet.xpm")));

  setAutoResize ( TRUE );
  resize (22,22);
}


PanelWindow::~PanelWindow ()
{
  delete theSessionPop;
}


void PanelWindow::restoreMainWindow ()
{
  // start the other mainwidget
  MyWidget* w = new MyWidget (sessions);
  KApplication::getKApplication()->setMainWidget (w);
  
  w->show ();
  delete this;
}


void PanelWindow::mousePressEvent (QMouseEvent* e)
{
  if (e->button() == RightButton) theSessionPop->popup (pos());
  else if (e->button() == LeftButton) 
    {
      restoreMainWindow ();
    }
}


void PanelWindow::startSession (int index)
{
  if (index > sessions->count()) return;

  sessions->startSession_ID (sessions->ID(index));
}
