/* *** l3q
   *** Filename: l3q.c
   *** Description: Queries the encoding queue
   *** Version: 0.80 [19980210] | Sander Steffann & Michiel Bronswijk
   ***          1.00 [19980225] | Release version 1.00
   *** Remarks:
*/
#include <stdio.h>
#include <sys/param.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <syslog.h>
#include <fcntl.h>
#include <errno.h>
#include "l3spool.h"
#include "wav_interface.h"

void main(int argc, char *argv[])
{
	FILE 	*ctrlfile;
	char 	filename[MAXPATHLEN];
	char	sourcename[MAXPATHLEN];
	char	bitratestr[10];
	int 	id;
	int 	count;
	int	byterate, percentage;
	long	speed;
	float	target_second, source_second;
	DIR *spooldir;
	struct dirent *direntry;
	struct stat	stat_source;
	struct stat	stat_target;
	
	printf("l3q - Version %s (%s %s)\n", L3VERSION, __DATE__, __TIME__);
	printf("Copyright (C) 1998 'Projectgroep MP3-studio voor Linux'\n");

	if (CreateLockFile() != 0) {
		printf("Could not create lockfile, please try again later\n");
		exit(1);
		}

	count = 0;

	
	printf(" ID    %%   Filename\n");
	printf("----- --- -------------------------------------------\n");

	/* First try to find the current file */
	sprintf(filename, "%s/cfl3.cur", SPOOLDIR);
	if ((ctrlfile = fopen(filename, "r")) != NULL) {
		fgets(sourcename, sizeof(filename), ctrlfile);
		sourcename[strlen(sourcename)-1] = 0;
		isWAVFile(sourcename, &speed);

		fgets(filename, sizeof(filename), ctrlfile);
		filename[strlen(filename)-1] = 0;

		/* skip deleteflag */
		fgets(bitratestr, sizeof(bitratestr), ctrlfile);

		fgets(bitratestr, sizeof(bitratestr), ctrlfile);
		bitratestr[strlen(bitratestr)-1] = 0;

		sscanf(bitratestr, "%d", &byterate);
		byterate /= 8;
		
		stat(sourcename, &stat_source);
		stat(filename, &stat_target);
		target_second = stat_target.st_size / byterate;
		source_second = stat_source.st_size / (speed);
		percentage = (int)((target_second/source_second)*100);
		if (percentage<0) percentage = 0;
		if (percentage>100) percentage = 100;
		printf("<CUR> %3d %s\n", percentage, sourcename);
		fclose(ctrlfile);
		
		count++;
		};
		
	spooldir = opendir(SPOOLDIR);
	while((direntry=readdir(spooldir)) != NULL)
	{
		if (sscanf(direntry->d_name, "cfl3.%d", &id) == 1)
		{
			strcpy(filename, SPOOLDIR);
			strcat(filename, "/");
			strcat(filename, direntry->d_name);
			if ((ctrlfile=fopen(filename, "r")) != NULL)
			{ 
				fgets(filename, sizeof(filename), ctrlfile);
				fclose(ctrlfile);
				printf("%5d   0 %s", id, filename);
				count++;
			}
		}
	}
	closedir(spooldir);
	if (count == 0)
	{
		printf("    -  -   <none>\n");
	}
	
	printf("-------------------------------------------------\n");
	printf("Total files in queue: %d\n", count);
	
 	RemoveLockFile();
}
