/* *** l3rm
   *** Filename: l3rm.c
   *** Description: Removes WAV files from the encoding queue
   *** Version: 0.80 [19980210] | Sander Steffann & Michiel Bronswijk
   ***          1.00 [19980225] | Release version 1.00
   *** Remarks:
*/
#include <stdio.h>
#include <sys/param.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <syslog.h>
#include <fcntl.h>
#include <errno.h>
#include "l3spool.h"

void main(int argc, char *argv[])
{
	FILE *ctrlfile;
	char filename[MAXPATHLEN];
	int id;
	int count;
	DIR *spooldir;
	struct dirent *direntry;
	
	printf("l3rm - Version %s (%s %s)\n", L3VERSION, __DATE__, __TIME__);
	printf("Copyright (C) 1998 'Projectgroep MP3-studio voor Linux'\n");

	if (argc<2)
	{
		printf("Usage:\n  %s <queue-id>\n", argv[0]);
		exit(1);
	}
	
	if (atoi(argv[1]) < 1) {
		printf("No valid queue-id\n");
		exit(1);
	}

	if (CreateLockFile() != 0) {
		printf("Couldn't create lockfile, please try again later\n");
		exit(1);
	};
		
	strcpy(filename, SPOOLDIR);
	strcat(filename, "/cfl3.");
	strcat(filename, argv[1]);
	
	if (unlink(filename) == 0)
	{
		printf("Item removed\n");
	}
	else
	{
		printf("No item with that ID! (I think)\n");
	}

 	RemoveLockFile();
}
