#pragma interface
#ifndef INTERNAL_H
#define INTERNAL_H

#ifndef MISC_H
	#include <misc.h>
#endif

#ifndef DIALOG_H
	#include "dialog.h"
#endif


class BUTTONS_INFO {
	int but_options;	// Set of MENUBUT_xxxx
	int nb;
	const char *tb_title[10];
	const char *tb_icon[10];
	MENU_STATUS tbret[10];	// Return code associated with a button
	int y;			/* Coordinate of the line where the buttons are drawn */
	int tbx[10];	/* Horizontal coordinate of each buttons */
	SSTRING helpfile;	/* File to show when help is selected */
	struct {
		short int id;
		SSTRING title;
		SSTRING icon;
	}tbusr[10];
	int nbusr;
	/*~PROTOBEG~ BUTTONS_INFO */
public:
	BUTTONS_INFO (void);
	MENU_STATUS bid2status (int id);
	MENU_STATUS dokey (WINDOW *dialog,
		 int key,
		 int &selected,
		 int other_focus);
	void draw (WINDOW *dialog, int button);
	int evalwidth (void);
	void gui_draw (void);
private:
	void help (WINDOW *win);
public:
	void html_draw (void);
	void set (int _but_options, HELP_FILE&_helpfile);
	void setbutinfo (int id,
		 const char *title,
		 const char *icon);
	void setcursor (WINDOW *dialog, int button);
	void setup (int _y, int width);
	/*~PROTOEND~ BUTTONS_INFO */
};

class HTML_VARVAL{
	SSTRINGS vars;
	SSTRINGS vals;
	SSTRING context;
	int id;
	/*~PROTOBEG~ HTML_VARVAL */
public:
	HTML_VARVAL (const char *key);
	void add (const char *var, const char *val);
	int exist (const char *var);
	const char *getcontext (void);
	int getid (void);
	int getnb (void);
	const char *getval (const char *var, int &exist);
	const char *getval (int no);
	const char *getvar (int no);
	/*~PROTOEND~ HTML_VARVAL */
};

class FIELD_MENU: public FIELD_STRING{
	friend	class DIALOG;
	friend	class DIALOG_LISTE;
	friend	class DIALOG_RECORDS;
	friend	class DIALOG_MENU;
	int tbcol[DIALOG_MAXCOL];	// Width of each columns
	char *tag;
	char *icon;	// Xpm icon file or NULL
	char tag_is_key;	// Only the tag is used for the htmlkey
						// see FIELD_MENU::format_htmlkey()
	/*~PROTOBEG~ FIELD_MENU */
public:
	FIELD_MENU (const char *_icon,
		 const char *_tag,
		 const char *_str);
protected:
	void dokey (WINDOW *, int , FIELD_MSG&);
public:
	void drawgen (WINDOW *win, int selected);
	void drawtxt (WINDOW *dialog);
	void format_htmlkey (char *key, int);
	const char *getmenustr (void)const;
protected:
	int getwidths (int tb[], int &);
public:
	void gui_draw (int nof, int &);
	void html_draw (int nof);
	int html_validate (int);
protected:
	void restore (void);
	void save (void);
public:
	void setcursor (WINDOW *dialog);
	void setwidths (int total_width, int tb[]);
	void unselect (WINDOW *dialog);
	~FIELD_MENU (void);
	/*~PROTOEND~ FIELD_MENU */
};

class DIALOG_INTERNAL{
public:
	BUTTONS_INFO *buttons;
	int button;	// Button currently selected or -1
	int width;
	int height;
	SSTRING title;
	SSTRING sidetitle;
	SSTRING intro;
	SSTRING icon;
	int offset;	// Number of the first visible field
	int nbvisible;	// How many field are visible (window height)
	struct {
		SSTRING save;
		SSTRING ins;
		SSTRING add;
		SSTRING del;
	}what;	// Small explanation about the behavior of some special
		// buttons.
	struct {
		SSTRING top;
		SSTRING intro;
		SSTRING body;
		SSTRING end;
	}html_bypass;
	SSTRING internal_title;
	int  guidone;
	bool all_protected;
	bool autonewline;
	// Specific to FIELD_MENU
	int treelevel;
	int last_visited;	// Last field visited
	// Specific to DIALOG_LISTE
	DIALOG_RECORDS *subdia;
	int *lookup;
	int nblookup;
	bool height_hint;
};

extern int treemenu_pos[20];		// Assume maximum 20 levels of menu

#endif

