#include "internal.h"
#include "apache.m"

static APACHE_HELP_FILE help_dir ("dir");

PUBLIC void HTTPD_OVERRIDE::setallopt(int val)
{
	char cval = (val != 0) ? 1 : 0;
	authconfig = cval;
	fileinfo = cval;
	indexes = cval;
	limit = cval;
	options = cval;
}

PUBLIC HTTPD_OVERRIDE::HTTPD_OVERRIDE()
{
	setallopt (1);
}

PUBLIC void HTTPD_OVERRIDE::setdia (DIALOG &dia)
{
	dia.newf_title ("",MSG_U(T_OVERRIDE,"Override policies"));
	dia.newf_chk ("",authconfig,MSG_U(I_AUTHCONFIG,"Authentification configs"));
	dia.newf_chk ("",fileinfo,MSG_U(I_FILEINFO,"File info"));
	dia.newf_chk ("",indexes,MSG_R(I_INDEXES));
	dia.newf_chk ("",limit,MSG_U(I_LIMIT,"Limits"));
	dia.newf_chk ("",options,MSG_U(I_OPTIONS,"Options"));
}

PUBLIC int HTTPD_DIR::edit()
{
	int ret = -1;
	DIALOG dia;
	dia.newf_str (MSG_U(F_PATH,"Directory path"),path);
	feats.setdia (dia);
	over.setdia (dia);
	int nof = 0;
	while (1){
		MENU_STATUS code = dia.edit (MSG_U(T_DIRRULES,"Directory rules")
			,MSG_U(I_DIRRULES,"You are allowed to enter configurations\n"
				"whch apply to this directory and its sub-directories\n")
			,help_dir
			,nof,MENUBUT_ACCEPT|MENUBUT_CANCEL|MENUBUT_DEL);
		if (code == MENU_ESCAPE || code == MENU_CANCEL){
			break;
		}else if (code == MENU_DEL){
			if (xconf_delok()){
				ret = 1;
				break;
			}
		}else{
			ret = 0;
			break;
		}
	}
	if (ret != 0) dia.restore();
	return ret;
}

PUBLIC HTTPD_DIR *HTTPD_DIRS::getitem(int no) const
{
	return (HTTPD_DIR*)ARRAY::getitem(no);
}

static HTTPD_CONFIG *httpd;

PUBLIC int HTTPD_DIRS::write()
{
	return httpd->write();
}

PUBLIC int HTTPD_DIRS::edit(HTTPD_CONFIG &_httpd)
{
	httpd = &_httpd;
	int ret = -1;
	int nof = 0;
	while (1){
		DIALOG dia;
		int n = getnb();
		for (int i=0; i<n; i++){
			HTTPD_DIR *d = getitem(i);
			dia.new_menuitem("",d->path.get());
		}
		dia.addwhat (MSG_U(I_NEWDIR,"Select [Add] to add a new directory rule"));
		MENU_STATUS code = dia.editmenu (MSG_U(T_DIRS,"Directories")
			,MSG_U(I_DIRS,"You can override various rules directory\n"
				"per directory")
			,help_dir
			,nof,0);
		if (code == MENU_ESCAPE || code == MENU_QUIT){
			break;
		}else if (code == MENU_ADD){
			HTTPD_DIR *d = new HTTPD_DIR;
			ret = editone (d);
		}else if (nof < n && nof >= 0){
			ret = editone (nof);
		}
	}
	return ret;
}

