#include "internal.h"
#include "apache.m"

static APACHE_HELP_FILE help_apache ("apache");


PUBLIC void HTTPD_FEATURES::setdia (DIALOG &dia)
{
	dia.newf_title ("",MSG_U(T_FEATURES,"Features"));
	dia.newf_chk   ("",includes,MSG_U(I_INCLUDES,"Server side includes"));
	dia.newf_chk   ("",includesnoexec,MSG_U(I_INCLUDESNOEXEC,"IncludesNOEXEC"));
	dia.newf_chk   ("",execcgi,MSG_U(I_EXECCGI,"May execute CGI"));
	dia.newf_chk   ("",indexes,MSG_U(I_INDEXES,"Indexes"));
	dia.newf_chk   ("",followsymlinks,MSG_U(I_FOLLOWSYMLINK,"May follow symlinks"));
	dia.newf_chk   ("",symlinksifownermatch,MSG_U(I_FOLLOWOWNERSYMLINK
		,"Follow symlink if owner matches"));
	dia.newf_chk   ("",multiviews,MSG_U(I_MULTIVIEWS,"Multi views"));
}

PUBLIC void HTTPD_DOMOPT::setdia (
	DIALOG &dia,
	bool advanced)		// Show advanced features
{
	dia.newf_str (MSG_U(F_SERVERADMIN,"Administrator email"),serveradmin);
	dia.newf_str (MSG_U(F_SERVERNAME,"Server name"),servername);
	dia.newf_str (MSG_U(F_SERVERALIAS,"Server aliases"),serveralias);
	dia.newf_str (MSG_U(F_DOCUMENTROOT,"Document root"),documentroot);
	dia.newf_str (MSG_U(F_ERRLOG,"Error log"),errorlog);
	dia.newf_str (MSG_U(F_TRANSFERLOG,"Transfer log"),transferlog);
	dia.newf_str (MSG_U(F_AGENTLOG,"Agent log"),agentlog);
	dia.newf_str (MSG_U(F_REFERERLOG,"Referer log"),refererlog);
	if (advanced){
		dia.newf_str (MSG_U(F_SCRIPTALIAS,"Script Alias"),scriptalias);
		dia.newf_str (MSG_U(F_SETUIDUSER,"CGI SetUID User"),setuiduser);
		dia.newf_str (MSG_U(F_SETUIDGROUP,"CGI SetUID Group"),setuidgroup);
	}
}

PUBLIC int HTTPD_CONFIG::editdefaults()
{
	int ret = -1;
	DIALOG dia;
	defdom.setdia (dia,true);
	dia.newf_title ("",MSG_U(T_TUNING,"Tuning"));
	dia.newf_num (MSG_U(F_LISTENPORT,"Listen on port"),port);
	dia.newf_num (MSG_U(F_STARTSERVERS,"Start servers"),startservers);
	dia.newf_num (MSG_U(F_MAXCLIENTS,"Max clients per servers"),maxclients);
	dia.newf_num (MSG_U(F_MAXREQUESTS,"Max requests per child"),maxrequestsperchild);
	dia.newf_num (MSG_U(F_MINSPARESERVERS,"Minimum of spare servers"),minspareservers);
	dia.newf_num (MSG_U(F_MAXSPARESERVERS,"Maximum of spare servers"),maxspareservers);
	dia.newf_str (MSG_U(F_PIDFILE,"Pid file"),pidfile);
	#if 0
		dia.newf_str (MSG_U(F_UID,"Execute as user"),user);
		dia.newf_str (MSG_U(F_GID,"Execute as group"),group);
	#endif
	dia.newf_num (MSG_U(F_TIMEOUT,"Connection timeout"),timeout);
	dia.newf_chk ("",hostnamelookups,MSG_U(I_HOSTNAMELOOKUPS,"Host name lookups"));
	defdom.feats.setdia (dia);
	int nof = 0;
	while (1){
		MENU_STATUS code = dia.edit (
			MSG_U(T_APACHEDEF,"Apache defaults")
			,MSG_U(I_APACHEDEF,"You can configure the base setup and\n"
				"some defaults")
			,help_apache
			,nof);
		if (code == MENU_CANCEL || code == MENU_ESCAPE){
			break;
		}else if (code == MENU_ACCEPT){
			ret = 0;
			write();
			break;
		}
	}
	if (ret == -1) dia.restore();
	return ret;
}

int httpd_edit()
{
	int ret = 0;
	static const char *m_def = MSG_U(M_DEFAULT,"Defaults");
	static const char *m_domains = MSG_U(M_DOMAINS,"Virtual domains");
	static const char *m_subdirs = MSG_U(M_SUBDIRS,"Sub-directory specs");
	static const char *menuopt[]={
		"",		m_def,
		"",		m_domains,
		"",		m_subdirs,
		NULL,
	};
	DIALOG_MENU dia;
	dia.new_menuitems (menuopt);
	int choice=0;
	while (1){
		MENU_STATUS code = dia.editmenu (MSG_U(T_APACHE,"Apache administration")
			,MSG_U(I_APACHE,"This menu allows to configure the Apache web server")
			,help_apache
			,choice,0);
		if (code == MENU_QUIT || code == MENU_ESCAPE){
			break;
		}else{
			const char *key = menuopt[choice*2+1];
			HTTPD_CONFIG conf;
			if (key == m_def){
				conf.editdefaults();
			}else if (key == m_domains){
				conf.domains.edit(conf);
			}else if (key == m_subdirs){
				conf.dirs.edit(conf);
			}
		}
	}	
	return ret;
}
