/* _dict.cc 14/08/96 15.08.30 */
/* bind8.cc 21/10/98 19.03.00 */
PUBLIC BIND8_LEXPARSE::BIND8_LEXPARSE (CONFIG_FILE&_cfg);
PUBLIC BIND8_LEXPARSE::~BIND8_LEXPARSE (void);
PUBLIC bool BIND8_LEXPARSE::isok (void);
PRIVATE int BIND8_LEXPARSE::fillbuf (void);
PUBLIC const char *BIND8_LEXPARSE::gettoken (void);
PUBLIC void BIND8_LEXPARSE::error (const char *ctl, ...);
PUBLIC const char *BIND8_LEXPARSE::getarg1 (void);
PUBLIC bool BIND8_LEXPARSE::getarg_yesno (void);
PUBLIC bool BIND8_LEXPARSE::waserr (void);
PUBLIC int BIND8_LEXPARSE::expect (const char *s);
/* dns.cc 05/12/98 10.20.56 */
PUBLIC CONFIG_FILE_DNS::CONFIG_FILE_DNS (const char *_path);
PUBLIC int CONFIG_FILE_DNS::extract (SSTREAM&ss);
PRIVATE void DNS::parse4 (char *buf,
	 const char *fpath,
	 int noline,
	 bool extract);
PRIVATE void DNS::parseoptions (BIND8_LEXPARSE&lex);
PRIVATE void DNS::parseforwarders (BIND8_LEXPARSE&lex);
PRIVATE void DNS::parsezone (BIND8_LEXPARSE&lex, bool extract);
PRIVATE void DNS::parse8 (BIND8_LEXPARSE&lex, bool extract);
PUBLIC void DNS::setlocalhost (void);
PRIVATE void DNS::init (bool extract);
PUBLIC DNS::DNS (void);
PUBLIC DNS::DNS (bool extract);
PUBLIC int DNS::empty (void);
PUBLIC void DNS::basiccheck (void);
PRIVATE void DNS::mkzonedir (void);
PUBLIC int DNS::write (void);
PUBLIC int DNS::set (const char *fqhost,
	 const char *tbip[],
	 int nbip,
	 char doreverse[],
	 int &matchrev);
PUBLIC int DNS::setfromip (const char *host, const char *ip);
PUBLIC int DNS::set (const char *fqhost,
	 const char *tbip[],
	 int nbip);
PUBLIC int DNS::setns (const SSTRING&fqhost, const SSTRINGS&tbns);
PUBLIC int DNS::setmx (const SSTRING&fqhost, const SSTRINGS&tbmx);
PUBLIC void DNS::unset (const char *fqhost);
PUBLIC void DNS::unsetns (const SSTRING&fqhost);
PUBLIC void DNS::unsetmx (const SSTRING&fqhost);
PUBLIC int DNS::setcname (const SSTRING&fqhost, const SSTRING&cname);
PUBLIC PRIMARY *DNS::finddomain (const char *name)const;
PUBLIC SECONDARY *DNS::findsecond (const char *name)const;
PRIVATE void DNS::setconfig (SSTRING&p);
PUBLIC void DNS::listconfigs (void);
PUBLIC long DNS::getrevdate (void);
PUBLIC PRIMARY *DNS::findprimary (const char *host);
/* dnscheck.cc 16/09/95 13.32.38 */
PUBLIC void DNS::check (void);
/* dnsconf.cc 07/12/98 20.43.06 */
PUBLIC void DNS::editforwarders (void);
PUBLIC int DNS::edit (void);
PUBLIC int DNS::was_modified (void);
/* dnsmxs.cc 14/08/96 15.09.00 */
PUBLIC void DNS::editmxs (void);
/* dnsrecs.cc 08/10/98 11.38.02 */
PRIVATE int DNS::update_one (SSTRING&full,
	 IP_ADDRS&tba,
	 SSTRINGS&tbns,
	 SSTRINGS&tbmx,
	 SSTRING&cname,
	 char doreverse[4]);
PRIVATE int DNS::update_one (SSTRING&full,
	 IP_ADDRS&tba,
	 SSTRINGS&tbns,
	 SSTRINGS&tbmx,
	 SSTRING&cname);
PUBLIC void DNS::getalladr (IP_ADDRS&adrs);
PUBLIC void DNS::setip_in_dia (DIALOG&dia,
	 int level,
	 IP_ADDRS&tba,
	 const char *title);
PUBLIC void DNS::setip_in_dia (DIALOG&dia, IP_ADDRS&tba);
PRIVATE void DNS::editone_rev (SSTRING&full);
PRIVATE int DNS::check_dup (SSTRING&full,
	 IP_ADDRS&tba,
	 char doreverse[4]);
PUBLIC void DNS::editone (const char *name);
PUBLIC void DNS::editrecs (const char *preset);
/* features.cc 21/10/98 21.14.44 */
PUBLIC void DNS::editfeatures (void);
/* fqhost.cc 25/04/98 11.28.48 */
PRIVATE void FQHOST::init (const char *host);
PUBLIC FQHOST::FQHOST (const char *host);
PUBLIC FQHOST::FQHOST (const SSTRING&host);
PUBLIC FQHOST::FQHOST (const char *host, const char *domain);
PUBLIC int FQHOST::is_member (const char *domain, char *hostpart);
PUBLIC int FQHOST::is_reverse (void);
PUBLIC const char *FQHOST::gethostpart (const char *domain);
PUBLIC void FQHOST::formatfull (char *full);
PUBLIC void FQHOST::formatfull (SSTRING&full);
/* helpf.cc 14/08/96 15.09.36 */
PUBLIC DNSCONF_HELP_FILE::DNSCONF_HELP_FILE (const char *fname);
/* internal.cc 27/08/95 21.36.10 */
/* ipmap.cc 06/01/98 03.10.50 */
PUBLIC IPMAP *IPMAPS::getitem (int no);
PUBLIC IPMAPS::IPMAPS (void);
PUBLIC int IPMAPS::write (void);
PUBLIC void IPMAPS::setuse (IP_ADDRS&adrs);
PUBLIC void IPMAPS::setcombo (class FIELD_COMBO *comb);
PRIVATE void IPMAPS::newdiaf (DIALOG&dia, IPMAP *e);
PUBLIC int IPMAPS::edit (void);
PUBLIC int IPMAPS::allocateip (const char *range,
	 char *ip,
	 DNS&dns);
/* misc.cc 30/07/97 23.45.38 */
PUBLIC CACHEFILE::CACHEFILE (const char *_domain, const char *_path);
PUBLIC const char *CACHEFILE::getname (void);
PUBLIC void CACHEFILE::abspath (const char *basepath, char *abspath);
PUBLIC CACHEFILE *CACHEFILES::getitem (int no);
/* mod_dnsconf.cc 04/01/99 22.12.00 */
PUBLIC MODULE_dnsconf::MODULE_dnsconf (void);
PUBLIC void MODULE_dnsconf::setmenu (DIALOG&dia, MENU_CONTEXT context);
PUBLIC int MODULE_dnsconf::domenu (MENU_CONTEXT context,
	 const char *key);
PUBLIC int MODULE_dnsconf::dohtml (const char *key);
PUBLIC int MODULE_dnsconf::probe (int , int , bool);
PUBLIC int MODULE_dnsconf::message (const char *msg,
	 int ,
	 const char *[]);
PUBLIC void MODULE_dnsconf::usage (SSTRINGS&tb);
PUBLIC int MODULE_dnsconf::execmain (int argc, char *argv[]);
/* origin.cc 02/11/97 19.08.52 */
PUBLIC ORIGIN::ORIGIN (const char *_origin);
PUBLIC void ORIGIN::print (bool save_ori, TBFILE&tbf)const;
PUBLIC int ORIGIN::getalladr (IP_ADDRS&adrs);
PUBLIC int ORIGIN::was_modified (void);
PRIVATE int ORIGINS::parsespecial (const char *key,
	 const char *pt,
	 const char *first_origin,
	 TBFILE&tbf,
	 ORIGIN *&ori);
PRIVATE int ORIGINS::parseend (char *pt,
	 RECORD_PARSE&p,
	 ORIGIN *ori);
PUBLIC ORIGIN *ORIGINS::getitem (int no)const;
PUBLIC int ORIGINS::read (const char *named_dir,
	 const char *fname,
	 const char *first_origin,
	 bool extract);
PUBLIC int ORIGINS::save (const char *named_dir,
	 const char *fname)const;
/* primary.cc 20/12/98 14.41.22 */
PUBLIC PRIMARY::PRIMARY (const char *_domain,
	 const char *_file,
	 const char *named_dir,
	 bool extract);
PUBLIC PRIMARY::PRIMARY (void);
PUBLIC VIRTUAL void PRIMARY::setfromv (void);
PUBLIC PRIMARY_REV::PRIMARY_REV (const char *_domain,
	 const char *_file,
	 const char *named_dir,
	 bool extract);
PUBLIC PRIMARY_REV::PRIMARY_REV (void);
PUBLIC void PRIMARY_REV::setfromv (void);
PUBLIC int PRIMARY::was_modified (void);
PUBLIC VIRTUAL int PRIMARY::is_reverse (void);
PUBLIC int PRIMARY_REV::is_reverse (void);
PUBLIC int PRIMARY::getalladr (IP_ADDRS&adrs);
PRIVATE RECORD *PRIMARY::getfirst (RECORD_TYPE rtype);
PUBLIC RECORD_IN_SOA *PRIMARY::getsoa (void);
PUBLIC int PRIMARY::getns (SSTRING&dom, RECORDS&recs);
PUBLIC int PRIMARY::getns (SSTRING&dom, SSTRINGS&strs);
PUBLIC int PRIMARY::getmx (SSTRING&dom, RECORDS&recs);
PUBLIC int PRIMARY::getmx (SSTRING&dom, SSTRINGS&strs);
PUBLIC int PRIMARY::geta (SSTRING&dom, RECORDS&recs);
PUBLIC int PRIMARY::geta (SSTRING&dom, IP_ADDRS&adrs);
PUBLIC int PRIMARY::getcname (SSTRING&dom, SSTRING&cname);
PUBLIC void PRIMARY::updatesoa (void);
PUBLIC void PRIMARY::format_revision (char *buf);
PUBLIC int PRIMARY::write (bool bind8,
	 FILE *fout,
	 const char *named_dir)const;
PUBLIC void PRIMARY::addrec (RECORD *rec);
PUBLIC void PRIMARY::setupdia (DIALOG&dia,
	 DNS&dns,
	 int level,
	 PRIMARY_EDITINFO&info);
PUBLIC int PRIMARY::edit (DNS&dns);
PUBLIC PRIMARY *PRIMARYS::getitem (int no)const;
PUBLIC PRIMARY *PRIMARYS::getitem (const char *name)const;
PUBLIC int PRIMARYS::getalladr (IP_ADDRS&adrs);
PUBLIC PRIMARY *PRIMARYS::getitem (FQHOST&fq,
	 char *hostpart,
	 int dontitself);
PUBLIC PRIMARY *PRIMARYS::getitem (FQHOST&fq, char *hostpart);
PUBLIC int PRIMARYS::write (bool bind8,
	 FILE *fout,
	 const char *named_dir)const;
PUBLIC VIRTUAL PRIMARY *PRIMARYS::new_PRIMARY (void);
PUBLIC PRIMARY *PRIMARYS_REV::new_PRIMARY (void);
PUBLIC void PRIMARYS::edit (DNS&dns);
PUBLIC int PRIMARYS::adddomain (const char *domain,
	 const char *example,
	 DNS&dns);
PUBLIC int DNS::newdomain (const char *domain, const char *example);
/* primbydom.cc 20/12/98 14.41.44 */
PUBLIC RECORD_ITEM::RECORD_ITEM (RECORD *rec, const char *relname);
PUBLIC RECORD_ITEM *RECORD_ITEMS::getitem (int no)const;
PUBLIC void PRIMARY::edithosts (DNS&dns);
PRIVATE void PRIMARYS::setselect (DIALOG&dia);
PUBLIC void PRIMARYS::editbydom (DNS&dns);
/* primquery.cc 23/07/97 22.55.18 */
PUBLIC int PRIMARY::set (FQHOST&fq, RECORD *new_rec);
PUBLIC int PRIMARY::unset (RECORD *new_rec);
PUBLIC int PRIMARY::unset_left (const char *left);
PUBLIC int PRIMARY::locate_left (FQHOST&fq,
	 RECORD_TYPE rtype,
	 RECORDS&recs);
PUBLIC int PRIMARY::locate_rev (const char *fullname, IP_ADDRS&tba);
PUBLIC int PRIMARY::locate_right (const char *value,
	 RECORD_TYPE rtype,
	 SSTRINGS&recs);
PUBLIC int PRIMARYS::locate_right (const char *value,
	 RECORD_TYPE rtype,
	 SSTRINGS&recs);
PUBLIC int DNS::locate_ip (const char *ip, SSTRINGS&recs);
PUBLIC PRIMARY *DNS::locate_domain (const char *domain);
/* record.cc 19/08/97 23.29.10 */
PUBLIC RECORD::RECORD (RECORD_TYPE _id);
PUBLIC bool RECORD::is (RECORD_TYPE _id);
PUBLIC VIRTUAL void RECORD::sethostpart (const char *);
PROTECTED VIRTUAL int RECORD::cmpsame (const RECORD *);
PUBLIC VIRTUAL int RECORD::set (const RECORD *);
PUBLIC int RECORD::cmp (RECORD *other);
PUBLIC VIRTUAL int RECORD::cmp_left (const char *);
PUBLIC VIRTUAL const char *RECORD::get_left (void);
PUBLIC VIRTUAL int RECORD::cmp_right (const char *);
PUBLIC RECORD_IN::RECORD_IN (const RECORD_PARSE&p, RECORD_TYPE _id);
PUBLIC RECORD_IN::RECORD_IN (RECORD_TYPE _id);
PUBLIC void RECORD::setcomment (const char *str);
PUBLIC RECORD_COMMENT::RECORD_COMMENT (const char *str);
PUBLIC void RECORD_COMMENT::print (FILE *fout)const;
PUBLIC RECORD_IN_A::RECORD_IN_A (const RECORD_PARSE&p);
PUBLIC RECORD_IN_A::RECORD_IN_A (const char *_name, const char *_addr);
PUBLIC void RECORD_IN_A::sethostpart (const char *hostpart);
PROTECTED int RECORD_IN_A::cmpsame (const RECORD *other);
PROTECTED int RECORD_IN_A::cmp_left (const char *str);
PROTECTED int RECORD_IN_A::cmp_right (const char *str);
PUBLIC VIRTUAL const char *RECORD_IN_A::get_left (void);
PUBLIC int RECORD_IN_A::set (const RECORD *other);
PUBLIC int RECORD_IN_A::cmphost (const char *host);
PUBLIC void RECORD_IN_A::setip (const char *ip);
PUBLIC void RECORD_IN_A::print (FILE *fout)const;
PUBLIC RECORD_IN_PTR::RECORD_IN_PTR (const RECORD_PARSE&p);
PUBLIC RECORD_IN_PTR::RECORD_IN_PTR (const char *iprev,
	 const char *host);
PROTECTED int RECORD_IN_PTR::cmpsame (const RECORD *other);
PROTECTED int RECORD_IN_PTR::cmp_left (const char *str);
PROTECTED int RECORD_IN_PTR::cmp_right (const char *str);
PUBLIC int RECORD_IN_PTR::set (const RECORD *other);
PUBLIC void RECORD_IN_PTR::sethostpart (const char *hostpart);
PUBLIC void RECORD_IN_PTR::print (FILE *fout)const;
PUBLIC int RECORD_IN_PTR::cmpip (const char *ip);
PUBLIC RECORD_IN_NS::RECORD_IN_NS (const RECORD_PARSE&p);
PUBLIC RECORD_IN_NS::RECORD_IN_NS (const char *_name, const char *_ns);
PUBLIC RECORD_IN_NS::RECORD_IN_NS (void);
PROTECTED int RECORD_IN_NS::cmpsame (const RECORD *other);
PUBLIC int RECORD_IN_NS::set (const RECORD *other);
PUBLIC void RECORD_IN_NS::sethostpart (const char *hostpart);
PUBLIC int RECORD_IN_NS::cmp_left (const char *str);
PUBLIC void RECORD_IN_NS::print (FILE *fout)const;
PUBLIC RECORD_IN_CNAME::RECORD_IN_CNAME (const RECORD_PARSE&p);
PUBLIC RECORD_IN_CNAME::RECORD_IN_CNAME (const char *cname,
	 const char *realname);
PUBLIC int RECORD_IN_CNAME::cmp_left (const char *str);
PUBLIC void RECORD_IN_CNAME::sethostpart (const char *hostpart);
PROTECTED int RECORD_IN_CNAME::cmpsame (const RECORD *other);
PUBLIC void RECORD_IN_CNAME::print (FILE *fout)const;
PUBLIC RECORD_IN_MX::RECORD_IN_MX (const RECORD_PARSE&p);
PUBLIC RECORD_IN_MX::RECORD_IN_MX (const char *_mailname,
	 int priority,
	 const char *_servname);
PROTECTED int RECORD_IN_MX::cmpsame (const RECORD *other);
PUBLIC int RECORD_IN_MX::set (const RECORD *other);
PUBLIC int RECORD_IN_MX::cmp_left (const char *str);
PUBLIC void RECORD_IN_MX::print (FILE *fout)const;
PUBLIC void RECORD_IN_MX::sethostpart (const char *hostpart);
PUBLIC RECORD_PARSE::RECORD_PARSE (void);
PUBLIC RECORD_INCLUDE::RECORD_INCLUDE (const char *_path);
PUBLIC void RECORD_INCLUDE::print (FILE *fout)const;
PUBLIC RECORD_END_INCLUDE::RECORD_END_INCLUDE (void);
PUBLIC void RECORD_END_INCLUDE::print (FILE *)const;
PUBLIC RECORD *RECORDS::getitem (int no)const;
PUBLIC int RECORDS::save (TBFILE&tbf)const;
/* secondary.cc 20/12/98 14.42.02 */
PUBLIC SECONDARY::SECONDARY (const char *_domain,
	 const char *_backup,
	 const char **_ip_addr,
	 int nb_ip);
PUBLIC SECONDARY::SECONDARY (void);
PUBLIC void SECONDARY::write (bool bind8,
	 FILE *fout,
	 const char *named_dir)const;
PUBLIC int SECONDARY::edit (DNS&dns);
PUBLIC SECONDARY *SECONDARYS::getitem (int no)const;
PUBLIC SECONDARY *SECONDARYS::getitem (const char *name)const;
PUBLIC void SECONDARYS::write (bool bind8,
	 FILE *fout,
	 const char *named_dir)const;
PUBLIC void SECONDARYS::edit (DNS&dns);
/* soa.cc 25/02/98 14.52.56 */
PUBLIC RECORD_IN_SOA::RECORD_IN_SOA (const RECORD_PARSE&p);
PUBLIC RECORD_IN_SOA::RECORD_IN_SOA (void);
PUBLIC void RECORD_IN_SOA::print (FILE *fout)const;
PUBLIC void RECORD_IN_SOA::update (const char *name);
/* tbfile.cc 25/02/98 14.37.04 */
PUBLIC TBFILE::TBFILE (const char *_defpath, bool _extract);
PUBLIC TBFILE::~TBFILE (void);
PUBLIC FILE *TBFILE::fopen (const char *fname, const char *mode);
PUBLIC void TBFILE::fclose (void);
/* vhostcomng.cc 08/10/98 11.22.38 */
PUBLIC VIRTUAL_COMNG::VIRTUAL_COMNG (DICTIONARY&_dict);
PUBLIC void VIRTUAL_COMNG::setupdia (DIALOG&dia);
PUBLIC int VIRTUAL_COMNG::save (PRIVILEGE *priv);
PUBLIC int VIRTUAL_COMNG::validate (DIALOG&, int &nof);
PUBLIC int VIRTUAL_COMNG::deluser (PRIVILEGE *);
