/* _dict.cc 03/05/98 00.53.08 */
/* firewall.cc 03/05/98 01.05.00 */
PUBLIC IPFW_RULE *IPFW_RULES::getitem (int no);
PROTECTED void IPFW_RULES::init (CONFDB *_db,
	 const char *key,
	 const char *key_active);
PUBLIC IPFW_RULES_FORWARD::IPFW_RULES_FORWARD (CONFDB *_db);
PUBLIC IPFW_RULES_INPUT::IPFW_RULES_INPUT (CONFDB *_db);
PUBLIC IPFW_RULES_OUTPUT::IPFW_RULES_OUTPUT (CONFDB *_db);
PUBLIC IPFW_RULES_ACCT::IPFW_RULES_ACCT (CONFDB *_db);
PROTECTED int IPFW_RULES::savek (const char *key,
	 const char *key_active);
PUBLIC int IPFW_RULES_FORWARD::save (void);
PROTECTED IPFW_RULE *IPFW_RULES_FORWARD::newrule (void);
PROTECTED IPFW_RULE *IPFW_RULES_FORWARD::newrule (const char *pt);
PUBLIC int IPFW_RULES_INPUT::save (void);
PROTECTED IPFW_RULE *IPFW_RULES_INPUT::newrule (void);
PROTECTED IPFW_RULE *IPFW_RULES_INPUT::newrule (const char *pt);
PUBLIC int IPFW_RULES_OUTPUT::save (void);
PROTECTED IPFW_RULE *IPFW_RULES_OUTPUT::newrule (void);
PROTECTED IPFW_RULE *IPFW_RULES_OUTPUT::newrule (const char *pt);
PUBLIC int IPFW_RULES_ACCT::save (void);
PROTECTED IPFW_RULE *IPFW_RULES_ACCT::newrule (void);
PROTECTED IPFW_RULE *IPFW_RULES_ACCT::newrule (const char *pt);
PUBLIC int IPFW_RULES::edit (void);
PUBLIC int IPFW_RULES_INPUT::disable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_INPUT::enable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_INPUT::kernelok (void);
PUBLIC int IPFW_RULES_OUTPUT::disable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_OUTPUT::enable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_FORWARD::disable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_FORWARD::enable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_ACCT::disable (int doit, SSTRING *collect);
PUBLIC int IPFW_RULES_ACCT::enable (int , SSTRING *);
PUBLIC int IPFW_RULES_FORWARD::kernelok (void);
PUBLIC int IPFW_RULES_OUTPUT::kernelok (void);
PUBLIC int IPFW_RULES_ACCT::kernelok (void);
PRIVATE void IPFW_RULES::reset_nbbitmsk (void);
PUBLIC int IPFW_RULES::setup (int doit, SSTRING *collect);
/* ipfw.cc 03/05/98 01.03.48 */
/* ipfwrule.cc 03/05/98 01.35.42 */
PROTECTED IPFW_RULE::IPFW_RULE (void);
PROTECTED IPFW_RULEP::IPFW_RULEP (void);
PROTECTED IPFW_RULE::IPFW_RULE (const char *&buf);
PROTECTED IPFW_RULEP::IPFW_RULEP (const char *&buf);
PUBLIC IPFW_RULE_FORWARD::IPFW_RULE_FORWARD (const char *buf);
PUBLIC IPFW_RULE_FORWARD::IPFW_RULE_FORWARD (void);
PUBLIC IPFW_RULE_OUTPUT::IPFW_RULE_OUTPUT (const char *buf);
PUBLIC IPFW_RULE_OUTPUT::IPFW_RULE_OUTPUT (void);
PUBLIC IPFW_RULE_INPUT::IPFW_RULE_INPUT (const char *buf);
PUBLIC IPFW_RULE_INPUT::IPFW_RULE_INPUT (void);
PUBLIC IPFW_RULE_ACCT::IPFW_RULE_ACCT (const char *buf);
PUBLIC IPFW_RULE_ACCT::IPFW_RULE_ACCT (void);
PROTECTED void IPFW_RULE::savek (char *buf);
PUBLIC void IPFW_RULE_FORWARD::save (CONFDB *db);
PUBLIC void IPFW_RULE_INPUT::save (CONFDB *db);
PUBLIC void IPFW_RULE_OUTPUT::save (CONFDB *db);
PUBLIC void IPFW_RULE_ACCT::save (CONFDB *db);
PUBLIC void IPFW_RULE::present (char *buf);
PUBLIC int IPFW_RULE::nbbitmask (IPFW_SRC&f);
PUBLIC int IPFW_RULE::nbbitmask_from (void);
PUBLIC int IPFW_RULE::nbbitmask_to (void);
PUBLIC int IPFW_RULE::cmp_gen_to (IPFW_RULE *r,
	 int masq1,
	 int masq2,
	 int redir1,
	 int redir2);
PUBLIC int IPFW_RULE::cmp_gen_from (IPFW_RULE *r,
	 int masq1,
	 int masq2,
	 int redir1,
	 int redir2);
PUBLIC int IPFW_RULEP::cmp_policy_to (IPFW_RULEP *r,
	 int masq1,
	 int masq2,
	 int redir1,
	 int redir2);
PUBLIC int IPFW_RULEP::cmp_policy_from (IPFW_RULEP *r,
	 int masq1,
	 int masq2,
	 int redir1,
	 int redir2);
PUBLIC int IPFW_RULE_INPUT::cmp_from (IPFW_RULE *r);
PUBLIC int IPFW_RULE_INPUT::cmp_to (IPFW_RULE *r);
PUBLIC int IPFW_RULE_OUTPUT::cmp_from (IPFW_RULE *r);
PUBLIC int IPFW_RULE_OUTPUT::cmp_to (IPFW_RULE *r);
PUBLIC int IPFW_RULE_FORWARD::cmp_from (IPFW_RULE *r);
PUBLIC int IPFW_RULE_FORWARD::cmp_to (IPFW_RULE *r);
PUBLIC int IPFW_RULE_ACCT::cmp_from (IPFW_RULE *r);
PUBLIC int IPFW_RULE_ACCT::cmp_to (IPFW_RULE *r);
PRIVATE int IPFW_RULE::diacheck (IPFW_SRC&s, int &nof);
PUBLIC int IPFW_RULE::editk (DIALOG&dia, const char *title);
PROTECTED void IPFW_RULEP::setpolicy (DIALOG&dia);
PUBLIC int IPFW_RULE_FORWARD::edit (void);
PUBLIC int IPFW_RULE_OUTPUT::edit (void);
PUBLIC int IPFW_RULE_INPUT::edit (void);
PUBLIC int IPFW_RULE_ACCT::edit (void);
PUBLIC int IPFW_RULE::setup (int policy,
	 IPFW_SRC&f,
	 IPFW_SRC&t,
	 const char *type,
	 int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PROTECTED int IPFW_RULEP::setup (IPFW_SRC&f,
	 IPFW_SRC&t,
	 const char *type,
	 int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_FORWARD::setup_left (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_FORWARD::setup_right (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_OUTPUT::setup_left (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_OUTPUT::setup_right (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_INPUT::setup_left (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_INPUT::setup_right (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_ACCT::setup_left (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
PUBLIC int IPFW_RULE_ACCT::setup_right (int doit,
	 SSTRING *collect,
	 SSTRING&errmsg);
/* mod_firewall.cc 21/06/98 01.10.48 */
PUBLIC MODULE_firewall::MODULE_firewall (void);
PUBLIC void MODULE_firewall::setmenu (DIALOG&dia,
	 MENU_CONTEXT context);
PUBLIC int MODULE_firewall::domenu (MENU_CONTEXT context,
	 const char *key);
PUBLIC int MODULE_firewall::dohtml (const char *key);
PUBLIC int MODULE_firewall::probe (int level, int , bool);
PUBLIC int MODULE_firewall::message (const char *msg,
	 int ,
	 const char *[]);
PUBLIC int MODULE_firewall::execmain (int argc, char *argv[]);
