#include <stdio.h>
#include <translat.h>
#include <netconf.h>
#include <popen.h>
#include <daemoni.h>
#include "internal.h"
#include "samba.m"

const char subsys_samba[]="smb";


MODULE_DEFINE_VERSION(samba);

static CONFIG_FILE f_smbpasswd ("/etc/smbpasswd",help_nil
	,CONFIGF_MANAGED|CONFIGF_OPTIONNAL
	,"root","root",0600
	,subsys_samba);

PUBLIC MODULE_SAMBA::MODULE_SAMBA()
	: LINUXCONF_MODULE("samba")
{
	linuxconf_loadmsg ("samba",PACKAGE_REV);
}
static const char *keymenu=NULL;

PUBLIC void MODULE_SAMBA::setmenu (
	DIALOG &dia,
	MENU_CONTEXT context)
{
	if (context == MENU_NETWORK_SERVER){
		keymenu = MSG_U(M_SAMBA,"Samba file server");
		dia.new_menuitem ("samba","",keymenu);
	}
}

PUBLIC int MODULE_SAMBA::domenu (
	MENU_CONTEXT context,
	const char *key)
{
	if (context == MENU_NETWORK_SERVER){
		if (key == keymenu){
			samba_edit();
		}
	}
	return 0;
}

PUBLIC int MODULE_SAMBA::message (const char *msg, int argc, const char *argv[])
{
	int ret = LNCF_NOT_APPLICABLE;
	if (strcmp(msg,"chgpasswd")==0){
		SMB_CONF smb;
		if (smb.syncpass){
			const char *user = argv[0];
			const char *passwd = argv[1];
			ret = 0;
			if (!f_smbpasswd.exist()) f_smbpasswd.create();
			const char smbpasswd[]="smbpasswd";
			DAEMON_INTERNAL *dae = daemon_find (smbpasswd);
			if (dae != NULL && dae->is_managed()){
				char buf[200];
				#if 0
					sprintf (buf,"%s -pipe -add %s",dae->getpath(),user);
				#else
					sprintf (buf,"%s -a %s \"%s\"",dae->getpath(),user,passwd);
				#endif
				POPEN pop (buf);
				FILE *fout = pop.getfout();
				fprintf (fout,"%s\n",passwd);
				fflush (fout);
				while (pop.wait(1)>=0){
					char buf[100];
					if (pop.readout (buf,sizeof(buf)-1) == 0){
						xconf_notice ("%s: %s",smbpasswd,buf);
					}
					if (pop.readerr (buf,sizeof(buf)-1) == 0){
						xconf_error ("%s: %s",smbpasswd,buf);
					}
				}
			}else{
				ret = -1;
			}
		}
	}
	return ret;
}

static MODULE_SAMBA samba;
