#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global Changing_var; 
global CurPos; 
global CurrentFile_var; 
global CurrentSong; 
global ListView; 
global NumOfSongs; 
global bindir; 
global bitrate_var; 
global configfile; 
global filename_var; 
global layer_var; 
global mode_var; 
global mp3loc; 
global playerLocation; 
global playloc; 
global remainingCheck; 
global repeatCheck; 
global samplerate_var; 
global seenHelp; 
global shuffleCheck; 
global status_var; 
global time_var; 
global timeindex; 
global totalCheck; 
global version_var; 
global widget; 
    set widget(CheckingWindow) {.top17}
    set widget(ConfirmExit) {.top35}
    set widget(ConfirmExitMP3Studio) {.top35}
    set widget(DirListWindow) {.top29.fra19.cpd43.01}
    set widget(FileBox) {.top17.cpd27.01}
    set widget(FileListWindow) {.top29.fra19.cpd20.01}
    set widget(MP3player) {.top20}
    set widget(PlayListEditor) {.top29}
    set widget(PlayListWindow) {.top29.fra26.cpd27.01}
    set widget(SelectFile) {.top18}
    set widget(SelectFile_Window) {.top18}
    set widget(loadmp3) {.top22}
    set widget(rev,.top17) {CheckingWindow}
    set widget(rev,.top17.cpd27.01) {FileBox}
    set widget(rev,.top17.scr25) {scrollY}
    set widget(rev,.top18) {SelectFile_Window}
    set widget(rev,.top20) {MP3player}
    set widget(rev,.top22) {loadmp3}
    set widget(rev,.top29) {PlayListEditor}
    set widget(rev,.top29.fra19.cpd20.01) {FileListWindow}
    set widget(rev,.top29.fra19.cpd43.01) {DirListWindow}
    set widget(rev,.top29.fra26.cpd27.01) {PlayListWindow}
    set widget(rev,.top35) {ConfirmExit}
    set widget(scrollY) {.top17.scr25}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc ChangePosition {pos} {
global timeindex songlength_var CurPos status_var NumOfSongs

if { $NumOfSongs > 0 } {


set CurPos [ expr $CurPos + $pos ]

if { $CurPos > $songlength_var } {
  set CurPos $songlength_var
}

if { $CurPos < 0 } {
  set CurPos 0
}

set timeindex [ expr (100 * $CurPos) / $songlength_var ]

if { $status_var == "Playing" } {
  StopPlaying
  ShowTime $CurPos
  StartMp3 $CurPos
} else {
  ShowTime $CurPos
}


}

return
}

proc EndOfSong {} {
global NumOfSongs CurrentSong CurrentFile_var PlayListArray repeatCheck ListView

if { $CurrentSong == $NumOfSongs } {

  set CurrentSong 1 
  set CurrentFile_var $PlayListArray($CurrentSong)
  if { $ListView == 1 } {
    .top26.cpd35.01 selection clear
    .top26.cpd35.01 select set [expr $CurrentSong - 1]
    .top26.cpd35.01 yview [ expr $CurrentSong - 1 ]
  }
  GetMp3Info

  if { $repeatCheck == 1 } {
    StartMp3 0
  }

} else {

  set CurrentSong [ expr $CurrentSong + 1 ]
  set CurrentFile_var $PlayListArray($CurrentSong)
  GetMp3Info
  if { $ListView == 1 } {
     ShowList
  }
  StartMp3 0

}

return
}

proc GenerateShuffleList {} {
global NormalPlayListArray NormalLengthArray NumOfSongs TimeArray
global ShufflePlayListArray ShuffleTimeArray

set date [ exec date ]
set idx [ string last ":" $date ]
set number [ string range $date [expr $idx + 1] [expr $idx + 3] ]
if { [string index $number 0] == "0" } {
  set number [ string range $number 1 end ]
} 
set number [ expr $number / 4 ]

set primelist {17 19 23 29 31 37 41 43 47 51 53 61 71 101 97}
set prime [ lindex $primelist $number ]

if { ($NumOfSongs == [expr $prime - 1 ] ) || ($NumOfSongs == [expr $prime + 1 ]) || ($NumOfSongs == $prime) } {
  set number [ expr $number + 1]
  if { $number > [ llength $primelist ] } {
    set number 1
  }
  set prime [ lindex $primelist $number ]
} 



set IndexEnd 1
set ShuffleTimeArray(1) 0
set index $prime

while { $IndexEnd <= $NumOfSongs } {

  while { $index > $NumOfSongs } {
    set index [ expr $index - $NumOfSongs ]
  }

  set ShufflePlayListArray($IndexEnd) $NormalPlayListArray($index)

  set hulp [ expr $IndexEnd + 1 ]

  set ShuffleTimeArray($hulp) [ expr $ShuffleTimeArray($IndexEnd) + $NormalLengthArray($index) ]

  set index [expr $index + $prime]
  set IndexEnd [expr $IndexEnd + 1]

}

return
}

proc GetMp3Info {} {
global entry_var status_var filename_var version_var layer_var 
global bitrate_var samplerate_var mode_var songlength_var
global CurrentFile_var playerLocation timeindex
global remainingCheck CurPos

set status_var "Getting file info"
set timeindex 0
set CurPos 0

set stream [ open "| $playerLocation/player info $CurrentFile_var " ]

while { ![eof $stream] } {
 set string [ gets $stream ]


 if { [string match "INFO*" $string] == 1 } {
  
# determine filename #

  set hulp1 [ string last Version $string ]
  set hulp2 [ expr $hulp1 - 1 ] 
  set hulp [ string range $string 5 $hulp2 ]
  set hulp0 [ expr [ string last / $hulp ] + 1 ]
  set hulp1 [ string range $hulp $hulp0 $hulp2] 

  set filename_var $hulp1


# determine Version #

  set hulp3 [ string last Layer $string ]
  set hulp4 [ expr $hulp3 - 1 ]
  set hulp5 [ expr $hulp2 + 1 ] 
  set hulp [ string range $string $hulp5 $hulp4 ]

  set version_var $hulp


# determine Layer #

  set hulp6 [ string last Bitrate $string ]
  set hulp7 [ expr $hulp6 - 1 ]
  set hulp8 [ expr $hulp4 + 1 ]
  set hulp [ string range $string $hulp8 $hulp7 ]

  set layer_var $hulp


# determine Bitrate #

  set hulp9  [ string last Samplerate $string ]
  set hulp10 [ expr $hulp9 - 1 ]
  set hulp11 [ expr $hulp7 + 1 ]
  set hulp [ string range $string $hulp11 $hulp10 ]

  set bitrate_var $hulp


# determine Samplerate #

  set hulp12  [ string last Mode $string ]
  set hulp13 [ expr $hulp12 - 1 ]
  set hulp14 [ expr $hulp10 + 12 ]
  set hulp [ string range $string $hulp14 $hulp13 ]

  set samplerate_var "$hulp KHz"


# determine Mode #

  set hulp15  [ string last Duration $string ]
  set hulp16 [ expr $hulp15 - 1 ]
  set hulp17 [ expr $hulp13 + 5 ]
  set hulp [ string range $string $hulp17 $hulp16 ]

  set mode_var $hulp


# determine Duration #

  set hulp18 [ string last Duration $string ]
  set hulp19 [ expr $hulp18 + 9 ]
  set hulp [ string range $string $hulp19 end ]

  set songlength_var $hulp
  if { $remainingCheck == 1} {
     ShowTime $hulp
  } else {
     ShowTime 0
  }



 }
}


catch { close $stream }

set status_var "Stopped"

return
}

proc GotoNextSong {} {
global PlayListArray NumOfSongs CurrentSong status_var CurrentFile_var

if { $NumOfSongs > 0 } {


set CurrentSong [ expr $CurrentSong + 1 ]

if { $CurrentSong > $NumOfSongs } {
    set CurrentSong 1
}

set CurrentFile_var $PlayListArray($CurrentSong)

if { $status_var == "Playing" } {
  StopPlaying
  GetMp3Info
  StartMp3 0
} else {
  GetMp3Info
}




}

return
}

proc GotoPrevSong {} {
global PlayListArray NumOfSongs CurrentSong status_var CurrentFile_var

if { $NumOfSongs > 0 } {

set CurrentSong [ expr $CurrentSong - 1 ]

if { $CurrentSong < 1 } {
    set CurrentSong $NumOfSongs
}

set CurrentFile_var $PlayListArray($CurrentSong)

if { $status_var == "Playing" } {
  StopPlaying
  GetMp3Info
  StartMp3 0
} else {
  GetMp3Info
}




}
return
}

proc IO_Handler {} {
global waarde stream songlength_var timeindex Changing_var CurPos ListView

if { ![eof $stream] } {
 set waarde [ gets $stream ]
 
 set hulp [ string last Playpos $waarde ]

 if { $hulp > 0 } { 
   set hulp1 [ expr $hulp + 8 ]
   set hulp [ string range $waarde $hulp1 end ]

   set CurPos $hulp
   set precise [ expr (100 * $hulp) / $songlength_var ]

   if { $Changing_var == 0} {
     set timeindex $precise
   }

   ShowTime $hulp
 }

} else {
 catch {close $stream}
 EndOfSong
}


return
}

proc InitPlayWindow {} {
global status_var filename_var version_var layer_var 
global bitrate_var samplerate_var mode_var songlength_var

set filename_var ""
set version_var ""
set layer_var ""
set bitrate_var ""
set samplerate_var ""
set mode_var ""
set songlength_var ""
set status_var "no file selected"

return
}

proc LoadMp3 {} {
global CurrentFile_var

set CurrentFile_var "/home/jeffrey/TCL/MP3Player/rem.mp3"

GetMp3Info
}

proc LoadPlaylist {} {
global PlayListArray CurrentFile_var playerLocation PlayListFilename FileChecking
global TempPlayListArray NumOfSongs FileErrors
global TimeArray TotalTime checkingIndex TempIndex TempTotal
global NormalPlayListArray NormalLengthArray

grab .top17
Window show .top17
set FileChecking 1
set FileErrors 0
set status_var "Reading playlist"

if [ catch { open $PlayListFilename r } fileId ] {
  set ErrorMessage "Error opening playlistfile:\n$fileId"
  Window show .top22
  return

} else {

  set TempTotal 1
  set TempPlayListArray($TempTotal) [ gets $fileId ]

  while { ![eof $fileId] } {

   set TempTotal [expr $TempTotal + 1]
   set TempPlayListArray($TempTotal) [ gets $fileId ]

  }

close $fileId

# Check whether the files are mp3's

# Number of songs in PlayListAr
set NumOfSongs 0

# Total duration
set TotalTime 0         

# Index in TempPlayListArray
set TempIndex 1         

# Array with starting times
set TimeArray(0) 0      

# file errors encountered?
set FileErrors 0        

#clear errorlistbox
.top17.fra18.cpd24.01 delete 0 end

LoadPlaylistStart

}
return
}

proc LoadPlaylistIO_Handler {} {
global FileErrors stream NumOfSongs PlayListArray TempPlayListArray
global TimeArray TotalTime checkingIndex TempIndex TempTotal
global NormalPlayListArray NormalLengthArray playerLocation NormalTimeArray

while { ![eof $stream] } {

  set string [ gets $stream ] 

   if { [string match "INFO*" $string] == 1 } {
   
        # determine Duration #
        set hulp1 [ string last Duration $string ]
        set hulp2 [ expr $hulp1 + 9 ]
        set hulp  [ string range $string $hulp2 end ]

        set NumOfSongs [ expr $NumOfSongs + 1 ]

        # Fill the playlist & copy in NormalPlayList (no shuffle)
        set PlayListArray($NumOfSongs) $TempPlayListArray($TempIndex)
        set NormalPlayListArray($NumOfSongs) $PlayListArray($NumOfSongs)

        # Keep track of starting points & duration of songs & total time
        set TimeArray($NumOfSongs) $TotalTime 
        set NormalTimeArray($NumOfSongs) $TotalTime
        set NormalLengthArray($NumOfSongs) $hulp
        set TotalTime [ expr $TotalTime + $hulp ]

      } else {

        if { [string match "ERROR*" $string] == 1 } {
           set hulp [ string range $string 7 end ]
           .top17.fra18.cpd24.01 insert end $hulp 
        set FileErrors 1
        }
      }

}

catch { close $stream }

set TempIndex [ expr $TempIndex + 1 ]
set checkingIndex [ expr (($TempIndex * 100) / $TempTotal) ]
LoadPlaylistStart

return
}

proc LoadPlaylistStart {} {
# Hier start je steeds het scannen van een file
global stream playerLocation CurrentFile_var FileErrors
global TotalTime shuffleCheck ListView FileChecking
global TempPlayListArray TempIndex   TempTotal
global PlayListArray     CurrentSong NumOfSongs

if { $TempIndex <= $TempTotal } {

  set filename $TempPlayListArray($TempIndex)
  set stream [ open "| $playerLocation/player info $filename " ] 
  fconfigure $stream -blocking 0
  fileevent $stream readable {LoadPlaylistIO_Handler}

} else {

 # If no File errors occured, hide the Checking Window

 set FileChecking 0
 if { $FileErrors == 0 } {
  Window hide .top17
 }

 #Show first file

 set shuffleCheck 0
 if { $NumOfSongs > 0 } {
  set CurrentSong 1
  set CurrentFile_var $PlayListArray($CurrentSong)
  GetMp3Info
 }

 if { $ListView == 1 } {
    ShowList
  }
   
 # Generate shuffle playlist
 GenerateShuffleList

}

grab release .top17
return
}

proc LoadPrefs {} {
global configfile mp3loc playloc bindir

if [ catch { open $configfile r } fileId ] {
    puts stdout "Error opening configfile!"

  set mp3loc "/"
  set playloc "/usr/local/mp3studio"
  set bindir [ gets $fileId ]

} else {

  set mp3loc [ gets $fileId ]
  set playloc [ gets $fileId ]
  set wavloc [ gets $fileId ]
  set newloc [ gets $fileId ]
  set samplecommand [ gets $fileId ]
  set mixercommand [ gets $fileId ]
  set devtape [ gets $fileId ]
  set bindir [ gets $fileId ]

}

close $fileId
return
}

proc MakePlayList {} {
global SelectedArray numOfSelected SelectMP3DirEntry status_var
global PlayListFilename playerLocation 

set PlayListFilename "~/.mp3playerlist.lst"
set status_var "Generating playlist"

if [ catch { open $PlayListFilename w 0600 } fileId ] {
  puts stdout "Error opening playlistfile:\n$fileId"
  return

} else {

  set index 1
  while { $index <= $numOfSelected } {
      puts $fileId "$SelectMP3DirEntry/$SelectedArray($index)"
      puts stdout "$SelectMP3DirEntry/$SelectedArray($index)"
      set index [ expr $index + 1 ]
  }

}

catch { close $fileId }




Window show .top17
grab release .top17
#LoadPlaylist

# remove temp-file
#catch { exec rm /tmp/mp3playerlist.lst }
return
}

proc Select_File_Change_Dir {dir} {
global SelectDirEntry Selected_File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {

# no existing dir

} else { 
    catch { exec "pwd" } SelectDirEntry
    if { $SelectDirEntry == "/" } {
        set Selected_File "/"
        Select_File_Show $SelectDirEntry 
    } else {
        if { [string range $Selected_File end end] == "/" } {
        } else {
            set Selected_File $SelectDirEntry
        }   
    Select_File_Show $SelectDirEntry
    }
}
}

proc Select_File_Show {Dir} {
global SelectDirEntry Selected_File filter

set SelectDirEntry $Dir
#set Selected_File $SelectDirEntry
# Clear window contents
.top32.cpd41.01 delete 0 end
.top32.cpd42.01 delete 0 end


if { $SelectDirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top32.cpd41.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top32.cpd41.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top32.cpd42.01 insert end $naam
    }
   }
}
}

proc Select_MP3File_Change_Dir {dir} {
global SelectMP3DirEntry Selected_MP3File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {

# no existing dir

} else { 
    catch { exec "pwd" } SelectMP3DirEntry
    if { $SelectMP3DirEntry == "/" } {
        set Selected_MP3File "/"
        Select_MP3File_Show $SelectMP3DirEntry 
    } else {
        if { [string range $Selected_MP3File end end] == "/" } {
        } else {
            set Selected_MP3File $SelectMP3DirEntry
        }   
    Select_MP3File_Show $SelectMP3DirEntry
    }
}
}

proc Select_MP3File_Show {Dir} {
global SelectMP3DirEntry Selected_MP3File mp3filter

set SelectMP3DirEntry $Dir

# Clear window contents
.top22.cpd30.01 delete 0 end
.top22.cpd30.01 delete 0 end

.top22.cpd30.01 delete 0 end

if { $SelectMP3DirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top22.cpd30.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top22.cpd30.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $mp3filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top22.cpd32.01 insert end $naam
    }
   }
}
}

proc ShowHelp {} {
global playerLocation seenHelp


if { $seenHelp == 0 } {

if [ catch { open $playerLocation/mp3player.hlp r } fileId ] {
  puts stdout "Error opening helpfile:$fileId"
  Window hide .top18
  return

} else {

  set string [ gets $fileId ]

  while { ![eof $fileId] } {

   .top18.cpd22.03 insert end "$string\n"
   set string [ gets $fileId ]
   .top18.cpd22.03 delete 1.0 1.end

  }
}

close $fileId
set seenHelp 1

}

return
}

proc ShowList {} {
global status_var NumOfSongs PlayListArray CurrentSong ListView

Window show .top26
set ListView 1

.top26.cpd35.01 delete 0 end

if { $NumOfSongs > 0 } {
  
  set index 1
  while { $index <= $NumOfSongs } {

    .top26.cpd35.01 insert end "$index. $PlayListArray($index)"
    set index [expr $index + 1 ]

  }

  .top26.cpd35.01 select set [expr $CurrentSong - 1]
  .top26.cpd35.01 yview [ expr $CurrentSong - 1 ]

}
}

proc ShowTime {argument} {
global time_var totalCheck remainingCheck TimeArray CurrentSong TotalTime
global NumOfSongs

if { $totalCheck == 1 } {
  # Add length previous songs
  set time [ expr round($argument) + $TimeArray($CurrentSong) ]
  if { $remainingCheck == 1 } {
    set time [ expr $TotalTime - $time ]
  }
} else {
  # Use the argument value
  set time round($argument)
  if { $remainingCheck == 1 } {
    if { $CurrentSong == $NumOfSongs } {
       set time [ expr ($TotalTime - $TimeArray($CurrentSong) - $time) ]
    } else {
       set time [ expr ($TimeArray([expr $CurrentSong + 1]) - $TimeArray($CurrentSong) -$time)]
    }
  }
}










# Show this time on the display

set hours [ expr $time / 3600 ]

set hulp [ expr $time / 60 ]
set minutes [ expr $hulp - ($hours * 60) ]
set seconds [ expr $time - ($hours * 3600) - ($minutes * 60) ]


set time ""
if { $hours < 10 } {
  set time "0$hours"
} else {
  set time $hours
}

if { $minutes < 10 } {
  set time "$time:0$minutes"
} else {
  set time "$time:$minutes"
}

if { $seconds < 10 } {
  set time "$time:0$seconds"
} else {
  set time "$time:$seconds"
}

set time_var $time

return
}

proc ShufflePlayToggle {} {
global shuffleCheck status_var ListView
global ShufflePlayListArray PlayListArray NormalPlayListArray NumOfSongs
global CurrentFile_var CurrentSong CurPos ShuffleTimeArray TimeArray NormalTimeArray

# Stop playing ?
set play 0
if { $status_var == "Playing" } {
  set play 1
  StopPlaying
}

# Playlist := ShufflePlayList OR NormalPlayList

if { $shuffleCheck == 1 } {
  set index 1
  while { $index <= $NumOfSongs } {
    set PlayListArray($index) $NormalPlayListArray($index)
    set TimeArray($index) $NormalTimeArray($index)
    set index [expr $index + 1]
  }
} else {
  # Nieuwe shuffle-list maken
  GenerateShuffleList
  set index 1
  while { $index <= $NumOfSongs } {
    set PlayListArray($index) $ShufflePlayListArray($index)
    set TimeArray($index) $ShuffleTimeArray($index)
    set index [expr $index + 1]
  }
}

#Show first file

 if { $NumOfSongs > 0 } {
  set CurrentSong 1
  set CurrentFile_var $PlayListArray($CurrentSong)
  GetMp3Info
 }

# Update Playlist-View
 if { $ListView == 1 } {
   ShowList
 }


# Resume playing ?
if { $play == 1 } {
  StartMp3 $CurPos
}
}

proc StartListMp3 {} {
global status_var PlayListArray NumOfSongs CurrentSong CurrentFile_var

set selindex [ .top26.cpd35.01 curselection ]

if { $selindex >= 0 } {

 set selected [ .top26.cpd35.01 get $selindex ]

 set hulp [ string first "." $selected ]
 set number [ string range $selected 0 [ expr $hulp - 1 ] ]
 set selected [ string range $selected [expr $hulp + 2] end ]

 set CurrentSong $number
 set CurrentFile_var $PlayListArray($CurrentSong)

  if { $status_var == "Playing" } {
     StopPlaying
     GetMp3Info
     StartMp3 0
   } else {
     GetMp3Info
     StartMp3 0
   }


}

return
}

proc StartMp3 {pos} {
global stream CurrentFile_var status_var NumOfSongs
global playerLocation

if { $NumOfSongs > 0 } {

  set status_var "Playing"
  cd $playerLocation

  set stream [ open "| ./player play $CurrentFile_var $pos " ]
  fconfigure $stream -blocking 0
  fileevent $stream readable {IO_Handler}
} 

return
}

proc Start_Select_File {Arg_Filter Startdir} {
global filter Selected_File
set filter $Arg_Filter
Window show .top32
grab .top32
.top32.cpd41.01 delete 0 end
.top32.cpd42.01 delete 0 end
set Dir $Startdir
set Selected_File $Dir
Select_File_Show $Dir
}

proc Start_Select_MP3File {Arg_Filter Startdir} {
global mp3filter Selected_MP3File
set mp3filter $Arg_Filter

Window show .top22
#grab .top22

.top22.cpd32.01 delete 0 end
.top22.cpd30.01 delete 0 end

set Dir $Startdir
set Selected_MP3File $Dir
Select_MP3File_Show $Dir
}

proc StopPlaying {} {
global stream status_var

if { $status_var == "Pausing" } {
  set status "Paused"
} else {
  set status "Stopped"
}

if { $status_var == "Playing" } {
  catch { exec killall l3dec }
  catch {close $stream}
}

set status_var $status

return
}

proc main {argc argv} {
global playerLocation Changing_var ListView seenHelp configfile
global NumOfSongs CurPos CurrentFile_var CurrentSong bindir

set configfile "~/.mp3studiorc"
LoadPrefs

set CurrentFile_var ""
set NumOfSongs 0
set CurrentSong 0
set CurPos 0
set Changing_var 0
set ListView 0
set seenHelp 0
set playerLocation $bindir
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 
    wm focusmodel $base passive
    wm geometry $base 309x285+105+176
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Checking files"
    frame $base.fra18  -background #505050 -borderwidth 2 -height 75 -width 125 
    scale $base.fra18.sca19  -activebackground #323232 -background #505050  -font -adobe-helvetica-medium-r-normal-*-*-80-*-*-p-*-iso8859-*  -foreground #FFFFFFFFFFFF -highlightbackground #505050 -orient horiz  -state disabled -troughcolor #323232 -variable checkingIndex 
    frame $base.fra18.cpd24  -background #323232 -borderwidth 1 -height 30 -relief raised  -width 30 
    listbox $base.fra18.cpd24.01  -background #323232  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -foreground #d47639 -highlightbackground Black  -highlightcolor #d6a400 -xscrollcommand {.top17.fra18.cpd24.02 set}  -yscrollcommand {.top17.fra18.cpd24.03 set} 
    scrollbar $base.fra18.cpd24.02  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top17.fra18.cpd24.01 xview} -highlightbackground #323232  -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra18.cpd24.03  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top17.fra18.cpd24.01 yview} -highlightbackground #323232  -orient vert -troughcolor #323232 -width 10 
    message $base.fra18.mes26  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2  -text {Percentage of file already scanned} 
    message $base.fra18.mes27  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised  -text {Checking Files} 
    message $base.fra18.mes28  -aspect 15000 -background #505050  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #009a00 -padx 5 -pady 2 -text {Detected errors} 
    button $base.but25  -activebackground #921016 -activeforeground White -background #323232  -command {global FileChecking
if { $FileChecking < 1 } {
  Window hide $widget(CheckingWindow)
  grab release .top17
}}  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text Dismiss 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra18  -x 0 -y 0 -width 310 -height 285 -anchor nw -bordermode ignore 
    place $base.fra18.sca19  -x 5 -y 50 -width 299 -height 43 -anchor nw -bordermode ignore 
    place $base.fra18.cpd24  -x 10 -y 118 -width 290 -height 135 -anchor nw -bordermode ignore 
    grid columnconf $base.fra18.cpd24 0 -weight 1
    grid rowconf $base.fra18.cpd24 0 -weight 1
    grid $base.fra18.cpd24.01  -in .top17.fra18.cpd24 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw 
    grid $base.fra18.cpd24.02  -in .top17.fra18.cpd24 -column 0 -row 1 -columnspan 1 -rowspan 1  -sticky ew 
    grid $base.fra18.cpd24.03  -in .top17.fra18.cpd24 -column 1 -row 0 -columnspan 1 -rowspan 1  -sticky ns 
    place $base.fra18.mes26  -x 20 -y 40 -width 273 -height 16 -anchor nw -bordermode ignore 
    place $base.fra18.mes27  -x 5 -y 5 -width 300 -height 31 -anchor nw -bordermode ignore 
    place $base.fra18.mes28  -x 6 -y 99 -width 103 -height 16 -anchor nw -bordermode ignore 
    place $base.but25  -x 216 -y 256 -width 85 -height 26 -anchor nw -bordermode ignore
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel  -background #505050 -cursor xterm -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 497x358+483+101
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm title $base "Help Window Player"
    message $base.mes20  -aspect 15000 -background #505050  -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-*  -foreground #949690 -padx 5 -pady 2 -relief raised  -text {MP3-Studio Help Window} 
    button $base.but21  -activebackground #921016 -activeforeground White -background #323232  -command {Window hide .top18}  -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-*  -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3  -text Close 
    frame $base.cpd22  -background #303030 -borderwidth 1 -height 30  -highlightbackground #303030 -relief raised -width 30 
    scrollbar $base.cpd22.01  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top18.cpd22.03 xview} -highlightbackground Black  -highlightcolor #323232 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd22.02  -activebackground #d6a400 -background #323232 -borderwidth 1  -command {.top18.cpd22.03 yview} -highlightbackground #323232  -orient vert -troughcolor #323232 -width 10 
    text $base.cpd22.03  -background #303030  -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-*  -foreground #d6a400 -height 1 -highlightbackground Black  -selectbackground #921016 -selectforeground White -width 8  -xscrollcommand {.top18.cpd22.01 set}  -yscrollcommand {.top18.cpd22.02 set} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes20  -x 4 -y 3 -width 488 -height 36 -anchor nw -bordermode ignore 
    place $base.but21  -x 380 -y 325 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.cpd22  -x 8 -y 44 -width 478 -height 276 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd22 0 -weight 1
    grid rowconf $base.cpd22 0 -weight 1
    grid $base.cpd22.01  -in .top18.cpd22 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd22.02  -in .top18.cpd22 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd22.03  -in .top18.cpd22 -column 0 -row 0 -columnspan 1 -rowspan 1  -sticky nesw
}

proc vTclWindow.top20 {base} {
    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground Black 
    wm focusmodel $base passive
    wm geometry $base 418x244+55+239
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "MP3-Player"
    frame $base.fra17 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground White -width 125 
    message $base.fra17.mes19 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text {Now playing} 
    entry $base.fra17.ent20 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground #323232 \
        -selectbackground #323232 -state disabled -textvariable filename_var 
    message $base.fra17.mes22 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -relief groove \
        -text { joint_stereo } -textvariable mode_var 
    message $base.fra17.mes23 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -relief groove -text {Layer 3 } \
        -textvariable layer_var 
    scale $base.fra17.sca27 \
        -activebackground #921016 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #FFFFFFFFFFFF -highlightbackground #505050 -orient horiz \
        -showvalue 0 -troughcolor #202200 -variable timeindex 
    bind $base.fra17.sca27 <Button> {
        global Changing_var
        set Changing_var 1
    }
    bind $base.fra17.sca27 <ButtonRelease-1> {
        global timeindex songlength_var CurPos NumOfSongs

if { $NumOfSongs > 0 } {
  set CurPos [ expr ($songlength_var * $timeindex) / 100 ]
  ChangePosition 0
  set Changing_var 0
} else {
  set timeindex 0
}
    }
    button $base.fra17.but28 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global CurPos status_var

if { $status_var != "Playing"} {

StartMp3 $CurPos

}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Play 
    button $base.fra17.but29 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var CurPos

if { $status_var =="Paused" } {
  set status_var "Playing"
  StartMp3 $CurPos

} else {

   if { $status_var == "Playing" } {
     set status_var "Pausing"
     StopPlaying
   }

}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Pause 
    button $base.fra17.but30 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {ChangePosition -15} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Rew 
    button $base.fra17.but31 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var

switch -exact $status_var {

"Playing" {  set $status_var "Stopped"
             StopPlaying
          }

"Paused"  { set $status_var "Stopped"
          }

}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Stop 
    button $base.fra17.but32 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {ChangePosition 15} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Fwd 
    entry $base.fra17.ent34 \
        -background #305000 \
        -font -adobe-times-medium-r-normal-*-34-*-*-*-*-*-*-* \
        -foreground Green -justify center -state disabled \
        -textvariable time_var 
    message $base.fra17.mes20 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightcolor White -padx 5 -pady 2 \
        -relief groove -text {Version 1 } -textvariable version_var 
    message $base.fra17.mes24 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -relief groove \
        -text {Bitrate 112 } -textvariable bitrate_var 
    message $base.fra17.mes25 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -relief groove -text {44100  KHz} \
        -textvariable samplerate_var 
    message $base.fra17.mes26 \
        -aspect 15000 -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -padx 5 -pady 2 -relief groove -text Stopped \
        -textvariable status_var 
    button $base.fra17.but27 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command GotoPrevSong \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Prev 
    button $base.fra17.but33 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command GotoNextSong \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Next 
    checkbutton $base.fra17.che17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -indicatoron 0 \
        -selectcolor #500000 -text Remaining -variable remainingCheck 
    bind $base.fra17.che17 <ButtonRelease> {
        global timeindex songlength_var NumOfSongs

if { $NumOfSongs > 0 } {
  set hulp [ expr (($songlength_var * $timeindex)/100) ]
  ShowTime $hulp
}
    }
    checkbutton $base.fra17.che18 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black \
        -highlightcolor #500000 -indicatoron 0 -selectcolor #500000 \
        -text Shuffle -variable shuffleCheck 
    bind $base.fra17.che18 <Button-1> {
        ShufflePlayToggle
    }
    checkbutton $base.fra17.che19 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -indicatoron 0 \
        -selectcolor #500000 -text Repeat -variable repeatCheck 
    checkbutton $base.fra17.che35 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -disabledforeground #500000 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black \
        -highlightcolor #500000 -indicatoron 0 -relief raised \
        -selectcolor #500000 -text Total -variable totalCheck 
    bind $base.fra17.che35 <ButtonRelease> {
        global timeindex songlength_var NumOfSongs

if { $NumOfSongs > 0 } {
  set hulp [ expr (($songlength_var * $timeindex)/100) ]
  ShowTime $hulp
 }
    }
    button $base.but35 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var
if {$status_var == "Playing"} {
  StopPlaying
}

Window hide $widget(MP3player)
exit} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Exit Player} 
    button $base.but37 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var loc

if { $status_var == "Playing" } {
  StopPlaying
}

Start_Select_File "*.lst" "$playloc"} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Load Playlist} 
    message $base.mes17 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3 Studio Player} 
    button $base.but19 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global status_var mp3loc

if { $status_var == "Playing" } {
  StopPlaying
}

Start_Select_MP3File "*.mp3" "$mp3loc"} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Load File(s)} 
    button $base.but21 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command ShowList \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Show List} 
    button $base.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window show .top18
ShowHelp} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text ? 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra17 \
        -x 2 -y 35 -width 410 -height 175 -anchor nw -bordermode ignore 
    place $base.fra17.mes19 \
        -x 10 -y 7 -width 73 -height 16 -anchor nw -bordermode ignore 
    place $base.fra17.ent20 \
        -x 90 -y 5 -width 313 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.mes22 \
        -x 290 -y 30 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.mes23 \
        -x 12 -y 49 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.sca27 \
        -x 6 -y 118 -width 396 -height 25 -anchor nw -bordermode ignore 
    place $base.fra17.but28 \
        -x 180 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.but29 \
        -x 234 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.but30 \
        -x 74 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.but31 \
        -x 127 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.but32 \
        -x 287 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.ent34 \
        -x 124 -y 29 -width 163 -height 60 -anchor nw -bordermode ignore 
    place $base.fra17.mes20 \
        -x 12 -y 30 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.mes24 \
        -x 12 -y 69 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.mes25 \
        -x 290 -y 50 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.mes26 \
        -x 290 -y 70 -width 108 -height 18 -anchor nw -bordermode ignore 
    place $base.fra17.but27 \
        -x 21 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.but33 \
        -x 340 -y 147 -width 50 -height 22 -anchor nw -bordermode ignore 
    place $base.fra17.che17 \
        -x 209 -y 93 -width 90 -height 20 -anchor nw -bordermode ignore 
    place $base.fra17.che18 \
        -x 19 -y 93 -width 90 -height 20 -anchor nw -bordermode ignore 
    place $base.fra17.che19 \
        -x 303 -y 93 -width 90 -height 20 -anchor nw -bordermode ignore 
    place $base.fra17.che35 \
        -x 114 -y 93 -width 90 -height 20 -anchor nw -bordermode ignore 
    place $base.but35 \
        -x 309 -y 213 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but37 \
        -x 94 -y 213 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.mes17 \
        -x 3 -y 3 -width 410 -height 31 -anchor nw -bordermode ignore 
    place $base.but19 \
        -x 5 -y 213 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.but21 \
        -x 183 -y 213 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.but17 \
        -x 272 -y 213 -width 31 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top22 {base} {
    if {$base == ""} {
        set base .top22
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 516x336+90+414
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "select mp3-file(s)"
    message $base.mes23 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Select one or more mp3-files} 
    entry $base.ent24 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #323232 -textvariable Selected_MP3File 
    bind $base.ent24 <KeyRelease> {
        Select_MP3File_Change_Dir $Selected_MP3File
    }
    message $base.mes25 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Selection 
    entry $base.ent26 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -state disabled \
        -textvariable SelectMP3DirEntry 
    message $base.mes27 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Filter 
    entry $base.ent28 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground Black -textvariable mp3filter 
    bind $base.ent28 <Button> {
        Select_MP3File_Show $SelectMP3DirEntry
    }
    bind $base.ent28 <Key-Return> {
        Select_MP3File_Show $SelectMP3DirEntry
    }
    bind $base.ent28 <Key-Tab> {
        Select_MP3File_Show $SelectMP3DirEntry
    }
    frame $base.cpd30 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground #323232 -relief raised -width 30 
    listbox $base.cpd30.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -xscrollcommand {.top22.cpd30.02 set} \
        -yscrollcommand {.top22.cpd30.03 set} 
    bind $base.cpd30.01 <Double-ButtonRelease-1> {
        set selected [ .top22.cpd30.01 curselection ]
if { [ llength $selected ] > 0 } {
  set dir $SelectMP3DirEntry/[ .top22.cpd30.01 get $selected ]
  set Selected_MP3File $dir
  Select_MP3File_Change_Dir $dir
}
    }
    scrollbar $base.cpd30.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top22.cpd30.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd30.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top22.cpd30.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    frame $base.cpd32 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground #323232 -relief raised -width 30 
    listbox $base.cpd32.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode extended \
        -xscrollcommand {.top22.cpd32.02 set} \
        -yscrollcommand {.top22.cpd32.03 set} 
    bind $base.cpd32.01 <Double-Button-1> {
        global SelectedArray numOfSelected

grab release .top22


set idx [ .top22.cpd32.01 curselection ]

set numOfSelected 0
foreach index $idx {
  set numOfSelected [ expr $numOfSelected + 1 ]
  set SelectedArray($numOfSelected) [.top22.cpd32.01 get $index $index]
}

Window hide .top22

MakePlayList
    }
    scrollbar $base.cpd32.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top22.cpd32.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd32.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top22.cpd32.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    button $base.but33 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {set Selected_File ""
Window hide .top32
set PlayListFilename $Selected_File} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Cancel 
    button $base.but34 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global SelectedArray numOfSelected

set idx [ .top22.cpd32.01 curselection ]

set numOfSelected 0
foreach index $idx {
  set numOfSelected [ expr $numOfSelected + 1 ]
  set SelectedArray($numOfSelected) [.top22.cpd32.01 get $index $index]
}

grab release .top22
Window hide .top22

MakePlayList
grab release .top17
Window hide .top17
LoadPlaylist} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes23 \
        -x 3 -y 3 -width 510 -height 31 -anchor nw -bordermode ignore 
    place $base.ent24 \
        -x 72 -y 40 -width 438 -height 22 -anchor nw -bordermode ignore 
    place $base.mes25 \
        -x 8 -y 42 -width 58 -height 16 -anchor nw -bordermode ignore 
    place $base.ent26 \
        -x 8 -y 69 -width 348 -height 22 -anchor nw -bordermode ignore 
    place $base.mes27 \
        -x 374 -y 72 -width 38 -height 16 -anchor nw -bordermode ignore 
    place $base.ent28 \
        -x 417 -y 69 -width 93 -height 22 -anchor nw -bordermode ignore 
    place $base.cpd30 \
        -x 8 -y 95 -width 155 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd30 0 -weight 1
    grid rowconf $base.cpd30 0 -weight 1
    grid $base.cpd30.01 \
        -in .top22.cpd30 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd30.02 \
        -in .top22.cpd30 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd30.03 \
        -in .top22.cpd30 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.cpd32 \
        -x 169 -y 95 -width 340 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd32 0 -weight 1
    grid rowconf $base.cpd32 0 -weight 1
    grid $base.cpd32.01 \
        -in .top22.cpd32 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd32.02 \
        -in .top22.cpd32 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd32.03 \
        -in .top22.cpd32 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but33 \
        -x 315 -y 305 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.but34 \
        -x 410 -y 305 -width 85 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top26 {base} {
    if {$base == ""} {
        set base .top26
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 423x383+476+215
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Playlist"
    message $base.mes27 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Current Playlist} 
    button $base.but29 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command StartListMp3 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Play file} 
    button $base.but30 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global ListView
set ListView 0
Window hide .top26} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Close 
    frame $base.cpd35 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd35.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -xscrollcommand {.top26.cpd35.02 set} \
        -yscrollcommand {.top26.cpd35.03 set} 
    bind $base.cpd35.01 <Double-Button-1> {
        StartListMp3
    }
    scrollbar $base.cpd35.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top26.cpd35.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor Black -width 10 
    scrollbar $base.cpd35.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top26.cpd35.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor Black -width 10 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes27 \
        -x 3 -y 3 -width 415 -height 31 -anchor nw -bordermode ignore 
    place $base.but29 \
        -x 19 -y 350 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.but30 \
        -x 305 -y 350 -width 100 -height 26 -anchor nw -bordermode ignore 
    place $base.cpd35 \
        -x 10 -y 40 -width 400 -height 305 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd35 0 -weight 1
    grid rowconf $base.cpd35 0 -weight 1
    grid $base.cpd35.01 \
        -in .top26.cpd35 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd35.02 \
        -in .top26.cpd35 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd35.03 \
        -in .top26.cpd35 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
}

proc vTclWindow.top32 {base} {
    if {$base == ""} {
        set base .top32
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 516x336+46+501
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Select playlist"
    message $base.mes33 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Select Playlist} 
    message $base.mes34 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Selection 
    message $base.mes35 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Filter 
    entry $base.ent36 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #323232 -textvariable Selected_File 
    bind $base.ent36 <KeyRelease> {
        Select_File_Change_Dir $Selected_File
    }
    entry $base.ent37 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -state disabled \
        -textvariable SelectDirEntry 
    entry $base.ent38 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground Black -textvariable filter 
    button $base.but39 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {set Selected_File ""
Window hide .top32
grab release .top32
set PlayListFilename $Selected_File} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Cancel 
    button $base.but40 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global Selected_File SelectDirEntry
global PlayListFilename

set idx [ .top32.cpd42.01 curselection ]
if { [ llength $idx ] > 0 } {
  set filenaam [.top32.cpd42.01 get $idx $idx]
  set nieuw ""
  append nieuw $SelectDirEntry  "/" $filenaam
  set Selected_File $nieuw
  set PlayListFilename $Selected_File

  Window hide .top32
  grab release .top32

  Window show $widget(CheckingWindow)
  LoadPlaylist
} else {
  Window hide .top32
  grab release .top32
}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    frame $base.cpd41 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground #323232 -relief raised -width 30 
    listbox $base.cpd41.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -xscrollcommand {.top32.cpd41.02 set} \
        -yscrollcommand {.top32.cpd41.03 set} 
    bind $base.cpd41.01 <Double-ButtonRelease-1> {
        set selected [ .top32.cpd41.01 curselection ]
if { [ llength $selected ] > 0 } {
  set dir $SelectDirEntry/[ .top32.cpd41.01 get $selected ]
  set Selected_File $dir
  Select_File_Change_Dir $dir
}
    }
    scrollbar $base.cpd41.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top32.cpd41.01 xview} -highlightbackground Black \
        -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd41.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top32.cpd41.01 yview} -highlightbackground Black \
        -orient vert -troughcolor #323232 -width 10 
    frame $base.cpd42 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground #323232 -relief raised -width 30 
    listbox $base.cpd42.01 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -xscrollcommand {.top32.cpd42.02 set} \
        -yscrollcommand {.top32.cpd42.03 set} 
    scrollbar $base.cpd42.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top32.cpd42.01 xview} -highlightbackground Black \
        -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd42.03 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top32.cpd42.01 yview} -highlightbackground Black \
        -orient vert -troughcolor #323232 -width 10 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes33 \
        -x 3 -y 3 -width 510 -height 31 -anchor nw -bordermode ignore 
    place $base.mes34 \
        -x 8 -y 42 -width 58 -height 16 -anchor nw -bordermode ignore 
    place $base.mes35 \
        -x 374 -y 72 -width 38 -height 16 -anchor nw -bordermode ignore 
    place $base.ent36 \
        -x 70 -y 40 -width 438 -height 22 -anchor nw -bordermode ignore 
    place $base.ent37 \
        -x 8 -y 69 -width 348 -height 22 -anchor nw -bordermode ignore 
    place $base.ent38 \
        -x 417 -y 69 -width 93 -height 22 -anchor nw -bordermode ignore 
    place $base.but39 \
        -x 315 -y 305 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.but40 \
        -x 410 -y 305 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.cpd41 \
        -x 8 -y 97 -width 155 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd41 0 -weight 1
    grid rowconf $base.cpd41 0 -weight 1
    grid $base.cpd41.01 \
        -in .top32.cpd41 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd41.02 \
        -in .top32.cpd41 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd41.03 \
        -in .top32.cpd41 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.cpd42 \
        -x 170 -y 97 -width 340 -height 205 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd42 0 -weight 1
    grid rowconf $base.cpd42 0 -weight 1
    grid $base.cpd42.01 \
        -in .top32.cpd42 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd42.02 \
        -in .top32.cpd42 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd42.03 \
        -in .top32.cpd42 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
}

Window show .
Window show .top20

main $argc $argv
