/* *** oss_interface ***
   *** Filename: oss_interface.h
   *** History: 19980109 Ver 1.00 Rev A | Michiel Bronswijk
   ***          19980225 Release version 1.00
   *** Description: C-header file for oss_interface.c
   *** Changes:
*/

#ifndef OSS_INTERFACE_H

#define OSS_INTERFACE_H

#define 	sound_OK		0
#define		sound_DEVICENOTAVAIL	-1
#define		sound_NOTSUPPORTED	-2
#define		sound_ERROR		-3

/*	soundInitPlay:
	Initializes the soundcard for digital audio play */
int	soundInitPlay(int sFormat, int sChannel, int *sSpeed);

/*	soundInitRecord:
	Initializes the soundcard for digital audio play */
int	soundInitRecord(int sFormat, int sChannel, int *sSpeed);

/*	soundDone:
	Stops the soundcard playing digital audio */
int	soundDone(int forced);

/*	soundPlay:
	Sends buffer to soundcard */
int	soundPlay(const void *buffer, int buflength);

/*	soundRecord:
	fills buffer from soundcard */
int	soundRecord(void *buffer, int buflength);

/*	soundPause;
	Pauses playing/recording */
int	soundPause(void);

#endif
   