#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global CurDirEntry; 
global PlayListFilename; 
global PlaylistArrayLength; 
global bindir; 
global devtape; 
global mixercommand; 
global mp3filter; 
global mp3loc; 
global newloc; 
global playloc; 
global samplecommand; 
global seenHelp; 
global wavloc; 
global widget; 
    set widget(CheckingWindow) {.top17}
    set widget(ConfirmExit) {.top35}
    set widget(ConfirmExitMP3Studio) {.top35}
    set widget(DirListWindow) {.top29.fra19.cpd43.01}
    set widget(FileBox) {.top17.cpd27.01}
    set widget(FileListWindow) {.top29.fra19.cpd20.01}
    set widget(MP3player) {.top20}
    set widget(PlayListEditor) {.top29}
    set widget(PlayListWindow) {.top29.fra26.cpd27.01}
    set widget(SelectFile) {.top18}
    set widget(SelectFile_Window) {.top18}
    set widget(helpwindow) {.top45}
    set widget(rev,.top17) {CheckingWindow}
    set widget(rev,.top17.cpd27.01) {FileBox}
    set widget(rev,.top17.scr25) {scrollY}
    set widget(rev,.top18) {SelectFile_Window}
    set widget(rev,.top20) {MP3player}
    set widget(rev,.top29) {PlayListEditor}
    set widget(rev,.top29.fra19.cpd20.01) {FileListWindow}
    set widget(rev,.top29.fra19.cpd43.01) {DirListWindow}
    set widget(rev,.top29.fra26.cpd27.01) {PlayListWindow}
    set widget(rev,.top35) {ConfirmExit}
    set widget(rev,.top45) {helpwindow}
    set widget(scrollY) {.top17.scr25}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc AddToPlaylist {} {
global PlaylistArray PlaylistArrayLength CurDirEntry

foreach f [.top29.fra19.cpd20.01 curselection ] {
 incr PlaylistArrayLength 1
 set idx [expr $PlaylistArrayLength - 1]
 set PlaylistArray($idx) "$CurDirEntry/[.top29.fra19.cpd20.01 get $f]"
}

.top29.fra19.cpd20.01 selection clear 0 end
Playlist_ShowList
}

proc ChangeDirectory {} {
global CurDirEntry


set selected [ .top29.fra19.cpd43.01 curselection ]
if {$selected == ""} {
    # niets doen, want geen selectie
} else {

set dir [ .top29.fra19.cpd43.01 get $selected ]

if { $dir == ".." } {
   set idx [string last "/" $CurDirEntry ]
   if { $idx == 0} {
     set dir2 "/"
   } else {
     set idx [expr $idx -1 ]
     set dir2 [string range $CurDirEntry 0 $idx ]
   } 

} else {
  if { $CurDirEntry == "/" } { 
    set dir2 "/$dir"
  } else {
    set dir2 "$CurDirEntry/$dir"
  }
}

if [ catch { cd $dir2 } err ] {
puts stderr "error while changing current directory to $dir2"
} else { 
  DirList_ShowDir $dir2
}
} 
# einde, wel selectie
}

proc DeleteFromPlaylist {} {
global PlaylistArray PlaylistArrayLength

set f [.top29.fra26.cpd27.01 curselection ]
# f is nu een list met de te verwijderen items
set NewIndex 0
# loop alle nummers in de array af
for {set index 0} { $index < $PlaylistArrayLength } {incr index 1} {
set uit [format %i $index]
set vgl [lsearch $f $uit]
# als het item niet geselecteerd is verhogen we newindex en copieren we
# het item van de oude plaats naar de nieuwe positie newindex
# en verhogen we newindex
if { $vgl == -1} {set PlaylistArray($NewIndex) $PlaylistArray($index)
incr NewIndex }
}
# Tot hier de loop die alle items afloopt
set PlaylistArrayLength $NewIndex 
# De lengte van de array moet opnieuw bepaald worden!
# En vervolgens de nieuwe situatie laten zien.
Playlist_ShowList
}

proc DirList_ShowDir {Dir} {
global DirListWindow FileListWindow mp3filter
global CurDirEntry

set CurDirEntry $Dir

# Clear window contents
.top29.fra19.cpd43.01 delete 0 end
.top29.fra19.cpd20.01 delete 0 end


if { $CurDirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top29.fra19.cpd43.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top29.fra19.cpd43.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
#   $FileListWindow insert end $naam
    if {[string match $mp3filter $naam ] == 1} {
    .top29.fra19.cpd20.01 insert end $naam
    }
   }
}
}

proc InitPlaylistArray {} {
global PlaylistArray
global PlaylistArrayLength

set PlaylistArrayLength 0
}

proc LoadPlaylist {} {
global PlaylistArray PlaylistArrayLength PlayListFilename Yes_or_No_is_yes
if { ![file isfile $PlayListFilename] } {
    # file does not exists!
    set Yes_or_No_is_yes "LoadPlaylist"
    Yes_or_No "$PlayListFilename is not a regular playlist file! \n \n try again?"


} elseif [ catch { open $PlayListFilename r } fileId ] {
#    puts stderr "$fileId: Error opening playlistfile: $PlayListFilename"
    set Yes_or_No_is_yes "LoadPlaylist"
    Yes_or_No "Error opening playlist file $PlayListFilename \n $fileId \n \n try again?"

    } else {
#       puts stdout "$Filename Opened file for reading..."
#        set PlaylistArrayLength 0
        while { ![eof $fileId] } {
            set  regel [ gets $fileId ]
            if {$regel == "" } {
            } else {
                set PlaylistArray($PlaylistArrayLength) $regel
                incr PlaylistArrayLength 1
                .top29.fra26.cpd27.01 insert end "$PlaylistArrayLength. $PlaylistArray([expr $PlaylistArrayLength -1])"
            }
        }
    }
}

proc Loadprefs {} {
global mp3loc playloc wavloc newloc samplecommand mixercommand devtape
global bindir

set bindir "/usr/local/mp3studio"
set mp3loc "/"
set playloc "/"
set wavloc "/"
set newloc "/"
set samplecommand "/usr/local/SoundStudio/soundstudio"
set mixercommand "/usr/X11R6/bin/xmixer"
set devtape "/dev/nst0"
set configfile "~/.mp3studiorc"

if [ catch { open $configfile r } fileId ] {
  # Check if file exists
  if { [ file exists $configfile ] == 0 } {
     SavePrefs
     return
  } else {
    puts stdout "Error opening configfile!"
    return
  }

} else {

  set mp3loc [ gets $fileId ]
  set playloc [ gets $fileId ]
  set wavloc [ gets $fileId ]
  set newloc [ gets $fileId ]
  set samplecommand [ gets $fileId ]
  set mixercommand [ gets $fileId ]
  set devtape [ gets $fileId ]
  set bindir [ gets $fileId ]

}

close $fileId
return
}

proc Playlist_ShowList {} {
global PlaylistArray PlaylistArrayLength

.top29.fra26.cpd27.01 delete 0 end

set eind [expr $PlaylistArrayLength + 1 ]
for {set index 1} { $index < $eind } {incr index 1} { 
   .top29.fra26.cpd27.01 insert end "$index. $PlaylistArray([expr $index -1 ])"
}
.top29.fra26.cpd27.01 yview moveto 1
}

proc SavePlaylist {} {
global PlaylistArray PlaylistArrayLength PlayListFilename Yes_or_No_is_yes
if { [file exists $PlayListFilename] } {
    # file does exist!
    set Yes_or_No_is_yes "SavePlaylist_continue"
    Yes_or_No "$PlayListFilename exists! \n \n Overwrite old playlist with new playlist?"

} else {
    SavePlaylist_continue
}
}

proc SavePlaylist_continue {} {
global PlaylistArray PlaylistArrayLength PlayListFilename  set Yes_or_No_is_yes

if [ catch { open $PlayListFilename w 0600 } fileId ] {
    set Yes_or_No_is_yes "SavePlaylist_continue"
    Yes_or_No "$fileId \n \n Error saving playlist $PlayListFilename \n \n Try again?"
} else {
   # puts stdout "$PlayListFilename Filename Opened file for writing..."
    for {set x 0 } {$x < $PlaylistArrayLength} {incr x 1} {
        puts $fileId "$PlaylistArray($x)"    
    }
    close $fileId
}
}

proc Select_File_Change_Dir {dir} {
global SelectDirEntry Selected_File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {

# en file-listbox ledigen omdat de directory niet geldig is en er dus geen files zijn!Select_File_Change_Dir
# .top18.fra20.01 delete 0 end

#set idx [string last "/" $Selected_File ]
#set newdir [string range $Selected_File 0 $idx ]
#puts stdout "Nieuwe directory moet eigenlijk zijn:$newdir"

} else { 
    catch { exec "pwd" } SelectDirEntry
    if { $SelectDirEntry == "/" } {
        set Selected_File "/"
        Select_File_Show $SelectDirEntry 
    } else {
        if { [string range $Selected_File end end] == "/" } {
        } else {
            set Selected_File $SelectDirEntry
        }   
    Select_File_Show $SelectDirEntry
    }
}
}

proc Select_File_Show {Dir} {
global SelectDirEntry Selected_File filter

set SelectDirEntry $Dir
#set Selected_File $SelectDirEntry
# Clear window contents
.top18.fra32.01 delete 0 end
.top18.fra20.01 delete 0 end

.top18.fra32.01 delete 0 end

if { $SelectDirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top18.fra32.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top18.fra32.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top18.fra20.01 insert end $naam
    }
   }
}
}

proc ShowHelp {} {
global bindir status_var seenHelp


if { $seenHelp == 0 } {

if [ catch { open $bindir/playlistedit.hlp r } fileId ] {
  set status_var "Error opening helpfile:$fileId"
  Window hide .top45
  return

} else {
  Window show .top45
  .top45.cpd47.03 delete 1.0 end
  set string [ gets $fileId ]

  while { ![eof $fileId] } {

   .top45.cpd47.03 insert end "$string\n"
   set string [ gets $fileId ]
  .top45.cpd47.03 delete 1.0 1.end

  }
}

close $fileId
set seenHelp 1
}

return
}

proc StartPlaylistEditor {} {
Window show .top29
global PlaylistArray PlaylistArrayLength mp3filter mp3loc
InitPlaylistArray
set mp3filter "*.mp3"
DirList_ShowDir $mp3loc
Playlist_ShowList
}

proc Start_Select_File {Arg_Filter Startdir} {
global filter Selected_File
set filter $Arg_Filter
Window show .top18
grab .top18
set Dir $Startdir
set Selected_File $Dir
Select_File_Show $Dir
}

proc StopPlaylistEditor {} {
#Hier moeten files gesloten worden e.d. Komt nog. Nu alleen window weg.

#Window hide $widget(ConfirmExitPlaylist)
Window hide .top18

#Window hide $widget(PlayListEditor)
Window hide .top29
}

proc Yes_or_No {question} {
global Vraagje
set Vraagje $question
Window show .top21
grab .top21
}

proc test {} {
global Selected_File
puts stdout "gevonden file:$Selected_File"
}

proc main {argc argv} {
global seenHelp
Window hide .top18
Window hide .top21
Window hide .top45
Loadprefs
set seenHelp 0
StartPlaylistEditor
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+0+0
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground Black \
        -highlightcolor #000000 
    wm focusmodel $base passive
    wm geometry $base 519x295+314+209
    wm maxsize $base 1009 738
    wm minsize $base 500 200
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "select file"
    entry $base.ent25 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -textvariable Selected_File 
    bind $base.ent25 <KeyRelease> {
        Select_File_Change_Dir $Selected_File
    }
    frame $base.fra32 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra32.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -height 14 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single -width 10 \
        -xscrollcommand {.top18.fra32.02 set} \
        -yscrollcommand {.top18.fra32.03 set} 
    bind $base.fra32.01 <Double-ButtonRelease-1> {
        set selected [ .top18.fra32.01 curselection ]
if {$selected == "" } {
    # selected is leeg, niets doen!
} else {
set dir $SelectDirEntry/[ .top18.fra32.01 get $selected ]
set Selected_File $dir

Select_File_Change_Dir $dir
}
    }
    scrollbar $base.fra32.02 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra32.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra32.03 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top18.fra32.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    menu $base.m17 \
        -background #9900991B99FE -cursor {} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #FFFFFFFFFFFF 
    frame $base.fra20 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra20.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single -width 49 \
        -xscrollcommand {.top18.fra20.02 set} \
        -yscrollcommand {.top18.fra20.03 set} 
    bind $base.fra20.01 <ButtonRelease-1> {
        global Selected_File SelectDirEntry

set idx [ .top18.fra20.01 curselection ]
if {$idx == ""} {
    # cursel = leeg, niet doen!
} else {


set filenaam [.top18.fra20.01 get $idx $idx]
set nieuw ""
append nieuw $SelectDirEntry  "/" $filenaam

set Selected_File $nieuw
}
    }
    scrollbar $base.fra20.02 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra20.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra20.03 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra20.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    button $base.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {set Selected_File ""
grab release .top18
Window hide .top18} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Cancel 
    entry $base.ent19 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #921016 -textvariable filter 
    bind $base.ent19 <Button> {
        Select_File_Show $SelectDirEntry
    }
    bind $base.ent19 <Key-Return> {
        Select_File_Show $SelectDirEntry
    }
    bind $base.ent19 <Key-Tab> {
        Select_File_Show $SelectDirEntry
    }
    button $base.but24 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global Select_File_Target Selected_File
global PlayListFilename
grab release .top18
Window hide .top18
set PlayListFilename $Selected_File
if {$Select_File_Target == "import" } {
    LoadPlaylist 
}
if {$Select_File_Target == "save" } {
    SavePlaylist
}} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    entry $base.ent17 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -state disabled \
        -textvariable SelectDirEntry 
    message $base.mes22 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Select a Playlist} 
    message $base.mes23 \
        -aspect 15000 -background #505050 -foreground #009a00 -padx 5 -pady 2 \
        -text Filter 
    message $base.mes24 \
        -aspect 15000 -background #505050 -foreground #009a00 -padx 5 -pady 2 \
        -text Selection 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent25 \
        -x 71 -y 40 -width 438 -height 22 -anchor nw -bordermode ignore 
    place $base.fra32 \
        -x 7 -y 98 -width 170 -height 160 -anchor nw -bordermode ignore 
    grid columnconf $base.fra32 0 -weight 1
    grid rowconf $base.fra32 0 -weight 1
    grid $base.fra32.01 \
        -in .top18.fra32 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra32.02 \
        -in .top18.fra32 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.fra32.03 \
        -in .top18.fra32 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.fra20 \
        -x 183 -y 98 -width 325 -height 160 -anchor nw -bordermode ignore 
    grid columnconf $base.fra20 0 -weight 1
    grid rowconf $base.fra20 0 -weight 1
    grid $base.fra20.01 \
        -in .top18.fra20 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra20.02 \
        -in .top18.fra20 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.fra20.03 \
        -in .top18.fra20 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but17 \
        -x 315 -y 261 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.ent19 \
        -x 415 -y 69 -width 93 -height 22 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 411 -y 260 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.ent17 \
        -x 8 -y 69 -width 348 -height 22 -anchor nw -bordermode ignore 
    place $base.mes22 \
        -x 5 -y 5 -width 510 -height 31 -anchor nw -bordermode ignore 
    place $base.mes23 \
        -x 374 -y 72 -width 38 -height 16 -anchor nw -bordermode ignore 
    place $base.mes24 \
        -x 5 -y 40 -width 58 -height 16 -anchor nw -bordermode ignore 
}

proc vTclWindow.top21 {base} {
    if {$base == ""} {
        set base .top21
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground Black 
    wm focusmodel $base passive
    wm geometry $base 389x186+292+374
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Question"
    frame $base.fra22 \
        -background #c40000 -borderwidth 2 -height 75 -relief groove \
        -width 125 
    message $base.fra22.mes26 \
        -aspect 380 -background #505050 -foreground #f4f400 -justify center \
        -padx 5 -pady 2 \
        -text {couldn't open "/nieuw/root/mp3playlist_winplay3.lst": read-only file system 
 
 Error saving playlist /nieuw/root/mp3playlist_winplay3.lst 
 
 Try again?} \
        -textvariable Vraagje 
    button $base.but25 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {grab release .top21
Window hide .top21} -foreground #d6a400 \
        -highlightbackground Black -padx 9 -pady 3 -text No 
    button $base.but24 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {grab release .top21
Window hide .top21
$Yes_or_No_is_yes} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Yes 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra22 \
        -x 10 -y 15 -width 365 -height 105 -anchor nw -bordermode ignore 
    place $base.fra22.mes26 \
        -x 5 -y 5 -width 358 -height 96 -anchor nw -bordermode ignore 
    place $base.but25 \
        -x 240 -y 140 -width 137 -height 26 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 15 -y 140 -width 137 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top29 {base} {
    if {$base == ""} {
        set base .top29
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground Black 
    wm focusmodel $base passive
    wm geometry $base 539x553+168+177
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "MP3 Studio Playlist Editor"
    frame $base.fra30 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    entry $base.fra30.ent31
    label $base.fra30.lab32 \
        -anchor w -borderwidth 1 -justify left -text {Current directory} 
    frame $base.fra30.cpd38 \
        -borderwidth 1 -height 30 -relief raised -width 30 
    listbox $base.fra30.cpd38.01 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -xscrollcommand {.top29.fra30.cpd38.02 set} \
        -yscrollcommand {.top29.fra30.cpd38.03 set} 
    scrollbar $base.fra30.cpd38.02 \
        -borderwidth 1 -command {.top29.fra30.cpd38.01 xview} -orient horiz \
        -width 10 
    scrollbar $base.fra30.cpd38.03 \
        -borderwidth 1 -command {.top29.fra30.cpd38.01 yview} -orient vert \
        -width 10 
    button $base.fra30.but40 \
        -padx 11 -pady 4 -text {Add selection to playlist} 
    message $base.fra30.mes41 \
        -aspect 15000 -padx 5 -pady 2 -relief raised -text {Song selection} 
    frame $base.fra36 \
        -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.fra17 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground #949690 -highlightcolor #d9d9d9 -relief raised \
        -width 125 
    message $base.fra17.mes18 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -text {Playlist Editor} 
    frame $base.fra19 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground Black -relief groove -width 125 
    frame $base.fra19.cpd20 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra19.cpd20.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode extended -width 49 \
        -xscrollcommand {.top29.fra19.cpd20.02 set} \
        -yscrollcommand {.top29.fra19.cpd20.03 set} 
    bind $base.fra19.cpd20.01 <Double-ButtonRelease-1> {
        AddToPlaylist
    }
    scrollbar $base.fra19.cpd20.02 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra19.cpd20.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra19.cpd20.03 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra19.cpd20.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    message $base.fra19.mes22 \
        -aspect 15000 -background #505050 -foreground #949690 -padx 5 -pady 2 \
        -relief raised -text {Song Selection Window} 
    label $base.fra19.lab23 \
        -anchor w -background #505050 -borderwidth 1 -foreground #009a00 \
        -justify left -text Directory: 
    button $base.fra19.but25 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command AddToPlaylist -foreground #d6a400 -highlightbackground Black \
        -padx 9 -pady 3 -text {Add selection to Playlist} 
    frame $base.fra19.cpd43 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra19.cpd43.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single \
        -xscrollcommand {.top29.fra19.cpd43.02 set} \
        -yscrollcommand {.top29.fra19.cpd43.03 set} 
    bind $base.fra19.cpd43.01 <Double-ButtonRelease-1> {
        ChangeDirectory
    }
    scrollbar $base.fra19.cpd43.02 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra19.cpd43.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra19.cpd43.03 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra19.cpd43.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    entry $base.fra19.ent21 \
        -background #323232 -foreground #d47639 -highlightbackground Black \
        -selectbackground #921016 -textvariable mp3filter 
    bind $base.fra19.ent21 <Key-Return> {
        DirList_ShowDir $CurDirEntry
    }
    message $base.fra19.mes20 \
        -anchor nw -aspect 1500 -background #323232 -foreground #d47639 \
        -highlightbackground Black -padx 2 -pady 2 -relief sunken \
        -text /vol/vol2/Mp3 -textvariable CurDirEntry 
    label $base.fra19.lab27 \
        -anchor e -background #505050 -borderwidth 1 -foreground #009a00 \
        -justify right -text filter: 
    frame $base.fra26 \
        -background #505050 -borderwidth 2 -height 75 \
        -highlightbackground black -relief groove -width 125 
    frame $base.fra26.cpd27 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra26.cpd27.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode extended \
        -xscrollcommand {.top29.fra26.cpd27.02 set} \
        -yscrollcommand {.top29.fra26.cpd27.03 set} 
    bind $base.fra26.cpd27.01 <Double-ButtonRelease-1> {
        DeleteFromPlaylist
    }
    scrollbar $base.fra26.cpd27.02 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra26.cpd27.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra26.cpd27.03 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top29.fra26.cpd27.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    message $base.fra26.mes28 \
        -aspect 15000 -background #505050 -foreground #949690 -padx 5 -pady 2 \
        -relief raised -text {PlayList window} 
    label $base.fra26.lab30 \
        -anchor w -background #505050 -borderwidth 1 -foreground #009a00 \
        -justify left -text Playlist: 
    entry $base.fra26.ent31 \
        -background #323232 -foreground #d47639 -highlightbackground Black \
        -state disabled -textvariable PlayListFilename 
    button $base.fra26.but32 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command DeleteFromPlaylist -foreground #d6a400 \
        -highlightbackground Black -padx 9 -pady 3 \
        -text {Delete Selection from Playlist} 
    button $base.fra26.but33 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global Select_File_Target playloc
set Select_File_Target "save"
Start_Select_File *.lst $playloc} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Save as} 
    button $base.fra26.but34 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window hide .top29
exit} -foreground #d6a400 \
        -highlightbackground Black -padx 9 -pady 3 -text Exit 
    button $base.fra26.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global Select_File_Target playloc
set Select_File_Target "import"
set pwd [exec pwd]
Start_Select_File *.lst $playloc} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Import 
    message $base.fra26.mes18 \
        -padx 5 -pady 2 -text message 
    button $base.fra26.but18 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command ShowHelp -foreground #d6a400 -highlightbackground Black \
        -padx 9 -pady 3 -text ? 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.fra17 \
        -x 5 -y 5 -width 530 -height 40 -anchor nw -bordermode ignore 
    place $base.fra17.mes18 \
        -x 5 -y 5 -width 518 -height 26 -anchor nw -bordermode ignore 
    place $base.fra19 \
        -x 5 -y 50 -width 530 -height 245 -anchor nw -bordermode ignore 
    place $base.fra19.cpd20 \
        -x 185 -y 55 -width 330 -height 155 -anchor nw -bordermode ignore 
    grid columnconf $base.fra19.cpd20 0 -weight 1
    grid rowconf $base.fra19.cpd20 0 -weight 1
    grid $base.fra19.cpd20.01 \
        -in .top29.fra19.cpd20 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra19.cpd20.02 \
        -in .top29.fra19.cpd20 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra19.cpd20.03 \
        -in .top29.fra19.cpd20 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    place $base.fra19.mes22 \
        -x 5 -y 5 -width 518 -height 21 -anchor nw -bordermode ignore 
    place $base.fra19.lab23 \
        -x 9 -y 31 -width 66 -height 18 -anchor nw -bordermode ignore 
    place $base.fra19.but25 \
        -x 185 -y 215 -anchor nw -bordermode ignore 
    place $base.fra19.cpd43 \
        -x 10 -y 55 -width 170 -height 155 -anchor nw -bordermode ignore 
    grid columnconf $base.fra19.cpd43 0 -weight 1
    grid rowconf $base.fra19.cpd43 0 -weight 1
    grid $base.fra19.cpd43.01 \
        -in .top29.fra19.cpd43 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra19.cpd43.02 \
        -in .top29.fra19.cpd43 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra19.cpd43.03 \
        -in .top29.fra19.cpd43 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    place $base.fra19.ent21 \
        -x 450 -y 30 -width 63 -height 22 -anchor nw -bordermode ignore 
    place $base.fra19.mes20 \
        -x 75 -y 29 -width 333 -height 23 -anchor nw -bordermode ignore 
    place $base.fra19.lab27 \
        -x 406 -y 31 -width 40 -height 18 -anchor nw -bordermode ignore 
    place $base.fra26 \
        -x 5 -y 300 -width 530 -height 250 -anchor nw -bordermode ignore 
    place $base.fra26.cpd27 \
        -x 10 -y 55 -width 510 -height 155 -anchor nw -bordermode ignore 
    grid columnconf $base.fra26.cpd27 0 -weight 1
    grid rowconf $base.fra26.cpd27 0 -weight 1
    grid $base.fra26.cpd27.01 \
        -in .top29.fra26.cpd27 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra26.cpd27.02 \
        -in .top29.fra26.cpd27 -column 0 -row 1 -columnspan 1 -rowspan 1 \
        -sticky ew 
    grid $base.fra26.cpd27.03 \
        -in .top29.fra26.cpd27 -column 1 -row 0 -columnspan 1 -rowspan 1 \
        -sticky ns 
    place $base.fra26.mes28 \
        -x 5 -y 5 -width 518 -height 21 -anchor nw -bordermode ignore 
    place $base.fra26.lab30 \
        -x 10 -y 32 -width 51 -height 18 -anchor nw -bordermode ignore 
    place $base.fra26.ent31 \
        -x 65 -y 30 -width 453 -height 22 -anchor nw -bordermode ignore 
    place $base.fra26.but32 \
        -x 66 -y 215 -width 191 -height 26 -anchor nw -bordermode ignore 
    place $base.fra26.but33 \
        -x 360 -y 215 -width 73 -height 26 -anchor nw -bordermode ignore 
    place $base.fra26.but34 \
        -x 445 -y 215 -width 72 -height 26 -anchor nw -bordermode ignore 
    place $base.fra26.but17 \
        -x 272 -y 215 -width 72 -height 26 -anchor nw -bordermode ignore 
    place $base.fra26.mes18 \
        -x 35 -y -280 -anchor nw -bordermode ignore 
    place $base.fra26.but18 \
        -x 15 -y 215 -width 32 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top45 {base} {
    if {$base == ""} {
        set base .top45
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 498x357+504+77
    wm maxsize $base 1265 994
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "Help Window Encoder"
    message $base.mes46 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3-Studio Help Window} 
    frame $base.cpd47 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    scrollbar $base.cpd47.01 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top45.cpd47.03 xview} -highlightbackground Black \
        -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.cpd47.02 \
        -activebackground #d6a400 -background #323232 -borderwidth 1 \
        -command {.top45.cpd47.03 yview} -highlightbackground Black \
        -orient vert -troughcolor #323232 -width 10 
    text $base.cpd47.03 \
        -background #323232 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d6a400 -height 1 -highlightbackground Black \
        -selectbackground #921016 -selectforeground White -width 8 \
        -xscrollcommand {.top45.cpd47.01 set} \
        -yscrollcommand {.top45.cpd47.02 set} 
    button $base.but48 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global seenHelp
set seenHelp 0
Window hide $widget(helpwindow)} \
        -disabledforeground Black \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Close 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes46 \
        -x 5 -y 5 -width 488 -height 36 -anchor nw -bordermode ignore 
    place $base.cpd47 \
        -x 10 -y 45 -width 478 -height 276 -anchor nw 
    grid columnconf $base.cpd47 0 -weight 1
    grid rowconf $base.cpd47 0 -weight 1
    grid $base.cpd47.01 \
        -in .top45.cpd47 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd47.02 \
        -in .top45.cpd47 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd47.03 \
        -in .top45.cpd47 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    place $base.but48 \
        -x 380 -y 325 -width 100 -height 26 -anchor nw -bordermode ignore 
}

Window show .
Window show .top18
Window show .top21
Window show .top29
Window show .top45

main $argc $argv
