#!/usr/bin/wish
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global Mixer_bin; 
global Samplerate; 
global Timer_Listarray_Length; 
global atjobcommand; 
global bindir; 
global devtape; 
global duur; 
global eindtijd; 
global filename; 
global jobdir; 
global mixercommand; 
global mp3loc; 
global newloc; 
global playloc; 
global rec_channels; 
global rec_source; 
global samplecommand; 
global seenHelp; 
global starttijd; 
global stereo; 
global wavloc; 
global widget; 
    set widget(CheckingWindow) {.top17}
    set widget(ConfirmExit) {.top35}
    set widget(ConfirmExitMP3Studio) {.top35}
    set widget(DirListWindow) {.top29.fra19.cpd43.01}
    set widget(FileBox) {.top17.cpd27.01}
    set widget(FileListWindow) {.top29.fra19.cpd20.01}
    set widget(MP3player) {.top20}
    set widget(PlayListEditor) {.top29}
    set widget(PlayListWindow) {.top29.fra26.cpd27.01}
    set widget(SelectFile) {.top18}
    set widget(SelectFile_Window) {.top18}
    set widget(rev,.top17) {CheckingWindow}
    set widget(rev,.top17.cpd27.01) {FileBox}
    set widget(rev,.top17.scr25) {scrollY}
    set widget(rev,.top18) {SelectFile_Window}
    set widget(rev,.top20) {MP3player}
    set widget(rev,.top29) {PlayListEditor}
    set widget(rev,.top29.fra19.cpd20.01) {FileListWindow}
    set widget(rev,.top29.fra19.cpd43.01) {DirListWindow}
    set widget(rev,.top29.fra26.cpd27.01) {PlayListWindow}
    set widget(rev,.top35) {ConfirmExit}
    set widget(scrollY) {.top17.scr25}

#################################
# USER DEFINED PROCEDURES
#
proc init {argc argv} {

}

init $argc $argv


proc Add_job_to_list {} {
catch {exec /usr/bin/at -V } stream
set regellist [split $stream \n] 
set regel [lindex $regellist 0] 
set versie [lindex $regel 2]
if { [string match "3*" $versie] == 1 } {
    #puts stdout "nieuwe versie"
    Add_job_to_list_nieuwe_versie
} else {
    #puts stdout "oude versie: $versie"
    Add_job_to_list_oude_versie
}

set status_var "Reading at-jobs"
}

proc Add_job_to_list_nieuwe_versie {} {
# Alleen aanroepen als alle velden correct zijn ingevuld!
global Timer_Listarray Timer_Listarray_Length Atjob_Array filename 
global starttijd eindtijd Samplerate stereo atjobcommand mixercommand
global rec_channels channel_vol rec_source

set Timer_Listarray(file,$Timer_Listarray_Length) $filename
set Timer_Listarray(starttijd,$Timer_Listarray_Length) $starttijd
set Timer_Listarray(einddatum,$Timer_Listarray_Length) [exec date -d $eindtijd "+%Y-%m-%d"]
set Timer_Listarray(eindtijd,$Timer_Listarray_Length) [exec date -d $eindtijd "+%H:%M"]
set Timer_Listarray(Samplerate,$Timer_Listarray_Length) $Samplerate    
set Timer_Listarray(stereo,$Timer_Listarray_Length) $stereo

set starttijd [exec date -d $Timer_Listarray(starttijd,$Timer_Listarray_Length) "+%H:%M %Y-%m-%d"]
set duur [expr [exec date -d $eindtijd +%s] - [exec date -d $starttijd +%s]]

set atcommand ""
foreach channel $rec_channels {
    if [string match "*$channel*" $rec_source] {
        append atcommand "$mixercommand set src $channel 1 > /dev/null \n"
        append atcommand "$mixercommand set vol $channel $channel_vol($channel) > /dev/null \n"
    } else {
        append atcommand "$mixercommand set src $channel 0 > /dev/null \n"
    }
}


if {$stereo == "Stereo"} {
    set commando "$atjobcommand $filename -sr $Samplerate -ch 2 -rt $duur > /dev/null \n"
} else {
    set commando "$atjobcommand $filename -sr $Samplerate -ch 1 -rt $duur > /dev/null \n"
}

append atcommand $commando
catch {exec /usr/bin/at $starttijd << $atcommand  } stream

# catch {exec /home/mp3/sampler/at-compile-hack $starttijd < /home/mp3/sampler/test } stream
set regellist [split $stream \n] 
set regel [lindex $regellist 1] 
set atjobnr [lindex $regel 1]
# puts stdout "atjobnr:$atjobnr"
set Timer_Listarray(atjobnr,$Timer_Listarray_Length) $atjobnr

incr Timer_Listarray_Length
}

proc Add_job_to_list_oude_versie {} {
# Alleen aanroepen als alle velden correct zijn ingevuld!
global Timer_Listarray Timer_Listarray_Length Atjob_Array filename
global starttijd eindtijd Samplerate stereo atjobcommand mixercommand
global rec_channels channel_vol rec_source


set Timer_Listarray(file,$Timer_Listarray_Length) $filename
set Timer_Listarray(starttijd,$Timer_Listarray_Length) $starttijd
set Timer_Listarray(einddatum,$Timer_Listarray_Length) [exec date -d $eindtijd "+%Y-%m-%d"]
set Timer_Listarray(eindtijd,$Timer_Listarray_Length) [exec date -d $eindtijd "+%H:%M"]
set Timer_Listarray(Samplerate,$Timer_Listarray_Length) $Samplerate    
set Timer_Listarray(stereo,$Timer_Listarray_Length) $stereo

set starttijd [exec date -d $Timer_Listarray(starttijd,$Timer_Listarray_Length) "+%H:%M %m/%d/%y"]
# puts stdout "starttijd voor at: $starttijd"
set duur [expr [exec date -d $eindtijd +%s] - [exec date -d $starttijd +%s]]

set atcommand ""
foreach channel $rec_channels {
    if [string match "*$channel*" $rec_source] {
        append atcommand "$mixercommand set src $channel 1 > /dev/null \n"
        append atcommand "$mixercommand set vol $channel $channel_vol($channel) > /dev/null \n"
    } else {
        append atcommand "$mixercommand set src $channel 0 > /dev/null \n"
    }
}

if {$stereo == "Stereo"} {
    set commando "$atjobcommand $filename -sr $Samplerate -ch 2 -rt $duur > /dev/null \n"
} else {
    set commando "$atjobcommand $filename -sr $Samplerate -ch 1 -rt $duur > /dev/null \n"
}
append atcommand $commando
catch {exec /usr/bin/at $starttijd << $atcommand  } stream

# catch {exec /home/mp3/sampler/at-compile-hack $starttijd < /home/mp3/sampler/test } stream
set regellist [split $stream \n] 
set regel [lindex $regellist 0] 
# puts stdout "regel:$regel"
set atjobnr [lindex $regel 1]
# puts stdout "atjobnr:$atjobnr"
set Timer_Listarray(atjobnr,$Timer_Listarray_Length) $atjobnr

incr Timer_Listarray_Length
}

proc Delete_job_from_list {arraynr} {
global filename Timer_Listarray Timer_Listarray_Length

if { $arraynr == "" } {

#puts stdout "lege keuze!"

} else {


set Timer_Listarray_Length [expr $Timer_Listarray_Length - 1]
catch {exec /usr/bin/atrm $Timer_Listarray(atjobnr,$arraynr) } stream
for {set x $arraynr } {$x < $Timer_Listarray_Length } {incr x 1} {
    set Timer_Listarray(file,$x) $Timer_Listarray(file,[expr $x + 1])
    set Timer_Listarray(starttijd,$x) $Timer_Listarray(starttijd,[expr $x + 1])
    set Timer_Listarray(einddatum,$x) $Timer_Listarray(einddatum,[expr $x + 1])
    set Timer_Listarray(eindtijd,$x) $Timer_Listarray(eindtijd,[expr $x + 1])
    set Timer_Listarray(Samplerate,$x) $Timer_Listarray(Samplerate,[expr $x + 1])
    set Timer_Listarray(stereo,$x) $Timer_Listarray(stereo,[expr $x + 1])
    set Timer_Listarray(atjobnr,$x) $Timer_Listarray(atjobnr,[expr $x + 1])
# mixersettings:
    set Timer_Listarray(rec_channels,$x) $Timer_Listarray(rec_channels,[expr $x + 1])
    foreach channel $Timer_Listarray(rec_channels,$x) {
        set Timer_Listarray(channel_vol,$channel,$x) $Timer_Listarray(channel_vol,$channel,[expr $x +1])
    }
    set Timer_Listarray(rec_source,$x) $Timer_Listarray(rec_source,[expr $x +1])
}

set regellist [split $stream \n] 
set regel [lindex $regellist 0] 
#puts stdout "regel 1:$regel"
if { [string match "*deleting running job*" $regel] == 1 } {
    puts stdout "Deze job is al bezig en wordt nu afgemaakt!"
}

#set atjobnr [lindex $regel 1]


}
}

proc Get_Mixer_Settings {} {
global Mixer_bin Timer_Listarray Timer_Listarray_Length 
global rec_channels channel_vol rec_source


# vraag recording kanalen op:
    catch {exec $Mixer_bin get dev rec  } stream
    set rec_channels $stream
#    puts stdout "rec channels: $stream"
    catch {exec $Mixer_bin get src } stream
    set rec_source $stream
#    puts stdout "rec source: $stream"
    foreach channel $rec_channels {
        catch {exec $Mixer_bin get vol $channel} stream
        set channel_vol($channel) $stream
#        puts stdout "volume channel $channel: $stream"
    }
}

proc Init_Timer {} {
global Timer_Listarray Timer_Listarray_Length Atjob_Array

# eerst variabelen (ook in arrays!) resetten....
foreach index [array names Timer_Listarray] {unset Timer_Listarray($index)}
set Timer_Listarray_Length 0
foreach index [array names Atjob_Array] {unset Atjob_Array($index)}

Read_atjobs
Read_jobs
Update_Timer_List
Show_Timer_List
}

proc Loadprefs {} {
global mp3loc playloc wavloc newloc samplecommand mixercommand devtape
global bindir

set bindir "/usr/local/mp3studio"
set mp3loc "/"
set playloc "/"
set wavloc "/"
set newloc "/"
set samplecommand "/usr/local/SoundStudio/soundstudio"
set mixercommand "/usr/X11R6/bin/xmixer"
set devtape "/dev/nst0"
set configfile "~/.mp3studiorc"

if [ catch { open $configfile r } fileId ] {
  # Check if file exists
  if { [ file exists $configfile ] == 0 } {
     SavePrefs
     return
  } else {
    puts stdout "Error opening configfile!"
    return
  }

} else {

  set mp3loc [ gets $fileId ]
  set playloc [ gets $fileId ]
  set wavloc [ gets $fileId ]
  set newloc [ gets $fileId ]
  set samplecommand [ gets $fileId ]
  set mixercommand [ gets $fileId ]
  set devtape [ gets $fileId ]
  set bindir [ gets $fileId ]

}

close $fileId
return
}

proc Read_atjobs {} {
catch {exec /usr/bin/at -V } stream
set regellist [split $stream \n] 
set regel [lindex $regellist 0] 
set versie [lindex $regel 2]
if { [string match "3*" $versie] == 1 } {
   # puts stdout "nieuwe versie"
    Read_atjobs_nieuwe_versie
} else {
   # puts stdout "oude versie: $versie"
    Read_atjobs_oude_versie
}

set status_var "Reading at-jobs"
}

proc Read_atjobs_nieuwe_versie {} {
global Atjob_Array
set stream [open "|/usr/bin/at -l" r]

set regel [ gets $stream]
while { ![eof $stream] } {
#    puts stdout "parsing: $regel"
    set Atjob_Array([lindex $regel 0],startdatum) [lindex $regel 1]
    set Atjob_Array([lindex $regel 0],starttijd) [lindex $regel 2]
    set Atjob_Array([lindex $regel 0],status) [lindex $regel 3]


#    puts stdout "atjobnr: [lindex $regel 0]"
#    puts stdout "startdatum: $Atjob_Array([lindex $regel 0],startdatum)"
#    puts stdout "starttijd: $Atjob_Array([lindex $regel 0],starttijd)"
#    puts stdout "status: $Atjob_Array([lindex $regel 0],status)"

    set regel [ gets $stream ]
}
close $stream
return
}

proc Read_atjobs_oude_versie {} {
global Atjob_Array

set stream [open "|/usr/bin/at -l" r]

set regel [ gets $stream]
# puts stdout "stream: $stream"
if { ![eof $stream] } {
    set regel [ gets $stream]
}
while { ![eof $stream] } {
#   puts stdout "parsing: $regel"
    set starttijd [lindex $regel 0]
    set startdatum [lindex $regel 1]
    set starttijd [exec date -d $starttijd "+%H:%M"]
    set startdatum [exec date -d $startdatum "+%Y-%m-%d"]
    set atjobnr [lindex $regel 4]
    set Atjob_Array($atjobnr,startdatum) $startdatum
    set Atjob_Array($atjobnr,starttijd) $starttijd
    set Atjob_Array($atjobnr,status) [lindex $regel 3]

#    puts stdout "startdatum: $Atjob_Array($atjobnr,startdatum)"
#    puts stdout "starttijd: $Atjob_Array($atjobnr,starttijd)"
#    puts stdout "status: $Atjob_Array($atjobnr,status)"

    set regel [ gets $stream ]
}
close $stream
return
}

proc Read_jobs {} {
global Timer_Listarray Timer_Listarray_Length Atjob_Array jobdir

set hostnaam [exec hostname]
set usernaam [exec whoami]
set Filename "$jobdir/jobs-$hostnaam-$usernaam"
set status_var "Reading sampler jobs"

if { ![file exists $Filename] } {
    set Timer_Listarray_Length 0
} elseif [ catch { open $Filename r } fileId ] {
    puts stderr "Error opening file with sampler jobs : $fileId"

} else {
#  puts stdout "$Filename Opened file for reading..."

  set Timer_Listarray_Length 0
  set regel [ gets $fileId ]
if { [string match "Sampler jobs MP3-Studio*" $regel] == 1 } {

  while { ![eof $fileId] } {
    set regel [gets $fileId ]
#   puts stdout "regel nr $aantal_regels bevat:$regel($aantal_regels)."

#   bepaal atjobnr van huidig ingelezen regel
    set atjobnr [lindex $regel 0]

#   vervolgens checken of de ingelezen job wel in de atjob-array bestaat:
    set atjobnr [lindex $regel 0]
    if [info exists Atjob_Array($atjobnr,status)] {
        # puts stdout "atjob $atjobnr bestaat!"
        # Timer_Listarray_lenhth verhogen, omdat er een geldige is gevonden!

        # alle variabelen van deze job setten, sommige komen uit atjob-array
        set Timer_Listarray(starttijd,$Timer_Listarray_Length) $Atjob_Array($atjobnr,startdatum)
        append Timer_Listarray(starttijd,$Timer_Listarray_Length) " " $Atjob_Array($atjobnr,starttijd)

        set Timer_Listarray(atjobnr,$Timer_Listarray_Length) [lindex $regel 0]
        set Timer_Listarray(file,$Timer_Listarray_Length) [lindex $regel 1]
        set Timer_Listarray(einddatum,$Timer_Listarray_Length) [lindex $regel 2]
        set Timer_Listarray(eindtijd,$Timer_Listarray_Length) [lindex $regel 3]
        set Timer_Listarray(Samplerate,$Timer_Listarray_Length) [lindex $regel 4]
        set Timer_Listarray(stereo,$Timer_Listarray_Length) [lindex $regel 5]
        
        set Timer_Listarray(rec_channels,$Timer_Listarray_Length) [gets $fileId ]
        
#       puts stdout "read: rec_channel $Timer_Listarray_Length = $Timer_Listarray(rec_channels,$Timer_Listarray_Length)"
        foreach channel $Timer_Listarray(rec_channels,$Timer_Listarray_Length) {
            set Timer_Listarray(channel_vol,$channel,$Timer_Listarray_Length) [gets $fileId]
        # end foreach
        
        }
        set Timer_Listarray(rec_source,$Timer_Listarray_Length) [gets $fileId ]
        set Timer_Listarray_Length [expr $Timer_Listarray_Length + 1]
        
    } else {
        # puts stdout "atjob $atjobnr bestaat niet!"
        set rec_channels  [gets $fileId ]
        foreach channel $rec_channels {
            gets $fileId
        # end foreach
        }
        set rec_source [gets $fileId ]
    }
 #   set Timer_Listarray(starttijd,$Timer_Listarray_Length) [exec date "+%y-%m-%d %H:%M"]

  }
 # einde while
} else {
    # Eerste regel file bevat niet "Sampler_jobs*"
    puts stderr "Fout: Sampler_job_file $Filename is niet correct!"
}
close $fileId
}
# einde else file exists
return
}

proc Select_File_Change_Dir {dir} {
global SelectDirEntry Selected_File
if {$dir == ""} { set dir "/" }
if [ catch { cd /$dir } err ] {

# en file-listbox ledigen omdat de directory niet geldig is en er dus geen files zijn!Select_File_Change_Dir
# .top18.fra20.01 delete 0 end

#set idx [string last "/" $Selected_File ]
#set newdir [string range $Selected_File 0 $idx ]
#puts stdout "Nieuwe directory moet eigenlijk zijn:$newdir"

} else { 
    catch { exec "pwd" } SelectDirEntry
    if { $SelectDirEntry == "/" } {
        set Selected_File "/"
        Select_File_Show $SelectDirEntry 
    } else {
        if { [string range $Selected_File end end] == "/" } {
        } else {
            set Selected_File $SelectDirEntry
        }   
    Select_File_Show $SelectDirEntry
    }
}
}

proc Select_File_Show {Dir} {
global SelectDirEntry Selected_File filter

set SelectDirEntry $Dir
#set Selected_File $SelectDirEntry
# Clear window contents
.top18.fra32.01 delete 0 end
.top18.fra20.01 delete 0 end

.top18.fra32.01 delete 0 end

if { $SelectDirEntry != "/" } { 
 # Add the ..-directory
 #DirListWindow insert end ".."
 .top18.fra32.01 insert end ".."
}

# Fill the windows
foreach f [lsort [glob -nocomplain $Dir/*]] {
  if [file isdirectory $f] {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    .top18.fra32.01 insert end $naam
#   $DirListWindow insert end $naam

   } else {

    set idx [string last "/" $f]
    set idx [expr $idx +1 ]
    set eind [string length $f]
    set naam [string range $f $idx $eind]
    if {[string match $filter $naam ] == 1} {

#       $FileListWindow insert end $naam
        .top18.fra20.01 insert end $naam
    }
   }
}
}

proc ShowHelp {} {
global bindir seenHelp


if { $seenHelp == 0 } {

if [ catch { open $bindir/samplerhelp.hlp r } fileId ] {
  set status_var "Error opening helpfile:$fileId"
  Window hide .top20
  return

} else {
  Window show .top20
  .top20.cpd26.03 delete 1.0 end

  set string [ gets $fileId ]

  while { ![eof $fileId] } {

   .top20.cpd26.03 insert end "$string\n"
   set string [ gets $fileId ]
 #  .top20.cpd26.03 delete 1.0 1.end

  }
}

close $fileId
set seenHelp 1

}

return
}

proc Show_Timer_List {} {
global Timer_Listarray Timer_Listarray_Length

.top17.cpd24.01 delete 0 end

set eind [expr $Timer_Listarray_Length - 0]
for {set index 1} { $index <= $eind } {incr index 1} { 
   .top17.cpd24.01  insert end "$index. $Timer_Listarray(file,[expr $index -1 ])"
}
.top17.cpd24.01  yview moveto 1

if {[.top17.cpd24.01 curselection ] == ""} {
#    .top17.cpd24.01 select set end end
}
}

proc Start_Sampling {} {
lobal stream CurrentFile_var status_var
global waarde playerLocation

set status_var "Playing"
set stream [ open "| $playerLocation/player play $CurrentFile_var $pos" ]
fconfigure $stream -blocking 0
fileevent $stream readable {IO_Handler}


return
}

proc Start_Select_File {Arg_Filter Startdir} {
global filter Selected_File
set filter $Arg_Filter
grab .top18
Window show .top18
set Dir $Startdir
set Selected_File $Dir
Select_File_Show $Dir
}

proc Update_Timer_List {} {
global filename Timer_Listarray starttijd eindtijd Samplerate stereo duur
global rec_channels channel_vol rec_source
#global PlaylistArray PlaylistArrayLength CurDirEntry
#
#foreach f [.top29.fra19.cpd20.01 curselection ] {
# incr PlaylistArrayLength 1
# set idx [expr $PlaylistArrayLength - 1]
# set PlaylistArray($idx) "$CurDirEntry/[.top29.fra19.cpd20.01 get $f]"
#}

#.top29.fra19.cpd20.01 selection clear 0 end
#Playlist_ShowList


if {[.top17.cpd24.01 curselection ] == ""} {
    set filename ""
    set starttijd ""
    set eindtijd ""
    set Samplerate "44100"
    set stereo "stereo"
    set duur ""
    set rec_channels ""
    set rec_source ""
} else {
Update_tijden
set filename $Timer_Listarray(file,[.top17.cpd24.01 curselection ])
set starttijd $Timer_Listarray(starttijd,[.top17.cpd24.01 curselection ])
set eindtijd $Timer_Listarray(einddatum,[.top17.cpd24.01 curselection ])
append eindtijd " " $Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ])
set Samplerate $Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection ])
set stereo $Timer_Listarray(stereo,[.top17.cpd24.01 curselection ])
set duur [expr [exec date -d $eindtijd +%s] - [exec date -d $starttijd +%s]]
# mixersettings van huidige job in globale variabelen zetten t.b.v. atjobcommando
set rec_channels $Timer_Listarray(rec_channels,[.top17.cpd24.01 curselection ])
foreach channel $rec_channels {
    set channel_vol($channel) $Timer_Listarray(channel_vol,$channel,[.top17.cpd24.01 curselection ])
}
set rec_source $Timer_Listarray(rec_source,[.top17.cpd24.01 curselection ])
}
}

proc Update_tijden {} {
# Alleen aanroepen als curselection bestaat!
global starttijd eindtijd Timer_Listarray Samplerate stereo
global rec_channels channel_vol rec_source
if {[.top17.cpd24.01 curselection] == ""} {
    # cursel was dus leeg!
    set starttijd ""
    set eindtijd ""
    set Samplerate 44100
    set stereo Stereo

} else {
    set fc [focus]
    set veranderd 0
#    puts stdout "focus:$fc"

    # puts stdout "start:$starttijd  eind:$eindtijd"
    if {$fc == ".top17.ent22"} {
        set result [catch {exec date -d $starttijd "+%Y-%m-%d %H:%M"} result2]
        if {!$result} {
            if {$result2 == $Timer_Listarray(starttijd,[.top17.cpd24.01 curselection]) } {
            } else {
                set Timer_Listarray(starttijd,[.top17.cpd24.01 curselection ]) $result2
                set starttijd $result2
                Window hide .top19
                set veranderd 1
            } 

        } else {

            Window show .top19
            set starttijd $Timer_Listarray(starttijd,[.top17.cpd24.01 curselection ])
            Update_Timer_List 

        }
    } 
# end if focus op starttijd
    if {$fc == ".top17.ent18"} {
        set result [catch {exec date -d $eindtijd "+%Y-%m-%d %H:%M"} result2]
        if !$result {
            set et $Timer_Listarray(einddatum,[.top17.cpd24.01 curselection])
            append et " " $Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ])
            if {$result2 == $et } {
            } else {
                set Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ]) [exec date -d $eindtijd "+%H:%M"]
                set Timer_Listarray(einddatum,[.top17.cpd24.01 curselection ]) [exec date -d $eindtijd "+%Y-%m-%d"]
                set eindtijd $result2
                Window hide .top19
                set veranderd 1
            }    
        } else {
            Window show .top19
            set eindtijd $Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ])
            Update_Timer_List 
        }
    }
# end if focus op eindtijd
}
if {$Samplerate == $Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection])} {
} else {
    set veranderd 1
}
if {$stereo == $Timer_Listarray(stereo,[.top17.cpd24.01 curselection])} {
} else {
    set veranderd 1
}
# mixersettings van huidige job in globale variabelen zetten t.b.v. atjobcommando
set Timer_Listarray(rec_channels,[.top17.cpd24.01 curselection ]) $rec_channels
foreach channel $rec_channels {
   set Timer_Listarray(channel_vol,$channel,[.top17.cpd24.01 curselection ]) $channel_vol($channel) 
}
set Timer_Listarray(rec_source,[.top17.cpd24.01 curselection ]) $rec_source 


if {$veranderd} {
    Delete_job_from_list [.top17.cpd24.01 curselection ]
    Add_job_to_list
}
# end if cursel bestaat
}

proc Write_jobs {} {
global Timer_Listarray Timer_Listarray_Length jobdir
set hostnaam [exec hostname]
set usernaam [exec whoami]
set Filename "$jobdir/jobs-$hostnaam-$usernaam"
set status_var "Writing sampler jobs"

if [ catch { open $Filename w 0600 } fileId ] {
  puts stderr "Error opening file for sampler jobs : $fileId"

} else {
  #  puts stdout "$Filename Opened file for writing..."
    puts $fileId "Sampler jobs MP3-Studio --- DO NOT EDIT!!!! ---" 
    for {set x 0 } {$x < $Timer_Listarray_Length} {incr x 1} {
        
  #   puts stdout "regel nr $aantal_regels bevat:$regel($aantal_regels)."

        puts $fileId "$Timer_Listarray(atjobnr,$x) $Timer_Listarray(file,$x) $Timer_Listarray(einddatum,$x) $Timer_Listarray(eindtijd,$x) $Timer_Listarray(Samplerate,$x) $Timer_Listarray(stereo,$x)"
        puts $fileId "$Timer_Listarray(rec_channels,$x)"
        foreach channel $Timer_Listarray(rec_channels,$x) {
            puts $fileId "$Timer_Listarray(channel_vol,$channel,$x)"
        # end foreach
        }
        puts $fileId "$Timer_Listarray(rec_source,$x)"
    # end for
    }
close $fileId
}
return
}

proc test {} {
global filename Timer_Listarray starttijd eindtijd
#global PlaylistArray PlaylistArrayLength CurDirEntry
#
#foreach f [.top29.fra19.cpd20.01 curselection ] {
# incr PlaylistArrayLength 1
# set idx [expr $PlaylistArrayLength - 1]
# set PlaylistArray($idx) "$CurDirEntry/[.top29.fra19.cpd20.01 get $f]"
#}

#.top29.fra19.cpd20.01 selection clear 0 end
#Playlist_ShowList


set filename $Timer_Listarray(file,[.top17.cpd24.01 curselection ])
set starttijd $Timer_Listarray(starttijd,[.top17.cpd24.01 curselection ])
set eindtijd $Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ])
set Samplerate $Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection ])

puts stdout "filename=$filename"
}

proc main {argc argv} {
global Mixer_bin seenHelp bindir jobdir atjobcommand mixercommand
set seenHelp 0

set bindir "/home/jeffrey/TCL/TIMER"
set jobdir "/tmp"
set atjobcommand "/home/mp3/final/recorder"
set mixercommand "/home/mp3/final/mixer"

set Mixer_bin "/home/mp3/final/mixer"

Loadprefs

Window show .top18
Window hide .top18
Window hide .top19
Window hide .top20
Init_Timer
Update_Timer_List
}

proc Window {args} {
global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 1x1+5+21
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "vt.tcl"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.top17 {base} {
    if {$base == ""} {
        set base .top17
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 458x264+46+450
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "sample-timer"
    entry $base.ent18 \
        -background #303030 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -selectbackground Red \
        -selectforeground White -textvariable eindtijd 
    bind $base.ent18 <Button> {
        Update_Timer_List
    }
    message $base.mes21 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground Black -padx 5 -pady 2 \
        -text {Ending time} 
    entry $base.ent22 \
        -background #303030 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -selectbackground Red \
        -selectforeground White -textvariable starttijd 
    bind $base.ent22 <Button> {
        Update_Timer_List
    }
    message $base.mes23 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground Black -padx 5 -pady 2 \
        -text Duration 
    frame $base.cpd24 \
        -background #303030 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.cpd24.01 \
        -background #303030 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single \
        -xscrollcommand {.top17.cpd24.02 set} \
        -yscrollcommand {.top17.cpd24.03 set} 
    bind $base.cpd24.01 <Button> {
        if {[.top17.cpd24.01 curselection] == ""} {
    # lege curselection, niets doen!
} else {
    Update_tijden
}
    }
    bind $base.cpd24.01 <ButtonRelease> {
        global filename Timer_Listarray starttijd eindtijd Samplerate stereo duur
if {[.top17.cpd24.01 curselection] == ""} {
    # curselection is leeg, niets doen!
} else {
set filename $Timer_Listarray(file,[.top17.cpd24.01 curselection ])
set starttijd $Timer_Listarray(starttijd,[.top17.cpd24.01 curselection ])
set eindtijd $Timer_Listarray(einddatum,[.top17.cpd24.01 curselection ])
append eindtijd " " $Timer_Listarray(eindtijd,[.top17.cpd24.01 curselection ])
set Samplerate $Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection ])
set stereo $Timer_Listarray(stereo,[.top17.cpd24.01 curselection ])
set duur [expr [exec date -d $eindtijd +%s] - [exec date -d $starttijd +%s]]

Update_Timer_List
}
    }
    scrollbar $base.cpd24.02 \
        -activebackground Black -background #303030 -borderwidth 1 \
        -command {.top17.cpd24.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor Black -width 10 
    scrollbar $base.cpd24.03 \
        -activebackground Black -background #303030 -borderwidth 1 \
        -command {.top17.cpd24.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor Black -width 10 
    message $base.mes28 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground #009a00 -padx 5 -pady 2 \
        -text Filename 
    button $base.but29 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {Delete_job_from_list [.top17.cpd24.01 curselection ]
Show_Timer_List
Update_Timer_List} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Delete entry} 
    button $base.but30 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {Update_Timer_List
Write_jobs
exit} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Exit 
    frame $base.cpd31 \
        -background #303030 -borderwidth 1 -height 30 \
        -highlightbackground #303030 -relief sunken -width 30 
    menubutton $base.cpd31.01 \
        -activebackground #921016 -activeforeground White -anchor w \
        -background #303030 -disabledforeground #d9d9d9 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -height 27 -highlightbackground Black \
        -menu .top17.cpd31.01.02 -padx 4 -pady 3 -relief raised -text 44100 \
        -textvariable Samplerate -width 29 
    menu $base.cpd31.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.01.02 add command \
        \
        -command {global Timer_Listarray Samplerate
set Samplerate 44100
Update_Timer_List
# set Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection ]) 44100} \
        -label 44100 
    $base.cpd31.01.02 add command \
        \
        -command {global Timer_Listarray Samplerate
set Samplerate 22050
Update_Timer_List
# set Timer_Listarray(Samplerate,[.top17.cpd24.01 curselection ]) 22050} \
        -label 22050 
    frame $base.cpd31.fra34 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra34.01 \
        -anchor w -padx 4 -pady 3 -text 44100 -width 102 
    menu $base.cpd31.fra34.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.fra34.01.02 add command \
        -label 44100 
    $base.cpd31.fra34.01.02 add command \
        -label 22050 
    frame $base.cpd31.fra35 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra35.01 \
        -anchor w -menu .top17.cpd31.fra35.fra35.01.02 -padx 4 -pady 3 \
        -text 44100 -width 102 
    menu $base.cpd31.fra35.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.fra35.01.02 add command \
        -label 44100 
    $base.cpd31.fra35.01.02 add command \
        -label 22050 
    frame $base.cpd31.fra35.03 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra35.03.04 \
        -anchor w -menu .top17.cpd31.fra35.fra35.03.fra34.01.02 -padx 4 \
        -pady 3 -text 44100 -width 102 
    frame $base.cpd31.fra36 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra36.01 \
        -anchor w -menu .top17.cpd31.fra36.fra36.01.02 -padx 4 -pady 3 \
        -text 44100 -width 102 
    menu $base.cpd31.fra36.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.fra36.01.02 add command \
        -label 44100 
    $base.cpd31.fra36.01.02 add command \
        -label 22050 
    frame $base.cpd31.fra36.03 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra36.03.04 \
        -anchor w -menu .top17.cpd31.fra36.fra36.03.fra34.01.02 -padx 4 \
        -pady 3 -text 44100 -width 102 
    frame $base.cpd31.fra37 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra37.01 \
        -anchor w -menu .top17.cpd31.fra37.fra37.01.02 -padx 4 -pady 3 \
        -text 44100 -width 102 
    menu $base.cpd31.fra37.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.fra37.01.02 add command \
        -label 44100 
    $base.cpd31.fra37.01.02 add command \
        -label 22050 
    frame $base.cpd31.fra37.03 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra37.03.04 \
        -anchor w -menu .top17.cpd31.fra37.fra37.03.fra34.01.02 -padx 4 \
        -pady 3 -text 44100 -width 102 
    frame $base.cpd31.fra38 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra38.01 \
        -anchor w -menu .top17.cpd31.fra38.fra38.01.02 -padx 4 -pady 3 \
        -text 44100 -width 102 
    menu $base.cpd31.fra38.01.02 \
        -cursor {} -tearoff 0 
    $base.cpd31.fra38.01.02 add command \
        -label 44100 
    $base.cpd31.fra38.01.02 add command \
        -label 22050 
    frame $base.cpd31.fra38.03 \
        -borderwidth 1 -height 30 -relief sunken -width 30 
    menubutton $base.cpd31.fra38.03.04 \
        -anchor w -menu .top17.cpd31.fra38.fra38.03.fra34.01.02 -padx 4 \
        -pady 3 -text 44100 -width 102 
    message $base.mes32 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground Black -padx 5 -pady 2 \
        -text Samplerate 
    message $base.mes17 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -highlightbackground Black -padx 5 -pady 2 \
        -text {Starting time} 
    menu $base.m17 \
        -cursor {} 
    checkbutton $base.che25 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {global stereo
Update_Timer_List
set Timer_Listarray(stereo,[.top17.cpd24.01 curselection ]) $stereo} \
        -disabledforeground #d9d9d9 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -indicatoron 0 \
        -offvalue Stereo -onvalue Mono -selectcolor #303030 -text stereo \
        -textvariable stereo -variable stereo 
    label $base.lab17 \
        -anchor w -background #303030 -borderwidth 1 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -relief sunken -textvariable filename 
    button $base.but18 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {Update_Timer_List
set pwd [exec pwd]
Start_Select_File *.wav $pwd} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text {Add entry} 
    label $base.lab18 \
        -anchor w -background #303030 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Red -highlightcolor White \
        -padx 4 -pady 3 -relief sunken -textvariable duur 
    message $base.mes18 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {MP3-Studio Sampler} 
    button $base.but19 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {Update_Timer_List
# Showhelp werkt nog niet, window is pleitte
ShowHelp} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text ? 
    button $base.but17 \
        -activebackground #921016 -activeforeground white -background #303030 \
        -command {if {[.top17.cpd24.01 curselection] == ""} {
# geen cs, niets doen,
} else {
    Get_Mixer_Settings
    Update_Timer_List
    Delete_job_from_list [.top17.cpd24.01 curselection ]
    Add_job_to_list
    Update_Timer_List
}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground black -padx 9 -pady 3 \
        -text {Save mixer} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent18 \
        -x 305 -y 105 -width 144 -height 22 -anchor nw -bordermode ignore 
    place $base.mes21 \
        -x 209 -y 104 -width 75 -height 22 -anchor nw -bordermode ignore 
    place $base.ent22 \
        -x 305 -y 75 -width 144 -height 22 -anchor nw -bordermode ignore 
    place $base.mes23 \
        -x 209 -y 135 -width 59 -height 22 -anchor nw -bordermode ignore 
    place $base.cpd24 \
        -x 5 -y 75 -width 200 -height 185 -anchor nw -bordermode ignore 
    grid columnconf $base.cpd24 0 -weight 1
    grid rowconf $base.cpd24 0 -weight 1
    grid $base.cpd24.01 \
        -in .top17.cpd24 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.cpd24.02 \
        -in .top17.cpd24 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd24.03 \
        -in .top17.cpd24 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.mes28 \
        -x 6 -y 45 -width 56 -height 14 -anchor nw -bordermode ignore 
    place $base.but29 \
        -x 356 -y 200 -width 96 -height 26 -anchor nw -bordermode ignore 
    place $base.but30 \
        -x 302 -y 233 -width 150 -height 26 -anchor nw -bordermode ignore 
    place $base.cpd31 \
        -x 304 -y 165 -width 70 -height 24 -anchor nw -bordermode ignore 
    pack $base.cpd31.01 \
        -in .top17.cpd31 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra34 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    pack $base.cpd31.fra34.01 \
        -in .top17.cpd31.fra34 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra35 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    pack $base.cpd31.fra35.01 \
        -in .top17.cpd31.fra35 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra35.03 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    place $base.cpd31.fra36 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    pack $base.cpd31.fra36.01 \
        -in .top17.cpd31.fra36 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra36.03 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    place $base.cpd31.fra37 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    pack $base.cpd31.fra37.01 \
        -in .top17.cpd31.fra37 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra37.03 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    place $base.cpd31.fra38 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    pack $base.cpd31.fra38.01 \
        -in .top17.cpd31.fra38 -anchor center -expand 0 -fill none -side left 
    place $base.cpd31.fra38.03 \
        -x 285 -y 145 -width 137 -height 26 -anchor nw 
    place $base.mes32 \
        -x 209 -y 167 -width 72 -height 22 -anchor nw -bordermode ignore 
    place $base.mes17 \
        -x 209 -y 75 -width 86 -height 22 -anchor nw -bordermode ignore 
    place $base.che25 \
        -x 380 -y 165 -width 70 -height 24 -anchor nw -bordermode ignore 
    place $base.lab17 \
        -x 67 -y 42 -width 382 -height 23 -anchor nw -bordermode ignore 
    place $base.but18 \
        -x 260 -y 200 -width 90 -height 26 -anchor nw -bordermode ignore 
    place $base.lab18 \
        -x 305 -y 134 -width 144 -height 23 -anchor nw -bordermode ignore 
    place $base.mes18 \
        -x 3 -y 5 -width 452 -height 31 -anchor nw -bordermode ignore 
    place $base.but19 \
        -x 215 -y 200 -width 35 -height 26 -anchor nw -bordermode ignore 
    place $base.but17 \
        -x 215 -y 233 -width 77 -height 26 -anchor nw -bordermode ignore 
}

proc vTclWindow.top18 {base} {
    if {$base == ""} {
        set base .top18
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground Black \
        -highlightcolor #000000 
    wm focusmodel $base passive
    wm geometry $base 516x301+15+434
    wm maxsize $base 1009 738
    wm minsize $base 500 200
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "select file"
    entry $base.ent25 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -highlightcolor White \
        -selectbackground Red -selectforeground White \
        -textvariable Selected_File 
    bind $base.ent25 <KeyRelease> {
        Select_File_Change_Dir $Selected_File
    }
    frame $base.fra32 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra32.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -height 14 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single -width 10 \
        -xscrollcommand {.top18.fra32.02 set} \
        -yscrollcommand {.top18.fra32.03 set} 
    bind $base.fra32.01 <Double-ButtonRelease-1> {
        set selected [ .top18.fra32.01 curselection ]
set dir $SelectDirEntry/[ .top18.fra32.01 get $selected ]
set Selected_File $dir

Select_File_Change_Dir $dir
    }
    scrollbar $base.fra32.02 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra32.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra32.03 \
        -activebackground #921016 -background #323232 -borderwidth 1 \
        -command {.top18.fra32.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    menu $base.m17 \
        -background #9900991B99FE -cursor {} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #FFFFFFFFFFFF 
    frame $base.fra20 \
        -background #323232 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    listbox $base.fra20.01 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground #d6a400 -selectmode single -width 49 \
        -xscrollcommand {.top18.fra20.02 set} \
        -yscrollcommand {.top18.fra20.03 set} 
    bind $base.fra20.01 <ButtonRelease-1> {
        global Selected_File SelectDirEntry
set idx [ .top18.fra20.01 curselection ]
if { [ llength idx ] > 0 } {
set filenaam [.top18.fra20.01 get $idx ]
set nieuw ""
if {$SelectDirEntry == "/"} {
    append nieuw $SelectDirEntry $filenaam
} else {
    append nieuw $SelectDirEntry  "/" $filenaam
}
set Selected_File $nieuw

}
    }
    scrollbar $base.fra20.02 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra20.01 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor #323232 -width 10 
    scrollbar $base.fra20.03 \
        -activebackground Black -background #323232 -borderwidth 1 \
        -command {.top18.fra20.01 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor #323232 -width 10 
    button $base.but17 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global filename
grab release .top18
Window hide .top18} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Cancel 
    entry $base.ent19 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black \
        -selectbackground Black -textvariable filter 
    bind $base.ent19 <Button> {
        Select_File_Show $SelectDirEntry
    }
    bind $base.ent19 <Key-Return> {
        Select_File_Show $SelectDirEntry
    }
    bind $base.ent19 <Key-Tab> {
        Select_File_Show $SelectDirEntry
    }
    button $base.but24 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {global filename starttijd eindtijd samplerate stereo Selected_File
grab release .top18
Window hide .top18
if ![ catch { cd $Selected_File } err ] {
set filename ""
# filename is directory!
} else {
set filename $Selected_File
set starttijd [exec date -d "1 hour" "+%Y-%m-%d %H:%M"]
set eindtijd [exec date -d "2 hour" "+%Y-%m-%d %H:%M"]
set samplerate  44100 
set stereo Stereo
Get_Mixer_Settings
Add_job_to_list
Show_Timer_List
.top17.cpd24.01 select set end end
Update_Timer_List
}} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    entry $base.ent17 \
        -background #323232 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d47639 -highlightbackground Black -state disabled \
        -textvariable SelectDirEntry 
    message $base.mes22 \
        -aspect 15000 -background #505050 \
        -font -b&h-lucidabright-demibold-r-normal-*-*-190-*-*-p-*-iso8859-* \
        -foreground #949690 -padx 5 -pady 2 -relief raised \
        -text {Select a wav-file for the sample} 
    message $base.mes23 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Filter 
    message $base.mes24 \
        -aspect 15000 -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #009a00 -padx 5 -pady 2 -text Selection 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.ent25 \
        -x 75 -y 40 -width 438 -height 22 -anchor nw -bordermode ignore 
    place $base.fra32 \
        -x 7 -y 98 -width 170 -height 160 -anchor nw -bordermode ignore 
    grid columnconf $base.fra32 0 -weight 1
    grid rowconf $base.fra32 0 -weight 1
    grid $base.fra32.01 \
        -in .top18.fra32 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra32.02 \
        -in .top18.fra32 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.fra32.03 \
        -in .top18.fra32 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.fra20 \
        -x 183 -y 98 -width 325 -height 160 -anchor nw -bordermode ignore 
    grid columnconf $base.fra20 0 -weight 1
    grid rowconf $base.fra20 0 -weight 1
    grid $base.fra20.01 \
        -in .top18.fra20 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    grid $base.fra20.02 \
        -in .top18.fra20 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.fra20.03 \
        -in .top18.fra20 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    place $base.but17 \
        -x 315 -y 265 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.ent19 \
        -x 420 -y 69 -width 93 -height 22 -anchor nw -bordermode ignore 
    place $base.but24 \
        -x 410 -y 265 -width 85 -height 26 -anchor nw -bordermode ignore 
    place $base.ent17 \
        -x 8 -y 69 -width 348 -height 22 -anchor nw -bordermode ignore 
    place $base.mes22 \
        -x 3 -y 3 -width 510 -height 31 -anchor nw -bordermode ignore 
    place $base.mes23 \
        -x 374 -y 72 -width 38 -height 16 -anchor nw -bordermode ignore 
    place $base.mes24 \
        -x 8 -y 42 -width 58 -height 16 -anchor nw -bordermode ignore 
}

proc vTclWindow.top19 {base} {
    if {$base == ""} {
        set base .top19
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 
    wm focusmodel $base passive
    wm geometry $base 267x245+381+454
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Info"
    menu $base.01 \
        -cursor {} 
    menu $base.02 \
        -cursor {} 
    button $base.03 \
        -activebackground #921016 -activeforeground White -background #323232 \
        -command {Window hide .top19} \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text OK 
    message $base.04 \
        -background #505050 \
        -font -adobe-helvetica-bold-r-normal-*-*-120-*-*-p-*-iso8859-* \
        -foreground #d6a400 -padx 5 -pady 2 \
        -text {Vul tijdstip in van de vorm

JJ-MM-DD uu:mm

Waarin  JJ = jaar (00 - 99
            MM = maand (01 - 12)
            DD = dag van de maand (01 - 31)
            uu = uur (00 - 23)
            mm = minute (00 - 59)
            ss = seconden (00 - 59)

Bijvoorbeeld: 98-02-24 14:34} 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.03 \
        -x 85 -y 195 -width 97 -height 26 -anchor nw -bordermode ignore 
    place $base.04 \
        -x 5 -y 5 -width 253 -height 176 -anchor nw -bordermode ignore 
}

proc vTclWindow.top20 {base} {
    if {$base == ""} {
        set base .top20
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -background #505050 -highlightbackground #505050 
    wm focusmodel $base passive
    wm geometry $base 556x367+431+100
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Help Window sampler"
    frame $base.cpd26 \
        -background #303030 -borderwidth 1 -height 30 \
        -highlightbackground Black -relief raised -width 30 
    scrollbar $base.cpd26.01 \
        -activebackground Black -background #303030 -borderwidth 1 \
        -command {.top20.cpd26.03 xview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient horiz -troughcolor Black -width 10 
    scrollbar $base.cpd26.02 \
        -activebackground Black -background #303030 -borderwidth 1 \
        -command {.top20.cpd26.03 yview} -highlightbackground Black \
        -highlightcolor #d6a400 -orient vert -troughcolor Black -width 10 
    text $base.cpd26.03 \
        -background #303030 \
        -font -Adobe-Helvetica-Medium-R-Normal-*-*-120-*-*-*-*-*-* \
        -foreground #d47639 -height 1 -highlightbackground Black \
        -selectbackground #d6a400 -width 8 \
        -xscrollcommand {.top20.cpd26.01 set} \
        -yscrollcommand {.top20.cpd26.02 set} 
    button $base.but27 \
        -activebackground #921016 -activeforeground White -background #303030 \
        -command {global seenHelp
set seenHelp 0
Window hide .top20} \
        -foreground #d6a400 -highlightbackground Black -padx 9 -pady 3 \
        -text Close 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.cpd26 \
        -x 5 -y 5 -width 553 -height 316 -anchor nw 
    grid columnconf $base.cpd26 0 -weight 1
    grid rowconf $base.cpd26 0 -weight 1
    grid $base.cpd26.01 \
        -in .top20.cpd26 -column 0 -row 1 -columnspan 1 -rowspan 1 -sticky ew 
    grid $base.cpd26.02 \
        -in .top20.cpd26 -column 1 -row 0 -columnspan 1 -rowspan 1 -sticky ns 
    grid $base.cpd26.03 \
        -in .top20.cpd26 -column 0 -row 0 -columnspan 1 -rowspan 1 \
        -sticky nesw 
    place $base.but27 \
        -x 385 -y 325 -width 127 -height 36 -anchor nw -bordermode ignore 
}

Window show .
Window show .top17
Window show .top18
Window show .top19
Window show .top20

main $argc $argv
