/* *** wav_interface ***
   *** Filename: wav_interface.h
   *** History: 19980121 Ver 1.00 | Michiel Bronswijk
   ***          19980225 Release version 1.00
   *** Description: C-header file for wav_interface.c
   *** Remarks: This is a very simple interface, just one WAV file
   *** at a time can be handled.
   *** Changes:
*/

#ifndef WAV_INTERFACE_H

#define WAV_INTERFACE_H

/*	isWAVFile
	Checks for a valid .WAV file */
int	isWAVFile(const char *pathname, long *speed);

/*	creatWAV:
	Creates a WAV file */
int	creatWAV(const char *pathname, int width, int channels, int rate);

/*	writeWAV:
	Writes to the previously created WAV file */
int	writeWAV(const void *buf, size_t count);

/*	closeWAV:
	Closes the previously created and written WAV file */
int	closeWAV(void);
#endif
   