%define prefix /usr
%define DATAVER 0.50.2
%define VER     1.6
Name: wmakerconf
Version: %{VER}
Release: 1
Summary: This is a GTK-based configuration tool for Window Maker
Group: X11/Window Managers
Copyright: GPL
Packager: Ullrich Hafner <hafner@bigfoot.de>
Vendor: NOP
Source0: ftp://sunshine.informatik.uni-wuerzburg.de/pub/wmaker/wmakerconf-%{VER}.tar.gz
Source1: wmakerconf-libPropList.tar.gz
Source2: ftp://sunshine.informatik.uni-wuerzburg.de/pub/wmaker/wmakerconf-data-%{DATAVER}.tar.gz
Icon: wmakerconf.xpm
Requires: WindowMaker, perl, gzip, lynx, wmakerconf-data >= 0.50.2
BuildRoot: /var/tmp/wmakerconf-root

%description
wmakerconf is a GTK+ based configuration tool for the window manager
Window Maker.

Support of all Window Maker attributes: Font selection browser, pixmap
preview browser, color selection dialog, shortcut dialog, file selection
dialog, ... 

Tooltips with short description of every attribute. 

New attributes can be simply integrated by changing the wmakerconf proplist

%package data
Version: %{DATAVER}
Summary: Data files for GTK-based configuration tool for Window Maker
Group: X11/Window Managers
Copyright: GPL
Packager: Ullrich Hafner <hafner@bigfoot.de>
Vendor: NOP
%description data
Data files containing information relating to the latest version of
WindowMaker for use by wmakerconf, the WindowMaker configuration
tool

%prep
%setup -q -a 1 -a 2

%build
cd libPropList
CFLAGS=$RPM_OPT_FLAGS ./configure --prefix=%{prefix}
make
cd ..
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=%{prefix} \
	--with-wmakerdir=%{prefix}/share/WindowMaker --disable-gtktest \
	--x-includes=libPropList --x-libraries=libPropList  --disable-imlibtest
make
cd wmakerconf-data-%{DATAVER}
./configure --prefix=%{prefix} --with-wmakerdir=%{prefix}/share/WindowMaker
make

%install
rm -rf $RPM_BUILD_ROOT
make install prefix=$RPM_BUILD_ROOT%{prefix}
make install  -C wmakerconf-data-%{DATAVER} prefix=$RPM_BUILD_ROOT%{prefix}
strip $RPM_BUILD_ROOT%{prefix}/bin/* || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc AUTHORS ChangeLog NEWS README TODO README.GTKstep MANUAL
%{prefix}/bin/*
%{prefix}/share/wmakerconf/COPYING
%{prefix}/share/wmakerconf/MANUAL
%{prefix}/share/wmakerconf/*.sh
%{prefix}/share/wmakerconf/*.pl
%{prefix}/share/wmakerconf/*.xpm
%{prefix}/share/wmakerconf/*.jpg
#%{prefix}/share/wmakerconf/GTKstep

%files data
%defattr(-,root,root)
%{prefix}/share/wmakerconf/WM*
%{prefix}/share/wmakerconf/wmaker-version

%changelog
* Wed Jan 20 1999 Ullrich Hafner <hafner@bigfoot.de>
- upgraded to wmakerconf 1.6

* Tue Dec 22 1998 Ullrich Hafner <hafner@bigfoot.de>
- upgraded to wmakerconf 1.5
- added prefix

* Thu Nov 19 1998 Ullrich Hafner <hafner@bigfoot.de>
- upgraded to wmakerconf 1.3
- updated data files for windowmaker 0.20.2 and above
- split into wmakerconf and wmakerconf-data package

* Sat Oct 10 1998 Cristian Gafton <gafton@redhat.com>
- strip binaries
- updated data files for windowmaker 0.20 and above

* Fri Sep 18 1998 Cristian Gafton <gafton@redhat.com>
- packaged for 5.2 to be used with WindowMaker
