#include "configure.h"
#include "mfinderapp.h"
#include <qpainter.h>
#include <qkeycode.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
 
extern ProgInfo prInfo[];
extern int prInfoNum;

extern char Editor[];
extern char Xterm[];

extern char IconPath[];
extern IconData *IData[];
extern int IDataNum;
extern FolderIconData *IFoldData, *IFoldLinkData;

//--------------------------- Icons -------------------------------
ConfIcnWin::ConfIcnWin(QWidget *, const char *)
{
	struct dirent **namelist;
	int m;
	
	setCaption("Configure");
	setFixedSize(400, 530); 
	x = QColor(160, 164, 160);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 12);
	fontbig = QFont("Helvetica", 18);
	fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	setFont(font);

	titlebig = new QLabel("Configure Icons", this, "title");
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setGeometry(20, 5, 200, 30);
	titlebig->setFont(fontbig);		
	titlebig->setAlignment(AlignLeft | AlignTop);

	titl2 = new QLabel("File", this, "t2");
	titl2->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl2->setGeometry(20, 65, 80, 15);
	titl2->setFont(font);		
	FileIcnEd = new QLineEdit(this, "");
	FileIcnEd->setGeometry(100, 60, 100, 25);
	FileIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FileIcnEd->setFont(font);
	FileIcnEd->setText(IData[0]->IcnName);
	buttFile = new QPushButton("change", this);
	buttFile->setGeometry(210, 63, 50, 20);
	buttFile->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFile->setFont(font);
	connect(buttFile, SIGNAL(clicked()), this, SLOT(setFileIcn()));	

	titl3 = new QLabel("File link", this, "t3");
	titl3->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl3->setGeometry(20, 95, 80, 15);
	titl3->setFont(font);		
	FileLnkIcnEd = new QLineEdit(this, "");
	FileLnkIcnEd->setGeometry(100, 90, 100, 25);
	FileLnkIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FileLnkIcnEd->setFont(font);
	FileLnkIcnEd->setText(IData[2]->IcnName);
	buttFileLnk = new QPushButton("change", this);
	buttFileLnk->setGeometry(210, 93, 50, 20);
	buttFileLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileLnk->setFont(font);
	connect(buttFileLnk, SIGNAL(clicked()), this, SLOT(setFileLnkIcn()));	

	titl4 = new QLabel("File exe", this, "t4");
	titl4->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl4->setGeometry(20, 125, 80, 15);
	titl4->setFont(font);		
	FileExeIcnEd = new QLineEdit(this, "");
	FileExeIcnEd->setGeometry(100, 120, 100, 25);
	FileExeIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FileExeIcnEd->setFont(font);
	FileExeIcnEd->setText(IData[1]->IcnName);
	buttFileExe = new QPushButton("change", this);
	buttFileExe->setGeometry(210, 123, 50, 20);
	buttFileExe->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExe->setFont(font);
	connect(buttFileExe, SIGNAL(clicked()), this, SLOT(setFileExeIcn()));	

	titl5 = new QLabel("File exe link", this, "t5");
	titl5->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl5->setGeometry(20, 155, 80, 15);
	titl5->setFont(font);		
	FileExeLnkIcnEd = new QLineEdit(this, "");
	FileExeLnkIcnEd->setGeometry(100, 150, 100, 25);
	FileExeLnkIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FileExeLnkIcnEd->setFont(font);
	FileExeLnkIcnEd->setText(IData[3]->IcnName);
	buttFileExeLnk = new QPushButton("change", this);
	buttFileExeLnk->setGeometry(210, 153, 50, 20);
	buttFileExeLnk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFileExeLnk->setFont(font);
	connect(buttFileExeLnk, SIGNAL(clicked()), this, SLOT(setFileExeLnkIcn()));	

	titl6 = new QLabel("Folder", this, "t6");
	titl6->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl6->setGeometry(20, 185, 80, 15);
	titl6->setFont(font);		
	FoldIcnEd = new QLineEdit(this, "");
	FoldIcnEd->setGeometry(100, 180, 100, 25);
	FoldIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FoldIcnEd->setFont(font);
	FoldIcnEd->setText(IFoldData->IcnName);
	buttFold = new QPushButton("change", this);
	buttFold->setGeometry(210, 183, 50, 20);
	buttFold->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFold->setFont(font);
	connect(buttFold, SIGNAL(clicked()), this, SLOT(setFoldIcn()));
	
	titl7 = new QLabel("Folder link", this, "t7");
	titl7->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titl7->setGeometry(20, 215, 80, 15);
	titl7->setFont(font);		
	FoldLinkIcnEd = new QLineEdit(this, "");
	FoldLinkIcnEd->setGeometry(100, 210, 100, 25);
	FoldLinkIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	FoldLinkIcnEd->setFont(font);
	FoldLinkIcnEd->setText(IFoldLinkData->IcnName);
	buttFoldLink = new QPushButton("change", this);
	buttFoldLink->setGeometry(210, 213, 50, 20);
	buttFoldLink->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttFoldLink->setFont(font);
	connect(buttFoldLink, SIGNAL(clicked()), this, SLOT(setFoldLinkIcn()));

	reqIcList = new QListBox(this, "Bu");
	reqIcList->setLineWidth(2);
	reqIcList->setPalette(QPalette(CGnorm, CGinv, CGinv));
	reqIcList->setFont(font);
	reqIcList->setBackgroundMode(PaletteBase);
	reqIcList->setGeometry(275, 65, 105, 105);
	connect(reqIcList, SIGNAL(highlighted(const char *)), 
						this, SLOT(changeReqIcnLabIcn(const char *)));

 	m = scandir(IconPath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++)
		if(strcmp(namelist[i]->d_name, ".") != 0 
					&& strcmp(namelist[i]->d_name, "..") != 0)
			reqIcList->insertItem(namelist[i]->d_name);
	
	sprintf(icnName, "%s/%s", IconPath, reqIcList->text(0));
	reqIcona = QPixmap(icnName);
	ReqIcnLab = new QLabel(this);
	ReqIcnLab->setGeometry(300, 185, 55, 55);
	ReqIcnLab->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	ReqIcnLab->setFont(font);
	ReqIcnLab->setPixmap(reqIcona);


	tablelist = new Table(200, 3, 120, 20, this);
	tablelist->setGeometry(10, 255, 380, 85);
	tablelist->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	tablelist->setLineWidth(2);
	connect(tablelist, SIGNAL(rowchng(int)), this, SLOT(setEditTxt(int)));

	for(int i = 0; i < IDataNum - 4; i++) {
		tablelist->setCellContent(i, 0, IData[i + 4]->pref);
		tablelist->setCellContent(i, 1, IData[i + 4]->suff);
		tablelist->setCellContent(i, 2, IData[i + 4]->IcnName);
	}	
	
	prefEd = new QLineEdit(this, "");
	prefEd->setGeometry(15,350, 110,24);
	prefEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	prefEd->setFont(font);
	suffEd = new QLineEdit(this, "");
	suffEd->setGeometry(135,350, 110,24);
	suffEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffEd->setFont(font);
	namIcnEd = new QLineEdit(this, "");
	namIcnEd->setGeometry(255,350, 110,24);
	namIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	namIcnEd->setFont(font);
	
	butRemove = new QPushButton("Remove", this);
	butRemove->setGeometry(15,385, 50,20);
	butRemove->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butRemove->setFont(font);
	connect(butRemove, SIGNAL(clicked()), tablelist, SLOT(removeLine()));	
	butChange = new QPushButton("Change", this);
	butChange->setGeometry(70,385, 50,20);
	butChange->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butChange->setFont(font);
	connect(butChange, SIGNAL(clicked()), this, SLOT(changeLine()));	
	butAdd = new QPushButton("Add", this);
	butAdd->setGeometry(125,385, 50,20);
	butAdd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butAdd->setFont(font);
	connect(butAdd, SIGNAL(clicked()), this, SLOT(addLine()));	
	butCancel = new QPushButton("Cancel", this);
	butCancel->setGeometry(210,490, 80,30);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butCancel->setFont(font);
	connect(butCancel, SIGNAL(clicked()), this, SLOT(Close()));	
	butOk = new QPushButton("OK", this);
	butOk->setGeometry(300,490, 80,30);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	butOk->setFont(font);
	connect(butOk, SIGNAL(clicked()), this, SLOT(makeNewIcnInfo()));	

	icnList = new QListBox(this, "Icoane");
	icnList->setLineWidth(2);
	icnList->setPalette(QPalette(CGnorm, CGinv, CGinv));
	icnList->setFont(font);
	icnList->setBackgroundMode(PaletteBase);
	icnList->setGeometry(255,385, 120,85);
	connect(icnList, SIGNAL(highlighted(const char *)), 
						this, SLOT(changeIcnLabIcn(const char *)));

 	m = scandir(IconPath, &namelist, 0, alphasort);
	for(int i = 0; i < m; i++)
		if(strcmp(namelist[i]->d_name, ".") != 0 
					&& strcmp(namelist[i]->d_name, "..") != 0)
			icnList->insertItem(namelist[i]->d_name);
		
	sprintf(icnName, "%s/%s", IconPath, icnList->text(0));
	Icona = QPixmap(icnName);
	IcnLab = new QLabel(this);
	IcnLab->setGeometry(195, 385, 55, 55);
	IcnLab->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	IcnLab->setFont(font);
	IcnLab->setPixmap(Icona);
	
	buttsetIcn = new QPushButton("change", this);
	buttsetIcn->setGeometry(190, 450, 55, 20);
	buttsetIcn->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	buttsetIcn->setFont(font);
	connect(buttsetIcn, SIGNAL(clicked()), this, SLOT(changeNamIcn()));	
}

void ConfIcnWin::setEditTxt(int rownum)
{
	this->rownum = rownum;
	prefEd->setText(tablelist->cellContent(rownum, 0));
	suffEd->setText(tablelist->cellContent(rownum, 1));
	namIcnEd->setText(tablelist->cellContent(rownum, 2));
}

void ConfIcnWin::changeIcnLabIcn(const char *icname)
{
	sprintf(icnName, "%s/%s", IconPath, icname);
	Icona = QPixmap(icnName);
	IcnLab->setPixmap(Icona);
}

void ConfIcnWin::changeReqIcnLabIcn(const char *icname)
{
	sprintf(icnName, "%s/%s", IconPath, icname);
	reqIcona = QPixmap(icnName);
	ReqIcnLab->setPixmap(reqIcona);
}

void ConfIcnWin::changeNamIcn()
{
	namIcnEd->setText(icnList->text(icnList->currentItem()));
}

void ConfIcnWin::setFileIcn()
{
	FileIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::setFileLnkIcn()
{
	FileLnkIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::setFileExeIcn()
{
	FileExeIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::setFileExeLnkIcn()
{
	FileExeLnkIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::setFoldIcn()
{
	FoldIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::setFoldLinkIcn()
{
	FoldLinkIcnEd->setText(reqIcList->text(reqIcList->currentItem()));
}

void ConfIcnWin::changeLine()
{
	tablelist->setCellContent(rownum, 0, prefEd->text());
	tablelist->setCellContent(rownum, 1, suffEd->text());
	tablelist->setCellContent(rownum, 2, namIcnEd->text());
}

void ConfIcnWin::addLine()
{
	tablelist->AddALine(prefEd->text(), suffEd->text(), namIcnEd->text());
}

void ConfIcnWin::makeNewIcnInfo()
{
	char fPath[256] = "";
	char **cellTxt;
	bool domask;
	QImage pixmask;
		
	for(int i = 0; i < IDataNum; i++)
		delete IData[i];
		
	delete IFoldData;
	delete IFoldLinkData;

	IData[0] = new IconData;
	sprintf(IData[0]->IcnName, FileIcnEd->text());  // default 
	IData[1] = new IconData;
	sprintf(IData[1]->IcnName, FileExeIcnEd->text());  // FILEXE 
	IData[2] = new IconData;
	sprintf(IData[2]->IcnName, FileLnkIcnEd->text());  // FILLNK 
	IData[3] = new IconData;
	sprintf(IData[3]->IcnName, FileExeLnkIcnEd->text());  // FILEXELNK 
	IDataNum = 4;
	cellTxt = (char **)malloc(4 * sizeof(char *));
	for(int i = 0; i < 200; i++) {
		cellTxt[0] = (char *)tablelist->cellContent(i, 0);
		cellTxt[1] = (char *)tablelist->cellContent(i, 1);
		cellTxt[2] = (char *)tablelist->cellContent(i, 2);
		if(cellTxt[0] != NULL && cellTxt[1] != NULL && cellTxt[2] != NULL) {
			IData[IDataNum] = new IconData;
			sprintf(IData[IDataNum]->pref, "%s", cellTxt[0]);
			sprintf(IData[IDataNum]->suff, "%s", cellTxt[1]);
			sprintf(IData[IDataNum]->IcnName, "%s", cellTxt[2]);
			IDataNum++;
		}
	}
	for(int i = 0; i < IDataNum; i++) {
		sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
		IData[i]->Icn = QImage(fPath, "XPM");
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		domask = TRUE;
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			QRgb pix = IData[i]->Icn.pixel(h, 0);
			int red = qRed(pix);
			int green = qGreen(pix);		
			int blue = qBlue(pix);
			if(red < 5 && green < 5 && blue < 5)
				domask = FALSE;
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->Icona = QPixmap();
		IData[i]->Icona.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->Icona.setMask(IData[i]->Icona.createHeuristicMask());
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		pixmask = IData[i]->Icn.createHeuristicMask();
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			for(int j = 0; j < IData[i]->Icn.height(); j++) {
				QRgb pix = IData[i]->Icn.pixel(h, j);
				if(qRed(pixmask.pixel(h, j)) == 0) {
					int red = qRed(pix);
					int green = qGreen(pix);		
					int blue = qBlue(pix);
					if(red > 0) red = (int)(red/2);
					if(green > 0) green = (int)(green/2);
					if(blue > 0) blue = (int)(blue/2);
					IData[i]->Icn.setPixel(h, j, qRgb(red, green, blue));
				}
			}
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->IconaSel = QPixmap();
		IData[i]->IconaSel.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->IconaSel.setMask(IData[i]->Icona.createHeuristicMask());
	}

	IFoldData = new FolderIconData; 
	sprintf(IFoldData->IcnName, FoldIcnEd->text());
	sprintf(fPath, "%s/%s", IconPath, IFoldData->IcnName);
	IFoldData->Icn = QImage(fPath, "XPM");
	
	IFoldData->Icona = QPixmap();
	IFoldData->Icona.convertFromImage(IFoldData->Icn);
	IFoldData->Icona.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	pixmask = IFoldData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSel = QPixmap();
	IFoldData->IconaSel.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSel.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaOpen = QPixmap();
	IFoldData->IconaOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaOpen.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);	
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSelOpen = QPixmap();
	IFoldData->IconaSelOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSelOpen.setMask(IFoldData->Icona.createHeuristicMask());


	IFoldLinkData = new FolderIconData;	
	sprintf(IFoldLinkData->IcnName, FoldLinkIcnEd->text());
	sprintf(fPath, "%s/%s", IconPath, IFoldLinkData->IcnName);
	IFoldLinkData->Icn = QImage(fPath, "XPM");
	
	IFoldLinkData->Icona = QPixmap();
	IFoldLinkData->Icona.convertFromImage(IFoldLinkData->Icn);
	IFoldLinkData->Icona.setMask(IFoldLinkData->Icona.createHeuristicMask());

	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	pixmask = IFoldLinkData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSel = QPixmap();
	IFoldLinkData->IconaSel.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSel.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaOpen = QPixmap();
	IFoldLinkData->IconaOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);		
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSelOpen = QPixmap();
	IFoldLinkData->IconaSelOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSelOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());

	free(cellTxt);
	emit icninfodone();
	Close();
}

void ConfIcnWin::Close()
{
	this->~ConfIcnWin();
}

void ConfIcnWin::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 35, width(), 35);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 36, width(), 36);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 480, width(), 480);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 481, width(), 481);
	p.end();
}

//------------------------ Programs ------------------------------------
ConfEditWin::ConfEditWin(QWidget *, const char *)
{
	setCaption("Configure");
	setFixedSize(400, 370);
	x = QColor(160, 164, 160);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	CGinv = QColorGroup(white, black, x.light(), x.dark(), x.dark(120), white, black);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 12);
	fontbig = QFont("Helvetica", 18);
	setFont(font);

	titlebig = new QLabel("Configure Programs", this, "title");
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setGeometry(20, 5, 200, 30);
	titlebig->setFont(fontbig);		
	titlebig->setAlignment(AlignLeft | AlignTop);

	tablelist = new Table(100, 3, 120, 20, this);
	tablelist->setGeometry(10,50, 380,140);
	tablelist->setFrameStyle(QFrame::Panel | QFrame::Sunken);
	tablelist->setLineWidth(2);
	connect(tablelist, SIGNAL(rowchng(int)), this, SLOT(setEditTxt(int)));

	for(int i = 0; i < prInfoNum; i++) {
		tablelist->setCellContent(i, 0, prInfo[i].pref);
		tablelist->setCellContent(i, 1, prInfo[i].suff);
		tablelist->setCellContent(i, 2, prInfo[i].ProgName);
	}	
	
	prefEd = new QLineEdit(this, "");
	prefEd->setGeometry(15,200, 110,24);
	prefEd->setFont(font);
	prefEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	suffEd = new QLineEdit(this, "");
	suffEd->setGeometry(135,200, 110,24);
	suffEd->setFont(font);
	suffEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	namIcnEd = new QLineEdit(this, "");
	namIcnEd->setGeometry(255,200, 110,24);
	namIcnEd->setFont(font);
	namIcnEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	defEditEd = new QLineEdit(this, "");
	defEditEd->setGeometry(15,285, 60,24);
	defEditEd->setFont(font);
	defEditEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	defEditEd->setText(Editor);
	xtermEd = new QLineEdit(this, "");
	xtermEd->setGeometry(90,285, 295,24);
	xtermEd->setMaxLength(128);
	xtermEd->setFont(font);
	xtermEd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	xtermEd->setText((const char *)Xterm);

	butRemove = new QPushButton("Remove", this);
	butRemove->setGeometry(15,235, 50,20);
	butRemove->setFont(font);
	butRemove->setPalette(QPalette(CGnorm, CGnorm, CGnorm));	
	connect(butRemove, SIGNAL(clicked()), tablelist, SLOT(removeLine()));	
	butChange = new QPushButton("Change", this);
	butChange->setGeometry(70,235, 50,20);
	butChange->setFont(font);
	butChange->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(butChange, SIGNAL(clicked()), this, SLOT(changeLine()));	
	butAdd = new QPushButton("Add", this);
	butAdd->setGeometry(125,235, 50,20);
	butAdd->setFont(font);
	butAdd->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(butAdd, SIGNAL(clicked()), this, SLOT(addLine()));	
	butCancel = new QPushButton("Cancel", this);
	butCancel->setGeometry(210,330, 80,30);
	butCancel->setFont(font);
	butCancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(butCancel, SIGNAL(clicked()), this, SLOT(Close()));	
	butOk = new QPushButton("OK", this);
	butOk->setGeometry(300,330, 80,30);
	butOk->setFont(font);
	butOk->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(butOk, SIGNAL(clicked()), this, SLOT(makeNewEditInfo()));	
}

void ConfEditWin::Close()
{
	this->~ConfEditWin();
}

void ConfEditWin::setEditTxt(int rownum)
{
	this->rownum = rownum;
	prefEd->setText(tablelist->cellContent(rownum, 0));
	suffEd->setText(tablelist->cellContent(rownum, 1));
	namIcnEd->setText(tablelist->cellContent(rownum, 2));
}

void ConfEditWin::changeLine()
{
	tablelist->setCellContent(rownum, 0, prefEd->text());
	tablelist->setCellContent(rownum, 1, suffEd->text());
	tablelist->setCellContent(rownum, 2, namIcnEd->text());
}

void ConfEditWin::addLine()
{
	tablelist->AddALine(prefEd->text(), suffEd->text(), namIcnEd->text());
}

void ConfEditWin::makeNewEditInfo()
{
	char **cellTxt;
	
	cellTxt = (char **)malloc(4 * sizeof(char *));
	for(int i = 0; i < prInfoNum; i++) {
		sprintf(prInfo[i].pref, " ");
		sprintf(prInfo[i].suff, " ");
		sprintf(prInfo[i].ProgName, " ");
	}	
	prInfoNum = 0;
	for(int i = 0; i < 100; i++) {
		cellTxt[0] = (char *)tablelist->cellContent(i, 0);
		cellTxt[1] = (char *)tablelist->cellContent(i, 1);
		cellTxt[2] = (char *)tablelist->cellContent(i, 2);
		
		if(cellTxt[0] != NULL && cellTxt[1] != NULL && cellTxt[2] != NULL) {
			sprintf(prInfo[prInfoNum].pref, "%s", cellTxt[0]);
			sprintf(prInfo[prInfoNum].suff, "%s", cellTxt[1]);
			sprintf(prInfo[prInfoNum].ProgName, "%s", cellTxt[2]);
			prInfoNum++;
		}
	}
	free(cellTxt);
	sprintf(Editor, "%s", defEditEd->text());
	sprintf(Xterm, "%s", xtermEd->text());

	emit editinfodone();
	Close();
}

void ConfEditWin::paintEvent(QPaintEvent *)
{
	QPainter p;
	
	p.begin(this);
	p.drawText(15, 280, "editor");
	p.drawText(90, 280, "xterm");
	
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 35, width(), 35);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 36, width(), 36);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 320, width(), 320);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 321, width(), 321);	
	
	p.end();
}

//------------------------- Table -------------------------------------
Table::Table(int numRows, int numCols, int cellwidth, int cellheight, 
													QWidget *parent, const char *name)
      :QTableView(parent, name)
{
	x = QColor(160, 164, 160);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	CGinv = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 12);
	setFont(font);

	curRow = curCol = 0;
	setBackgroundMode(PaletteBase);
	setNumCols(numCols);
	setNumRows(numRows);
	setCellWidth(cellwidth);
	setCellHeight(cellheight);
	setTableFlags(Tbl_vScrollBar | Tbl_clipCellPainting | Tbl_smoothScrolling);

	contents = new QString[numRows * numCols];
}

Table::~Table()
{
	delete[] contents;
}

const char* Table::cellContent(int row, int col) const
{
	return contents[indexOf(row, col)];
}

void Table::setCellContent(int row, int col, const char* c)
{
	contents[indexOf(row, col)] = c;
	updateCell(row, col);
}

void Table::paintCell(QPainter* p, int row, int col)
{
	int w = cellWidth(col);
	int h = cellHeight(row);
	int x2 = w - 1;
 	int y2 = h - 1;

	QColorGroup g = colorGroup();
	if(row == curRow) {	
		QColor fc;
	   fc = QColor(160, 164, 160);
		p->setBackgroundColor(fc);
		p->setPen(g.text());
		p->fillRect(0, 0, x2, y2, fc);
		p->drawText(0, 0, w, h, AlignCenter, contents[indexOf(row,col)]);
	} else {
		p->setBackgroundColor(QColor(255, 255, 255));
		p->setPen(g.text());
		p->drawLine(x2, 0, x2, y2);
		p->drawLine(0, y2, x2, y2);
		p->drawText(0, 0, w, h, AlignCenter, contents[indexOf(row,col)]);
	}
}

void Table::mousePressEvent(QMouseEvent* e)
{
	int oldRow = curRow;
	int oldCol = curCol;
	QPoint clickedPos = e->pos();
	curRow = findRow(clickedPos.y());
	curCol = findCol(clickedPos.x());
	if(curRow != oldRow) {
		updateCell(oldRow, 0);
		updateCell(oldRow, 1);
		updateCell(oldRow, 2);
		updateCell(curRow, 0);	
		updateCell(curRow, 1);	
		updateCell(curRow, 2);
		emit rowchng(curRow);
	}
}

void Table::focusInEvent(QFocusEvent *)
{
	updateCell(curRow, curCol);
}    

void Table::focusOutEvent(QFocusEvent *)
{
	updateCell(curRow, curCol);
}    

int Table::indexOf(int row, int col) const
{
	return (row * numCols()) + col;
}

void Table::AddALine(const char *pref, const char *suff, const char *namicn)
{
	for(int i = numRows() - 1; i > curRow; i --) {
		setCellContent(i, 0, cellContent(i - 1, 0));
		setCellContent(i, 1, cellContent(i - 1, 1));
		setCellContent(i, 2, cellContent(i - 1, 2));
	}
	setCellContent(curRow, 0, pref);
	setCellContent(curRow, 1, suff);
	setCellContent(curRow, 2, namicn);
}

void Table::removeLine()
{
	for(int i = curRow; i < numRows() - 1; i ++) {
		setCellContent(i, 0, cellContent(i + 1, 0));
		setCellContent(i, 1, cellContent(i + 1, 1));
		setCellContent(i, 2, cellContent(i + 1, 2));
	}
}

