#ifndef CONFIG_H
#define CONFIG_H

#include "common.h"
#include <qmlined.h> 
#include <qlined.h> 
#include <qpushbt.h>
#include <qpixmap.h> 
#include <qbitmap.h> 
#include <qimage.h> 
#include <qlabel.h>
#include <qframe.h> 
#include <qlistbox.h> 
#include <qtablevw.h> 
#include <qcolor.h>
#include <qfont.h> 

class Table : public QTableView
{
	Q_OBJECT
public:
	Table(int numRows, int numCols, int cellwidth, int cellheight,
											QWidget* parent=0, const char* name=0);
	~Table();

	QColor x;
	QColorGroup	CGnorm, CGinv;
	QFont font, fontbig;
    
	const char* cellContent(int, int) const;
	void setCellContent(int, int, const char*);
	void AddALine(const char *, const char *, const char *);

signals:
	void rowchng(int);

public slots:
	void removeLine();

protected:
	void paintCell(QPainter*, int, int);
	void mousePressEvent(QMouseEvent*);
	void focusInEvent(QFocusEvent* );
	void focusOutEvent(QFocusEvent*);
    
private:
	int indexOf(int, int) const;
	QString* contents;
	int curRow;
	int curCol;
};

class ConfIcnWin : public QWidget
{
	Q_OBJECT
public:
	ConfIcnWin(QWidget *parent=0, const char *name=0);

	QColor x;
	QColorGroup	CGnorm, CGinv;
	QFont font, fontbold, fontbig;
	QLabel *titlebig, *titl1, *titl2, *titl3, *titl4, *titl5, *titl6, *titl7;
   QLabel *IcnLab, *ReqIcnLab;
    
	Table *tablelist;
	QListBox *icnList, *reqIcList;
	QPixmap Icona, reqIcona;
	char icnPath[256];
	char icnName[256];
	QLineEdit *prefEd, *suffEd, *namIcnEd;
	QLineEdit *FileIcnEd, *FileLnkIcnEd, *FileExeIcnEd, *FileExeLnkIcnEd;
	QLineEdit *FoldIcnEd, *FoldLinkIcnEd;
	
	QPushButton *butRemove, *butChange, *butAdd, *buttsetIcn, *butCancel, *butOk;
	QPushButton *buttFile, *buttFileLnk, *buttFileExe, *buttFileExeLnk;
	QPushButton *buttFold, *buttFoldLink;
	int rownum;
	
signals:
	void icninfodone();
	
public slots:
	void setEditTxt(int);
	
	void setFileIcn();
	void setFileLnkIcn();
	void setFileExeIcn();
	void setFileExeLnkIcn();
	void setFoldIcn();
	void setFoldLinkIcn();
	
	void changeIcnLabIcn(const char *);
	void changeReqIcnLabIcn(const char *);
	void changeNamIcn();
	void changeLine();
	void addLine();
	void makeNewIcnInfo();
	void Close();
	
protected:
	void paintEvent(QPaintEvent *);

private:

};

class ConfEditWin : public QWidget
{
	Q_OBJECT
public:
	ConfEditWin(QWidget *parent=0, const char *name=0);

	QColor x;
	QColorGroup	CGnorm, CGinv;
	QFont font, fontbig;
	QLabel *titlebig;
    
	Table *tablelist;
	QLineEdit *prefEd, *suffEd, *namIcnEd, *defEditEd, *xtermEd;
	QPushButton *butRemove, *butChange, *butAdd, *butCancel, *butOk;
	int rownum;
	
signals:
	void editinfodone();
	
public slots:
	void setEditTxt(int);
	void changeLine();
	void addLine();
	void makeNewEditInfo();
	void Close();
	
protected:
	void paintEvent(QPaintEvent *);

private:

};


#endif
