#ifndef DESKOBJ_H
#define DESKOBJ_H

#include <qwidget.h>
#include <qstring.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qfont.h>
#include <qevent.h> 
#include "common.h"
#include "infowin.h"
#include "popup.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <iostream.h>
#include <pwd.h>
#include <grp.h>

class DeskObj : public QWidget
{
	Q_OBJECT
public:
	DeskObj(QWidget *parent=0, const char *path=0, 
							const char *name=0, int id=0, int x=0, int y=0);
	
	void UpdateIcon();
	void UpdateMyData();
	void CalcDim();
	void Select();
	void Unselect();
	void SelOpen();
	void UnselOpen();
	void Close();
	void DragMove();
	void DragLeave();

	bool isSelect;
	bool isOpen;
	bool isOpenUnsl;
	bool isDragging;
	int type;
	int id;
	char name[256];
	char path[256];
	char parentpath[256];
	char myLinkTo[512];
	char cmdline[256];
	QPixmap Icona;
	QBitmap mask;
	QFont font;
	int IDataRef;	
	char pixname[256];
	int pxIcn, pxLabel;
	InfoWin *IWin;
	char ERR[256];
   int x, y;
	int textXOffset, textYOffset, pixmapXOffset, pixmapYOffset;
	int xOffset, yOffset;
   int width, height;
	Popup *popupMenu;

signals:
	void clickonme(int);
	void doubleclick(char*, char*, int);
	void dragattempt(char *, char *, int);
	void mousemove(int);
	void dragdone(bool);
	void removeme(int);
	
public slots:
	void OpenFromPopUp();
	void InfoFromPopUp();
	void RemoveMe();
	
protected:
	void resizeEvent(QResizeEvent *);
	void paintEvent(QPaintEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
		
private:

};

#endif // FILEOBJ_H
