#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include "dndicon.h"
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <stdlib.h>

extern "C" {
	void XShapeCombineMask(Display*, Window, int, int, int, Pixmap, int);
 	#define ShapeBounding                   0 
	#define ShapeSet                        0 
}

DnDIcon::DnDIcon(QPixmap pix) 
			:QWidget(0L, 0L, WStyle_Customize | WStyle_Tool | WStyle_NoBorder)
{
	dndpmap = QPixmap(pix);
	setGeometry(-100, -100, pix.width(), pix.height());
	dndpmap.setMask(dndpmap.createHeuristicMask());
	xOffset = 0;
	yOffset = 0;
 	show();
}

DnDIcon::~DnDIcon() 
{

}

//-------------------------------------------------------------------------
//                            eventi
//-------------------------------------------------------------------------
void DnDIcon::resizeEvent(QResizeEvent *)
{
	XShapeCombineMask(x11Display(), winId(), ShapeBounding, 0, 0, 
			dndpmap.mask()->handle(), ShapeSet);
}

void DnDIcon::paintEvent(QPaintEvent *) 
{
	bitBlt(this, 0, 0, &dndpmap);
}

