#include "filelabel.h"
#include <qwidget.h>
#include <qcolor.h>
#include <qlabel.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mfinderapp.h"

extern int maxlabelw;

FileLabel::FileLabel(QWidget *parent, const char *name)
			 :QLabel(parent, name)
{
	maxlabelw = 60;
	
	x = QColor(230, 230, 230);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	CGinv = QColorGroup(white, black, x.light(), x.dark(), x.dark(120), white, black);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	
	font = QFont("Helvetica", 10);
	setFont(font);
	strncpy(this->name, name, 64);
	setAutoResize(TRUE);
	isSelect = FALSE;
}

void FileLabel::cutText()
{
	int w = 0, cw = 0, i = 0;

	cutname = new char[64];
	
	QFontMetrics fm(QFont("Helvetica", 10));
	w = fm.boundingRect(name).width();
	if(w > maxlabelw) {
		i = 0;
		while(cw <= maxlabelw - 3) {
			cutname[i] = name[i];
			cutname[i+1] = '\0';
			QFontMetrics fmm(QFont("Helvetica", 10));
			cw = fmm.boundingRect(cutname).width();
			i++;
		}
		cutname[i] = '\0';
		if(strcmp(name, cutname) != 0) {
			if((strlen(name) - strlen(cutname)) < 3) {
				strncpy(cutname, name, 64);
			} else {
				cutname[i] = '.';
				cutname[i + 1] = '.';
				cutname[i + 2] = '.';
				cutname[i + 3] = '\0';
			}
		} 
	} else {
		strncpy(cutname, name, 64);
	}
	
	setText(cutname);
}

void FileLabel::select()
{
	isSelect = TRUE;
	setText(name);
	setPalette(QPalette(CGinv, CGinv, CGinv));
	raise();
}

void FileLabel::unselect()
{
	isSelect = FALSE;
	setText(cutname);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
}

//-------------------------------------------------------------------------
//                            eventi
//-------------------------------------------------------------------------
void FileLabel::mousePressEvent(QMouseEvent *)
{
	if(! isSelect) {
		emit selattempt(0);
		select();
	} else 
		unselect();
}


ShelfFileLabel::ShelfFileLabel(QWidget *parent, const char *name)
			      :FileLabel(parent, name)
{
	x = QColor(170, 170, 170);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	CGinv = QColorGroup(white, black, x.light(), x.dark(), x.dark(120), white, black);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	
	maxlabelw = 60;
	
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	
	font = QFont("Helvetica", 10);
	setFont(font);
	strncpy(this->name, name, 64);

	setAutoResize(TRUE);
	isSelect = FALSE;
}
