#ifndef FILEOBJ_H
#define FILEOBJ_H

#include <qwidget.h>
#include <qstring.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qevent.h> 
#include <qkeycode.h>
#include "common.h"
#include "filelabel.h"
#include "infowin.h"
#include "dialogs.h"
#include "popup.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <iostream.h>
#include <pwd.h>
#include <grp.h>

class FileObj : public QWidget
{
	Q_OBJECT
public:
	FileObj(QWidget *parent=0, const char *name=0, 
								int n=0, int idParent=0, char *ParentName=0);
	
	void UpdateIcon();
	void UpdateMyData();
	void Select();
	void Unselect();
	void SelOpen();
	void UnselOpen();
	void Open(QMouseEvent *e);
	void Close();
	void InfoObj();
	void DragMove();
	void DragLeave();	
	
	bool isSelect;
	bool isOpen;
	bool isOpenUnsl;
	bool isDragging;
	int idLocal;
	int idParent;
	int type;
	bool isdotfile;
	bool isdothided;
	char name[256];
	char ParentName[256];
	char myPath[512];
	char myLinkTo[512];
	char cmdline[256];
	QPixmap Icona;
	int IDataRef;	
	char pixname[256];
	FileLabel *Label;
	int pxIcn, pxLabel;
	InfoWin *IWin;
	Dialog *dialog;
	char ERR[256];
	Popup *popupMenu;
   
signals:
	void selattempt(int);
	void openunslattempt(int);
	void openattempt(int, QMouseEvent *);
	void shiftclick(int);
	void dragattempt(char *, char *, int, int);
	void mousemove();
	void dragdone(bool);
	void openfile(char*);
	void openfile(char*, char*);
	void renameme();
	void editme();
	void openmewith();
	void deleteme();
	
public slots:
	void slotsel(int);
	void OpenFromPopUp();
	void RenameFromPopUp();
	void InfoFromPopUp();
	void EditFromPopUp();
	void OpWithFromPopUp();
	void DeleteFromPopUp();
	
protected:
	void mousePressEvent(QMouseEvent *);
	void mouseDoubleClickEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);
	bool eventFilter(QObject *, QEvent *);
   void closeEvent(QCloseEvent *);

 private:

};

#endif // FILEOBJ_H
