#include "common.h"
#include "mfinderapp.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <ctype.h>
#include <limits.h>

UserInfo user;

int compare(const void *a, const void *b)
{
	return strcmp(*(char **)a, *(char **)b);
}

int create(char *path, mode_t mode)
{
 	int file = open(path, O_WRONLY|O_CREAT|O_EXCL, mode);
 	if (file == -1 || close(file)) return -1;
 	return 0;
}

int rdel(char *path, bool isdir)
{
	struct dirent **namelist;
	struct stat listStat;
	char *path2;
	int m, a, i, res;
  
  	path2 = (char*)malloc(512 * sizeof(char));
  
	res = 0;
	if(!isdir) {
		free(path2);
		return res = unlink(path);
	}
	m = scandir(path, &namelist, 0, alphasort);
	if(m == 2) {
		free(path2);
		return res = rmdir(path);
	}
	for(a = 0; a < m; a++) {
		if(strcmp(namelist[a]->d_name, ".") != 0 && strcmp(namelist[a]->d_name, "..") != 0) {
			sprintf(path2, "%s/%s", path, namelist[a]->d_name);
			i = lstat(path2, &listStat);
			if(!S_ISDIR(listStat.st_mode)) {
				res = unlink(path2);
			} else {
				res = rdel(path2, TRUE);
				res = rmdir(path2);
			} 
		}
	}
	free(path2);
	return res = rmdir(path);
}

int copyfile(char *oldpath, char *newpath) 
{
	struct stat stats;
	int src = -1, dest = -1, n;
	char *buf;

  	buf = (char*)malloc(BUFSIZ * sizeof(char));

	if((src = open(oldpath, O_RDONLY)) == -1 || stat(oldpath, &stats)) {
		free(buf);
		return -1;
	}
	if((dest = creat(newpath, stats.st_mode)) == -1) {
		free(buf);
		return -1;
	}
  	while((n = read(src, buf, BUFSIZ)) != 0) {
    	if(n == -1 || write(dest, buf, n) != n) {
    		free(buf);
			return -1;
		}
	}

  	if(close(src)) {
    	src = -1;
    	free(buf);
		return -1;
  	} else {
  		free(buf);
    	return close(dest);
   }
}

int copydir(char *oldpath, char *newpath) 
{
	struct dirent **namelist;
	struct stat listStat;
	char *oldpath2;
	char *newpath2;
	int m, a, ls, res;
  	user.umask = umask(0);
  	umask(user.umask);
  	user.umask = 0777777 ^ user.umask;
  
  	oldpath2 = (char*)malloc(512 * sizeof(char));
  	newpath2 = (char*)malloc(512 * sizeof(char));

	res = 0;
	res = mkdir(newpath, user.umask & 0777);
	if(res != 0) {
		free(oldpath2);
		free(newpath2);
		return res;
	}
	m = scandir(oldpath, &namelist, 0, alphasort);
	for(a = 0; a < m; a++) {
		if(strcmp(namelist[a]->d_name, ".") != 0 && strcmp(namelist[a]->d_name, "..") != 0) {
			if(strcmp(oldpath, "/") == 0) {
				sprintf(oldpath2, "%s%s", oldpath, namelist[a]->d_name);
			} else {
				sprintf(oldpath2, "%s/%s", oldpath, namelist[a]->d_name);
			}
			if(strcmp(newpath, "/") == 0) {
				sprintf(newpath2, "%s%s", newpath, namelist[a]->d_name);
			} else {
				sprintf(newpath2, "%s/%s", newpath, namelist[a]->d_name);
			}

			ls = lstat(oldpath2, &listStat);

			if(S_ISREG(listStat.st_mode))
				res = copyfile(oldpath2, newpath2);
			if(S_ISDIR(listStat.st_mode))
				res = copydir(oldpath2, newpath2);
			if(S_ISFIFO(listStat.st_mode))
	  			res = mkfifo(newpath2, user.umask & 0666);
			if(S_ISBLK(listStat.st_mode) || S_ISCHR(listStat.st_mode) || S_ISSOCK(listStat.st_mode))
	  			res = mknod(newpath2, user.umask & 0666, listStat.st_rdev);
			if(S_ISLNK(listStat.st_mode)) {
	  			char lnk[MAXPATHLEN+1];
	  			int l = readlink(oldpath2, lnk, MAXPATHLEN);
	  			if(l<0) res = 1;
	  			else {
	      		lnk[l] = '\0';
	      		res = symlink(lnk, newpath2);
	  			}
      	}
		}
	}
	free(oldpath2);
	free(newpath2);
	return res;
}
