#include "icnpathdlg.h"
#include "mfinderapp.h"

extern char IconPath[];
extern IconData *IData[];
extern int IDataNum;
extern FolderIconData *IFoldData, *IFoldLinkData;

IcnPathDlg::IcnPathDlg(QWidget *parent, const char *name)
		     :QWidget(parent, name)
{
	setCaption("Configure");
	setFixedSize(400, 205); 
	x = QColor(160, 164, 160);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 12);
	fontbold = QFont("Helvetica", 12);
	fontbold.setBold(TRUE);
	fontbig = QFont("Helvetica", 18);

	titlebig = new QLabel("Icons Path", this, "title");
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setGeometry(20, 5, 200, 30);
	titlebig->setFont(fontbig);		
	titlebig->setAlignment(AlignLeft | AlignTop);

	textfield = new QLineEdit(this, "icpt");
	textfield->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	textfield->setGeometry(20, 45, 360, 20);
	textfield->setFont(font);
	
	icnList = new QListBox(this, "Icoane");
	icnList->setLineWidth(2);
	icnList->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	icnList->setFont(font);
	icnList->setBackgroundMode(PaletteBase);
	icnList->setGeometry(100, 75, 200, 70);
	connect(icnList, SIGNAL(selected(int)), this, SLOT(changeIPath(int)));

	cancel = new QPushButton("Cancel", this);
	cancel->setGeometry(220, 165, 75, 28);
	cancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	cancel->setFont(font);		
	cancel->setDefault(TRUE);
	connect(cancel, SIGNAL(clicked()), SLOT(Close()));

	change = new QPushButton("Change", this);
	change->setGeometry(305, 165, 75, 28);
	change->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	change->setFont(font);		
	connect(change, SIGNAL(clicked()), SLOT(saveIPath()));

	paths = new char*[100];
	dnames = new char*[100];

	sprintf(currIcnPath, "%s", IconPath);
	
	setIPath(currIcnPath);
	textfield->setText(currIcnPath);
}

void IcnPathDlg::setIPath(const char *p)
{
	int a = 0;
	char ptmp[256] = "";
		
	if(paths != NULL) delete[] paths;
	if(dnames != NULL) delete[] dnames;

 	m = scandir(p, &namelist, 0, alphasort);
	paths = new char*[m];
	dnames = new char*[m];
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0) {
			if(strcmp(p, "/") == 0) 
				sprintf(ptmp, "%s%s", p, namelist[i]->d_name);
			else
				sprintf(ptmp, "%s/%s", p, namelist[i]->d_name);
		   lstat(ptmp, &listStat);
			if(S_ISDIR(listStat.st_mode)) {
				paths[a] = new char[strlen(ptmp)+1];
				strcpy(paths[a], ptmp);
				dnames[a] = new char[strlen(namelist[i]->d_name)+1];
				strcpy(dnames[a], namelist[i]->d_name);
				a++;
			}
		}
	}
	icnList->clear();
	for(int i = 0; i < a; i++)
		icnList->insertItem(dnames[i]);
		
	sprintf(currIcnPath, "%s", p);
	textfield->setText(currIcnPath);
	textfield->update;
}

void IcnPathDlg::changeIPath(int id)
{
	char P[MAXPATHLEN] = "";
	
	realpath(paths[id], P);
	setIPath(P);
}

void IcnPathDlg::saveIPath()
{
	sprintf(IconPath, "%s", currIcnPath);
	emit ipathchanged();
	close();
}

void IcnPathDlg::Close()
{
	if(paths != NULL) 
		delete[] paths;
	if(dnames != NULL) 
		delete[] dnames;

	close();
}

void IcnPathDlg::paintEvent(QPaintEvent *)
{
	QPainter p;
				
	p.begin(this);
	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 35, width(), 35);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 36, width(), 36);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 155, width(), 155);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 156, width(), 156);
	p.end();
}

