#include "infoframe.h"
#include <qwidget.h> 
#include <qlabel.h> 
#include <qapp.h> 
#include <stdio.h>
#include <stdlib.h>

InfoFrame::InfoFrame(QWidget *parent, const char *name)
			  : QFrame(parent, name)
{
	QColor x = QColor(160, 164, 160);
	QColorGroup CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	setFrameStyle(QFrame::Panel | QFrame::Raised);
	font = QFont("Helvetica", 10);
 	strncpy(path, name, 256);
	labInf = new QLabel(this, "labInf");
	labInf->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	labInf->setFont(font);
	labInf->setAutoResize(TRUE);

	updateData();
}

void InfoFrame::resizeEvent(QResizeEvent *)
{
	labInf->move(21, 3);
}

void InfoFrame::updateData()
{
	struct dirent **namelist;
	int m;
	char buf[256] = "";
 	long bsize, ksize, free, free_blocks;
	struct statfs statf;
	
	m = scandir(path, &namelist, 0, alphasort);
	sprintf(buf, "%i items", m - 2);

	statfs(path, &statf);
	
 	bsize = (long)statf.f_bsize / 1024L;
 	if(!bsize)
 		ksize = 1024L / (long)statf.f_bsize;

	free_blocks = statf.f_bfree;

	if(bsize)
		free = free_blocks * bsize;
	else
		free = free_blocks / ksize;

	sprintf(buf, "%s  -  %ld KBytes available", buf, free);

	labInf->setText(buf);
	labInf->update();
}
