// ----------------------------------------------------------------------------
// $Header$
// ----------------------------------------------------------------------------
// $RCSfile$
// ----------------------------------------------------------------------------
// Written 1997 by Christoph Pesch
// ----------------------------------------------------------------------------
// LAST CHANGE DONE: 30. September 1997
// ----------------------------------------------------------------------------

#ifndef ___infopanel___
#define ___infopanel___

#include <qwidget.h>
#include <qframe.h>

// ----------------------------------------------------------------------------
// CLASS: infopanel
// 
// DERIVED FROM: QFrame
//
// DESCRIPTION: 
// Provides a standard infopanel for the nextapp class.
// If you use the default design -- either by using the constructor
// infopanel(parent, name, TRUE), or by calling use_default(TRUE) --
// the title, the version number, the author and a comment will be displayed.
// (Make sure to choose a proper size for the infopanel).
// The title can be set with the set_title method and queried
// with the get_title method.
// The author can be set with the set_author method and queried
// with the get_author method.
// The version can be set with the set_version method and queried
// with the get_version method.
// The comment can be set with the set_version method and queried
// with the get_comment method.
//
// If you dont use the default design -- either by using the constructor
// infopanel(parent, name, FALSE), or by calling use_default(FALSE) --
// you have to add your own widgets to be displayed in the infopanel.
//
// You can query with use_default() whether the default design is used.
// 
// LAST CHANGE DONE: 30. September 1997
// ----------------------------------------------------------------------------

class infopanel : public QFrame
{
Q_OBJECT
   
protected:
   const char *version;
   const char *title;
   const char *author;
   const char *comment;
   bool useDefault;

   virtual void drawContents (QPainter*);
   
public: 
   infopanel(QWidget* parent=0, const char* name=0, bool def=TRUE);
   ~infopanel();

   void set_version(const char*);
   void set_title(const char*);
   void set_author(const char*);
   void set_comment(const char*);
   void use_default(bool);

   const char* get_version() const;
   const char* get_title() const;
   const char* get_author() const;
   const char* get_comment() const;
   bool use_default() const;
};

#endif

// ----------------------------------------------------------------------------
// $Log$
// ----------------------------------------------------------------------------

// EOF
