#include "infowin.h"
#include "mfinderapp.h"

extern "C" {
	#include <stdio.h>
	#include <stdlib.h>
}

InfoWin::InfoWin(QWidget *parent, const char *name, bool modal)
		  : QDialog(parent, name, modal)
{
	x = QColor(160, 164, 160);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, white);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 10);
	fontbig = QFont("Helvetica", 18);
	setCaption("Info");
	setFixedSize(310, 290);

	titlebig = new QLabel(name, this, "big");
	titlebig->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	titlebig->setGeometry(20, 5, 200, 30);
	titlebig->setFont(fontbig);		
	titlebig->setAlignment(AlignLeft | AlignTop);

	userEdit = new QLineEdit(this, "userEdit");
	userEdit->setGeometry(20, 55, 95, 28);
	userEdit->setFont(font);		
	userEdit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	groupEdit = new QLineEdit(this, "groupEdit");
	groupEdit->setGeometry(130, 55, 95, 28);
	groupEdit->setFont(font);		
	groupEdit->setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	ckFrame = new QFrame(this);
	ckFrame->setGeometry(70,150, 170,85);
	ckUread = new QCheckBox(ckFrame, "ckb");
	ckUread->move(0, 0);
	ckUwrite = new QCheckBox(ckFrame, "ckb");
	ckUwrite->move(50, 0);
	ckUexec = new QCheckBox(ckFrame, "ckb");
	ckUexec->move(100, 0);
	ckUID = new QCheckBox(ckFrame, "ckb");
	ckUID->move(150, 0);
	ckGread = new QCheckBox(ckFrame, "ckb");
	ckGread->move(0, 30);
	ckGwrite = new QCheckBox(ckFrame, "ckb");
	ckGwrite->move(50, 30);
	ckGexec = new QCheckBox(ckFrame, "ckb");
	ckGexec->move(100, 30);	
	ckGID = new QCheckBox(ckFrame, "ckb");
	ckGID->move(150, 30);	
	ckOread = new QCheckBox(ckFrame, "ckb");
	ckOread->move(0, 60);
	ckOwrite = new QCheckBox(ckFrame, "ckb");
	ckOwrite->move(50, 60);
	ckOexec = new QCheckBox(ckFrame, "ckb");
	ckOexec->move(100, 60);	
	ckSticky = new QCheckBox(ckFrame, "ckb");
	ckSticky->move(150, 60);
	
	cancel = new QPushButton("Cancel", this);
	cancel->setGeometry(90, 250, 95, 28);
	cancel->setFont(font);		
	cancel->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	connect(cancel, SIGNAL(clicked()), SLOT(reject()));
	ok = new QPushButton("Ok", this);
	ok->setGeometry(200, 250, 95, 28);
	ok->setFont(font);		
	ok->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	ok->setDefault(TRUE);
	connect(ok, SIGNAL(clicked()), SLOT(accept()));
}

void InfoWin::paintEvent(QPaintEvent *)
{
	QPainter p;
	
	p.begin(this);

	p.setFont(font);

	p.drawText(20, 50, "Owner:");
	p.drawText(130, 50, "Group:");

	p.drawText(10, 100, fPath);
	p.drawText(10, 115, fSize);
	p.drawText(10, 130, lastMod);

	p.drawText(70, 145, "read");
	p.drawText(120, 145, "write");
	p.drawText(170, 145, "exec.");
	p.drawText(220, 145, "special");

	p.drawText(10, 170, "User:");
	p.drawText(10, 200, "Group:");
	p.drawText(10, 230, "Others:");

	p.drawText(250, 170, "set UID");
	p.drawText(250, 200, "set GID");
	p.drawText(250, 230, "Sticky");

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 35, width(), 35);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 36, width(), 36);

	p.setPen(QPen(QColor(80, 80, 80), 1));
	p.drawLine(0, 240, width(), 240);
	p.setPen(QPen(QColor(245, 245, 245), 1));
	p.drawLine(0, 241, width(), 241);

	p.end();
}

