#include "macmenu.h"
#include <qpainter.h>
#include <qdrawutl.h>
#include <qapp.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>

extern "C" {
	void XShapeCombineMask(Display*, Window, int, int, int, Pixmap, int);
 	#define ShapeBounding                   0 
	#define ShapeSet                        0 
}

MacMenuBar::MacMenuBar(QWidget *parent, const char *name)
			  :QWidget(parent, name, WStyle_Customize | WStyle_Tool | WStyle_NoBorder)
{
	x = QColor(220, 220, 220);
	CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	font = QFont("Helvetica", 12);
	setFont(font);

	macappleMenu = new QPopupMenu();
	macappleMenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	macappleMenu->setFont(font);
	macappleMenu->insertItem("WMFinder Info", qApp, SLOT(showInfo()));

	macfileMenu = new QPopupMenu();
	macfileMenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	macfileMenu->setFont(font);
	macfileMenu->insertItem("Open", qApp, SLOT(OpenObjfromMenu()), CTRL+Key_O);
	macfileMenu->insertItem("Close", qApp, SLOT(CloseWinfromMenu()), CTRL+Key_W);
	macfileMenu->insertItem("New Folder", qApp, SLOT(NewFolder()), CTRL+Key_N);
	macfileMenu->insertItem("New File", qApp, SLOT(NewFile()), CTRL+Key_M);
	macfileMenu->insertItem("Rename", qApp, SLOT(RenameObj()), CTRL+Key_R);
	macfileMenu->insertItem("Info", qApp, SLOT(InfoObj()), CTRL+Key_I);
	macfileMenu->insertItem("Edit", qApp, SLOT(Edit()), CTRL+Key_E);
	macfileMenu->insertItem("Open  With...", qApp, SLOT(OpenWith()));
	macfileMenu->insertItem("Delete", qApp, SLOT(DelObj()), CTRL+Key_D);
	
	maceditMenu = new QPopupMenu();
	maceditMenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	maceditMenu->setFont(font);
	maceditMenu->insertItem("Select All", qApp, SLOT(SelectAllObjfromMenu()), CTRL+Key_A);
	maceditMenu->insertItem("Start xterm", qApp, SLOT(StartXTerm()), CTRL+Key_T);
	maceditMenu->insertItem("Show Clipboard");
	
	macviewMenu = new QPopupMenu();
	macviewMenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	macviewMenu->setFont(font);
   macviewMenu->insertItem("Update Windows", qApp, SLOT(UpdateWins()));
   macviewMenu->insertItem("Normal Sort", qApp, SLOT(NoDirFirst()));
   macviewMenu->insertItem("Dir First Sort", qApp, SLOT(DirFirst()));

	macspecialMenu = new QPopupMenu();
	macspecialMenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	macspecialMenu->setFont(font);
   macspecialMenu->insertItem("Configure Icons", qApp, SLOT(ConfIcn()));
   macspecialMenu->insertItem("Change Icons Path", qApp, SLOT(ChooseIcnDir()));
   macspecialMenu->insertItem("Configure Programs", qApp, SLOT(ConfEdit()));
	macspecialMenu->insertSeparator();
   macspecialMenu->insertItem("Quit", qApp, SLOT(quit()));
	
	macappsmenu = new QPopupMenu();
	macappsmenu->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	macappsmenu->setFont(font);
   macappsmenu->insertItem("Hide", qApp, SLOT(hide()));
   macappsmenu->insertItem("Hide Others", qApp, SLOT(hide_others()));

	bar = new QMenuBar(this);
	bar->setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	bar->setFont(font);
	bar->insertItem("Mela", macappleMenu);
	bar->insertItem("File", macfileMenu);
	bar->insertItem("Edit", maceditMenu);
	bar->insertItem("View", macviewMenu);
	bar->insertItem("Special", macspecialMenu);
	bar->insertSeparator();
	bar->insertItem("Apps", macappsmenu);
	bar->setSeparator(QMenuBar::InWindowsStyle);
}
