#include "mfinderapp.h"

extern ProgInfo prInfo[];
extern int prInfoNum;
extern char Editor[];
extern char Xterm[];
extern int objdragtype;

#define PSIZE 4
#define PIECES ((64/PSIZE)*(64/PSIZE))

void mfinderapp::makeDeskObjFromFile(char *obpath, char *obname, int x, int y)
{
		deskobj[dskobnum] = new DeskObj(0L, obpath, obname, dskobnum, x, y);
		connect(deskobj[dskobnum], SIGNAL(clickonme(int)), 
										this, SLOT(UnselDskObjs(int)));
		connect(deskobj[dskobnum], SIGNAL(doubleclick(char*, char*, int)), 
										this, SLOT(opnDeskObj(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(dragattempt(char*, char*, int)), 
										this, SLOT(PrepObDeskDrag(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(mousemove(int)), 
										this, SLOT(DeskObDnD(int)));
		connect(deskobj[dskobnum], SIGNAL(dragdone(bool)), 
										this, SLOT(dndDone(bool)));
		connect(deskobj[dskobnum], SIGNAL(removeme(int)), 
										this, SLOT(RemoveDeskObj(int)));
		dskobnum++;
}

void mfinderapp::makeDeskObj(int x, int y)
{
	bool found = FALSE;
	
	for(int i = 0; i < dskobnum; i++)
		if(deskobj[i] != NULL)
			if(strcmp(deskobj[i]->path, srclst[0]) == 0 && deskobj[i]->isVisible())
				found = TRUE;
	
	if(!found) {
		deskobj[dskobnum] = new DeskObj(0L, srclst[0], srclstnames[0], dskobnum, x, y);
		connect(deskobj[dskobnum], SIGNAL(clickonme(int)), 
										this, SLOT(UnselDskObjs(int)));
		connect(deskobj[dskobnum], SIGNAL(doubleclick(char*, char*, int)), 
										this, SLOT(opnDeskObj(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(dragattempt(char*, char*, int)), 
										this, SLOT(PrepObDeskDrag(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(mousemove(int)), 
										this, SLOT(DeskObDnD(int)));
		connect(deskobj[dskobnum], SIGNAL(dragdone(bool)), 
										this, SLOT(dndDone(bool)));
		connect(deskobj[dskobnum], SIGNAL(removeme(int)), 
										this, SLOT(RemoveDeskObj(int)));
		dskobnum++;
	}
}

void mfinderapp::changeDeskObj(char *path1, char *path2, char *newname)
{
	int X, Y;
	bool found = FALSE;
	
	for(int i = 0; i < dskobnum; i++) {
		if(deskobj[i] != NULL) {
			if(strcmp(deskobj[i]->path, path1) == 0 && deskobj[i]->isVisible()) {
				X = deskobj[i]->x;
				Y = deskobj[i]->y;
				deskobj[i]->close();
				found = TRUE;
			}
		}
	}
	if(found) {
		deskobj[dskobnum] = new DeskObj(0L, path2, newname, dskobnum, X, Y);
		connect(deskobj[dskobnum], SIGNAL(clickonme(int)), 
										this, SLOT(UnselDskObjs(int)));
		connect(deskobj[dskobnum], SIGNAL(doubleclick(char*, char*, int)), 
										this, SLOT(opnDeskObj(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(dragattempt(char*, char*, int)), 
										this, SLOT(PrepObDeskDrag(char*, char*, int)));
		connect(deskobj[dskobnum], SIGNAL(mousemove(int)), 
										this, SLOT(DeskObDnD(int)));
		connect(deskobj[dskobnum], SIGNAL(dragdone(bool)), 
										this, SLOT(dndDone(bool)));
		connect(deskobj[dskobnum], SIGNAL(removeme(int)), 
										this, SLOT(RemoveDeskObj(int)));
		dskobnum++;
	}
}

void mfinderapp::UnselDskObjs(int obid)
{
	for(int i = 0; i < dskobnum; i++) {
		if(deskobj[i] != NULL) {
			if(deskobj[i]->id != obid) {
				if(deskobj[i]->isSelect && ! deskobj[i]->isOpen)
					deskobj[i]->Unselect();
				if(deskobj[i]->isSelect && deskobj[i]->isOpen)
					deskobj[i]->UnselOpen();
			}
		}
	}
	for(int i = 0; i < WinCount; i++) {
		if(FWin[i] != NULL) {
			for(int j = 0; j < FWin[i]->objsframe->FileCount; j++) {
				if(FWin[i]->objsframe->filobj[j] != NULL) {
					if(FWin[i]->objsframe->filobj[j]->isSelect && FWin[i]->objsframe->filobj[j]->isOpen == FALSE)
						FWin[i]->objsframe->filobj[j]->Unselect();
					if(FWin[i]->objsframe->filobj[j]->isSelect && FWin[i]->objsframe->filobj[j]->isOpen == TRUE)
						FWin[i]->objsframe->filobj[j]->UnselOpen();
				}
			}
		}
	}
}			

void mfinderapp::opnDeskObj(char *deskobname, char *deskobpath, int deskobtype)
{
	char buff[256] = "";
	char cmd[128] = "";
	char name2[256] = "";
	char *pref, *suff = "", *token, *delims = ".";
	bool found = FALSE;

	switch(deskobtype) {
		case DR:
			DirOpen(deskobpath, "", FALSE, -1);
			break;
			
		case FIL:
			sprintf(name2, "%s", deskobname);
			token = strtok(name2, delims);
			pref = token;
			while(token != NULL) {
				suff = token;
				token = strtok(NULL, delims);
			}
			if(deskobname[0] == '.') {
				for(int i = 0; i < prInfoNum; i++) {
					if(strcmp(prInfo[i].pref, ".") == 0) {
						sprintf(cmd, "%s", prInfo[i].ProgName);
						found = TRUE;
						break;
					}
				}
			}
			if(!found) {
				for(int i = 0; i < prInfoNum; i++) {
					if(strcmp(pref, prInfo[i].pref) == 0) {
						sprintf(cmd, "%s", prInfo[i].ProgName);
						found = TRUE;
						break;
					}
				}
			}
			if(!found) {
				for(int i = 0; i < prInfoNum; i++) {
					if(strcmp(suff, prInfo[i].suff) == 0) {
						sprintf(cmd, "%s", prInfo[i].ProgName);
						found = TRUE;
						break;
					}
				}
			}
			if(!found)
				sprintf(cmd, "%s", Editor);
			
			sprintf(buff, "%s %s", cmd, deskobpath);
			ExecComm(buff);
			break;
			
		case FILEXE:
			sprintf(buff, "%s", deskobpath);
			ExecComm(buff);
			break;
			
		default:
			break;
	}
}

void mfinderapp::RemoveDeskObj(int objid)
{
	int shFid = 0, shObid = 0;
	int m, t, q, k, sw, sh, x, y;
	short px[PIECES], py[PIECES];
	char pvx[PIECES], pvy[PIECES];
	char ax[PIECES], ay[PIECES];
	Display *scr;
	QPixmap Ptmp;

	Ptmp = QPixmap(deskobj[objid]->Icona);
	Ptmp.detach();
	x = deskobj[objid]->pos().x();
	y = deskobj[objid]->pos().y();	

	deskobj[objid]->close();

	scr = desktop()->x11Display();
	sw = desktop()->width();
	sh = desktop()->height();

	for(t=0, k=0; t < 48/PSIZE; t++) {
		for(q=0; q < 48/PSIZE; q++) {
	   	if(rand()%3) {
				ax[k] = t;
				ay[k] = q;
				px[k] = x + t * PSIZE;
				py[k] = y + q * PSIZE;
				pvx[k] = rand()%7 - 3;
				pvy[k] = -12 -rand()%6;
				k++;
	    	} else {
				ax[k] = -1;
	    	}
		}
	}
	q = k;
	while(k > 0) {
		for(t = 0; t < q; t++) {
	    	if(ax[t] >= 0) {
				px[t] += pvx[t];
				py[t] += pvy[t];
				pvy[t]++;
				if(px[t] < -48 || px[t] > sw || py[t] > sh) {
		    		ax[t] = -1;
		    		k--;
				} else {
		    		XCopyArea(scr, Ptmp.handle(), desktop()->winId(),
		    		DefaultGC(scr, 0),
			      						ax[t]*PSIZE, ay[t]*PSIZE, 
			      							PSIZE, PSIZE, px[t], py[t]);
				}
	    	}
		}
		for(t = 0; t < q; t++) {
			if(ax[t] >= 0) {
				XClearArea(scr, desktop()->winId(), px[t], py[t], PSIZE,
				PSIZE, 1);
	    	}
		}
	}
}

void mfinderapp::PrepObDeskDrag(char *objpath, char *objparentpath, int objid)
{
	ObDeskMoving = TRUE;
	DndDataCount = 0;
	DndIcnCount = 0;
	isDnDtarget = FALSE;
	offdndtype = -1;
	sprintf(DndSourcePath, "%s", objparentpath);
	srclst = new char*[1];
	srclstnames = new char*[1];
	
	objdragtype = deskobj[objid]->type;
	srclst[DndDataCount] = deskobj[objid]->path;
	srclstnames[DndDataCount] = deskobj[objid]->name;
	DndDataCount++;

	deskobj[objid]->raise();
	dskobdragid = objid;
	dskobX = deskobj[objid]->pos().x();
	dskobY = deskobj[objid]->pos().y();

//	QPoint curp = QCursor::pos();
//	deskobj[objid]->xOffset = curp.x() - dskobX;
//	deskobj[objid]->yOffset = curp.y() - dskobY;
	
	offdndtype = deskobj[objid]->type;
}

void mfinderapp::DeskObDnD(int objid)
{
	p = QCursor::pos();
	
	deskobj[objid]->move(p.x(), p.y());
	deskobj[objid]->x = p.x();
	deskobj[objid]->y = p.y();

	Objtmp = widgetAt(p, TRUE);
	if(Objtmp != 0L) {
		if(ObjAt != Objtmp) {
			if(ObjAt != 0L) {
				if(ObjAt->inherits("FileObj")) {
					FileObj *target = (FileObj*)ObjAt;
					target->DragLeave();
				}
				if(ObjAt->inherits("ObjsFrame")) {
					ObjsFrame *target = (ObjsFrame*)ObjAt;
					target->DragLeave();
				}
				if(ObjAt->inherits("DeskObj")) {
					DeskObj *target = (DeskObj*)ObjAt;				
					target->DragLeave();
				}
			}
			ObjAt = Objtmp;
			if(ObjAt->inherits("FileObj")) {
				FileObj *target = (FileObj*)ObjAt;
				target->DragMove();
			}
			if(ObjAt->inherits("ObjsFrame")) {
				ObjsFrame *target = (ObjsFrame*)ObjAt;
				target->DragMove();
			}
			if(ObjAt->inherits("DeskObj")) {
				DeskObj *target = (DeskObj*)ObjAt;				
				target->DragMove();
			}
		}
	} else {
		if(ObjAt != 0L) {
			if(ObjAt->inherits("FileObj")) {
				FileObj *target = (FileObj*)ObjAt;
				target->DragLeave();
			}
			if(ObjAt->inherits("ObjsFrame")) {
				ObjsFrame *target = (ObjsFrame*)ObjAt;
				target->DragLeave();
			}
			if(ObjAt->inherits("DeskObj")) {
				DeskObj *target = (DeskObj*)ObjAt;	
				target->DragLeave();
			}			
			ObjAt = 0L;
		}
	}
}


