#include "mfinderapp.h"
#include <qprogdlg.h> 
#include <pwd.h>
#include <grp.h>

extern char Editor[];
extern char Xterm[];

extern IconData *IData[];
extern int IDataNum;
extern FolderIconData *IFoldData, *IFoldLinkData;
extern int objdragtype;

extern int errno;

static char *NOERR = "noerr";
static char *NAMUSE = "This name is already in use!\n";
static char *NODEL = "You dont have write permission\nfor some elements.\nThese\
elements wasn't deleted!\n";
static char *NOCOPY = "You dont have write permission\nfor some elements.\nThese\
elements wasn't copied!\n";
static char *SOUCDEST = "Source and destination are identical!\n";
static char *SYSERR = "System Error!\n";	

#define PSIZE 4
#define PIECES ((64/PSIZE)*(64/PSIZE))

// ---------------- New Object ---------------------------------------------
void mfinderapp::NewFolder()
{
	char *err;
	int m;
	
	isdir = TRUE;
	err = NewObject();
	if(strcmp(err, NOERR) != 0) {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		m = dialog->exec();
	}
}

void mfinderapp::NewFile()
{
	char *err;
	int m;
	
	isdir = FALSE;
	err = NewObject();
	if(strcmp(err, NOERR) != 0) {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		m = dialog->exec();
	}
}

char* mfinderapp::NewObject()
{
	char objName[256] = "";
	char IcName[128] = "";
	char destDir[256] = "";
	char Path[256] = "";
	struct dirent **namelist;
	int n;
	
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus())	
			sprintf(destDir, "%s", FWin[i]->name);

	if(access(destDir, W_OK)) {
		sprintf(ERR, "You have not write permission\nfor \"%s\"!\n", destDir);
		return ERR;
	}
	
	if(strcmp(destDir, "/") == 0) 
		sprintf(Path, "%s", destDir);
	else
		sprintf(Path, "%s/", destDir);

	if(isdir)
		dialog = new Dialog(0L, "New Folder", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	else
		dialog = new Dialog(0L, "New File", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
	if(dialog->exec()) {
		sprintf(objName, "%s", dialog->editfield->text());
		for(int i = 0; i < strlen(objName); i++) {
			if(objName[i] == ' ' || objName[i] == '/' || objName[i] == '*'
				|| objName[i] == '(' || objName[i] == ')' || objName[i] == '['
				|| objName[i] == ']' || objName[i] == '{' || objName[i] == '}'
				|| objName[i] == '\\' || objName[i] == '<' || objName[i] == '>'
				|| objName[i] == '^' || objName[i] == '!' || objName[i] == '?'
				|| objName[i] == '$' || objName[i] == '&' || objName[i] == '#'
				|| objName[i] == '|' || objName[i] == '~' || objName[i] == '\"'
				|| objName[i] == '\'' || objName[i] == '`') {
				sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", objName[i]);
				return ERR;
			}
		}
				
  		n = scandir(destDir, &namelist, 0, alphasort);
  		if(n < 0) 
  			perror("scandir");
		else 
			for(int a = 0; a <= n - 1; a++)
				if(strcmp(namelist[a]->d_name, objName) == 0)
					return NAMUSE;
			
		strcat(Path, objName);
		if(isdir) {
			if(mkdir(Path, S_IRUSR | S_IRGRP | S_IROTH | 
						S_IWUSR | S_IXUSR | S_IXGRP | S_IXOTH))
				return SYSERR;
		} else {
			if(create(Path, S_IRUSR | S_IRGRP | S_IROTH | S_IWUSR))
				return SYSERR;
		}
		for(int i = 0; i < WinCount; i++) {
			if(strcmp(FWin[i]->name, destDir) == 0) {
				UpdateDnDWin(i, objName);
				FWin[i]->objsframe->SortObjs();
				FWin[i]->Info->updateData();
			}
		}
	}
	isdir = FALSE;
	return NOERR;
}

// ---------------- Delete Objects ---------------------------------------------
void mfinderapp::DelObj()
{
	char *err;
	int m;
	
	err = DoDel();
	if(strcmp(err, NOERR) != 0) {
		dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, err);
		m = dialog->exec();
	}
}

char* mfinderapp::DoDel()
{
	char destDir[256] = "";
	char Path[256] = "";
	struct stat listStat;
	bool noaccess = FALSE;
	bool candel = TRUE;
	int ls, nwin;
	
	nwin = -1;
	for(int i = 0; i < WinCount; i++)
		for(int j = 0; j < FWin[i]->objsframe->FileCount; j++)
			if(FWin[i]->objsframe->filobj[j]->isSelect)
				nwin = i;
			
	if(nwin == -1) {
		return NOERR;
	} else {
		sprintf(destDir, "%s", FWin[nwin]->name);
		if(access(destDir, W_OK)) {
			sprintf(ERR, "You have not write permission\nfor \"%s\"!\n", destDir);
			return ERR;
		}
		sprintf(ERR, "Are you sure that want to\ndelete the selected items?\n");
		dialog = new Dialog(0L, "Delete", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
		if(dialog->exec()) {			
			for(int j = 0; j < FWin[nwin]->objsframe->FileCount; j++) {
				if(FWin[nwin]->objsframe->filobj[j]->isSelect) {
					if(strcmp(destDir, "/") == 0)
						sprintf(Path, "%s%s", destDir, FWin[nwin]->objsframe->filobj[j]->name);
					else
						sprintf(Path, "%s/%s", destDir, FWin[nwin]->objsframe->filobj[j]->name);

					if(access(Path, W_OK)) {
						ls = lstat(Path, &listStat);
						if(!S_ISLNK(listStat.st_mode))
							candel = FALSE;
					}
					if(candel) {
						if(FWin[nwin]->objsframe->filobj[j]->type == DR) {
							if(rdel(Path, TRUE)) {
								noaccess = TRUE;
							} else {
								if(FWin[nwin]->objsframe->filobj[j]->isOpen) {
									for(int w = 0; w < WinCount; w++)
 										if(strcmp(FWin[w]->name, Path) == 0)
 											FWin[w]->close();
 								}
 								FWin[nwin]->objsframe->filobj[j]->close();

								for(int m = 0; m < dskobnum; m++)
									if(deskobj[m] != NULL) 
										if(strcmp(deskobj[m]->path, 
													FWin[nwin]->objsframe->filobj[j]->myPath) == 0) 
											deskobj[m]->close();

							}
						} else {
							if(rdel(Path, FALSE))
								noaccess = TRUE;
							else 
								FWin[nwin]->objsframe->filobj[j]->close();

							for(int m = 0; m < dskobnum; m++)
								if(deskobj[m] != NULL) 
									if(strcmp(deskobj[m]->path, 
											FWin[nwin]->objsframe->filobj[j]->myPath) == 0) 
										deskobj[m]->close();
						}
					} else {
						noaccess = TRUE;
					}
				}
			}
			FWin[nwin]->objsframe->SortObjs();
			FWin[nwin]->Info->updateData();
		}
	}
	if(noaccess)
		return NODEL;

	return NOERR;
}

// ---------------- Rename Object -------------------------------------
void mfinderapp::RenameObj()
{
	char path1[256] = "", path2[256] = "", newname[256] = "";
	QPixmap RenameIcn;
	QPixmap labPix;
	QPainter pnt;
	bool isvalid;
	int m, nwin, pixWidth, labWidth, pixX, labX;

	nwin = -1;
	for(int i = 0; i < WinCount; i++)
		for(int j = 0; j < FWin[i]->objsframe->FileCount; j++)
			if(FWin[i]->objsframe->filobj[j]->isSelect)
				nwin = i;
	
	if(nwin >= 0)	{
		if(access(FWin[nwin]->name, W_OK)) {
			sprintf(ERR, "You have not write permission \n for \"%s\"!\n", FWin[nwin]->name);
			dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
			m = dialog->exec();
			return;
		}
		for(int j = 0; j < FWin[nwin]->objsframe->FileCount; j++) {
			if(FWin[nwin]->objsframe->filobj[j]->isSelect) {
				isvalid = TRUE;
				sprintf(path1, "%s", FWin[nwin]->objsframe->filobj[j]->myPath);
				dialog = new Dialog(0L, "Rename", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
				dialog->editfield->setText(FWin[nwin]->objsframe->filobj[j]->name);
				if(dialog->exec()) {
					sprintf(newname, "%s", dialog->editfield->text());
					for(int h = 0; h < strlen(newname); h++) {
						if(newname[h] == ' ' || newname[h] == '/' || newname[h] == '*'
							|| newname[h] == '(' || newname[h] == ')' || newname[h] == '['
							|| newname[h] == ']' || newname[h] == '{' || newname[h] == '}'
							|| newname[h] == '\\' || newname[h] == '<' || newname[h] == '>'
							|| newname[h] == '^' || newname[h] == '!' || newname[h] == '?'
							|| newname[h] == '$' || newname[h] == '&' || newname[h] == '#'
							|| newname[h] == '|' || newname[h] == '~' || newname[h] == '\"'
							|| newname[h] == '\'' || newname[h] == '`') {
							isvalid = FALSE;
							sprintf(ERR, "The name is not a valid name!\nIllegal use of \"%c\" !\n", newname[h]);
							dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
							m = dialog->exec();
							return;
						}
					} 			
					if(isvalid) {
						for(int h = 0; h < FWin[nwin]->objsframe->FileCount; h++) {
							if(strcmp(FWin[nwin]->objsframe->filobj[h]->name, newname) == 0) {
								isvalid = FALSE;
								sprintf(ERR, "This name is already in use!\n");
								dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE,FALSE, FALSE, ERR);
								m = dialog->exec();									
								return;
							}					
						}
					}
					if(isvalid) {
						if(strcmp(FWin[nwin]->name, "/") == 0) 
							sprintf(path2, "%s%s", FWin[nwin]->name, newname);
						else
							sprintf(path2, "%s/%s", FWin[nwin]->name, newname);

						if(rename(path1, path2)) {
							sprintf(ERR, "You don't have write access\nfor some elements!\n");
							dialog = new Dialog(0L, "Error", TRUE, 0, TRUE, TRUE, FALSE, FALSE, ERR);
							m = dialog->exec();									
							return;
						} else {
							UpdateDelDnDObj(nwin, FWin[nwin]->objsframe->filobj[j]->name);
							UpdateDnDWin(nwin, newname);
							FWin[nwin]->objsframe->SortObjs();
							FWin[nwin]->Info->updateData();
							changeDeskObj(path1, path2, newname);

							for(int w = 0; w < WinCount; w++) {
 								if(strcmp(FWin[w]->name, path1) == 0)
 									FWin[w]->close();
 							}
						}	
					}
				}
			}	
		}		
	}
}

// ---------------- Info Object -------------------------------------
void mfinderapp::InfoObj()
{
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus())
			for(int j = 0; j < FWin[i]->objsframe->FileCount; j++)
				if(FWin[i]->objsframe->filobj[j]->isSelect)
					FWin[i]->objsframe->filobj[j]->InfoObj();

}

// ------------------------ DnD ----------------------------------------
void mfinderapp::dndDone(bool iscopy)
{
	char *err;
	bool found = FALSE;
	int m, t, q, k, x, y;

	for(int i = 0; i < DndIcnCount; i++)
		if(dndicon[i] != NULL)
			dndicon[i]->~DnDIcon();
	DndIcnCount = 0;

	for(int j = 0; j < WinCount; j++) {
		if(FWin[j] != NULL) {
			if(FWin[j]->isVisible()) {
				FWin[j]->objsframe->DragLeave();
				
				for(int v = 0; v < FWin[j]->objsframe->FileCount; v++) {
					if(FWin[j]->objsframe->filobj[v] != NULL) {
						if(FWin[j]->objsframe->filobj[v]->isVisible())
							FWin[j]->objsframe->filobj[v]->DragLeave();
					}
				}
			}
		}
	}
	for(int j = 0; j < dskobnum; j++)
		if(deskobj[j] != NULL)
			if(deskobj[j]->isVisible()) {
				deskobj[j]->DragLeave();
				deskobj[j]->lower();
			}
			
	isDnDtarget = FALSE;					
	p = QCursor::pos();
	Objtmp = widgetAt(p, TRUE);
	if(Objtmp != NULL) {
		if(Objtmp->inherits("FileObj")) {
			FileObj *dndTarget = (FileObj*)Objtmp;
			if(dndTarget->type == DR || dndTarget->type == DRLNK) {
				sprintf(DndTargetPath, "%s", dndTarget->myPath);
				isDnDtarget = TRUE;
			}
		}
		if(!isDnDtarget) {
			if(Objtmp->inherits("ObjsFrame")) {
				ObjsFrame *dndTarget = (ObjsFrame*)Objtmp;
				sprintf(DndTargetPath, "%s", dndTarget->name);
				isDnDtarget = TRUE;
			}
		}
		if(!isDnDtarget) {
			if(Objtmp->inherits("DeskObj")) {
				DeskObj *dndTarget = (DeskObj*)Objtmp;
				if(dndTarget->type == DR) {
					sprintf(DndTargetPath, "%s", dndTarget->path);
					isDnDtarget = TRUE;
				}
			}
		}
	}
	
// ----------------------- OFFIX & DESKOBJS DND -----------------------
	if(Objtmp == NULL || !isDnDtarget) {
		if(DndDataCount == 1) {
			if(offdndtype == FIL || offdndtype == FILEXE || offdndtype == DR) {
				if(offdndtype == FIL)
					DataType = 2;
				if(offdndtype == FILEXE)
					DataType = 7;
				if(offdndtype == DR)
					DataType = 5;

				XChangeProperty(dspl, DefaultRootWindow(dspl), 
									 DndSelection, XA_STRING, 8,
		    						 PropModeReplace, 
		    						 (unsigned char *)srclst[0], 
		    						 strlen(srclst[0])+1);
				DataOK = TRUE;
				OffixDrop(p.x(), p.y());
			}
		}
		isDnDtarget = FALSE;
		clearDnD();	
		
		if(ObDeskMoving)
			if(deskobj[dskobdragid] != NULL)
				if(deskobj[dskobdragid]->isVisible())
					deskobj[dskobdragid]->lower();
		return;
	}
// -------------------------------------------------------------------
				
	if(isDnDtarget) {
	
		if(ObDeskMoving)
			if(deskobj[dskobdragid] != NULL)
				if(deskobj[dskobdragid]->isVisible()) {
					deskobj[dskobdragid]->lower();
					deskobj[dskobdragid]->move(dskobX, dskobY);
					deskobj[dskobdragid]->x = dskobX;
					deskobj[dskobdragid]->y = dskobY;
				}
	
		if(strcmp(DndTargetPath, DndSourcePath) == 0) {
			clearDnD();
			return;
		}
		if(strcmp(DndTargetPath, "") == 0) {
			clearDnD();
			return;
		}
		if(strcmp(DndTargetPath, srclst[0]) == 0) {
			clearDnD();
			return;
		}

		if(iscopy) {
			sprintf(ERR, "Are you sure that you want to copy the selected items\nfrom: %s\nto: %s\n", DndSourcePath, DndTargetPath);
			dialog = new Dialog(0L, "Copy", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
			if(dialog->exec()) {			
				Copy();
				return;
			} else {
				clearDnD();
				return;
			}
		} else {
			sprintf(ERR, "Are you sure that you want to move the selected items\nfrom: %s\nto: %s\n", DndSourcePath, DndTargetPath);
			dialog = new Dialog(0L, "Move", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
			if(dialog->exec()) {			
				Move();
				return;	
			} else {
				clearDnD();	
				return;
			}
		}
	} else {
		clearDnD();
		return;
	}
}

void mfinderapp::Move()
{
	struct dirent **namelist;
	struct stat listStat, lStat;
	char P[256] = "";
	char buf1[256] = "", buf2[256] = "";
	bool noaccess = FALSE;
	bool somefilesys = TRUE;
	bool samename = FALSE;
	int m, a, rn, ad, ls, lst, idsrcwin, idtrgtwin;
	
	idsrcwin = -1;
	idtrgtwin = -1;
	for(int j = 0; j < WinCount; j++)
		if(FWin[j] != NULL)
			if(FWin[j]->isVisible())
				if(strcmp(FWin[j]->name, DndSourcePath) == 0)
					idsrcwin = j;

	for(int j = 0; j < WinCount; j++)
		if(FWin[j] != NULL)
			if(FWin[j]->isVisible())
				if(strcmp(FWin[j]->name, DndTargetPath) == 0)
					idtrgtwin = j;

	m = scandir(DndTargetPath, &namelist, 0, alphasort);
	
	if(dstdirlstnames != NULL)
		delete[] dstdirlstnames;
	dstdirlstnames = new char*[m];
	a = 0;
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0 && strcmp(namelist[i]->d_name, "..") != 0) {
			dstdirlstnames[a] = namelist[i]->d_name;
			a++;
		}	
	}
	if(access(DndTargetPath, W_OK)) {
		sprintf(ERR, "You have not write permission \n for \"%s\"!\n", DndTargetPath);
		clearDnD();
		dndErr("Error", ERR);
		return;
	}
	for(int i = 0; i < DndDataCount; i++) {
		if(strcmp(DndTargetPath, srclst[i]) == 0) {
			clearDnD();
			dndErr("Error", SOUCDEST);
			return;
		}
	}

	if(objtorempath != NULL)
		delete[] objtorempath;
	objtorempath = new char*[m];
	if(objtoremname != NULL)
		delete[] objtoremname;
	objtoremname = new char*[m];
	rn = 0;
	for(int i = 0; i < DndDataCount; i++) {
		for(int j = 0; j < a; j++) {
			if(strcmp(srclstnames[i], dstdirlstnames[j]) == 0) {
				samename = TRUE;
				sprintf(buf2, "%s", srclstnames[i]);
				if(strcmp(DndTargetPath, "/") == 0)
					sprintf(buf1, "%s%s", DndTargetPath, srclstnames[i]);
				else
					sprintf(buf1, "%s/%s", DndTargetPath, srclstnames[i]);
				
				objtorempath[rn] = new char[strlen(buf1)+1];
				strcpy(objtorempath[rn], buf1);
				objtoremname[rn] = new char[strlen(buf2)+1];
				strcpy(objtoremname[rn], buf2);				
				rn++;
			}
		}
	}

	if(samename) {
		sprintf(ERR, "Some items have the same name.\nDo you want to sobstitute them?\n");
		dialog = new Dialog(0L, "Move", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
		if(dialog->exec()) {
		
			for(int i = 0; i < rn; i++) {
				ls = lstat(objtorempath[i], &listStat);
				if(S_ISDIR(listStat.st_mode)) { 
					if(rdel(objtorempath[i], TRUE)) {
						clearDnD();
						dndErr("Error", NOCOPY);
						return;
					}
				} else {
					if(rdel(objtorempath[i], FALSE)) {
						clearDnD();
						dndErr("Error", NOCOPY);
						return;
					}
				}
				if(idtrgtwin != -1)
					UpdateDelDnDObj(idtrgtwin, objtoremname[i]);
			}
			if(idtrgtwin != -1)
				FWin[idtrgtwin]->objsframe->SortObjs();
		
			for(int i = 0; i < DndDataCount; i++) {
				if(strcmp(DndTargetPath, "/") == 0) 
					sprintf(P, "%s%s", DndTargetPath, srclstnames[i]);
				else
					sprintf(P, "%s/%s", DndTargetPath, srclstnames[i]);

				if(rename(srclst[i], P)) {
					if(errno == EXDEV) {
						somefilesys = FALSE;
						sprintf(buf1, "%s", srclst[i]);
						sprintf(buf2, "%s", P);
						lst = lstat(buf1, &lStat);
						if(S_ISREG(lStat.st_mode))
							if(copyfile(buf1, buf2)) 
								noaccess = TRUE; 
						if(S_ISDIR(lStat.st_mode))
							if(copydir(buf1, buf2))
								noaccess = TRUE; 
						if(S_ISFIFO(lStat.st_mode)) 
	  						if(mkfifo(buf2, user.umask & 0666))
								noaccess = TRUE; 
						if(S_ISBLK(lStat.st_mode) || S_ISCHR(lStat.st_mode) || S_ISSOCK(lStat.st_mode)) 
	  						if(mknod(buf2, user.umask & 0666, lStat.st_rdev)) 
								noaccess = TRUE; 
						if(S_ISLNK(lStat.st_mode)) {
	  						char lnk[MAXPATHLEN+1];
	  						int l = readlink(buf1, lnk, MAXPATHLEN);
	      				lnk[l] = '\0';
	      				if(symlink(lnk, buf2)) 
								noaccess = TRUE; 
      				}
					} else {
						noaccess = TRUE; 
					}
				}
				if(noaccess) {
					clearDnD();
					dndErr("Error", NOCOPY);
					return;
				}
				if(idtrgtwin != -1)
					UpdateDnDWin(idtrgtwin, srclstnames[i]);
				
				if(somefilesys && idsrcwin != -1) 
					UpdateDelDnDObj(idsrcwin, srclstnames[i]);

				changeDeskObj(srclst[i], P, srclstnames[i]);
					
			} // QUESTO !!!! fine del loop di DndDataCount

			if(idsrcwin != -1 && somefilesys) {
				FWin[idsrcwin]->objsframe->SortObjs();		
				FWin[idsrcwin]->Info->updateData();
			}			
			if(idtrgtwin != -1) {
				FWin[idtrgtwin]->objsframe->SortObjs();
				FWin[idtrgtwin]->Info->updateData();
			}
			for(int j = 0; j < WinCount; j++)
				if(FWin[j] != NULL)
					if(FWin[j]->isVisible())
						for(int k = 0; k < DndDataCount; k++)
 							if(strcmp(FWin[j]->name, srclst[k]) == 0)
 								FWin[j]->close();
 								
			clearDnD();
			return;
		} else {
			clearDnD();
			return;		// Cancel nel dialogo	
		} 
	}			 // if samename
	
	for(int i = 0; i < DndDataCount; i++) {
		if(strcmp(DndTargetPath, "/") == 0) 
			sprintf(P, "%s%s", DndTargetPath, srclstnames[i]);
		else
			sprintf(P, "%s/%s", DndTargetPath, srclstnames[i]);

		if(rename(srclst[i], P)) {
			if(errno == EXDEV) {
				somefilesys = FALSE;
				sprintf(buf1, "%s", srclst[i]);
				sprintf(buf2, "%s", P);
				lst = lstat(buf1, &lStat);
				if(S_ISREG(lStat.st_mode))
					if(copyfile(buf1, buf2)) 
						noaccess = TRUE; 
				if(S_ISDIR(lStat.st_mode))
					if(copydir(buf1, buf2))
						noaccess = TRUE; 
				if(S_ISFIFO(lStat.st_mode)) 
	  				if(mkfifo(buf2, user.umask & 0666))
						noaccess = TRUE; 
				if(S_ISBLK(lStat.st_mode) || S_ISCHR(lStat.st_mode) || S_ISSOCK(lStat.st_mode))
	  				if(mknod(buf2, user.umask & 0666, lStat.st_rdev)) 
						noaccess = TRUE; 
				if(S_ISLNK(lStat.st_mode)) {
	  				char lnk[MAXPATHLEN+1];
	  				int l = readlink(buf1, lnk, MAXPATHLEN);
	      		lnk[l] = '\0';
	      		if(symlink(lnk, buf2)) 
						noaccess = TRUE; 
      		}
			} else {
				noaccess = TRUE; 
			}
		}
		if(noaccess) {
			clearDnD();
			dndErr("Error", NOCOPY);
			return;
		}
		if(somefilesys && idsrcwin != -1) 
			UpdateDelDnDObj(idsrcwin, srclstnames[i]);

		if(idtrgtwin != -1)
			UpdateDnDWin(idtrgtwin, srclstnames[i]);

		changeDeskObj(srclst[i], P, srclstnames[i]);
		
	} /// QUESTO !!!! fine del loop di DndDataCount
	
	if(idsrcwin != -1 && somefilesys) {
		FWin[idsrcwin]->objsframe->SortObjs();		
		FWin[idsrcwin]->Info->updateData();
	}			
	if(idtrgtwin != -1) {
		FWin[idtrgtwin]->objsframe->SortObjs();
		FWin[idtrgtwin]->Info->updateData();
	}
	for(int j = 0; j < WinCount; j++)
		if(FWin[j] != NULL)
			if(FWin[j]->isVisible())
				for(int k = 0; k < DndDataCount; k++)
 					if(strcmp(FWin[j]->name, srclst[k]) == 0)
 						FWin[j]->close();

	if(noaccess) {
		clearDnD();
		dndErr("Error", NOCOPY);
		return;
	}
	
	clearDnD();
} 

void mfinderapp::Copy()
{
	struct dirent **namelist;
	struct stat listStat;
	char P[256] = "";
	char buf1[256] = "", buf2[256] = "";
	char dlogline[512] = "";
	bool noaccess = FALSE;
	bool samename = FALSE;
	int m, a, rn, ad, ls, widp, widm, idsrcwin, idtrgtwin;

	idsrcwin = -1;
	idtrgtwin = -1;
	for(int j = 0; j < WinCount; j++)
		if(FWin[j] != NULL)
			if(FWin[j]->isVisible())
				if(strcmp(FWin[j]->name, DndSourcePath) == 0)
					idsrcwin = j;

	for(int j = 0; j < WinCount; j++)
		if(FWin[j] != NULL)
			if(FWin[j]->isVisible())
				if(strcmp(FWin[j]->name, DndTargetPath) == 0)
					idtrgtwin = j;

	m = scandir(DndTargetPath, &namelist, 0, alphasort);
	dstdirlstnames = new char*[m];
	a = 0;
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0 && strcmp(namelist[i]->d_name, "..") != 0) {
			dstdirlstnames[a] = namelist[i]->d_name;
			a++;
		}	
	}
	if(strcmp(DndTargetPath, DndSourcePath) == 0) {
		clearDnD();
		return;
	}
	if(access(DndTargetPath, W_OK)) {
		sprintf(ERR, "You have not write permission \nfor \"%s\"!\n", DndTargetPath);
		clearDnD();
		dndErr("Error", ERR);
		return;
	}
	for(int i = 0; i < DndDataCount; i++) {
		if(strcmp(DndTargetPath, srclst[i]) == 0) {
			clearDnD();
			dndErr("Error", SOUCDEST);
			return;
		}
	}
	
	if(objtorempath != NULL)
		delete[] objtorempath;
	objtorempath = new char*[m];
	if(objtoremname != NULL)
		delete[] objtoremname;
	objtoremname = new char*[m];
	rn = 0;
	for(int i = 0; i < DndDataCount; i++) {
		for(int j = 0; j < a; j++) {
			if(strcmp(srclstnames[i], dstdirlstnames[j]) == 0) {
				samename = TRUE;
				sprintf(buf2, "%s", srclstnames[i]);
				if(strcmp(DndTargetPath, "/") == 0)
					sprintf(buf1, "%s%s", DndTargetPath, srclstnames[i]);
				else
					sprintf(buf1, "%s/%s", DndTargetPath, srclstnames[i]);
				
				objtorempath[rn] = new char[strlen(buf1)+1];
				strcpy(objtorempath[rn], buf1);
				objtoremname[rn] = new char[strlen(buf2)+1];
				strcpy(objtoremname[rn], buf2);				
				rn++;
			}
		}
	}
	
	if(samename) {
		sprintf(ERR, "Some items have the same name.\nDo you want to sobstitute them?\n");
		dialog = new Dialog(0L, "Copy", TRUE, 0, TRUE, TRUE, FALSE, TRUE, ERR);
		if(dialog->exec()) {
		
			for(int i = 0; i < rn; i++) {
				ls = lstat(objtorempath[i], &listStat);
				if(S_ISDIR(listStat.st_mode)) { 
					if(rdel(objtorempath[i], TRUE)) {
						clearDnD();
						dndErr("Error", NOCOPY);
						return;
					}
				} else {
					if(rdel(objtorempath[i], FALSE)) {
						clearDnD();
						dndErr("Error", NOCOPY);
						return;
					}
				}
				if(idtrgtwin != -1)
					UpdateDelDnDObj(idtrgtwin, objtoremname[i]);
			}
			if(idtrgtwin != -1)
				FWin[idtrgtwin]->objsframe->SortObjs();

		} else {
			clearDnD();
			return;		// Cancel nel Dialogo	
		}
	}

	sprintf(ERR, "These elements was not copied: ");

	dialogcopy = new DialogCopy(0L, "Copy");
	connect(this, SIGNAL(dlogchngline(char*)), 
				dialogcopy, SLOT(changeText(char *)));
	dialogcopy->show();
	processOneEvent();
	QResizeEvent er = QResizeEvent(dialogcopy->size(), dialogcopy->size());
	sendEvent(dialogcopy, &er);
	processOneEvent();
	syncX();
	flushX();

	for(int i = 0; i < DndDataCount; i++) {
		if(strcmp(DndTargetPath, "/") == 0) 
			sprintf(P, "%s%s", DndTargetPath, srclstnames[i]);
		else
			sprintf(P, "%s/%s", DndTargetPath, srclstnames[i]);

		sprintf(dlogline, "From: %s\nTo: %s\n", srclst[i], P);
		emit dlogchngline(dlogline);
		processOneEvent();

		ls = lstat(srclst[i], &listStat);
		if(S_ISREG(listStat.st_mode))
			if(copyfile(srclst[i], P)) 
				sprintf(ERR, "%s\n%s", ERR, srclstnames[i]);
		if(S_ISDIR(listStat.st_mode))
			if(copydir(srclst[i], P))
				sprintf(ERR, "%s\n%s", ERR, srclstnames[i]);
		if(S_ISFIFO(listStat.st_mode)) 
	  		if(mkfifo(P, user.umask & 0666))
				sprintf(ERR, "%s\n%s", ERR, srclstnames[i]);
		if(S_ISBLK(listStat.st_mode) || S_ISCHR(listStat.st_mode) || S_ISSOCK(listStat.st_mode)) 
	  		if(mknod(P, user.umask & 0666, listStat.st_rdev)) 
				sprintf(ERR, "%s\n%s", ERR, srclstnames[i]);
		if(S_ISLNK(listStat.st_mode)) {
	  		char lnk[MAXPATHLEN+1];
	  		int l = readlink(srclst[i], lnk, MAXPATHLEN);
	      lnk[l] = '\0';
	      if(symlink(lnk, P)) 
				sprintf(ERR, "%s\n%s", ERR, srclstnames[i]);
      }
		if(idtrgtwin != -1 && strcmp(ERR, "These elements was not copied: ") == 0){
			UpdateDnDWin(idtrgtwin, srclstnames[i]);
			changeDeskObj(srclst[i], P, srclstnames[i]);
		}
	}
	if(idtrgtwin != -1) {
		FWin[idtrgtwin]->objsframe->SortObjs();
		FWin[idtrgtwin]->Info->updateData();
	}
	
	dialogcopy->hide();
	dialogcopy->~DialogCopy();
	
	if(strcmp(ERR, "These elements was not copied: ") != 0) {
		clearDnD();
		dndErr("Error", ERR);
		return;
	}
	
	clearDnD();
}

void mfinderapp::dndErr(char *title, char *error)
{
	dialog = new Dialog(0L, title, TRUE, 0, TRUE, TRUE, FALSE, TRUE, error);
	int m = dialog->exec();
}

void mfinderapp::UpdateDnDWin(int winNum, char *objName)
{
	FWin[winNum]->objsframe->makeFileObj(objName);
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(dragattempt(char*, char*, int, int)), this, SLOT(PrepDrag(char *, char *, int, int)));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(mousemove()), this, SLOT(DnD()));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(dragdone(bool)), this, SLOT(dndDone(bool)));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(openfile(char*)), this, SLOT(ExecComm(char *)));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(openfile(char*, char*)), this, SLOT(ExecComm(char *, char *)));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(renameme()), this, SLOT(RenameObj()));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(editme()), this, SLOT(Edit()));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(openmewith()), this, SLOT(OpenWith()));
	connect(FWin[winNum]->objsframe->filobj[FWin[winNum]->objsframe->FileCount-1],
		SIGNAL(deleteme()), this, SLOT(DelObj()));
}

void mfinderapp::UpdateDelDnDObj(int winNum, char *objName)
{
	for(int i = 0; i < FWin[winNum]->objsframe->FileCount; i++) {
		if(strcmp(objName, FWin[winNum]->objsframe->filobj[i]->name) == 0) {
			if(FWin[winNum]->objsframe->filobj[i]->isOpen) {
				for(int k = 0; k < WinCount; k++) {
					if(FWin[k] != NULL) {
						if(FWin[k]->isVisible()) {
							if(strcmp(FWin[k]->objOpen, FWin[winNum]->objsframe->filobj[i]->name) == 0)
								FWin[k]->close();
						}
					}
				}
			}
			FWin[winNum]->objsframe->filobj[i]->close();
		}
	}	
}

void mfinderapp::clearDnD()
{
	if(srclst != NULL)
		delete[] srclst;
	if(srclstnames != NULL)
		delete[] srclstnames;
	if(dstdirlstnames != NULL)
		delete[] dstdirlstnames;
	sprintf(DndTargetPath, "");
	sprintf(DndSourcePath, "");
	DndDataCount = 0;
	ObDeskMoving = FALSE;
	dskobdragid = -1;
	isDnDtarget = FALSE;
	offdndtype = -1;
}

// ---------------- Execute ---------------------------------------
void mfinderapp::ExecComm(char *cmdline)
{
	char cmd[1024] = "";
	char **argv = new char*[20];
	char *delims = " ";
	pid_t pid;
	
	strncpy(cmd, cmdline, 1024);
	char *token = strtok(cmd, delims);
	int argc = 0;
	argv[argc] = token;
	while(token != NULL && argc < 20) {
		argc++;
		token = strtok(NULL, delims);
		argv[argc] = token;
	}	
	argv[argc] = (char *)0;
	
	if ((pid = fork()) < 0) {
		perror("fork");
	} else {
		if(pid == 0) {
			freopen("/dev/null", "r", stdin);
			execvp(argv[0], argv);
			exit(1);
		} else {
			sleep(1);
   		delete []argv;
			chdir(user.home);
    	}
	}
}

void mfinderapp::ExecComm(char *cmdline, char *arg)
{
	char cmd[1024] = "";
	char **argv = new char*[21];
	char *delims = " ";
	pid_t pid;
	
	strncpy(cmd, cmdline, 1024);
	char *token = strtok(cmd, delims);
	int argc = 0;
	argv[argc] = token;
	while(token != NULL && argc < 20) {
		argc++;
		token = strtok(NULL, delims);
		argv[argc] = token;
	}
	if (arg)
		argv[argc++] = arg;
	argv[argc] = (char *)0;
	
	if ((pid = fork()) < 0) {
		perror("fork");
	} else {
		if(pid == 0) {
			freopen("/dev/null", "r", stdin);
			execvp(argv[0], argv);
			exit(1);
		} else {
			sleep(1);
			delete []argv;
 			chdir(user.home);
     	}
 	}
}

void mfinderapp::Edit()
{
	char cmdline[256] = "";
	int nwin;
	
	nwin = -1;
	for(int i = 0; i < WinCount; i++)
		for(int j = 0; j < FWin[i]->objsframe->FileCount; j++)
			if(FWin[i]->objsframe->filobj[j]->isSelect)
				nwin = i;

	if(nwin >= 0) {
		for(int j = 0; j < FWin[nwin]->objsframe->FileCount; j++) {
			if(FWin[nwin]->objsframe->filobj[j]->isSelect) {
				if(FWin[nwin]->objsframe->filobj[j]->type != DR && 
					FWin[nwin]->objsframe->filobj[j]->type != DRLNK && 
					FWin[nwin]->objsframe->filobj[j]->type != FILLNK && 
					FWin[nwin]->objsframe->filobj[j]->type != FILEXELNK) {

					if(strcmp(FWin[nwin]->name, "/") != 0)
						sprintf(cmdline, "%s/%s", FWin[nwin]->name,
											FWin[nwin]->objsframe->filobj[j]->name);
					else
						sprintf(cmdline, "%s%s", FWin[nwin]->name,
											FWin[nwin]->objsframe->filobj[j]->name);

					ExecComm(Editor, cmdline);
				}	
			}
		}
	}
}

void mfinderapp::OpenWith()
{
	char cmdline[256] = "";
	bool istarget = FALSE;
	char IcName[128] = "";
	int wnum = 0;
	
	for(int i = 0; i < WinCount; i++) {
		for(int j = 0; j < FWin[i]->objsframe->FileCount; j++) {
			if(FWin[i]->objsframe->filobj[j]->isSelect) {
				if(FWin[i]->objsframe->filobj[j]->type != DR && 
					FWin[i]->objsframe->filobj[j]->type != DRLNK && 
					FWin[i]->objsframe->filobj[j]->type != FILLNK && 
					FWin[i]->objsframe->filobj[j]->type != FILEXELNK) {

					wnum = i;
					istarget = TRUE;
				}
			}
		}
	}
	if(istarget) {
		dialog = new Dialog(0L, "Open With...", TRUE, 0, TRUE, FALSE, TRUE, TRUE, " ");
		if(dialog->exec()) {
			for(int j = 0; j < FWin[wnum]->objsframe->FileCount; j++) {
				if(FWin[wnum]->objsframe->filobj[j]->isSelect) {
					if(FWin[wnum]->objsframe->filobj[j]->type != DR && 
						FWin[wnum]->objsframe->filobj[j]->type != DRLNK && 
						FWin[wnum]->objsframe->filobj[j]->type != FILLNK && 
						FWin[wnum]->objsframe->filobj[j]->type != FILEXELNK) {

							char *cmd = strdup(dialog->editfield->text());
							char *arg = strdup(FWin[wnum]->objsframe->filobj[j]->myPath);
							ExecComm(cmd, arg);
							free(cmd);
							free(arg);
					}	
				}
			}
		}
	}
}

void mfinderapp::StartXTerm()
{
	for(int i = 0; i < WinCount; i++) {
		if(FWin[i]->hasFocus())	
			chdir(FWin[i]->name);	
	}
	ExecComm(Xterm);
	chdir(user.home);	
}
