#include <iostream.h>
#include "mfinderapp.h"
#include <qwindefs.h>
#include <qpushbt.h>
#include <qpoint.h> 
#include <qevent.h> 

ProgInfo prInfo[100];
int prInfoNum;
int objdragtype;

char Editor[64] = "";
char Xterm[255] = "";
bool hide_dot_files = TRUE;

char IconPath[512] = "";
IconData *IData[200];
int IDataNum;
FolderIconData *IFoldData, *IFoldLinkData;

mfinderapp::mfinderapp(int& argc, char** argv, const char *n, 
		       const unsigned char* icondata)
    		  : nextapp(argc, argv, n, icondata)
{
	char *delims = ":";
	char *token;
	char line[1024] = "";
	char fPath[MAX_PATH_LEN] = "";
	char buff[MAX_PATH_LEN] = "";
	char buf1[MAX_PATH_LEN] = "";
	char buf2[64] = "";
	int dox, doy;
	bool found = FALSE;
	bool domask;
	FILE *fConf;
	struct stat st;
	QImage pixmask;
	
	setStyle(WindowsStyle);
	setWinStyleHighlightColor(QColor(80, 80, 80));
	
	strscrn = new StrtScrn(0L, "ss");
	addWidget(strscrn);
	strscrn->setGeometry((desktop()->width() - strscrn->width()) / 2, 
					  			(desktop()->height() - strscrn->height()) / 2,
					  			 380, 240);
	strscrn->show();
	
	user.uid = getuid();
  	user.gid = getgid();
  	user.name = getenv("USER");
	strcpy(user.home, getenv("HOME"));
	strcpy(user.shell, "/bin/sh");
	if(gethostname(user.hostname, 128 - 1) == EINVAL)
      strcpy(user.hostname, "localhost");
  	user.umask = umask(0);
  	umask(user.umask);
  	user.umask = 0777777 ^ user.umask;

	dspl = desktop()->x11Display();
	DndProtocol = XInternAtom(dspl, "DndProtocol", FALSE);
	DndSelection = XInternAtom(dspl, "DndSelection", FALSE);

	chdir(user.home);
   
	DndIcnCount = 0;
	DndDataCount = 0;
	isDnDtarget = FALSE;
	WinCount = 0;
	dskobnum = 0;
	dskobdragid = -1;
	IDataNum = 0;
	prInfoNum = 0;
	WGeomCount = 0;
	isDnDtarget = FALSE;
	ObDeskMoving = FALSE;
	offdndtype = -1;
   DndSourcePath = new char[512];
   DndTargetPath = new char[512];

	realize_menus();

// --- ICONS ---	
	strscrn->statusfield->setText("reading icons...");	
	strscrn->update();

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/iconspath", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s/GNUstep/Library/WMFinder/Pixmaps", getenv("HOME"));
		fclose(fConf);
	}	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s", IconPath);
	fclose(fConf);
	
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfileicons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFileIcnsProvv);
		fclose(fConf);
	}	
	IData[0] = new IconData; 
	IData[1] = new IconData;
	IData[2] = new IconData;
	IData[3] = new IconData;
	IDataNum = 4;	
	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s%s%s%s", IData[0]->IcnName, IData[1]->IcnName, 
										IData[2]->IcnName, IData[3]->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/filetypes", getenv("HOME"));
	if(stat(fPath, &st)) {
		sprintf(buff, "%s/GNUstep/Library/WMFinder/Pixmaps", getenv("HOME"));
		fConf = fopen(fPath, "w");
		if(strcmp(IconPath, buff) == 0)
			fprintf(fConf, "%s", IcnsProvv);
		else
			fprintf(fConf, "\n");
		fclose(fConf);
	}	
	fConf = fopen(fPath, "r");
	while(fscanf(fConf, "%s", line) != EOF) {
		IData[IDataNum] = new IconData;
		token = strtok(line, delims);
		sprintf(IData[IDataNum]->pref, "%s", token);
		token = strtok(NULL, delims);
		sprintf(IData[IDataNum]->suff, "%s", token);
		token = strtok(NULL, delims);
		sprintf(IData[IDataNum]->IcnName, "%s", token);
		strscrn->explfield->setText(token);	
		strscrn->update();
		IDataNum++;
	}
	strscrn->explfield->setText(" ");	
	strscrn->update();	
	fclose(fConf);	
	
	strscrn->statusfield->setText("tuning icon colors...");	
	strscrn->update();	
	for(int i = 0; i < IDataNum; i++) {
		strscrn->explfield->setText(IData[i]->IcnName);	
		strscrn->update();
		sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
		
		if(i == 0) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR,
				FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 1) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic executable file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR,
				FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 2) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic linked file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR,
				FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 3) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic linked executable
				file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR,
				FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the file type
%s  %s   is missing in your courrent icons path:
You can choose it now from this list or,
later, from the Special-Configure-Icons Menu\n", 
IData[i]->pref, IData[i]->suff);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR,
				TRUE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}	
		}
				
		IData[i]->Icn = QImage(fPath, "XPM");
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		domask = TRUE;
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			QRgb pix = IData[i]->Icn.pixel(h, 0);
			int red = qRed(pix);
			int green = qGreen(pix);		
			int blue = qBlue(pix);
			if(red < 5 && green < 5 && blue < 5)
				domask = FALSE;
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->Icona = QPixmap();
		IData[i]->Icona.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->Icona.setMask(IData[i]->Icona.createHeuristicMask());
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		pixmask = IData[i]->Icn.createHeuristicMask();
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			for(int j = 0; j < IData[i]->Icn.height(); j++) {
				QRgb pix = IData[i]->Icn.pixel(h, j);
				if(qRed(pixmask.pixel(h, j)) == 0) {
					int red = qRed(pix);
					int green = qGreen(pix);		
					int blue = qBlue(pix);
					if(red > 0) red = (int)(red/2);
					if(green > 0) green = (int)(green/2);
					if(blue > 0) blue = (int)(blue/2);
					IData[i]->Icn.setPixel(h, j, qRgb(red, green, blue));
				}
			}
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->IconaSel = QPixmap();
		IData[i]->IconaSel.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->IconaSel.setMask(IData[i]->Icona.createHeuristicMask());
	}
	strscrn->explfield->setText(" ");	
	strscrn->update();

						        /* -- ICON DR -- */
	strscrn->statusfield->setText("reading dir icons...");	
	strscrn->update();
						        
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfoldericons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFolderIcnsProvv);
		fclose(fConf);
	}	
	IFoldData = new FolderIconData; 
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s", IFoldData->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/%s", IconPath, IFoldData->IcnName);
	if(stat(fPath, &st)) {
		sprintf(ERR, "The required icon for the directory
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
		chanicndlg = new ChooseAnIcnDlg(0L, 0L, IFoldData->IcnName, ERR, FALSE);
		if(chanicndlg->exec()) {
			sprintf(IFoldData->IcnName, "%s", chanicndlg->namIcnEd->text());
			sprintf(fPath, "%s/%s", IconPath, IFoldData->IcnName);
		}
	}
	
	IFoldData->Icn = QImage(fPath, "XPM");
	
	IFoldData->Icona = QPixmap();
	IFoldData->Icona.convertFromImage(IFoldData->Icn);
	IFoldData->Icona.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	pixmask = IFoldData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSel = QPixmap();
	IFoldData->IconaSel.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSel.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaOpen = QPixmap();
	IFoldData->IconaOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaOpen.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);	
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSelOpen = QPixmap();
	IFoldData->IconaSelOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSelOpen.setMask(IFoldData->Icona.createHeuristicMask());

							    /* -- ICON DRLNK -- */

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfoldericons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFolderIcnsProvv);
		fclose(fConf);
	}	
	IFoldLinkData = new FolderIconData;	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s%s", IFoldLinkData->IcnName, IFoldLinkData->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/%s", IconPath,IFoldLinkData->IcnName);
	if(stat(fPath, &st)) {
		sprintf(ERR, "The required icon for the linked directory
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
		chanicndlg = new ChooseAnIcnDlg(0L, 0L, IFoldLinkData->IcnName, ERR,
		FALSE);
		if(chanicndlg->exec()) {
			sprintf(IFoldLinkData->IcnName, "%s", chanicndlg->namIcnEd->text());
			sprintf(fPath, "%s/%s", IconPath, IFoldLinkData->IcnName);
		}
	}
	
	IFoldLinkData->Icn = QImage(fPath, "XPM");
	
	IFoldLinkData->Icona = QPixmap();
	IFoldLinkData->Icona.convertFromImage(IFoldLinkData->Icn);
	IFoldLinkData->Icona.setMask(IFoldLinkData->Icona.createHeuristicMask());

	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	pixmask = IFoldLinkData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSel = QPixmap();
	IFoldLinkData->IconaSel.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSel.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaOpen = QPixmap();
	IFoldLinkData->IconaOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);		
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSelOpen = QPixmap();
	IFoldLinkData->IconaSelOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSelOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());


// --- PROGRAMS ---	
	strscrn->statusfield->setText("looking for programs...");	
	strscrn->update();
	
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/programs", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ProgsProvv);
		fclose(fConf);
	}
	fConf = fopen(fPath, "r");
	while(fgets(line, 1024, fConf) != NULL) {
		int n = strlen(line);
		if(line[n-1] == '\n')
			line[n-1] = 0;
		token = strtok(line, delims);
		sprintf(prInfo[prInfoNum].pref, "%s", token);
		token = strtok(NULL, delims);
		sprintf(prInfo[prInfoNum].suff, "%s", token);
		token = strtok(NULL, delims);
		sprintf(prInfo[prInfoNum].ProgName, "%s", token);
		prInfoNum++;
	}
	fclose(fConf);		

// --- TEXT EDITOR ---
	strscrn->statusfield->setText("setting up the text editor...");	
	strscrn->statusfield->update();

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/editor", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", defEditProvv);
		fclose(fConf);
	}	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s", Editor);
	fclose(fConf);		

// --- XTERM ---
	strscrn->statusfield->setText("setting up xterm...");	
	strscrn->update();
		
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/xterm", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", xtermProvv);
		fclose(fConf);
	}	
	fConf = fopen(fPath, "rb");
	fread(Xterm, sizeof(Xterm), 1, fConf);
	fclose(fConf);		

// --- WINDOWS GEOMETRY ---
	strscrn->statusfield->setText("reading windows geometry...");	
	strscrn->update();
	
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/winsgeom", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "/:150:30:400:300:0:0\n");
		fclose(fConf);
	}
	fConf = fopen(fPath, "r");
	while(fgets(line, 1024, fConf) != NULL) {
		int n = strlen(line);
		if(line[n-1] == '\n')
			line[n-1] = 0;
		WGeom[WGeomCount] = new WinGeom;
		token = strtok(line, delims);
		sprintf(WGeom[WGeomCount]->wname, "%s", token);
		token = strtok(NULL, delims);
		WGeom[WGeomCount]->wx = atoi(token);
		token = strtok(NULL, delims);		
		WGeom[WGeomCount]->wy = atoi(token);
		token = strtok(NULL, delims);
		WGeom[WGeomCount]->ww = atoi(token);
		token = strtok(NULL, delims);
		WGeom[WGeomCount]->wh = atoi(token);
		token = strtok(NULL, delims);
		WGeom[WGeomCount]->dirfirst = atoi(token);
		token = strtok(NULL, delims);
		WGeom[WGeomCount]->dotfiles = atoi(token);
		WGeomCount++;
	}
	fclose(fConf);		

	strscrn->close();

// ------------- INITIALIZING --------------	
// ----- INIT WINDOWS -------
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/windows", getenv("HOME"));
	if(stat(fPath, &st)) {
		sprintf(buf1, "%s", getenv("HOME"));
		DirOpen(buf1, "", FALSE, -1);
	} else {
		fConf = fopen(fPath, "r");
		while(fgets(buf1, MAX_PATH_LEN, fConf) != NULL) {
			int n = strlen(buf1);
			if (buf1[n-1] == '\n')
				buf1[n-1] = 0;
			if(!stat(buf1, &st)) {
				DirOpen(buf1, "", FALSE, -1);
				found = TRUE;
			}
		}
		fclose(fConf);
		if(!found) {
			sprintf(buf1, "%s", getenv("HOME"));
			DirOpen(buf1, "", FALSE, -1);
		}
	}
	
// ----- INIT DESK OBJS -------
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/deskobjs", getenv("HOME"));
	if(!stat(fPath, &st)) {
		fConf = fopen(fPath, "r");
		while(fscanf(fConf, "%s", buf1) != EOF) {
			fscanf(fConf, "%s%i%i", buf2, &dox, &doy);
			if(!stat(buf1, &st)) {
				makeDeskObjFromFile(buf1, buf2, dox, doy);
			}
		}
		fclose(fConf);
	}

}

void mfinderapp::setTopWinByName(char *n)
{
	for(int i = 0; i < WinCount; i++) {
		if(strcmp(FWin[i]->name, n) == 0) {
			FWin[i]->raise();
			FWin[i]->setActiveWindow();
		}
	}
}

void mfinderapp::ReCountWins(int WclosedId)
{

}

//-------------------------------------------------------------------------
//                               slots
//-------------------------------------------------------------------------
void mfinderapp::DirOpen(char *namewin, char *namefile,
										bool closeParent, int ObjWinRef)
{
	char dir[256] = "";
	struct dirent **namelist;
	struct stat listStat;
	int m, a, i;
	bool NewWin;
	bool found = FALSE;
	
	this->closeParent = closeParent;
	NewWin = TRUE;
	
	if(ObjWinRef >= 0) {
		if(strcmp(namewin, "/") == 0)
			sprintf(dir,"%s%s", namewin, namefile);
		else
			sprintf(dir,"%s/%s", namewin, namefile);
	} else {
		sprintf(dir,"%s", namewin);
	}
	
	for(int j = 0; j < WinCount; j++) {
		if(strcmp(FWin[j]->name, dir) == 0) {
			if(FWin[j]->isVisible()) {
				setTopWinByName(dir);
				
				if(ObjWinRef != -1) {
					for(int n = 0; n < FWin[ObjWinRef]->objsframe->FileCount; n++) {
						if(strcmp(FWin[ObjWinRef]->objsframe->filobj[n]->name, namefile) == 0) {
							FWin[ObjWinRef]->objsframe->filobj[n]->isOpen = TRUE;
							FWin[ObjWinRef]->objsframe->filobj[n]->isSelect = TRUE;
							FWin[ObjWinRef]->objsframe->filobj[n]->isOpenUnsl = FALSE;
							FWin[ObjWinRef]->objsframe->filobj[n]->Label->select();
							FWin[ObjWinRef]->objsframe->filobj[n]->update();
						}			
					}
				}
				
				NewWin = FALSE;
			}
		}
	} 
	if(NewWin) {
		setOverrideCursor(waitCursor);
		FWin[WinCount] = new MFinderWin(0L, dir, namefile, WinCount);
		connect(FWin[WinCount], SIGNAL(clickonwin(char *, int, bool)),
				this, SLOT(SelObjFatherOfWin(char *, int, bool)));
		connect(FWin[WinCount], SIGNAL(newfolder()), this, SLOT(NewFolder()));
		connect(FWin[WinCount], SIGNAL(newfile()), this, SLOT(NewFile()));
		connect(FWin[WinCount], SIGNAL(deleteobj()), this, SLOT(DelObj()));
		connect(FWin[WinCount], SIGNAL(renameobj()), this, SLOT(RenameObj()));
		connect(FWin[WinCount], SIGNAL(infoobj()), this, SLOT(InfoObj()));
		connect(FWin[WinCount], SIGNAL(edit()), this, SLOT(Edit()));
		connect(FWin[WinCount], SIGNAL(startxterm()), this, SLOT(StartXTerm()));
		connect(FWin[WinCount], SIGNAL(update(int)), this, SLOT(UpdateAWin(int)));
		connect(FWin[WinCount], SIGNAL(savewin(int)), this, SLOT(SaveWin(int)));
		connect(FWin[WinCount], SIGNAL(quitapp()), this, SLOT(quit()));
		connect(FWin[WinCount]->objsframe, SIGNAL(clickonwin(char *, int, bool)),
				this, SLOT(SelObjFatherOfWin(char *, int, bool)));
		connect(FWin[WinCount]->objsframe, SIGNAL(UnselObjsOfOtherWin(int)),
				this, SLOT(UnselObjsOfWins(int)));

  		m = scandir(dir, &namelist, 0, alphasort);
  		if(m < 0) perror("scandir");
  		else 
			for(a = 0; a <= m - 1; a++)
				FWin[WinCount]->objsframe->makeFileObj(namelist[a]->d_name);

		connect(FWin[WinCount]->objsframe, 
				SIGNAL(openattempt(char*, char*, bool, int)),
				this, SLOT(DirOpen(char *, char *, bool, int)));
		connect(FWin[WinCount]->objsframe, 
				SIGNAL(menuopen(char*, char*, bool, int)),
				this, SLOT(DirOpen(char *, char *, bool, int)));

		for(int j = 0; j < FWin[WinCount]->objsframe->FileCount; j++) {
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(dragattempt(char*, char*, int, int)),
				this, SLOT(PrepDrag(char *, char *, int, int)));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(mousemove()), this, SLOT(DnD()));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(dragdone(bool)), this, SLOT(dndDone(bool)));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(openfile(char*)), this, SLOT(ExecComm(char *)));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(openfile(char*, char*)), this, SLOT(ExecComm(char *, char*)));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(renameme()), this, SLOT(RenameObj()));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(editme()), this, SLOT(Edit()));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(openmewith()), this, SLOT(OpenWith()));
			connect(FWin[WinCount]->objsframe->filobj[j],
				SIGNAL(deleteme()), this, SLOT(DelObj()));
		}
		
		for(int j = 0; j < WGeomCount; j++) {
			if(strcmp(FWin[WinCount]->name, WGeom[j]->wname) == 0) {
				FWin[WinCount]->setGeometry(WGeom[j]->wx, WGeom[j]->wy, WGeom[j]->ww, WGeom[j]->wh);
				FWin[WinCount]->objsframe->dirfirst = WGeom[j]->dirfirst;
				FWin[WinCount]->objsframe->dotfiles = WGeom[j]->dotfiles;
				found = TRUE;
				break;
			}
		}
		if(!found) {
			FWin[WinCount]->setGeometry(150, 30, 400, 300);
			FWin[WinCount]->objsframe->dirfirst = 0;
		}

		addWidget(FWin[WinCount]);
		FWin[WinCount]->show();
		FWin[WinCount]->objsframe->SortObjs();
		UpdateAWin(WinCount);
		restoreOverrideCursor();
				
		WinCount++;
	}
	if(closeParent) {
		for(int j = 0; j < WinCount; j++) {
			if(FWin[j]->id == ObjWinRef) {
				FWin[j]->close();
				ReCountWins(FWin[j]->id);
				break;
			}
		}
	}	

	this->closeParent = FALSE;
	
	if(ObjWinRef != -1) {
		for(int n = 0; n < FWin[ObjWinRef]->objsframe->FileCount; n++) {
			if(strcmp(FWin[ObjWinRef]->objsframe->filobj[n]->name, namefile) == 0) {
				FWin[ObjWinRef]->objsframe->filobj[n]->isOpen = TRUE;
				FWin[ObjWinRef]->objsframe->filobj[n]->isSelect = TRUE;
				FWin[ObjWinRef]->objsframe->filobj[n]->isOpenUnsl = FALSE;
				FWin[ObjWinRef]->objsframe->filobj[n]->Label->select();
				FWin[ObjWinRef]->objsframe->filobj[n]->update();
			}			
		}
	} 
	for(int j = 0; j < dskobnum; j++) {
		if(deskobj[j] != NULL) {
			if(strcmp(deskobj[j]->path, dir) == 0) {
				deskobj[j]->SelOpen();
			}
		}
	}
}

void mfinderapp::HideDots()
{
	hide_dot_files = (!hide_dot_files) ? TRUE : FALSE;
	UpdateWins();
}

void mfinderapp::SelObjFatherOfWin(char *WinName, int IdWinClose, bool wclose)
{
	char wname[256] = "";
	char PathObj[256] = "";
	char namObj[64] = "";
	int m = 0, j = 0;
	bool scan = TRUE;
	
	sprintf(wname, "%s", WinName);
	for(int i = 0; i < strlen(wname); i++)
		if(wname[i] == '/') m++;
	for(int i = 0; i < strlen(wname); i++) {
		if(wname[i] == '/') {
			j++;
			if(i == 0 && j == m) {
				sprintf(PathObj, "/");
				wname[i] = ' ';
				sscanf(wname, "%s", namObj);
				scan = FALSE;
				break;
			}
			if(i != 0 && j == m) {
				wname[i] = ' ';
			}
		}
	}
	if(scan) sscanf(wname, "%s%s", PathObj, namObj);

	for(m = 0; m < WinCount; m++) {
		if(FWin[m] != NULL) {
			if(FWin[m]->isVisible()) {
				if(strcmp(FWin[m]->name, PathObj) == 0) {
					for(j = 0; j < FWin[m]->objsframe->FileCount; j++) {
						if(strcmp(FWin[m]->objsframe->filobj[j]->name, namObj) == 0) {
							if(wclose) FWin[m]->objsframe->filobj[j]->Close();
							else FWin[m]->objsframe->filobj[j]->SelOpen();
							break;
						}
					}
				}
			}
		}
	}	
	for(m = 0; m < WinCount; m++) {
		if(FWin[m] != NULL) {
			if(FWin[m]->isVisible()) {
				if(strcmp(FWin[m]->name, PathObj) != 0) {
					for(j = 0; j < FWin[m]->objsframe->FileCount; j++) {
						if(FWin[m]->objsframe->filobj[j]->isSelect && FWin[m]->objsframe->filobj[j]->isOpen == FALSE)
							FWin[m]->objsframe->filobj[j]->Unselect();
						if(FWin[m]->objsframe->filobj[j]->isSelect && FWin[m]->objsframe->filobj[j]->isOpen)
							FWin[m]->objsframe->filobj[j]->UnselOpen();
					}
				}
			}
		}
	}
	
	for(int i = 0; i < dskobnum; i++) {
		if(deskobj[i] != NULL) {
			if(deskobj[i]->isVisible()) {
				if(strcmp(deskobj[i]->path, WinName) == 0) {
					if(wclose) 
						deskobj[i]->Close();
					else 
						deskobj[i]->SelOpen();
				} else {
					if(deskobj[i]->isSelect && deskobj[i]->isOpen == FALSE)
						deskobj[i]->Unselect();
					if(deskobj[i]->isSelect && deskobj[i]->isOpen)
						deskobj[i]->UnselOpen();
				}
			}
		}
	}	
	
	if(wclose)
		ReCountWins(IdWinClose);
}

void mfinderapp::UnselObjsOfWins(int wId)
{
	for(int m = 0; m < WinCount; m++) {
		if(FWin[m]->id != wId) {
			for(int j = 0; j < FWin[m]->objsframe->FileCount; j++) {
				if(FWin[m]->objsframe->filobj[j]->isSelect && FWin[m]->objsframe->filobj[j]->isOpen == FALSE)
					FWin[m]->objsframe->filobj[j]->Unselect();
				if(FWin[m]->objsframe->filobj[j]->isSelect && FWin[m]->objsframe->filobj[j]->isOpen == TRUE)
					FWin[m]->objsframe->filobj[j]->UnselOpen();
			}
		}
	}
	for(int i = 0; i < dskobnum; i++) {
		if(deskobj[i] != NULL) {
			if(deskobj[i]->id != dskobdragid) {
				if(deskobj[i]->isSelect && ! deskobj[i]->isOpen)
					deskobj[i]->Unselect();
				if(deskobj[i]->isSelect && deskobj[i]->isOpen)
					deskobj[i]->UnselOpen();
			}
		}
	}
}

//----------------------------- DnD -----------------------------------
void mfinderapp::PrepDrag(char *name, char *ParentName, int idLocal, int idParent)
{
	struct dirent **namelist;
	int m, pixWidth, labWidth, pixX, labX;
	QPixmap labPix;
	QPainter pnt;
	DndDataCount = 0;
	isDnDtarget = FALSE;
	offdndtype = -1;

	sprintf(DndSourcePath, "%s", ParentName);
	m = scandir(DndSourcePath, &namelist, 0, alphasort);
	srclst = new char*[m];
	srclstnames = new char*[m];

	for(int i = 0; i < WinCount; i++)
		FWin[i]->objsframe->isShiftClick = FALSE;
	
	pixWidth = FWin[idParent]->objsframe->filobj[idLocal]->Icona.width();
	labPix = QPixmap::grabWindow(FWin[idParent]->objsframe->filobj[idLocal]->Label->winId());
	labWidth = labPix.width();
	if(pixWidth >= labWidth) {
		IcnDrg = QPixmap(pixWidth, 65);
		pixX = 0;
		labX = (pixWidth - labWidth)/2;
	} else {	
		IcnDrg = QPixmap(labWidth, 65);
		labX = 0;
		pixX = (labWidth - pixWidth)/2;
	}
	pnt.begin(&IcnDrg);
	pnt.fillRect(IcnDrg.rect(), white);
	pnt.drawPixmap(pixX, 0, FWin[idParent]->objsframe->filobj[idLocal]->Icona);
	pnt.drawPixmap(labX, 50, labPix);
	pnt.end();
	
	dndicon[DndIcnCount] = new DnDIcon(IcnDrg); 

	objdragtype = FWin[idParent]->objsframe->filobj[idLocal]->type;
	
	srclst[DndDataCount] = new char[strlen(FWin[idParent]->objsframe->filobj[idLocal]->myPath)+1];
	strcpy(srclst[DndDataCount], FWin[idParent]->objsframe->filobj[idLocal]->myPath);
	srclstnames[DndDataCount] = new char[strlen(FWin[idParent]->objsframe->filobj[idLocal]->name)+1];
	strcpy(srclstnames[DndDataCount], FWin[idParent]->objsframe->filobj[idLocal]->name);

	DndDataCount++;
	
	QPoint ObjPos = FWin[idParent]->objsframe->filobj[idLocal]->pos();
	
	int MainObjX = ObjPos.x();
	int MainObjY = ObjPos.y();

	dndicon[DndIcnCount]->xOffset = 0; // aggiungere l'offset rispetto al mouse
	dndicon[DndIcnCount]->yOffset = 0;

	DndIcnCount++;

	for(int i = 0; i < FWin[idParent]->objsframe->FileCount; i++) {
		if(FWin[idParent]->objsframe->filobj[i]->isSelect) {
			if(FWin[idParent]->objsframe->filobj[i]->idLocal != idLocal) {

				pixWidth = FWin[idParent]->objsframe->filobj[i]->Icona.width();
				labPix = QPixmap::grabWindow(FWin[idParent]->objsframe->filobj[i]->Label->winId());
				labWidth = labPix.width();
				if(pixWidth >= labWidth) {
					IcnDrg = QPixmap(pixWidth, 65);
					pixX = 0;
					labX = (pixWidth - labWidth)/2;
				} else {	
					IcnDrg = QPixmap(labWidth, 65);
					labX = 0;
					pixX = (labWidth - pixWidth)/2;
				}
				pnt.begin(&IcnDrg);
				pnt.fillRect(IcnDrg.rect(), white);
				pnt.drawPixmap(pixX, 0, FWin[idParent]->objsframe->filobj[i]->Icona);
				pnt.drawPixmap(labX, 50, labPix);
				pnt.end();

				dndicon[DndIcnCount] = new DnDIcon(IcnDrg);

				srclst[DndDataCount] = new char[strlen(FWin[idParent]->objsframe->filobj[i]->myPath)+1];
				strcpy(srclst[DndDataCount], FWin[idParent]->objsframe->filobj[i]->myPath);
				srclstnames[DndDataCount] = new char[strlen(FWin[idParent]->objsframe->filobj[i]->name)+1];
				strcpy(srclstnames[DndDataCount], FWin[idParent]->objsframe->filobj[i]->name);

				DndDataCount++;
				
				ObjPos = FWin[idParent]->objsframe->filobj[i]->pos();	
				int ObjX = ObjPos.x();
				int ObjY = ObjPos.y();

				dndicon[DndIcnCount]->xOffset = ObjX - MainObjX;
				dndicon[DndIcnCount]->yOffset = ObjY - MainObjY;

				DndIcnCount++;
			}
		}
	}
	for(int i = 0; i < FWin[idParent]->objsframe->FileCount; i++) {
		if(FWin[idParent]->objsframe->filobj[i]->isSelect) {
			if(FWin[idParent]->objsframe->filobj[i]->isOpen)
				FWin[idParent]->objsframe->filobj[i]->UnselOpen();
			else
				FWin[idParent]->objsframe->filobj[i]->Unselect();
		}
	}

	offdndtype = FWin[idParent]->objsframe->filobj[idLocal]->type;
}

void mfinderapp::DnD()
{
	p = QCursor::pos();
	
	for(int i = 0; i < DndIcnCount; i++)
		dndicon[i]->move(p.x() + dndicon[i]->xOffset, p.y() + dndicon[i]->yOffset);

	Objtmp = widgetAt(p, TRUE);
	if(Objtmp != 0L) {
		if(ObjAt != Objtmp) {
			if(ObjAt != 0L) {
				if(ObjAt->inherits("FileObj")) {
					FileObj *target = (FileObj*)ObjAt;
					target->DragLeave();
				}
				if(ObjAt->inherits("ObjsFrame")) {
					ObjsFrame *target = (ObjsFrame*)ObjAt;
					target->DragLeave();
				}
				if(ObjAt->inherits("DeskObj")) {
					DeskObj *target = (DeskObj*)ObjAt;				
					target->DragLeave();
				}
			}
			ObjAt = Objtmp;
			if(ObjAt->inherits("FileObj")) {
				FileObj *target = (FileObj*)ObjAt;
				target->DragMove();
			}
			if(ObjAt->inherits("ObjsFrame")) {
				ObjsFrame *target = (ObjsFrame*)ObjAt;
				target->DragMove();
			}
			if(ObjAt->inherits("DeskObj")) {
				DeskObj *target = (DeskObj*)ObjAt;				
				target->DragMove();
			}
		}
	} else {
		if(ObjAt != 0L) {
			if(ObjAt->inherits("FileObj")) {
				FileObj *target = (FileObj*)ObjAt;
				target->DragLeave();
			}
			if(ObjAt->inherits("ObjsFrame")) {
				ObjsFrame *target = (ObjsFrame*)ObjAt;
				target->DragLeave();
			}
			if(ObjAt->inherits("DeskObj")) {
				DeskObj *target = (DeskObj*)ObjAt;	
				target->DragLeave();
			}			
			ObjAt = 0L;
		}
	}
}	

//----------------------------- Menus --------------------------------

void mfinderapp::realize_menus()
{
#ifdef MACMENU

	macmenubar = new MacMenuBar(0L, 0L);
	macmenubar->setGeometry(0, 0, desktop()->width(), 20);
	macmenubar->show();
	macmenubar->lower();
	
#else
	
	fileMenu = add_submenu(main_menu(), "File");
	   add_item(fileMenu, "Open  ^O", this, SLOT(OpenObjfromMenu()));
	   add_item(fileMenu, "Close  ^W", this, SLOT(CloseWinfromMenu()));
	   add_item(fileMenu, "New Folder ^N", this, SLOT(NewFolder()));
	   add_item(fileMenu, "New File ^M", this, SLOT(NewFile()));
	   add_item(fileMenu, "Rename ^R", this, SLOT(RenameObj()));
	   add_item(fileMenu, "Info ^I", this, SLOT(InfoObj()));
	   add_item(fileMenu, "Edit ^E", this, SLOT(Edit()));
	   add_item(fileMenu, "Open  With...", this, SLOT(OpenWith()));
	   add_item(fileMenu, "Delete ^D", this, SLOT(DelObj()));
   
	editMenu = add_submenu(main_menu(), "Edit");
	   add_item(editMenu, "Select All ^A", this, SLOT(SelectAllObjfromMenu()));
	   add_item(editMenu, "Start xterm ^T", this, SLOT(StartXTerm()));
		add_item(editMenu, "Show Clipboard");

	viewMenu = add_submenu(main_menu(), "View");
   	add_item(viewMenu, "Update Windows ^U", this, SLOT(UpdateWins()));
   	add_item(viewMenu, "Normal Sort", this, SLOT(NoDirFirst()));
   	add_item(viewMenu, "Dir First Sort", this, SLOT(DirFirst()));
   	add_item(viewMenu, "Show/Hide Dot Files", this, SLOT(HideDots()));
   
	specialMenu = add_submenu(main_menu(), "Special");
   	confMenu = add_submenu(specialMenu, "Configure");
   		add_item(confMenu, "Icons", this, SLOT(ConfIcn()));
   		add_item(confMenu, "Change Icons Path", this, SLOT(ChooseIcnDir()));
   		add_item(confMenu, "Programs", this, SLOT(ConfEdit()));
   	add_item(specialMenu, "WMFinder Info", this, SLOT(showInfo()));
     	add_item(specialMenu, "Help", this, SLOT(showHelp()));

   add_item(menu, "Hide", this, SLOT(hide()));
   add_item(menu, "Hide Others", this, SLOT(hide_others()));
   add_item(menu, "Quit", this, SLOT(quit()));

   nextapp::realize_menus();

#endif
}

void mfinderapp::OpenObjfromMenu()
{
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus()) 
			for(int j = 0; j < FWin[i]->objsframe->FileCount; j++) 
				if(FWin[i]->objsframe->filobj[j]->isSelect) {
					QMouseEvent e(Event_MouseButtonDblClick, 
										FWin[i]->objsframe->filobj[j]->pos(), 
												LeftButton, LeftButton);
					sendEvent(FWin[i]->objsframe->filobj[j], &e);
				}
}

void mfinderapp::CloseWinfromMenu()
{
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus()) 
			FWin[i]->close();
}

void mfinderapp::SelectAllObjfromMenu()
{
	for(int i = 0; i < WinCount; i++) {
		if(FWin[i]->hasFocus()) {
			setOverrideCursor(waitCursor);
			FWin[i]->objsframe->isShiftClick = TRUE;
			for(int j = 0; j < FWin[i]->objsframe->FileCount; j++) {
				if( ! FWin[i]->objsframe->filobj[j]->isSelect) {
					if(FWin[i]->objsframe->filobj[j]->isOpen)
						FWin[i]->objsframe->filobj[j]->SelOpen();
					else
						FWin[i]->objsframe->filobj[j]->Select();
				}
			}
			FWin[i]->objsframe->isShiftClick = FALSE;
			restoreOverrideCursor();
		}
	}
}

void mfinderapp::UpdateWins()
{
	for(int i = 0; i < WinCount; i++) 
		UpdateAWin(i);
}

void mfinderapp::UpdateAWin(int wid)
{
	struct dirent **namelist;
	struct stat listStat;
	int m, a, n, dlp, dlm, ls;
	bool foundp = FALSE, foundm = FALSE;
	
	m = scandir(FWin[wid]->name, &namelist, 0, alphasort);
	newlist = new char*[m];
	a = 0;
	for(int i = 0; i < m; i++) {
		if(strcmp(namelist[i]->d_name, ".") != 0 && strcmp(namelist[i]->d_name, "..") != 0) {
			if (namelist[i]->d_name[0] == '.') {
		    	if (!hide_dot_files) {
					newlist[a] = namelist[i]->d_name;
			 		a++;
				}
			} else {
				newlist[a] = namelist[i]->d_name;
				a++;
			}	
		}
	}
	oldlist = new char*[FWin[wid]->objsframe->FileCount];
	for(n = 0; n < FWin[wid]->objsframe->FileCount; n++)
		oldlist[n] = FWin[wid]->objsframe->filobj[n]->name;
	
	if(a >= n) {
		difflistp = new char*[a];
		difflistm = new char*[a];
	} else {
		difflistp = new char*[n];
		difflistm = new char*[n];
	}
	qsort(newlist, a, sizeof(char *), compare);
	qsort(oldlist, n, sizeof(char *), compare);

	dlp = 0;
	dlm = 0;
	for(int i = 0; i < a; i++) {
		foundp = FALSE;
		for(int j = 0; j < n; j++) {
			if(strcmp(newlist[i], oldlist[j]) == 0) {
				foundp = TRUE;
				break;
			}
		}
		if(!foundp) {
			difflistp[dlp] = newlist[i];
			dlp++;
		}
	}
	for(int j = 0; j < n; j++) {
		foundm = FALSE;
		for(int i = 0; i < a; i++) {
			if(strcmp(oldlist[j], newlist[i]) == 0) {
				foundm = TRUE;
				break;
			}
		}
		if(!foundm) {
			difflistm[dlm] = oldlist[j];
			dlm++;
		}
	}

	if(dlp > 0) 
		foundp = TRUE;  // ATTENZIONE li usiamo in senso cotrario,
	else					 //
		foundp = FALSE; //
	if(dlm > 0) 		 //
		foundm = TRUE;  // ovvero, se sono veri esistono delle differenze
	else					 //
		foundm = FALSE; //
	
	if(foundp || foundm) {
		setOverrideCursor(waitCursor);
	
		if(foundm)	
			for(int i = 0; i < dlm; i++)
				UpdateDelDnDObj(wid, difflistm[i]);
				
		if(foundp)
			for(int i = 0; i < dlp; i++)
				UpdateDnDWin(wid, difflistp[i]);

		FWin[wid]->objsframe->SortObjs();
	}
	
	delete[] oldlist;
	delete[] newlist;
	delete[] difflistp;
	delete[] difflistm;
	restoreOverrideCursor();
}

void mfinderapp::DirFirst()
{
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus()) {
			FWin[i]->objsframe->dirfirst = TRUE;
			FWin[i]->objsframe->SortObjs();
		}
}

void mfinderapp::NoDirFirst()
{
	for(int i = 0; i < WinCount; i++)
		if(FWin[i]->hasFocus()) {
			FWin[i]->objsframe->dirfirst = FALSE;
			FWin[i]->objsframe->SortObjs();
		}
}

void mfinderapp::DotFiles()
{
	for(int i = 0; i < WinCount; i++) {
		if(FWin[i]->hasFocus()) {
			if(FWin[i]->objsframe->dotfiles == TRUE) {
				FWin[i]->objsframe->dotfiles = FALSE;
				FWin[i]->objsframe->SortObjs();
				return;
			} else {
				FWin[i]->objsframe->dotfiles = TRUE;
				FWin[i]->objsframe->SortObjs();
			}
		}
	}
}

void mfinderapp::SaveWin(int WinId)
{
	bool itis = FALSE;

	for(int i = 0; i < WGeomCount; i++) {
		if(strcmp(FWin[WinId]->name, WGeom[i]->wname) == 0) {
			WGeom[i]->wx = FWin[WinId]->x();
			WGeom[i]->wy = FWin[WinId]->y();
			WGeom[i]->ww = FWin[WinId]->width();
			WGeom[i]->wh = FWin[WinId]->height();
			WGeom[i]->dirfirst = FWin[WinId]->objsframe->dirfirst;
			WGeom[i]->dotfiles = FWin[WinId]->objsframe->dotfiles;
			itis = TRUE;
			break;
		}
	}
	if(!itis) {
		WGeom[WGeomCount] = new WinGeom;
		sprintf(WGeom[WGeomCount]->wname, "%s", FWin[WinId]->name);
		WGeom[WGeomCount]->wx = FWin[WinId]->x();
		WGeom[WGeomCount]->wy = FWin[WinId]->y();
		WGeom[WGeomCount]->ww = FWin[WinId]->width();
		WGeom[WGeomCount]->wh = FWin[WinId]->height();
		WGeom[WGeomCount]->dirfirst = FWin[WinId]->objsframe->dirfirst;
		WGeom[WGeomCount]->dotfiles = FWin[WinId]->objsframe->dotfiles;
		WGeomCount++;
	}
}

void mfinderapp::ConfIcn()
{
	cnficnWin = new ConfIcnWin(0L, "conf");
	addWidget(cnficnWin);
	connect(cnficnWin, SIGNAL(icninfodone()), this, SLOT(UpdateIcons()));	
	cnficnWin->show();
}

void mfinderapp::UpdateIcons()
{
	FILE *fTypes;
	char fTypesPath[256] = "";
	
	sprintf(fTypesPath, "%s/GNUstep/Library/WMFinder/filetypes", getenv("HOME"));
	fTypes = fopen(fTypesPath, "w");
	for(int i = 4; i < IDataNum; i++)
		fprintf(fTypes, "%s:%s:%s\n", IData[i]->pref, IData[i]->suff, IData[i]->IcnName);
	fclose(fTypes);

	sprintf(fTypesPath, "%s/GNUstep/Library/WMFinder/reqfileicons", getenv("HOME"));
	fTypes = fopen(fTypesPath, "w");
	fprintf(fTypes, "%s\n%s\n%s\n%s\n", IData[0]->IcnName, IData[1]->IcnName,
													IData[2]->IcnName, IData[3]->IcnName);
	fclose(fTypes);

	sprintf(fTypesPath, "%s/GNUstep/Library/WMFinder/reqfoldericons", getenv("HOME"));
	fTypes = fopen(fTypesPath, "w");
	fprintf(fTypes, "%s\n%s\n", IFoldData->IcnName, IFoldLinkData->IcnName);
	fclose(fTypes);
	
	for(int i = 0; i < WinCount; i++) {
		if(FWin[i] != NULL) {
			if(FWin[i]->isVisible()) {
				for(int j = 0; j < FWin[i]->objsframe->FileCount; j++) {
					if(FWin[i]->objsframe->filobj[j] != NULL)
						if(FWin[i]->objsframe->filobj[j]->isVisible())
							FWin[i]->objsframe->filobj[j]->UpdateIcon();
				}
			}
		}
	}
	
	for(int i = 0; i < dskobnum; i++)
		if(deskobj[i] != NULL)
			if(deskobj[i]->isVisible())
				deskobj[i]->UpdateIcon();
}

void mfinderapp::ConfEdit()
{
	cnfeditWin = new ConfEditWin(0L, "conf");
	connect(cnfeditWin, SIGNAL(editinfodone()), this, SLOT(UpdateProgs()));	
	addWidget(cnfeditWin);
	cnfeditWin->show();
}

void mfinderapp::UpdateProgs()
{
	FILE *fProgs;
	char fProgsPath[256] = "";
	FILE *fEditor;
	char fEditorPath[256] = "";
	FILE *fXterm;
	char fXtermPath[256] = "";	

	sprintf(fProgsPath, "%s/GNUstep/Library/WMFinder/programs", getenv("HOME"));
	fProgs = fopen(fProgsPath, "w");
	for(int i = 0; i < prInfoNum; i++)
		fprintf(fProgs, "%s:%s:%s\n", prInfo[i].pref, prInfo[i].suff, prInfo[i].ProgName);
	fclose(fProgs);
	
	sprintf(fEditorPath, "%s/GNUstep/Library/WMFinder/editor", getenv("HOME"));
	fEditor = fopen(fEditorPath, "w");
	fprintf(fEditor, "%s\n", Editor);
	fclose(fEditor);
	
	sprintf(fXtermPath, "%s/GNUstep/Library/WMFinder/xterm", getenv("HOME"));
	
	fXterm = fopen(fXtermPath, "wb");
	fwrite(Xterm, sizeof(Xterm), 1, fXterm);
	fclose(fXterm);
}

void mfinderapp::showInfo()
{
	wmfinfo = new WMFInfo(0L, "ss");
	addWidget(wmfinfo);
	wmfinfo->setGeometry((desktop()->width() - wmfinfo->width()) / 2, 
					  			(desktop()->height() - wmfinfo->height()) / 2,
					  			 380, 240);
	wmfinfo->show();
}

void mfinderapp::showHelp()
{
	wmfhelp = new HelpWin(0L, "hh");
	addWidget(wmfhelp);
	wmfhelp->setGeometry((desktop()->width() - wmfhelp->width()) / 2, 
			  (desktop()->height() - wmfhelp->height()) / 2, 380, 240);
	wmfhelp->show();
}

void mfinderapp::quit()
{
	char fPath[MAX_PATH_LEN] = "";
	FILE *fConf;
	struct stat st;

   delete[] DndSourcePath;
   delete[] DndTargetPath;

// ----------------- WINDOWS -------------------
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/windows", getenv("HOME"));
	fConf = fopen(fPath, "w");
	for(int i = 0; i < WinCount; i++)
		if(FWin[i] != NULL)
			if(FWin[i]->isVisible()) {
				SaveWin(FWin[i]->id);
				fprintf(fConf, "%s\n", FWin[i]->name);
			}
	fclose(fConf);

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/winsgeom", getenv("HOME"));
	fConf = fopen(fPath, "w");
	for(int i = 0; i < WGeomCount; i++) {
		fprintf(fConf, "%s:%i:%i:%i:%i:%i:%i\n",
			WGeom[i]->wname, WGeom[i]->wx, WGeom[i]->wy, 
			WGeom[i]->ww, WGeom[i]->wh, 
			WGeom[i]->dirfirst, WGeom[i]->dotfiles);
	}
	fclose(fConf);
	for(int i = 0; i < WGeomCount; i++)
		delete WGeom[i];

// ----------------- DESK OBJS -------------------
	sprintf(fPath, "%s/GNUstep/Library/WMFinder/deskobjs", getenv("HOME"));
	fConf = fopen(fPath, "w");
	for(int i = 0; i < dskobnum; i++)
		if(deskobj[i] != NULL)
			if(deskobj[i]->isVisible())
				fprintf(fConf, "%s %s %i %i\n", deskobj[i]->path, deskobj[i]->name,
																	deskobj[i]->x, deskobj[i]->y);
	fclose(fConf);
	
	qApp->quit();
}

void mfinderapp::OffixDrop(int DropX, int DropY)
{
	XEvent Event;
	Window DispatchWindow;
	int lx, ly;

	if(!DataOK)
		return;

	if(!XTranslateCoordinates(dspl, desktop()->winId(), desktop()->winId(),
											DropX, DropY, &lx, &ly, &Target)) {
		DataOK = FALSE;
		return;
	}
	if(!Target) {
		makeDeskObj(DropX, DropY);
		DataOK = FALSE;
		return;    // makeDeskObj() se c'e' gia' non lo fa !
	}

	DispatchWindow = Target;

	if(DataType == 2) {
		Event.xclient.type = ClientMessage;
		Event.xclient.display = dspl;
		Event.xclient.message_type = DndProtocol;
		Event.xclient.format = 32;
		Event.xclient.window = Target;
		Event.xclient.data.l[0] = DataType;
   	Event.xclient.data.l[1] = 0;
   	Event.xclient.data.l[2] = 0;
		Event.xclient.data.l[3] = DropX + 65536L*(long)DropY;
		Event.xclient.data.l[4] = 1;

		XSendEvent(dspl, DispatchWindow, True, NoEventMask, &Event);
	}
	DataOK = FALSE;
	if(ObDeskMoving)
		if(deskobj[dskobdragid] != NULL)
			if(deskobj[dskobdragid]->isVisible()) {
				deskobj[dskobdragid]->lower();
				deskobj[dskobdragid]->move(dskobX, dskobY);
			}
}

void mfinderapp::ChooseIcnDir()
{
	if(cnficnWin != NULL)
		if(cnficnWin->isVisible())
			cnficnWin->close();
	icnpathdlg = new IcnPathDlg(0L, "ipd");
	connect(icnpathdlg, SIGNAL(ipathchanged()),
			  							this, SLOT(ChangeIconPath()));	
	addWidget(icnpathdlg);
	icnpathdlg->show();
}

void mfinderapp::ChangeIconPath()
{
	char *delims = ":";
	char *token;
	char line[128] = "";
	char fPath[256] = "";
	char buff[256] = "";
	char buf1[256] = "";
	char buf2[64] = "";
	int dox, doy;
	bool found = FALSE;
	bool domask;
	FILE *fConf;
	struct stat st;
	QImage pixmask;

	for(int i = 0; i < IDataNum; i++)
		delete IData[i];

	delete IFoldData;
	delete IFoldLinkData;

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/iconspath", getenv("HOME"));
	fConf = fopen(fPath, "w");
	fprintf(fConf, "%s\n", IconPath);
	fclose(fConf);

// --- ICONS ---	

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfileicons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFileIcnsProvv);
		fclose(fConf);
	}	
	IData[0] = new IconData;  // default  (file generico)
	IData[1] = new IconData;  // FILEXE 
	IData[2] = new IconData;  // FILLNK 
	IData[3] = new IconData;  // FILEXELNK
	IDataNum = 4;	
	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s%s%s%s", IData[0]->IcnName, IData[1]->IcnName, 
										IData[2]->IcnName, IData[3]->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/filetypes", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "\n");
		fclose(fConf);
	}	
	fConf = fopen(fPath, "r");
	while(fscanf(fConf, "%s", line) != EOF) {
		IData[IDataNum] = new IconData;
		token = strtok(line, delims);
		sprintf(IData[IDataNum]->pref, "%s", token);
		token = strtok(NULL, delims);
		sprintf(IData[IDataNum]->suff, "%s", token);
		token = strtok(NULL, delims);
		sprintf(IData[IDataNum]->IcnName, "%s", token);
		strscrn->explfield->setText(token);	
		strscrn->update();
		IDataNum++;
	}
	fclose(fConf);	
	
	for(int i = 0; i < IDataNum; i++) {
		sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);

		if(i == 0) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR, FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 1) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic executable file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR, FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 2) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic linked file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR, FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else if(i == 3) {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the generic linked executable file
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR, FALSE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}
		} else {
			if(stat(fPath, &st)) {
				sprintf(ERR, "The required icon for the file type
%s  %s   is missing in your courrent icons path:
You can choose it now from this list or,
later, from the Special-Configure-Icons Menu\n", 
IData[i]->pref, IData[i]->suff);
				chanicndlg = new ChooseAnIcnDlg(0L, 0L, IData[i]->IcnName, ERR, TRUE);
				if(chanicndlg->exec()) {
					sprintf(IData[i]->IcnName, "%s", chanicndlg->namIcnEd->text());
					sprintf(fPath, "%s/%s", IconPath, IData[i]->IcnName);
				}
			}	
		}

		IData[i]->Icn = QImage(fPath, "XPM");
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		domask = TRUE;
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			QRgb pix = IData[i]->Icn.pixel(h, 0);
			int red = qRed(pix);
			int green = qGreen(pix);		
			int blue = qBlue(pix);
			if(red < 5 && green < 5 && blue < 5)
				domask = FALSE;
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->Icona = QPixmap();
		IData[i]->Icona.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->Icona.setMask(IData[i]->Icona.createHeuristicMask());
		IData[i]->Icn = IData[i]->Icn.convertDepth(32);
		pixmask = IData[i]->Icn.createHeuristicMask();
		for(int h = 0; h < IData[i]->Icn.width(); h++) {
			for(int j = 0; j < IData[i]->Icn.height(); j++) {
				QRgb pix = IData[i]->Icn.pixel(h, j);
				if(qRed(pixmask.pixel(h, j)) == 0) {
					int red = qRed(pix);
					int green = qGreen(pix);		
					int blue = qBlue(pix);
					if(red > 0) red = (int)(red/2);
					if(green > 0) green = (int)(green/2);
					if(blue > 0) blue = (int)(blue/2);
					IData[i]->Icn.setPixel(h, j, qRgb(red, green, blue));
				}
			}
		}
		IData[i]->Icn = IData[i]->Icn.convertDepth(8);
		IData[i]->IconaSel = QPixmap();
		IData[i]->IconaSel.convertFromImage(IData[i]->Icn);
		if(domask)
			IData[i]->IconaSel.setMask(IData[i]->Icona.createHeuristicMask());
	}

					        /* -- ICON DR -- */

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfoldericons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFolderIcnsProvv);
		fclose(fConf);
	}	
	IFoldData = new FolderIconData; 
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s", IFoldData->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/%s", IconPath, IFoldData->IcnName);
	if(stat(fPath, &st)) {
		sprintf(ERR, "The required icon for the directory
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
		chanicndlg = new ChooseAnIcnDlg(0L, 0L, IFoldData->IcnName, ERR, FALSE);
		if(chanicndlg->exec()) {
			sprintf(IFoldData->IcnName, "%s", chanicndlg->namIcnEd->text());
			sprintf(fPath, "%s/%s", IconPath, IFoldData->IcnName);
		}
	}
	
	IFoldData->Icn = QImage(fPath, "XPM");
	
	IFoldData->Icona = QPixmap();
	IFoldData->Icona.convertFromImage(IFoldData->Icn);
	IFoldData->Icona.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	pixmask = IFoldData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSel = QPixmap();
	IFoldData->IconaSel.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSel.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaOpen = QPixmap();
	IFoldData->IconaOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaOpen.setMask(IFoldData->Icona.createHeuristicMask());
	
	IFoldData->IcnCopy = IFoldData->Icn.copy();
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(32);	
	for(int h = 0; h < IFoldData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldData->IcnCopy.height(); j++) {
			QRgb pix = IFoldData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldData->IcnCopy = IFoldData->IcnCopy.convertDepth(8);		
	IFoldData->IconaSelOpen = QPixmap();
	IFoldData->IconaSelOpen.convertFromImage(IFoldData->IcnCopy);	
	IFoldData->IconaSelOpen.setMask(IFoldData->Icona.createHeuristicMask());

							    /* -- ICON DRLNK -- */

	sprintf(fPath, "%s/GNUstep/Library/WMFinder/reqfoldericons", getenv("HOME"));
	if(stat(fPath, &st)) {
		fConf = fopen(fPath, "w");
		fprintf(fConf, "%s", ReqFolderIcnsProvv);
		fclose(fConf);
	}	
	IFoldLinkData = new FolderIconData;	
	fConf = fopen(fPath, "r");
	fscanf(fConf, "%s%s", IFoldLinkData->IcnName, IFoldLinkData->IcnName);
	fclose(fConf);

	sprintf(fPath, "%s/%s", IconPath, IFoldLinkData->IcnName);
	if(stat(fPath, &st)) {
		sprintf(ERR, "The required icon for the linked directory
is missing in your courrent icons path:
%s\n
You must choose it now from this list !\n", IconPath);
		chanicndlg = new ChooseAnIcnDlg(0L, 0L, IFoldLinkData->IcnName, ERR, FALSE);
		if(chanicndlg->exec()) {
			sprintf(IFoldLinkData->IcnName, "%s", chanicndlg->namIcnEd->text());
			sprintf(fPath, "%s/%s", IconPath, IFoldLinkData->IcnName);
		}
	}
	
	IFoldLinkData->Icn = QImage(fPath, "XPM");
	
	IFoldLinkData->Icona = QPixmap();
	IFoldLinkData->Icona.convertFromImage(IFoldLinkData->Icn);
	IFoldLinkData->Icona.setMask(IFoldLinkData->Icona.createHeuristicMask());

	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	pixmask = IFoldLinkData->Icn.createHeuristicMask();
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				int red = qRed(pix);
				int green = qGreen(pix);		
				int blue = qBlue(pix);
				if(red > 0) red = (int)(red/2);
				if(green > 0) green = (int)(green/2);
				if(blue > 0) blue = (int)(blue/2);
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(red, green, blue));
			}
		}
	}
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSel = QPixmap();
	IFoldLinkData->IconaSel.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSel.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(80, 80, 110));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaOpen = QPixmap();
	IFoldLinkData->IconaOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());
	
	IFoldLinkData->IcnCopy = IFoldLinkData->Icn.copy();
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(32);		
	for(int h = 0; h < IFoldLinkData->IcnCopy.width(); h++) {
		for(int j = 0; j < IFoldLinkData->IcnCopy.height(); j++) {
			QRgb pix = IFoldLinkData->IcnCopy.pixel(h, j);
			if(qRed(pixmask.pixel(h, j)) == 0) {
				IFoldLinkData->IcnCopy.setPixel(h, j, qRgb(150, 150, 190));
			}
		}
	}	
	IFoldLinkData->IcnCopy = IFoldLinkData->IcnCopy.convertDepth(8);		
	IFoldLinkData->IconaSelOpen = QPixmap();
	IFoldLinkData->IconaSelOpen.convertFromImage(IFoldLinkData->IcnCopy);	
	IFoldLinkData->IconaSelOpen.setMask(IFoldLinkData->Icona.createHeuristicMask());

	UpdateIcons();
}
