#ifndef ___mfinderapp___
#define ___mfinderapp___

#include "nextapp.h"
#include <qsignal.h>
#include <qmlined.h>
#include "common.h"
#include "usrconf.h"
#include <qwidget.h>
#include <qstring.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qpainter.h>
#include <qcolor.h>
#include <qprogdlg.h> 
#include "macmenu.h"
#include "fileobj.h"
#include "mfinderwin.h"
#include "infowin.h"
#include "configure.h"
#include "deskobj.h"
#include "dialogs.h"
#include "icnpathdlg.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>
#include <errno.h>
#include <sys/stat.h>
#include <dirent.h>
#include <sys/param.h>
#include <ctype.h>
#include <math.h>
#include <signal.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/wait.h>
#include <X11/Intrinsic.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

	const char ReqFileIcnsProvv[] = 
"Files.xpm\n
Appl.xpm\n
FilesLink.xpm\n
ApplLink.xpm\n";

	const char ReqFolderIcnsProvv[] = 
"Folder.xpm\n
FolderLink.xpm\n";

	const char IcnsProvv[] = 
".:*:HAL-Eye.xpm\n
Makefile:*:RayTracedGear.xpm\n
makefile:*:RayTracedGear.xpm\n
Imakefile:*:RayTracedGear.xpm\n
README:*:Info.xpm\n
INSTALL:*:Info.xpm\n
AUTHORS:*:Info.xpm\n
NEWS:*:Info.xpm\n
COPYING:*:Info.xpm\n
*:c:MagDotC.xpm\n
*:cc:MagDotCC.xpm\n
*:cpp:MagDotCC.xpm\n
*:cxx:MagDotCC.xpm\n
*:C:MagDotCC.xpm\n
*:cp:MagDotCC.xpm\n
*:m:FileDotM.xpm\n
*:h:MagDotH.xpm\n
*:o:FileDotO.xpm\n
*:html:FileURL.xpm\n
*:htm:FileURL.xpm\n
*:gif:ImageGIF.xpm\n
*:GIF:ImageGIF.xpm\n
*:tiff:ImageTIFF.xpm\n
*:tif:ImageTIFF.xpm\n
*:TIFF:ImageTIFF.xpm\n
*:TIF:ImageTIFF.xpm\n
*:jpeg:ImageJPG.xpm\n
*:jpg:ImageJPG.xpm\n
*:JPEG:ImageJPG.xpm\n
*:JPG:ImageJPG.xpm\n
*:xpm:ImageXPM.xpm\n
*:xbm:ImageXBM.xpm\n
*:ps:FilePS.xpm\n
*:gz:FileTgz.xpm\n
*:z:FileZ.xpm\n
*:zip:FileZip.xpm\n
*:tar:FileTar.xpm\n";	
	
	const char ProgsProvv[] = 
"*:xpm:xv\n
*:xbm:xv\n
*:tif:xv\n
*:tiff:xv\n
*:jpg:xv\n
*:jpeg:xv\n";
	
	const char defEditProvv[] = "nedit";
	const char xtermProvv[] = "xterm -geometry 80x25 -sl 256 -sb -ls -T xterm@www.imago.ro";
	
	typedef struct {
		int uid, gid;
		char *name;
  		char home[MAXPATHLEN];
  		char shell[MAXPATHLEN];
  		char hostname[128];
  		mode_t umask;
	} UserInfo;
	
	typedef struct {
		char pref[64];
		char suff[16];
		char ProgName[64];
	} ProgInfo;

	int create(char *, mode_t);
	int rdel(char *, bool);
	int copyfile(char *, char *);
	int copydir(char *, char *);
	int compare(const void *, const void *);

	struct IconData {
		char pref[64];
		char suff[16];
		char IcnName[64];
		QImage Icn;
		QPixmap Icona;
		QPixmap IconaSel;
	};

	struct FolderIconData {
		char IcnName[64];
		QImage Icn;
		QImage IcnCopy;
		QPixmap Icona;
		QPixmap IconaSel;
		QPixmap IconaOpen;
		QPixmap IconaSelOpen;
	};

	struct WinGeom {
		char wname[256];
		int wx, wy;
		int ww, wh;
		bool dirfirst;
		bool dotfiles;
	};


class mfinderapp : public nextapp
{
	Q_OBJECT
public: 
   mfinderapp(int& argc, char** argv, const char *n=NULL, const unsigned char* icondata=NULL);

	void setTopWinByName(char *);
	void ReCountWins(int);

	StrtScrn		*strscrn;
	WMFInfo		*wmfinfo;
	HelpWin		*wmfhelp;
   WMMenu 		*fileMenu, *editMenu, *viewMenu, *labelMenu, \
   				*specialMenu, *confMenu;
	MacMenuBar	*macmenubar;
	bool 			isdir;
	MFinderWin	*FWin[MAXWIN];
	int			WinCount;
	DnDIcon		*dndicon[MAXFILE];
	int			DndIcnCount;
	ConfIcnWin	*cnficnWin;
	ConfEditWin	*cnfeditWin;
	QPixmap 		IcnDrg;
	DeskObj		*deskobj[MAXFILE];
	int			dskobnum;
	int			dskobdragid;
	int			dskobX, dskobY;
	UserInfo 	user;
	Dialog 		*dialog;	
	DialogCopy	*dialogcopy;
	IcnPathDlg	*icnpathdlg;
	ChooseAnIcnDlg *chanicndlg;
	
	XButtonEvent	StartEvent;		/* event that started the drag */
	int				DragPrecision;	/* minimum dx,dy to start drag */
	int				Dragging;		/* Drag state flag */
	bool				DataOK;			/* Non-zero if data registered */
	Atom				WM_STATE;		/* Needed for icon stuff */
	Window			Target;			/* Drop window */
	Widget			MainWidget;		/* Main widget of application	*/
	int				DataType;		/* Current drag data type */
	XtEventHandler	OtherDrop;	/* Drop on non-reg app widget */
	XtEventHandler	RootDrop;	/* How to handle root drops */
	XtEventHandler	IconDrop;	/* How to handle icon drops */
	int				RootFlag;		/* Non-zero if dropped on root */
	long           LastDropVersion;/* Last drop protocol version */

	Atom DndProtocol, DndSelection;
	Display *dspl;	

	void OffixDrop(int, int);
	int offdndtype;
	
signals:
	void dlogchngline(char*);
	
public slots:
   virtual void realize_menus();
	void DirOpen(char *, char *, bool, int);
	void SelObjFatherOfWin(char *, int, bool);
	void UnselObjsOfWins(int);
	void UnselDskObjs(int);
	void opnDeskObj(char *, char *, int);
	void RemoveDeskObj(int);
	void PrepDrag(char *, char *, int, int);       // DnD
	void DnD();
	void DeskObDnD(int);
	void dndDone(bool);
	void PrepObDeskDrag(char *, char *, int);
	void OpenObjfromMenu();					// For the Menu
	void CloseWinfromMenu();
	void SelectAllObjfromMenu();
	void ExecComm(char *);
	void ExecComm(char *, char *);
	void NewFolder();
	void NewFile();
	char* NewObject();
	void DelObj();
	char* DoDel();
	void RenameObj();
	void InfoObj();
	void StartXTerm();
	void OpenWith();
	void Edit();
	void UpdateWins();
	void UpdateAWin(int);
	void DirFirst();
	void NoDirFirst();
	void DotFiles();
	void SaveWin(int);
	void ConfIcn();
	void UpdateIcons();
	void ConfEdit();
	void UpdateProgs();
	void showInfo();
	void ChooseIcnDir();
	void ChangeIconPath();
	void quit();
	void HideDots();
	void showHelp();
	
protected:	
	
private:   
	char			ERR[512];
	QPoint 		p;   		// per il Drag & Drop
	char 	*DndSourcePath;
	char 	*DndTargetPath;
	char **srclst;
	char **srclstnames;
	char **dstdirlstnames;
	char **objtorempath;
	char **objtoremname;
	char **oldlist;
	char **newlist;
	char **difflistp;
	char **difflistm;
	bool isDnDtarget;
	bool ObDeskMoving;
	QWidget 		*ObjAt;
	QWidget 		*Objtmp;
	bool 			closeParent;
	QPainter 	DrgSelPntr;  
	int			DndDataCount;
	WinGeom 		*WGeom[2000];
	WinGeom 		*WG;
	int			WGeomCount;

	void clearDnD();
	void Move();
	void Copy();
	void dndErr(char *, char *);
	void UpdateDnDWin(int, char *);
	void UpdateDelDnDObj(int, char *);
	
	void makeDeskObj(int, int);
	void changeDeskObj(char *, char *, char *);
	void makeDeskObjFromFile(char *, char *, int, int);
};

#endif
