#include "mfinderwin.h"
#include "mfinderapp.h"
#include <qpainter.h>
#include <qwidget.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qimage.h>
#include <qapp.h>
#include <qbutton.h>
#include <qwindow.h>
#include <qscrbar.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include "dndicon.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <qkeycode.h>

MFinderWin::MFinderWin(QWidget *, const char *name, const char *objOpen, int WinCount)
			  : QWidget(0L, 0L)
{
	id = WinCount;
	strncpy(this->name, name, 256);
	strncpy(this->objOpen, objOpen, 256);
	setCaption(name);
	setIconText(name);

	QColor x = QColor(230, 230, 230);
	QColorGroup CGnorm = QColorGroup(black, x, x.light(), x.dark(),
	x.dark(120), black, x);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));

	setMinimumWidth(200);  // provvisorio !
	lastfcswidg = FALSE;
	
	objsframe = new ObjsFrame(this, name, id);
	connect(objsframe, SIGNAL(resizeDone(int)), this, SLOT(ResizeSBar(int)));
	Info = new InfoFrame(this, name);
	sBar = new MfindScrBar(this, "barv");
	connect(sBar, SIGNAL(valueChanged(int)), this, SLOT(ScrollV(int)));
	YScrollBar = 0;
			
	emit clickonwin(this->name, id, FALSE);
}

//-------------------------------------------------------------------------
//                               slots
//-------------------------------------------------------------------------
void MFinderWin::ScrollV(int y)
{
	YScrollBar = y;
	objsframe->setGeometry(24, YScrollBar*(-1)+25, width()-26, height()-27+YScrollBar);
}

void MFinderWin::ResizeSBar(int y)
{
	if((y - height()+30) > 0)
		sBar->setRange(0, y - height()+30);
	else
		sBar->setRange(0, 1);
}

//-------------------------------------------------------------------------
//                               eventi
//-------------------------------------------------------------------------
void MFinderWin::closeEvent(QCloseEvent *e)
{
	emit clickonwin(name, id, TRUE);
	emit savewin(id);
			
	this->hide();
	for(int i = 0; i < objsframe->FileCount; i++)
		objsframe->filobj[i]->close();
		
	QWidget::closeEvent(e);
}

void MFinderWin::focusInEvent(QFocusEvent *e)
{
	bool sel = FALSE;

	for(int i = 0; i < objsframe->FileCount; i++)
		if(objsframe->filobj[i]->isSelect) 
			sel = TRUE;
		
	if(! sel) emit clickonwin(name, id, FALSE);
	
	emit update(id);
}

void MFinderWin::focusOutEvent(QFocusEvent *e)
{
	QWidget::focusOutEvent(e);
}

void MFinderWin::resizeEvent(QResizeEvent *)
{
	Info->setGeometry(0, 0, width(), 20);
	objsframe->setGeometry(24, 25, width()-26, height()-27);
	sBar->setGeometry(1, 20, 18, height()-20);
	sBar->setValue(0);
	sBar->setSteps(75, height());
}

void MFinderWin::keyPressEvent(QKeyEvent *e)
{
	if(e->state() == ControlButton) {
		switch(e->key()) { 
			case Key_W: 
				close();
				break;	
			case Key_O:
				for(int i = 0; i < objsframe->FileCount; i++) {
					if(objsframe->filobj[i]->isSelect) {
						QMouseEvent e(Event_MouseButtonDblClick, 
											objsframe->filobj[i]->pos(), 
												LeftButton, LeftButton);
						qApp->sendEvent(objsframe->filobj[i], &e);
					}				
				}
				break;
			case Key_Q: 
				emit quitapp();
				break;	
			case Key_A: 
				qApp->setOverrideCursor(waitCursor);
				objsframe->isShiftClick = TRUE;
				for(int i = 0; i < objsframe->FileCount; i++)
					if( ! objsframe->filobj[i]->isSelect)
						if(objsframe->filobj[i]->isOpen)
							objsframe->filobj[i]->SelOpen();
						else
							objsframe->filobj[i]->Select();
				objsframe->isShiftClick = FALSE;
				qApp->restoreOverrideCursor();
				break;
			case Key_N: 
					emit newfolder();
				break;	
			case Key_M: 
					emit newfile();
				break;	
			case Key_D: 
					emit deleteobj();
				break;
			case Key_R: 
					emit renameobj();
				break;
			case Key_I: 
					emit infoobj();
				break;
			case Key_T: 
					emit startxterm();
				break;
			case Key_E: 
					emit edit();
				break;
			case Key_U: 
					emit update(id);
				break;
			default:             
				e->ignore();
				return;
		} 				
	} else
		e->ignore();
}

void MFinderWin::paintEvent(QPaintEvent *)
{
	QPainter p;
	
	p.begin(this);
	p.drawLine(1, 0, 1, height());
	p.drawRect(0, 20, 20, height()-23);
	p.end();
}
