#ifndef MFINDERWIN_H
#define MFINDERWIN_H

#include <qapp.h>
#include <qwidget.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qframe.h>
#include <qpopmenu.h> 
#include "common.h"
#include "fileobj.h"
#include "dndicon.h"
#include "objsframe.h"
#include "infoframe.h"
#include "mfindscrbar.h"
#include "macmenu.h"

class MFinderWin : public QWidget
{
	Q_OBJECT
public:
	MFinderWin(QWidget *parent=0, const char *name=0, const char *objOpen=0, int WinCount=0);
	int	id;
	char name[256];
	char objOpen[256];
	ObjsFrame *objsframe;
	MfindScrBar *sBar;
	QFrame *HiLiFrame;
	int YScrollBar;
	int minW;
	InfoFrame *Info;
	bool lastfcswidg;
	
signals:		
	void clickonwin(char *, int, bool);
	void windestroy(int, char *);
	void newfolder();
	void newfile();
	void deleteobj();
	void renameobj();
	void infoobj();
	void startxterm();
	void edit();
	void update(int);
	void savewin(int);
	void quitapp();
	
public slots:
	void ScrollV(int);
	void ResizeSBar(int);

protected:
	void closeEvent(QCloseEvent *);       
	void focusInEvent(QFocusEvent *);
	void focusOutEvent(QFocusEvent *);
	void resizeEvent(QResizeEvent *);
	void paintEvent(QPaintEvent *);
	void keyPressEvent(QKeyEvent *);
	
private:
	QWidget *Objtmp;

};

#endif // MFINDERWIN_H
