// ----------------------------------------------------------------------------
// $Header$
// ----------------------------------------------------------------------------
// $RCSfile$
// ----------------------------------------------------------------------------
// Written 1997 by Christoph Pesch
// ----------------------------------------------------------------------------
// LAST CHANGE DONE: 30. July 1997
// ----------------------------------------------------------------------------

#ifndef ___nextapp___
#define ___nextapp___
 
#include <qapp.h>
#include <qsignal.h>
#include <qpixmap.h>
#include "infopanel.h"

extern "C"
{
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <WMaker.h>
}


// ----------------------------------------------------------------------------
// CLASS: nextapp
//
// DERIVED FROM: QApplication
//
// DESCRIPTION: 
// Provides a replacement for QApplication and supports WindowMaker
// functions like Hide, HideOthers and WindowMaker menus.
// 
// LAST CHANGE DONE: 01. October 1997
// ----------------------------------------------------------------------------


class nextapp : public QApplication
{
Q_OBJECT

protected:
   char *appClassName;
   WMAppContext *app;   
   WMMenu *menu;
   infopanel info;
   QPixmap *icon;

   virtual bool x11EventFilter(XEvent *e);
   
public:
   nextapp(int& argc, char** argv, const char *n=NULL,
	   const unsigned char* icondata=NULL);
   void addWidget(QWidget *);

   WMMenu* main_menu();
   WMMenu* add_submenu(WMMenu*, const char*);
   void add_item(WMMenu* m, const char* name, QSignal* s, char* rtext=NULL);
   void add_item(WMMenu* m, const char* name, QObject* r=NULL,
		 const char* slot=NULL, char* rtext=NULL);
   virtual void realize_menus();

   infopanel* get_infopanel();
   
public slots:
   int show_info();
   int hide();
   int hide_others();
};

#endif

// ----------------------------------------------------------------------------
// $Log$
// ----------------------------------------------------------------------------

// EOF
