#include "objsframe.h"
#include "common.h"
#include <qkeycode.h>
#include <qapp.h>
#include <qevent.h> 
#include <qpainter.h> 
#include <qdrawutl.h>

ObjsFrame::ObjsFrame(QWidget *parent, const char *name, int WinRef)
			  : QWidget(parent, name)
{
	strncpy(this->name, name, 256);	
	id = WinRef;
	QColor x = QColor(230, 230, 230);
	QColorGroup CGnorm = QColorGroup(black, x, x.light(), x.dark(), x.dark(120), black, x);
	setPalette(QPalette(CGnorm, CGnorm, CGnorm));
	
	isShiftClick = FALSE;
	isDragging = FALSE;
	isDragShiftClick = FALSE;
	isDragTarget = FALSE;
	closeme = FALSE;
	FileCount = 0;
	
	makePopUp(name);
}

ObjsFrame::~ObjsFrame()
{
	delete[] dirs;
}

void ObjsFrame::makeFileObj(char *namObj)
{
	if(strcmp(namObj, ".") != 0 && strcmp(namObj, "..") != 0) {
		filobj[FileCount] = new FileObj(this, namObj, FileCount, id, name);
		connect(filobj[FileCount], SIGNAL(selattempt(int)), 
					this, SLOT(slotFileSel(int)));
		connect(filobj[FileCount], SIGNAL(shiftclick(int)), 
					this, SLOT(slotShiftClick(int)));	
		connect(filobj[FileCount], SIGNAL(openattempt(int, QMouseEvent *)), 
					this, SLOT(slotOpenObjs(int, QMouseEvent *)));	
					
		filobj[FileCount]->show();
		filobj[FileCount]->Label->show();
		FileCount++;
	}
}

void ObjsFrame::SortObjs()
{
	int fcTmp, m, n;
	
	if(dirfirst) {
		m = 0;
		for(int i = 0; i < FileCount; i++)
			if(filobj[i] != NULL)
				if(filobj[i]->isVisible() || filobj[i]->isdothided)
					if(filobj[i]->type == DR || filobj[i]->type == DRLNK)
						m++;

		objslist1 = new char*[m + 1];
		m = 0;
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i] != NULL) {
				if(filobj[i]->isVisible() || filobj[i]->isdothided) {
					if(filobj[i]->type == DR || filobj[i]->type == DRLNK) {
						objslist1[m] = filobj[i]->name;
						m++;
					}
				}
			}
		}
		qsort(objslist1, m, sizeof(char *), compare);
		fcTmp = 0;
		for(int i = 0; i < m; i++) {
			for(int j = 0; j < FileCount; j++) {
				if(filobj[j] != NULL) {
					if(filobj[j]->isVisible() || filobj[i]->isdothided) {
						if(strcmp(objslist1[i], filobj[j]->name) == 0) {
							fobjTmp[fcTmp] = filobj[j];
							fobjTmp[fcTmp]->idLocal = fcTmp;
							fcTmp++;
						}
					}
				}
			}
		}
		delete[] objslist1;
		n = 0;
		for(int i = 0; i < FileCount; i++)
			if(filobj[i] != NULL)
				if(filobj[i]->isVisible() || filobj[i]->isdothided)
					if(filobj[i]->type != DR && filobj[i]->type != DRLNK)
						n++;
		
		objslist2 = new char*[n + 1];
		n = 0;
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i] != NULL) {
				if(filobj[i]->isVisible() || filobj[i]->isdothided) {
					if(filobj[i]->type != DR && filobj[i]->type != DRLNK) {
						objslist2[n] = filobj[i]->name;
						n++;
					}
				}
			}
		}
		qsort(objslist2, n, sizeof(char *), compare);
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < FileCount; j++) {
				if(filobj[j] != NULL) {
					if(filobj[j]->isVisible() || filobj[i]->isdothided) {
						if(strcmp(objslist2[i], filobj[j]->name) == 0) {
							fobjTmp[fcTmp] = filobj[j];
							fobjTmp[fcTmp]->idLocal = fcTmp;
							fcTmp++;
						}
					}
				}
			}
		}
		delete[] objslist2;
		
		for(int i = 0; i < m + n; i++) 
			filobj[i] = fobjTmp[i];
		FileCount = m + n;
	} else {	
		m = 0;
		for(int i = 0; i < FileCount; i++)
			if(filobj[i] != NULL)
				if(filobj[i]->isVisible() || filobj[i]->isdothided)
					m++;
	
		objslist1 = new char*[m + 1];
		m = 0;
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i] != NULL) {
				if(filobj[i]->isVisible() || filobj[i]->isdothided) {
					objslist1[m] = filobj[i]->name;
					m++;
				}
			}
		}
		qsort(objslist1, m, sizeof(char *), compare);
		fcTmp = 0;
		for(int i = 0; i < m; i++) {
			for(int j = 0; j < FileCount; j++) {
				if(filobj[j] != NULL) {
					if(filobj[j]->isVisible() || filobj[i]->isdothided) {
						if(strcmp(objslist1[i], filobj[j]->name) == 0) {
							fobjTmp[fcTmp] = filobj[j];
							fobjTmp[fcTmp]->idLocal = fcTmp;
							fcTmp++;
						}
					}
				}
			}
		}
				
		delete[] objslist1;
		
		for(int i = 0; i < m; i++) 
			filobj[i] = fobjTmp[i];
		FileCount = m;
	}
	
	
/*	if(dotfiles) {    // dotfiles == true significa che non si devono vedere !
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i] != NULL) {
				if(filobj[i]->isdotfile) {
					filobj[i]->isdothided = TRUE;
					filobj[i]->hide();
					filobj[i]->Label->hide();
				}
			}
		}
	} else {
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i] != NULL) {
				if(filobj[i]->isdothided) {
					filobj[i]->show();
					filobj[i]->Label->show();
					filobj[i]->isdothided = FALSE;
				}
			}
		}
	}
*/	
	
		
	QResizeEvent e = QResizeEvent(this->size(), this->size());
	this->event(&e);
}

void ObjsFrame::makePopUp(const char *list)
{
	char *token;
	char *delims = "/";
	char paths[256] = "";
	
	popupMenu = new Popup();
	dirs = new char*[30];
	dirs[0] = "/";
	popupMenu->insertItem(dirs[0]);
	strncpy(paths, list, 256);
	ndirs = 1;
	token = strtok(paths, delims);
	dirs[ndirs] = token;
	if(dirs[ndirs] != NULL)
		popupMenu->insertItem(dirs[ndirs]);
	while(token != NULL) {
		ndirs++;
		token = strtok(NULL, delims);
		dirs[ndirs] = token;
		if(dirs[ndirs] != NULL)
			popupMenu->insertItem(dirs[ndirs]);
	}
	connect(popupMenu, SIGNAL(activated(int)), this, SLOT(OpenOtherWins(int)));
}

//-------------------------------------------------------------------------
//                               slots
//-------------------------------------------------------------------------
void ObjsFrame::slotFileSel(int n)
{
	if( ! isShiftClick && ! isDragShiftClick) {
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i]->idLocal != n) {
				if(filobj[i]->isSelect && ! filobj[i]->isOpen)
					filobj[i]->Unselect();
				if(filobj[i]->isSelect && filobj[i]->isOpen)
					filobj[i]->UnselOpen();
			}
		}
	}
	emit UnselObjsOfOtherWin(id);
}

void ObjsFrame::slotShiftClick(int n)
{
	if(n == 1) isShiftClick = TRUE;
	if(n == 0) isShiftClick = FALSE;
}

void ObjsFrame::slotOpenObjs(int, QMouseEvent *e)
{
	for(int i = 0; i < FileCount; i++) {
		if(filobj[i]->isSelect) {
			if(e->state() & ControlButton) {
				emit openattempt(filobj[i]->ParentName, filobj[i]->name, 
					TRUE, filobj[i]->idParent);			
			} else {
				emit openattempt(filobj[i]->ParentName, filobj[i]->name, 
					FALSE, filobj[i]->idParent);
			}
		}
	}
}

void ObjsFrame::OpenOtherWins(int menuid)
{
	char winpath[256] = "";

	if(menuid == 0) {
		emit menuopen("/", "", FALSE, 0);
	} else {
		for(int i = 1; i < menuid; i++)
			sprintf(winpath, "%s/%s", winpath, popupMenu->text(i));

		emit menuopen((char *)winpath, (char *)popupMenu->text(menuid), FALSE, id);
	}
}

//-------------------------------------------------------------------------
//                               eventi
//-------------------------------------------------------------------------
void ObjsFrame::resizeEvent(QResizeEvent *)
{
	int PosCount;
	int objsSpace = 20;
	int objswidth = 60;
	int HObjs, VObjs;
	int i = 0;
	
	HObjs = objsSpace;
	VObjs = 4;
	PosCount = 0;
	while(i < FileCount) {
		while(1) {
			if(filobj[i]->isVisible()) {
				if(PosCount > 0)
					HObjs = HObjs + objswidth + objsSpace;
				if(HObjs > width() - objswidth) 
					break;
				filobj[i]->move(HObjs, VObjs);
			 	if(filobj[i]->Label->width() < filobj[i]->width()) {
				 	filobj[i]->Label->move(HObjs + ((filobj[i]->width() -
						 					filobj[i]->Label->width()) / 2), VObjs + 50);
			 	} else {
				 	filobj[i]->Label->move(HObjs - ((filobj[i]->Label->width() -
						 					filobj[i]->width()) / 2), VObjs + 50);
				}
				i++;						 	
			 	PosCount++;
			 	if(i == FileCount) 
			 		break;
			} else {
				i++;
			}
		}
		HObjs = objsSpace;
		PosCount = 0;
		VObjs = VObjs + 75;
	}
	
	emit resizeDone(VObjs);	
}


void ObjsFrame::mousePressEvent(QMouseEvent *e)
{
	if(e->button() == RightButton) {
		if(strcmp(name, "/") != 0) {
			popupMenu->popup(mapToGlobal(e->pos()));
			if(e->state() & ControlButton)
				closeme = TRUE;
		}
	}
	
	if(e->state() & ShiftButton) {
		isShiftClick = TRUE;
	} else {
		for(int i = 0; i < FileCount; i++) {
			if(filobj[i]->isSelect && ! filobj[i]->isOpen)
				filobj[i]->Unselect();
			if(filobj[i]->isSelect && filobj[i]->isOpen)
				filobj[i]->UnselOpen();
		}
		isShiftClick = FALSE;
		emit clickonwin(name, id, FALSE);
	}
}

void ObjsFrame::mouseMoveEvent(QMouseEvent *)
{
	if( ! isDragging) {
		pBegSel = mapFromGlobal(QCursor::pos());
		isDragging = TRUE;
		isDragShiftClick = TRUE;
	} else {
		QPoint cpnt = mapFromGlobal(QCursor::pos());
		if(pBegSel.x() < cpnt.x()) {
			SelRect.setLeft(pBegSel.x());
			SelRect.setRight(cpnt.x());
		} else {
			SelRect.setLeft(cpnt.x());
			SelRect.setRight(pBegSel.x());
		}
		if(pBegSel.y() < cpnt.y()) {
			SelRect.setTop(pBegSel.y());
			SelRect.setBottom(cpnt.y());
		} else {
			SelRect.setTop(cpnt.y());
			SelRect.setBottom(pBegSel.y());
		}
		
		for(int i = 0; i < FileCount; i++) {
			QPoint cp(filobj[i]->x()+filobj[i]->width()/2,
									filobj[i]->y()+filobj[i]->height()/2);
			if(SelRect.contains(cp)) {
				if( ! filobj[i]->isSelect) {
					if(filobj[i]->isOpen)
						filobj[i]->SelOpen();
					else
						filobj[i]->Select();
				}
			} else {
				if( ! isShiftClick) {
					if(filobj[i]->isSelect) {
						if(filobj[i]->isOpen)
							filobj[i]->UnselOpen();
						else
							filobj[i]->Unselect();
					}	
				}
			}
		}
		update();
	}
}

void ObjsFrame::mouseReleaseEvent(QMouseEvent *)
{
	if(isDragging) {
		isDragging = FALSE;
		isDragShiftClick = FALSE;
		isShiftClick = FALSE;
		update();
	}
}

void ObjsFrame::paintEvent(QPaintEvent *)
{
	QPainter p;
	
	p.begin(this);
	if(isDragging) {
		p.drawRect(SelRect);
	}
	if(isDragTarget) {
		p.setPen(QPen(QColor(150, 150, 255), 2));
		p.drawRect(1, 1, width()-2, height()-2);
	}
	p.end();
}

void ObjsFrame::DragMove()
{
	isDragTarget = TRUE;
	update();	  
}

void ObjsFrame::DragLeave()
{
	isDragTarget = FALSE;
	update();	  
}

