#ifndef OBJSFRAME_H
#define OBJSFRAME_H

#include <qwidget.h>
#include <qpainter.h> 
#include <qframe.h> 
#include <qrect.h> 
#include "popup.h"
#include "common.h"
#include "fileobj.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int compare(const void *, const void *);

class ObjsFrame : public QWidget
{
	Q_OBJECT
public:
	ObjsFrame(QWidget *parent=0, const char *name=0, int WinRef=0);
	~ObjsFrame();
	void makeFileObj(char *);
	void SortObjs();
	void makePopUp(const char *);
	void DragMove();
	void DragLeave();
	
	char **objslist1;
	char **objslist2;
	char **objslist3;	
	char **objslist4;
	char name[256];
	int id;
	FileObj *filobj[MAXFILE];
	FileObj *fobjTmp[MAXFILE];
	int FileCount;
	int spContentY;
	bool dirfirst;
	bool dotfiles;
	bool isShiftClick;
	bool isDragging;
	bool isDragShiftClick;
	bool isDragTarget;
	Popup *popupMenu;
	
signals:
	void UnselObjsOfOtherWin(int);
	void clickonwin(char *, int, bool);
	void openattempt(char*, char*, bool, int);
	void resizeDone(int);
	void menuopen(char*, char*, bool, int);
	
public slots:
	void slotFileSel(int);
	void slotShiftClick(int);
	void slotOpenObjs(int, QMouseEvent *);
	void OpenOtherWins(int);
	
protected:
	void resizeEvent(QResizeEvent *);
	void mousePressEvent(QMouseEvent *);
	void mouseMoveEvent(QMouseEvent *);
	void mouseReleaseEvent(QMouseEvent *);
	void paintEvent(QPaintEvent *);

private:
	QPoint pBegSel;
	QRect SelRect;
	char P[512];
	char **dirs;
	int ndirs;
	bool closeme;
};

#endif // OBJSFRAME_H
